#ifndef RENESANCE_EE_H
#define RENESANCE_EE_H
#include <fstream>

class TRandom;

namespace SANC {

class Settings;
class Info;
class ModulesInterface;
class Time;
class Process;
class DataSaver;

class ReneSANCe_ee
{
public:
    ReneSANCe_ee(Settings & _cfg, Info & _info, Process & _proc, ModulesInterface & _mod, Time & _time, DataSaver & _ds);
    ~ReneSANCe_ee(){}
    void generateGrid();
    void generateEvents();
    void generateEventsNB();
private:
    Settings & cfg;
    Time & timing;
    Info & info;
    Process & proc;
    ModulesInterface & modules;
    DataSaver & ds;
    double xwgtup;
    long   loop;
    double MCresult,MCerror,MCwt;
    double branch[4]={0.},branch_err[4]={0.};
    TRandom *PseRan;
    std::ofstream output_brn;
    std::ofstream output_tot;
};

}
#endif // RENESANCE_EE_H
