************************************************************************
* sanc_nc_v1.31 package.
************************************************************************
* File (nc_si_1212_1212.f) is created on Вт ноя 14 03:43:46 MSK 2017.
************************************************************************
* This is the FORTRAN module (nc_si_1212_1212) to calculate EW
* cross-section (width) by using the helicity amplitudes
* for the Bhabha (el^+ + el^- -> el^+ + el^-) process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2017.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine nc_si_12_12__12_12 (s,t,u,sigma)
      implicit none!
      include 's2n_declare.h'

      integer iz,i,j,k,l,is,jj,izi
      real*8 sum,tw(2),sig(2),sq
      real*8 deltar,dr_bos,dr_fer
      real*8 kappa,cof,nsig,twcoeff,twl,coeff,slams
      complex*16 zoro
      complex*16 ff_qed_ll,ff_qed_lq,ff_qed_ql,ff_qed_qq,ff_qed_ld
      complex*16 ff_qed_qd,ff_ew_ll,ff_ew_lq,ff_ew_ql,ff_ew_qq
      complex*16 ff_ew_ld,ff_qed_gg
      complex*16 ff_llst,ff_lqst,ff_qlst,ff_qqst,ff_ldst,ff_qdst,ff_ggst
      complex*16 ff_llts,ff_lqts,ff_qlts,ff_qqts,ff_ldts,ff_qdts,ff_ggts
      complex*16 ffllst,fflqst,ffqlst,ffqqst,ffldst,ffqdst,ffggst
      complex*16 ffllts,fflqts,ffqlts,ffqqts,ffldts,ffqdts,ffggts

      complex*16 amp(2,2,2,2)
      real*8 costh3,sinth3
      real*8 kappaz
      real*8 amp2_(2,2,2),amp2(2,2)
      complex*16 chizt,chiztc,chizs,chizsc

      izi = 0
      if (ilin.eq.0) then
         twl = 0d0
      elseif (ilin.eq.1) then
         twl = 1d0
      endif

      cmz2 = mz2
      spr = s
      qs = -s
      ts = -t
      us = -u
      sq = dsqrt(s)

      cosf = (t-u)/s
      sinf = dsqrt(1d0-cosf**2)

      costh3 = cosf
      sinth3 = sinf

      kappaz = gf*rzm2/(sqrt(2d0)*8d0*pi)/alpha
      chizt = 4d0*kappaz*t/(t-mz**2)
      chiztc = dconjg(chizt)

      chizs = 4d0*kappaz*s/(s-cmz2)
      chizsc = dconjg(chizs)

      nsig = pi*alpha**2*conhc/s/2d0

      if (iborn.eq.1) then
         ff_llts = dcmplx(0d0,0d0)
         ff_qlts = dcmplx(0d0,0d0)
         ff_lqts = dcmplx(0d0,0d0)
         ff_qqts = dcmplx(0d0,0d0)
         ff_ggts = dcmplx(0d0,0d0)
         ff_llst = dcmplx(0d0,0d0)
         ff_qlst = dcmplx(0d0,0d0)
         ff_lqst = dcmplx(0d0,0d0)
         ff_qqst = dcmplx(0d0,0d0)
         ff_ggst = dcmplx(0d0,0d0)
      else
         coeff = cfprime*alpha/4d0/pi/stw2

         igzm2 = 1
         call delr(deltar,dr_bos,dr_fer)
         deltar = coeff*deltar
         call UniBosConsts_Bos ()
         call UniBosConsts_Fer ()

         call UniProConsts_fer (-s)
         call nc_ff_12_12__12_12 (-s,-t,-u)

         if ((iew.eq.0).and.(iqed.eq.1)) then
            ff_llst = coeff*ffarray(1,1)
            ff_lqst = coeff*ffarray(1,3)
            ff_qlst = coeff*ffarray(1,5)
            ff_qqst = coeff*ffarray(1,7)
            deltar = 0d0
         elseif ((iew.eq.1).and.(iqed.eq.0)) then
            ff_llst = coeff*ffarray(1,2)
            ff_lqst = coeff*ffarray(1,4)
            ff_qlst = coeff*ffarray(1,6)
            ff_qqst = coeff*ffarray(1,8)
         elseif ((iew.eq.1).and.(iqed.eq.1)) then
            ff_llst = coeff*(ffarray(1,1) + ffarray(1,2))
            ff_lqst = coeff*(ffarray(1,3) + ffarray(1,4))
            ff_qlst = coeff*(ffarray(1,5) + ffarray(1,6))
            ff_qqst = coeff*(ffarray(1,7) + ffarray(1,8))
         elseif ((iew.eq.0).and.(iqed.eq.0)) then
            ff_llst = dcmplx(0d0,0d0)
            ff_lqst = dcmplx(0d0,0d0)
            ff_qlst = dcmplx(0d0,0d0)
            ff_qqst = dcmplx(0d0,0d0)
            deltar = 0d0
         endif
         ff_ggst = coeff*ffarray(1,13)

         igzm2 = 0
         call UniProConsts_Fer (-t)
         call nc_ff_12_12__12_12 (-t,-s,-u)

         if ((iew.eq.0).and.(iqed.eq.1)) then
            ff_llts = coeff*ffarray(1,1)
            ff_lqts = coeff*ffarray(1,3)
            ff_qlts = coeff*ffarray(1,5)
            ff_qqts = coeff*ffarray(1,7)
            deltar = 0d0
         elseif ((iew.eq.1).and.(iqed.eq.0)) then
            ff_llts = coeff*ffarray(1,2)
            ff_lqts = coeff*ffarray(1,4)
            ff_qlts = coeff*ffarray(1,6)
            ff_qqts = coeff*ffarray(1,8)
         elseif ((iew.eq.1).and.(iqed.eq.1)) then
            ff_llts = coeff*(ffarray(1,1) + ffarray(1,2))
            ff_lqts = coeff*(ffarray(1,3) + ffarray(1,4))
            ff_qlts = coeff*(ffarray(1,5) + ffarray(1,6))
            ff_qqts = coeff*(ffarray(1,7) + ffarray(1,8))
         elseif ((iew.eq.0).and.(iqed.eq.0)) then
            ff_llts = dcmplx(0d0,0d0)
            ff_lqts = dcmplx(0d0,0d0)
            ff_qlts = dcmplx(0d0,0d0)
            ff_qqts = dcmplx(0d0,0d0)
            ff_ldts = dcmplx(0d0,0d0)
            deltar = 0d0
         endif
         ff_ggts = coeff*ffarray(1,13)

         if ((gfscheme.ge.1).and.(gfscheme.le.3)) then
            ff_llst = ff_llst-coeff*deltar
            ff_qlst = ff_qlst-coeff*deltar
            ff_lqst = ff_lqst-coeff*deltar
            ff_qqst = ff_qqst-coeff*deltar
            ff_llts = ff_llts-coeff*deltar
            ff_qlts = ff_qlts-coeff*deltar
            ff_lqts = ff_lqts-coeff*deltar
            ff_qqts = ff_qqts-coeff*deltar
         endif
         if ((gfscheme.eq.2).or.(gfscheme.eq.3)) then
            ff_ggst = ff_ggst-coeff*deltar
            ff_ggts = ff_ggts-coeff*deltar
         endif
         if (gfscheme.eq.4) then
            ff_llst = ff_llst-coeff*deltaa
            ff_qlst = ff_qlst-coeff*deltaa
            ff_lqst = ff_lqst-coeff*deltaa
            ff_qqst = ff_qqst-coeff*deltaa
            ff_llts = ff_llts-coeff*deltaa
            ff_qlts = ff_qlts-coeff*deltaa
            ff_lqts = ff_lqts-coeff*deltaa
            ff_qqts = ff_qqts-coeff*deltaa
         endif
         if (gfscheme.eq.4) then
            ff_ggst = ff_ggst-coeff*deltaa
            ff_ggts = ff_ggts-coeff*deltaa
         endif
      endif

      do iz = izi,1
         zoro = dcmplx(iz,0d0)

         ffllst = zoro + ff_llst
         ffqlst = zoro + ff_qlst
         fflqst = zoro + ff_lqst
         ffqqst = zoro + ff_qqst
         ffllts = zoro + ff_llts
         ffqlts = zoro + ff_qlts
         fflqts = zoro + ff_lqts
         ffqqts = zoro + ff_qqts

         if (ifgg.eq.0) then
            ffggst = zoro
            ffggts = zoro
         elseif (ifgg.eq.1) then
            ffggst = zoro + ff_ggst
            ffggts = zoro + ff_ggts
         elseif ((ifgg.eq.2).and.(gfscheme.ne.2)) then
            ffggst = zoro/(1d0 - ff_ggst)
            ffggts = zoro/(1d0 - ff_ggts)
         endif

      amp(1,1,1,1) =
     & +chizt*ffqqts*vmael**2*s/t*(-2)
     & +chizt*ffqlts*vmael*s/t*(+2)
     & +ffggts*s/t*(-2)

      amp(1,1,1,2) =
     & 0d0

      amp(1,1,2,1) =
     & 0d0

      amp(1,1,2,2) =
     & 0d0

      amp(1,2,1,1) =
     & 0d0

      amp(1,2,1,2) =
     & +chizs*ffqqst*vmael**2*(-1+costh3)
     & +chizs*fflqst*vmael*(+1-costh3)
     & +ffggst*(-1+costh3)

      amp(1,2,2,1) =
     & +chizs*ffqqst*vmael**2*(-1-costh3)
     & +chizs*ffllst*(-1-costh3)
     & +chizs*fflqst*vmael*(+1+costh3)
     & +chizs*ffqlst*vmael*(+1+costh3)
     & +chizt*ffqqts*vmael**2*s/t*(-1-costh3)
     & +chizt*ffllts*s/t*(-1-costh3)
     & +chizt*fflqts*vmael*s/t*(+1+costh3)
     & +chizt*ffqlts*vmael*s/t*(+1+costh3)
     & +ffggst*(-1-costh3)
     & +ffggts*s/t*(-1-costh3)

      amp(1,2,2,2) =
     & 0d0

      amp(2,1,1,1) =
     & 0d0

      amp(2,1,1,2) =
     & +chizs*ffqqst*vmael**2*(-1-costh3)
     & +chizt*ffqqts*vmael**2*s/t*(-1-costh3)
     & +ffggst*(-1-costh3)
     & +ffggts*s/t*(-1-costh3)

      amp(2,1,2,1) =
     & +chizs*ffqqst*vmael**2*(-1+costh3)
     & +chizs*ffqlst*vmael*(+1-costh3)
     & +ffggst*(-1+costh3)

      amp(2,1,2,2) =
     & 0d0

      amp(2,2,1,1) =
     & 0d0

      amp(2,2,1,2) =
     & 0d0

      amp(2,2,2,1) =
     & 0d0

      amp(2,2,2,2) =
     & +chizt*ffqqts*vmael**2*s/t*(-2)
     & +chizt*fflqts*vmael*s/t*(+2)
     & +ffggts*s/t*(-2)

         do i = 1,2
            do j = 1,2
               sum = 0d0
               do k = 1,2
                  do l = 1,2
                     sum = sum + amp(i,j,k,l)*conjg(amp(i,j,k,l))
                  enddo
               enddo
               amp2_(iz+1,i,j) = sum
            enddo
         enddo
      enddo

      do i = 1,2
         do j = 1,2
            amp2(i,j) = amp2_(2,i,j)-twl*amp2_(1,i,j)
         enddo
      enddo

      if (alr.eq.0) then
         sigma =
     &       (+(1+lamep)*(1+lamem)*amp2(1,1)
     &        +(1+lamep)*(1-lamem)*amp2(1,2)
     &        +(1-lamep)*(1+lamem)*amp2(2,1)
     &        +(1-lamep)*(1-lamem)*amp2(2,2))/4d0
      elseif (alr.eq.1) then
         sigma =
     &        +(amp2(1,2)-amp2(2,1))
      elseif (alr.eq.2) then
         sigma =
     &        +(amp2(1,2)+amp2(2,1))
      endif

      sigma = nsig*sigma
      if (sigma.ne.sigma) print *,'Sigma NAN!!!',s,t,u

      return
      end
