************************************************************************
* sanc_nc_v2.00 package.
************************************************************************
* File (nc_si_12_12__16_16.f) is created on Сб янв 27 22:38:03 MSK 2018.
************************************************************************
* This is the FORTRAN module (nc_si_12_12__16_16) to calculate EW
* cross-section (width) by using the helicity amplitudes
* for the el^- + el^- -> mo^- + mo^- process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2018.
*
* http://sanc.jinr.ru/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine nc_si_12_12__16_16 (s,t,u,sigma)
      implicit none!
      include 's2n_declare.h'

      integer iz,i,j,k,l,is,jj,izi
      real*8 sum,tw(2),sig(2),sq
      real*8 deltar,dr_bos,dr_fer
      real*8 kappa,cof,nsig,twcoeff,twl,coeff,slams,s1
      complex*16 zoro
      complex*16 ff_ll,ff_lq,ff_ql,ff_qq,ff_ld,ff_qd,ff_gg
      complex*16 ffll,fflq,ffql,ffqq,ffld,ffqd,ffgg

      real*8 betasmomo

      complex*16 amp(2,2,2,2)
      real*8 amp2_(2,2,2),amp2(2,2)
      real*8 sqrtpxsmomo,isqrtpxsmomo,pxsmomo
      real*8 costhmo,sinthmo
      real*8 kappaz
      complex*16 chizs,chizsc

      izi = 0
      if (ilin.eq.0) then
         twl = 0d0
      elseif (ilin.eq.1) then
         twl = 1d0
      endif

      cmz2 = mz2
      spr = s
      qs = -s
      ts = -t
      us = -u
      sq = dsqrt(s)

      s1 = s
      if (dabs(s-mz**2).le.1d-7) s1 = (mz**2-1d-7)

      betasmomo = sqrt(1d0-4d0*mmo**2/s)
      cosf = (t-u)/s/betasmomo
      sinf = dsqrt(1d0-cosf**2)

      sqrtpxsmomo = dsqrt(s-(mmo+mmo)**2)
      isqrtpxsmomo = 1d0/sqrtpxsmomo
      pxsmomo = (sqrtpxsmomo)**2
      costhmo = cosf
      sinthmo = sinf

      kappaz = gf*rzm2/(sqrt(2d0)*8d0*pi)/alpha
      if (irun.eq.0) then
         chizs = 4d0*kappaz*s/(s-cmz2)
      else
         chizs = 4d0*kappaz*s/(s-dcmplx(mz**2,-s*wz/mz))
      endif
      chizsc = dconjg(chizs)

      nsig = pi*alpha**2*conhc/s*betasmomo/2d0

      if (iborn.ne.1) then
         coeff = cfprime*alpha/4d0/pi/stw2

         igzm2 = 1
         call delr(deltar,dr_bos,dr_fer)
         deltar = coeff*deltar
         call UniBosConsts_Bos ()
         call UniBosConsts_Fer ()
         call UniProConsts_fer (-s1)
         call nc_ff_12_12__16_16 (-s1,-t,-u)

         if ((iew.eq.0).and.(iqed.ge.1)) then
            ff_ll = coeff*ffarray(1,1)
            ff_lq = coeff*ffarray(1,3)
            ff_ql = coeff*ffarray(1,5)
            ff_qq = coeff*ffarray(1,7)
            ff_ld = coeff*ffarray(1,9)
            ff_qd = coeff*ffarray(1,11)
            ff_gg = cmplx(0d0,0d0)
            deltaa = 0d0
            deltar = 0d0
         elseif ((iew.eq.1).and.(iqed.eq.0)) then
            ff_ll = coeff*ffarray(1,2)
            ff_lq = coeff*ffarray(1,4)
            ff_ql = coeff*ffarray(1,6)
            ff_qq = coeff*ffarray(1,8)
            ff_ld = coeff*ffarray(1,10)
            ff_qd = coeff*ffarray(1,12)
            ff_gg = coeff*ffarray(1,13)
         elseif ((iew.eq.1).and.(iqed.ge.1)) then
            ff_ll = coeff*(ffarray(1,1)  + ffarray(1,2))
            ff_lq = coeff*(ffarray(1,3)  + ffarray(1,4))
            ff_ql = coeff*(ffarray(1,5)  + ffarray(1,6))
            ff_qq = coeff*(ffarray(1,7)  + ffarray(1,8))
            ff_ld = coeff*(ffarray(1,9)  + ffarray(1,10))
            ff_qd = coeff*(ffarray(1,11) + ffarray(1,12))
            ff_gg = coeff*ffarray(1,13)
         elseif ((iew.eq.0).and.(iqed.eq.0)) then
            ff_ll = cmplx(0d0,0d0)
            ff_lq = cmplx(0d0,0d0)
            ff_ql = cmplx(0d0,0d0)
            ff_qq = cmplx(0d0,0d0)
            ff_ld = cmplx(0d0,0d0)
            ff_qd = cmplx(0d0,0d0)
            ff_gg = coeff*ffarray(1,13)
            deltar = 0d0
         endif

         if (iew.eq.1) then
            if ((gfscheme.ge.1).and.(gfscheme.le.3)) then
               ff_ll = ff_ll-deltar
               ff_ql = ff_ql-deltar
               ff_lq = ff_lq-deltar
               ff_qq = ff_qq-deltar
            endif
            if (gfscheme.eq.4) then
               ff_ll = ff_ll-deltaa
               ff_ql = ff_ql-deltaa
               ff_lq = ff_lq-deltaa
               ff_qq = ff_qq-deltaa
            endif
         endif

         if ((gfscheme.eq.2).or.(gfscheme.eq.3)) ff_gg = ff_gg-deltar
         if (gfscheme.eq.4) ff_gg = ff_gg-deltaa

      elseif (iborn.eq.1) then
         ff_ll = cmplx(0d0,0d0)
         ff_ql = cmplx(0d0,0d0)
         ff_lq = cmplx(0d0,0d0)
         ff_qq = cmplx(0d0,0d0)
         ff_ld = cmplx(0d0,0d0)
         ff_qd = cmplx(0d0,0d0)
         ff_gg = cmplx(0d0,0d0)
      endif

      do iz = izi,1
         zoro = dcmplx(iz,0d0)

         ffll = zoro + ff_ll
         ffql = zoro + ff_ql
         fflq = zoro + ff_lq
         ffqq = zoro + ff_qq
         ffld =        ff_ld
         ffqd =        ff_qd

         if (ifgg.eq.0) then
            ffgg = zoro
         elseif ((ifgg.eq.1).or.(ifgg.eq.3)) then
            ffgg = zoro + ff_gg
         elseif (((ifgg.eq.2).or.(ifgg.eq.4)).and.(gfscheme.eq.0)) then
            ffgg = zoro/(1d0 - ff_gg)
         endif

         if (iz.eq.1) then
            ffarray(2,1) = ffll
            ffarray(2,2) = ffql
            ffarray(2,3) = fflq
            ffarray(2,4) = ffqq
            ffarray(2,5) = ffld
            ffarray(2,6) = ffqd
            ffarray(2,7) = ffgg
         endif

      amp(1,1,1,1) =
     & 0d0

      amp(1,1,1,2) =
     & 0d0

      amp(1,1,2,1) =
     & 0d0

      amp(1,1,2,2) =
     & 0d0

      amp(1,2,1,1) =
     & +chizs*sinthmo/sq*pxsmomo*ffld*(-2*ael*amo*mmo)
     & +chizs*sinthmo/sq*pxsmomo*ffqd*(-vmael*amo*mmo)
     & +chizs*sinthmo/sq*ffqq*(-2*vmael*vmamo*mmo)
     & +chizs*sinthmo/sq*ffll*(-4*ael*amo*mmo)
     & +chizs*sinthmo/sq*fflq*(-4*ael*vmamo*mmo)
     & +chizs*sinthmo/sq*ffql*(-2*vmael*amo*mmo)
     & +sinthmo/sq*ffgg*(-2*qel*qmo*mmo)

      amp(1,2,1,2) =
     & +chizs*costhmo/sq*sqrtpxsmomo*ffll*(-2*ael*amo)
     & +chizs*costhmo/sq*sqrtpxsmomo*ffql*(-vmael*amo)
     & +chizs*costhmo*ffqq*(+vmael*vmamo)
     & +chizs*costhmo*ffll*(+2*ael*amo)
     & +chizs*costhmo*fflq*(+2*ael*vmamo)
     & +chizs*costhmo*ffql*(+vmael*amo)
     & +chizs/sq*sqrtpxsmomo*ffll*(+2*ael*amo)
     & +chizs/sq*sqrtpxsmomo*ffql*(+vmael*amo)
     & +chizs*ffqq*(-vmael*vmamo)
     & +chizs*ffll*(-2*ael*amo)
     & +chizs*fflq*(-2*ael*vmamo)
     & +chizs*ffql*(-vmael*amo)
     & +costhmo*ffgg*(+qel*qmo)
     & +ffgg*(-qel*qmo)

      amp(1,2,2,1) =
     & +chizs*costhmo/sq*sqrtpxsmomo*ffll*(-2*ael*amo)
     & +chizs*costhmo/sq*sqrtpxsmomo*ffql*(-vmael*amo)
     & +chizs*costhmo*ffqq*(-vmael*vmamo)
     & +chizs*costhmo*ffll*(-2*ael*amo)
     & +chizs*costhmo*fflq*(-2*ael*vmamo)
     & +chizs*costhmo*ffql*(-vmael*amo)
     & +chizs/sq*sqrtpxsmomo*ffll*(-2*ael*amo)
     & +chizs/sq*sqrtpxsmomo*ffql*(-vmael*amo)
     & +chizs*ffqq*(-vmael*vmamo)
     & +chizs*ffll*(-2*ael*amo)
     & +chizs*fflq*(-2*ael*vmamo)
     & +chizs*ffql*(-vmael*amo)
     & +costhmo*ffgg*(-qel*qmo)
     & +ffgg*(-qel*qmo)

      amp(1,2,2,2) =
     & +chizs*sinthmo/sq*pxsmomo*ffld*(-2*ael*amo*mmo)
     & +chizs*sinthmo/sq*pxsmomo*ffqd*(-vmael*amo*mmo)
     & +chizs*sinthmo/sq*ffqq*(-2*vmael*vmamo*mmo)
     & +chizs*sinthmo/sq*ffll*(-4*ael*amo*mmo)
     & +chizs*sinthmo/sq*fflq*(-4*ael*vmamo*mmo)
     & +chizs*sinthmo/sq*ffql*(-2*vmael*amo*mmo)
     & +sinthmo/sq*ffgg*(-2*qel*qmo*mmo)

      amp(2,1,1,1) =
     & +chizs*sinthmo/sq*pxsmomo*ffqd*(+vmael*amo*mmo)
     & +chizs*sinthmo/sq*ffqq*(+2*vmael*vmamo*mmo)
     & +chizs*sinthmo/sq*ffql*(+2*vmael*amo*mmo)
     & +sinthmo/sq*ffgg*(+2*qel*qmo*mmo)

      amp(2,1,1,2) =
     & +chizs*costhmo/sq*sqrtpxsmomo*ffql*(+vmael*amo)
     & +chizs*costhmo*ffqq*(-vmael*vmamo)
     & +chizs*costhmo*ffql*(-vmael*amo)
     & +chizs/sq*sqrtpxsmomo*ffql*(+vmael*amo)
     & +chizs*ffqq*(-vmael*vmamo)
     & +chizs*ffql*(-vmael*amo)
     & +costhmo*ffgg*(-qel*qmo)
     & +ffgg*(-qel*qmo)

      amp(2,1,2,1) =
     & +chizs*costhmo/sq*sqrtpxsmomo*ffql*(+vmael*amo)
     & +chizs*costhmo*ffqq*(+vmael*vmamo)
     & +chizs*costhmo*ffql*(+vmael*amo)
     & +chizs/sq*sqrtpxsmomo*ffql*(-vmael*amo)
     & +chizs*ffqq*(-vmael*vmamo)
     & +chizs*ffql*(-vmael*amo)
     & +costhmo*ffgg*(+qel*qmo)
     & +ffgg*(-qel*qmo)

      amp(2,1,2,2) =
     & +chizs*sinthmo/sq*pxsmomo*ffqd*(+vmael*amo*mmo)
     & +chizs*sinthmo/sq*ffqq*(+2*vmael*vmamo*mmo)
     & +chizs*sinthmo/sq*ffql*(+2*vmael*amo*mmo)
     & +sinthmo/sq*ffgg*(+2*qel*qmo*mmo)

      amp(2,2,1,1) =
     & 0d0

      amp(2,2,1,2) =
     & 0d0

      amp(2,2,2,1) =
     & 0d0

      amp(2,2,2,2) =
     & 0d0

         do i = 1,2
            do j = 1,2
               sum = 0d0
               do k = 1,2
                  do l = 1,2
                     sum = sum + amp(i,j,k,l)*conjg(amp(i,j,k,l))
                  enddo
               enddo
               amp2_(iz+1,i,j) = sum
            enddo
         enddo
      enddo

      do i = 1,2
         do j = 1,2
            amp2(i,j) = amp2_(2,i,j)-twl*amp2_(1,i,j)
         enddo
      enddo

      if (alr.eq.0) then
         sigma =
     &       (+(1+lamep)*(1+lamem)*amp2(1,1)
     &        +(1+lamep)*(1-lamem)*amp2(1,2)
     &        +(1-lamep)*(1+lamem)*amp2(2,1)
     &        +(1-lamep)*(1-lamem)*amp2(2,2))/4d0
      elseif (alr.eq.1) then
         sigma =
     &        +(amp2(1,2)-amp2(2,1))
      elseif (alr.eq.2) then
         sigma =
     &        +(amp2(1,2)+amp2(2,1))
      endif

      sigma = nsig*sigma
      if (sigma.ne.sigma) print *,'Sigma NAN!!!',s,t,u
!      if (sigma.gt.1e9)  print *,'Virt Inf',s,t,u, sigma,amp2(1,2,2,1),ffll,ffql,fflq

      return
      end
