#include "OF_LHEF.h"
#include "Info.h"
#include "Process.h"

using namespace SANC;

OF_LHEF::OF_LHEF(Info & _info, Process & _proc):OutputFormat(_info, _proc),lhef(LHEF(info))
{
    lhef.hepeup.nup = 5;
    lhef.hepeup.idprup = 10001;
    lhef.hepeup.xwgtup = lhef.hepeup.xwgtup;
    lhef.hepeup.scalup = -1;
    // lhef.hepeup.aqedup = consts_.alpha;
    // lhef.hepeup.aqcdup = consts_.alphas;

    lhef.hepeup.idup[0] = proc.idup[0];
    lhef.hepeup.idup[1] = proc.idup[1];
	lhef.hepeup.idup[2] = proc.idup[2];
	lhef.hepeup.idup[3] = proc.idup[3];
    lhef.hepeup.idup[4] = 22;

    lhef.hepeup.istup[0] = -1;
    lhef.hepeup.istup[1] = -1;
    lhef.hepeup.istup[2] = 1;
    lhef.hepeup.istup[3] = 1;
    lhef.hepeup.istup[4] = 1;

    lhef.hepeup.mothup[0][0] = 0;
    lhef.hepeup.mothup[1][0] = 0;
    lhef.hepeup.mothup[2][0] = 1;
    lhef.hepeup.mothup[3][0] = 1;
    lhef.hepeup.mothup[4][0] = 1;

    lhef.hepeup.mothup[0][1] = 0;
    lhef.hepeup.mothup[1][1] = 0;
    lhef.hepeup.mothup[2][1] = 2;
    lhef.hepeup.mothup[3][1] = 2;
    lhef.hepeup.mothup[4][1] = 2;

    lhef.hepeup.icolup[0][0] = 0;
    lhef.hepeup.icolup[1][0] = 0;
    lhef.hepeup.icolup[2][0] = 0;
    lhef.hepeup.icolup[3][0] = 0;
    lhef.hepeup.icolup[4][0] = 0;

    lhef.hepeup.icolup[0][1] = 0;
    lhef.hepeup.icolup[1][1] = 0;
    lhef.hepeup.icolup[2][1] = 0;
    lhef.hepeup.icolup[3][1] = 0;
    lhef.hepeup.icolup[4][1] = 0;

    lhef.hepeup.vtimup[0] = 1.0;
    lhef.hepeup.vtimup[1] = 1.0;
    lhef.hepeup.vtimup[2] = 1.0;
    lhef.hepeup.vtimup[3] = 1.0;
    lhef.hepeup.vtimup[4] = 1.0;

    lhef.hepeup.spinup[0] = 9.0;
    lhef.hepeup.spinup[1] = 9.0;
    lhef.hepeup.spinup[2] = 9.0;
    lhef.hepeup.spinup[3] = 9.0;
    lhef.hepeup.spinup[4] = 9.0;
}

void OF_LHEF::setOutput(std::ostream * _output) {
    output = _output;
}

void OF_LHEF::start() {
    lhef.printInit(*output);
}

void OF_LHEF::writeEvent() {
    lhef.hepeup.pup[0][0] = proc.event.P(0).px();
    lhef.hepeup.pup[1][0] = proc.event.P(1).px();
    lhef.hepeup.pup[2][0] = proc.event.P(2).px();
    lhef.hepeup.pup[3][0] = proc.event.P(3).px();
    lhef.hepeup.pup[4][0] = proc.event.P(4).px();

    lhef.hepeup.pup[0][1] = proc.event.P(0).py();
    lhef.hepeup.pup[1][1] = proc.event.P(1).py();
    lhef.hepeup.pup[2][1] = proc.event.P(2).py();
    lhef.hepeup.pup[3][1] = proc.event.P(3).py();
    lhef.hepeup.pup[4][1] = proc.event.P(4).py();

    lhef.hepeup.pup[0][2] = proc.event.P(0).pz();
    lhef.hepeup.pup[1][2] = proc.event.P(1).pz();
    lhef.hepeup.pup[2][2] = proc.event.P(2).pz();
    lhef.hepeup.pup[3][2] = proc.event.P(3).pz();
    lhef.hepeup.pup[4][2] = proc.event.P(4).pz();

    lhef.hepeup.pup[0][3] = proc.event.P(0).e();
    lhef.hepeup.pup[1][3] = proc.event.P(1).e();
    lhef.hepeup.pup[2][3] = proc.event.P(2).e();
    lhef.hepeup.pup[3][3] = proc.event.P(3).e();
    lhef.hepeup.pup[4][3] = proc.event.P(4).e();

    lhef.hepeup.pup[0][4] = proc.event.P(0).m();
    lhef.hepeup.pup[1][4] = proc.event.P(1).m();
    lhef.hepeup.pup[2][4] = proc.event.P(2).m();
    lhef.hepeup.pup[3][4] = proc.event.P(3).m();
    lhef.hepeup.pup[4][4] = proc.event.P(4).m();
    lhef.printEvent(*output);
}

void OF_LHEF::finish() {

}