#include "Settings.h"
#include "General.h"

using namespace SANC;

Settings::Settings() {
    if(const char* env_p = std::getenv("RENESANCE_ROOT")) {
        prefix = env_p;
        schema_file = prefix+std::string("/share/renesance/schema/renesance.schema");
        if (!file_exists(schema_file)) {
            std::cerr<<"Attension! Schema file not found!\n"
                       "Wrong value of RENESANCE_ROOT env variable.\n";
            exit(11);
        }
    }
    else {
        prefix = RENESANCE_ROOT;
        schema_file = prefix+std::string("/share/renesance/schema/renesance.schema");
        if (!file_exists(schema_file)) {
            std::cerr<<"Attension! Schema file\n"
                     << schema_file << "\n"
                        "not found.\n"
                        "ReneSANCe installation folder was moved or corrupted.\n"
                        "Please, run \"source bin/init.sh\" or setup RENESANCE_ROOT env variable.\n";
            exit(11);
        }
    }
}

Settings::~Settings() {}

void Settings::setPath(string _path)
{
    input_file = _path;
}
