************************************************************************
* sanc_nc_v2.00 package.
************************************************************************
* File (nc_ff_12_12__16_16.F) is created on Сб янв 27 21:46:54 MSK 2018.
************************************************************************
* This is the FORTRAN module (nc_ff_12_12__16_16) to calculate 1-loop EW
* form factors for the el^- + el^- -> mo^- + mo^- process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2018.
*
* http://sanc.jinr.ru/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine nc_ff_12_12__16_16 (qs,ts,us)
      implicit none!
#include "looptools.h"
#include "s2n_declare.h"

      complex*16 ff_qed_ll,ff_qed_lq,ff_qed_ql,ff_qed_qq,ff_qed_ld
      complex*16 ff_qed_qd,ff_ew_ll,ff_ew_ld,ff_ew_lq,ff_ew_ql,ff_ew_qq
      complex*16 ff_ew_qd,ff_qed_gg

      real*8 det3imomoqs
      real*8 a0fel,a0fmo,a0fw,a0fz,a0fh
      real*8 lnlamom,lnlaelm
      complex*16 b0pmozmo,b0pmohmo,b0pmocw
      complex*16 b0fqscc,b0ftsmoc,b0fusmoc,b0fmozmo,b0fmomoc,b0fqszc,b0
     & fqsmomo,b0fmowc,b0fmohmo,b0fqsww,b0fqszh,b0fqszz,b0ftscc
      complex*16 c0elelqszelc,c0momoqszmoc,c0momoqscmoc,c0cmotsczmo,c0i
     & relmots,c0cmousczmo,c0irelmous,c0elelqscelc,c0irmomoqs,c0irelelqs
     & ,c0irmoelts,c0irmoelus,c0ccqszcz,c0momoqszmoz,c0momoqswcw,c0momoq
     & szmoh,c0momoqsmozmo,c0momoqsmohmo,c0momoqscwc,c0cmotscwc,c0ccqswc
     & w,c0ccqscwc,c0ccqsczc
      complex*16 b0d1momoz
      complex*16 b0dwmocw
      complex*16 d0ccmomoqstszczmo,d0ccmomoqsuszczmo,d0ccmomoqstswcwc
      complex*16 jaaqstselmo,jaaqsuselmo,javqstselmoz,javqsuselmoz
      real*8 sdet3icmots,sdet3icmous,sdet4imotsus,sdet3imomoqs
      real*8 sdet3cmots,sdet3cmous
      real*8 pxx2zqsc
      complex*16 propzqs,propizqs,prop1zqs
      complex*16 b0fzww,b0fzzh
      real*8 der,errdersta,errdersys,deg,errdegsta,errdegsys

      common/unibos_bos/za1bos,zmzzzbos,zmwzwbos,zmhzhbos,deltarhobos
      common/unibos_fer/za1fer,zz1fer,zh1fer,zw1fer,zmsqrfer,
     & zmzzzfer,zmwzwfer,zmhzhfer,deltarhofer,tadfer
      common/unipro_fer/caldzfer,caldwfer,pizgfer,piggfer
      common/unipro_fer_d/piggferl,piggferh,piggfert
      common/unibos_fer_d/za1ferl,za1ferh,za1fert

      cmz2 = mz2

      if (irun.eq.0) then
         prop1zqs = (cmz2+qs)
      else
         prop1zqs = (dcmplx(mz**2,qs*wz/mz)+qs)
      endif
      propizqs = (rzm2+qs)
      propzqs = 1d0/propizqs
      det3imomoqs = 1d0/(-1d0/4d0*((-rmom2)**2+(-rmom2)**2+(qs)**2
     & -2d0*(-rmom2)*(-rmom2)-2d0*(-rmom2)*(qs)
     & -2d0*(-rmom2)*(qs)))
      a0fel = log(relm2/thmu2) - 1d0
      a0fmo = log(rmom2/thmu2) - 1d0
      a0fw = log(rwm2/thmu2) - 1d0
      a0fz = log(rzm2/thmu2) - 1d0
      a0fh = log(rhm2/thmu2) - 1d0
      lnlamom = log(rmom2/tlmu2)
      lnlaelm = log(relm2/tlmu2)
      b0pmozmo = b0p(-rmom2,zm2,mom2)
      b0pmohmo = b0p(-rmom2,hm2,mom2)
      b0pmocw = b0p(-rmom2,cm2,wm2)
      b0fqscc = b0f(qs,thmu2,cm2,cm2)
      b0ftsmoc = b0f(ts,thmu2,mom2,cm2)
      b0fusmoc = b0f(us,thmu2,mom2,cm2)
      b0fmozmo = b0f(-rmom2,thmu2,zm2,mom2)
      b0fmomoc = b0f(-rmom2,thmu2,mom2,cm2)
      b0fqszc = b0f(qs,thmu2,zm2,cm2)
      b0fqsmomo = b0f(qs,thmu2,mom2,mom2)
      b0fmowc = b0f(-rmom2,thmu2,wm2,cm2)
      b0fmohmo = b0f(-rmom2,thmu2,hm2,mom2)
      b0fqsww = b0f(qs,thmu2,wm2,wm2)
      b0fqszh = b0f(qs,thmu2,zm2,hm2)
      b0fqszz = b0f(qs,thmu2,zm2,zm2)
      b0ftscc = b0f(ts,thmu2,cm2,cm2)
      c0elelqszelc = -c0(relm2,relm2,-qs,rzm2,relm2,0d0)
      c0momoqszmoc = -c0(rmom2,rmom2,-qs,rzm2,rmom2,0d0)
      c0momoqscmoc = -c0(rmom2,rmom2,-qs,0d0,rmom2,0d0)
      c0cmotsczmo = -c0(0d0,rmom2,-ts,0d0,rzm2,rmom2)
      c0irelmots = c0ir(tlmu2,elm2,mom2,ts)
      c0cmousczmo = -c0(0d0,rmom2,-us,0d0,rzm2,rmom2)
      c0irelmous = c0ir(tlmu2,elm2,mom2,us)
      c0elelqscelc = -c0(relm2,relm2,-qs,0d0,relm2,0d0)
      c0irmomoqs = c0ir(tlmu2,mom2,mom2,qs)
      c0irelelqs = c0ir(tlmu2,elm2,elm2,qs)
      c0irmoelts = c0ir(tlmu2,mom2,elm2,ts)
      c0irmoelus = c0ir(tlmu2,mom2,elm2,us)
      c0ccqszcz = -c0(0d0,0d0,-qs,rzm2,0d0,rzm2)
      c0momoqszmoz = -c0(rmom2,rmom2,-qs,rzm2,rmom2,rzm2)
      c0momoqswcw = -c0(rmom2,rmom2,-qs,rwm2,0d0,rwm2)
      c0momoqszmoh = -c0(rmom2,rmom2,-qs,rzm2,rmom2,rhm2)
      c0momoqsmozmo = -c0(rmom2,rmom2,-qs,rmom2,rzm2,rmom2)
      c0momoqsmohmo = -c0(rmom2,rmom2,-qs,rmom2,rhm2,rmom2)
      c0momoqscwc = -c0(rmom2,rmom2,-qs,0d0,rwm2,0d0)
      c0cmotscwc = -c0(0d0,rmom2,-ts,0d0,rwm2,0d0)
      c0ccqswcw = -c0(0d0,0d0,-qs,rwm2,0d0,rwm2)
      c0ccqscwc = -c0(0d0,0d0,-qs,0d0,rwm2,0d0)
      c0ccqsczc = -c0(0d0,0d0,-qs,0d0,rzm2,0d0)
      b0d1momoz = b0d1(-rmom2,thmu2,mom2,zm2)
      b0dwmocw = b0dw(-rmom2,thmu2,cm2,wm2)
      d0ccmomoqstszczmo =
     & d0(0d0,0d0,rmom2,rmom2,-qs,-ts,rzm2,0d0,rzm2,rmom2)
      d0ccmomoqsuszczmo =
     & d0(0d0,0d0,rmom2,rmom2,-qs,-us,rzm2,0d0,rzm2,rmom2)
      d0ccmomoqstswcwc =
     & d0(0d0,0d0,rmom2,rmom2,-qs,-ts,rwm2,0d0,rwm2,0d0)
      jaaqstselmo = jaa(qs,ts,elm2,mom2)
      jaaqsuselmo = jaa(qs,us,elm2,mom2)
      javqstselmoz = jav(qs,ts,elm2,mom2,cmz2)
      javqsuselmoz = jav(qs,us,elm2,mom2,cmz2)
      sdet3icmots = 1d0/(ts+(mmo)**2)
      sdet3icmous = 1d0/(us+(mmo)**2)
      sdet4imotsus = 1d0/(ts*us-mmo**4)
      sdet3imomoqs = 1d0/(qs+(mmo+mmo)**2)
      sdet3cmots = (ts+mmo**2)
      sdet3cmous = (us+mmo**2)
      pxx2zqsc = (2*mz**2)+(qs)

      if (ifgg.le.2) then
         ff_qed_gg =
     &      -za1fer+stw**2*piggfer
      else
         call dhadr5x19(sqrt(-qs),0d0,der,errdersta,errdersys,deg,errdegsta,errdegsys)
         ff_qed_gg =
     &      -za1ferl+stw**2*piggferl-za1fert+stw**2*piggfert+der/alpha*4d0*pi*stw2
      endif

      ff_qed_ll =
     & +stw**2*(-qmo**2-qel**2+2*det3imomoqs*qmo**2*qs*mmo**2)
     & +sdet3cmots**3*sdet4imotsus**2*jaaqstselmo*dreal(propizqs)*stw**4
     & *cfscheme*(8*ctw**2*qel**2*qmo**2*us-8*ctw**2*qel**2*qmo**2*ts)
     & +sdet3cmots**2*sdet4imotsus**2*c0elelqszelc*dreal(propizqs)*stw**
     & 2*(2*qel*qmo*mz**2*mmo**2-2*qel*qmo*ts*mz**2+2*qel*qmo*qs*mmo**2-
     & 2*qel*qmo*qs*ts-2*qel*qmo*vmamo*mz**2*mmo**2+2*qel*qmo*vmamo*ts*m
     & z**2-2*qel*qmo*vmamo*qs*mmo**2+2*qel*qmo*vmamo*qs*ts-2*qel*vmael*
     & qmo*mz**2*mmo**2+2*qel*vmael*qmo*ts*mz**2-2*qel*vmael*qmo*qs*mmo*
     & *2+2*qel*vmael*qmo*qs*ts+4*qel*vmael*qmo*vmamo*mz**2*mmo**2-4*qel
     & *vmael*qmo*vmamo*ts*mz**2+4*qel*vmael*qmo*vmamo*qs*mmo**2-4*qel*v
     & mael*qmo*vmamo*qs*ts)
     & +sdet3cmots*sdet4imotsus**2*javqstselmoz*dreal(propizqs)*stw**2*(
     & -2*qel*qmo*mz**2*mmo**4+2*qel*qmo*ts**2*mz**2-2*qel*qmo*qs*mmo**4
     & +2*qel*qmo*qs*ts**2+2*qel*qmo*vmamo*mz**2*mmo**4-2*qel*qmo*vmamo*
     & ts**2*mz**2+2*qel*qmo*vmamo*qs*mmo**4-2*qel*qmo*vmamo*qs*ts**2+2*
     & qel*vmael*qmo*mz**2*mmo**4-2*qel*vmael*qmo*ts**2*mz**2+2*qel*vmae
     & l*qmo*qs*mmo**4-2*qel*vmael*qmo*qs*ts**2-4*qel*vmael*qmo*vmamo*mz
     & **2*mmo**4+4*qel*vmael*qmo*vmamo*ts**2*mz**2-4*qel*vmael*qmo*vmam
     & o*qs*mmo**4+4*qel*vmael*qmo*vmamo*qs*ts**2)
     & +sdet3cmots*sdet4imotsus**2*c0momoqszmoc*dreal(propizqs)*stw**2*(
     & 2*qel*qmo*mz**2*mmo**4-2*qel*qmo*us*mz**2*mmo**2+2*qel*qmo*ts*mz*
     & *2*mmo**2-2*qel*qmo*ts**2*mz**2+2*qel*qmo*qs*mmo**4-2*qel*qmo*qs*
     & us*mmo**2+2*qel*qmo*qs*ts*mmo**2-2*qel*qmo*qs*ts**2-2*qel*qmo*vma
     & mo*mz**2*mmo**4+2*qel*qmo*vmamo*us*mz**2*mmo**2-2*qel*qmo*vmamo*t
     & s*mz**2*mmo**2+2*qel*qmo*vmamo*ts**2*mz**2-2*qel*qmo*vmamo*qs*mmo
     & **4+2*qel*qmo*vmamo*qs*us*mmo**2-2*qel*qmo*vmamo*qs*ts*mmo**2+2*q
     & el*qmo*vmamo*qs*ts**2-2*qel*vmael*qmo*mz**2*mmo**4+2*qel*vmael*qm
     & o*us*mz**2*mmo**2-2*qel*vmael*qmo*ts*mz**2*mmo**2+2*qel*vmael*qmo
     & *ts**2*mz**2-2*qel*vmael*qmo*qs*mmo**4+2*qel*vmael*qmo*qs*us*mmo*
     & *2-2*qel*vmael*qmo*qs*ts*mmo**2+2*qel*vmael*qmo*qs*ts**2+4*qel*vm
     & ael*qmo*vmamo*mz**2*mmo**4-4*qel*vmael*qmo*vmamo*us*mz**2*mmo**2+
     & 4*qel*vmael*qmo*vmamo*ts*mz**2*mmo**2-4*qel*vmael*qmo*vmamo*ts**2
     & *mz**2+4*qel*vmael*qmo*vmamo*qs*mmo**4-4*qel*vmael*qmo*vmamo*qs*u
     & s*mmo**2+4*qel*vmael*qmo*vmamo*qs*ts*mmo**2-4*qel*vmael*qmo*vmamo
     & *qs*ts**2)
     & +sdet3cmots*sdet4imotsus**2*c0momoqscmoc*dreal(propizqs)*stw**4*c
     & fscheme*(64*ctw**2*qel**2*qmo**2*qs*mmo**4+16*ctw**2*qel**2*qmo**
     & 2*qs**2*mmo**2)
     & +sdet3cmots*sdet4imotsus**2*c0elelqszelc*dreal(propizqs)*stw**2*(
     & 2*qel*qmo*us*mz**2*mmo**2-2*qel*qmo*ts*mz**2*mmo**2+2*qel*qmo*qs*
     & us*mmo**2-2*qel*qmo*qs*ts*mmo**2-2*qel*qmo*vmamo*us*mz**2*mmo**2+
     & 2*qel*qmo*vmamo*ts*mz**2*mmo**2-2*qel*qmo*vmamo*qs*us*mmo**2+2*qe
     & l*qmo*vmamo*qs*ts*mmo**2-2*qel*vmael*qmo*us*mz**2*mmo**2+2*qel*vm
     & ael*qmo*ts*mz**2*mmo**2-2*qel*vmael*qmo*qs*us*mmo**2+2*qel*vmael*
     & qmo*qs*ts*mmo**2+4*qel*vmael*qmo*vmamo*us*mz**2*mmo**2-4*qel*vmae
     & l*qmo*vmamo*ts*mz**2*mmo**2+4*qel*vmael*qmo*vmamo*qs*us*mmo**2-4*
     & qel*vmael*qmo*vmamo*qs*ts*mmo**2)
     & +sdet3cmots*sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*stw**2*(-
     & 4*qel*qmo*mz**2*mmo**4+4*qel*qmo*ts**2*mz**2-4*qel*qmo*qs*mmo**4+
     & 4*qel*qmo*qs*ts**2+4*qel*qmo*vmamo*mz**2*mmo**4-4*qel*qmo*vmamo*t
     & s**2*mz**2+4*qel*qmo*vmamo*qs*mmo**4-4*qel*qmo*vmamo*qs*ts**2+4*q
     & el*vmael*qmo*mz**2*mmo**4-4*qel*vmael*qmo*ts**2*mz**2+4*qel*vmael
     & *qmo*qs*mmo**4-4*qel*vmael*qmo*qs*ts**2-8*qel*vmael*qmo*vmamo*mz*
     & *2*mmo**4+8*qel*vmael*qmo*vmamo*ts**2*mz**2-8*qel*vmael*qmo*vmamo
     & *qs*mmo**4+8*qel*vmael*qmo*vmamo*qs*ts**2)
     & +sdet3cmots*sdet4imotsus*javqstselmoz*dreal(propizqs)*stw**2*(4*q
     & el*qmo*ts-4*qel*qmo*vmamo*ts-4*qel*vmael*qmo*ts+8*qel*vmael*qmo*v
     & mamo*ts)
     & +sdet3cmots*sdet4imotsus*c0momoqszmoc*dreal(propizqs)*stw**2*(-4*
     & qel*qmo/qs*mz**2*mmo**2-4*qel*qmo*mmo**2+4*qel*qmo*vmamo/qs*mz**2
     & *mmo**2+4*qel*qmo*vmamo*mmo**2+4*qel*vmael*qmo/qs*mz**2*mmo**2+4*
     & qel*vmael*qmo*mmo**2-8*qel*vmael*qmo*vmamo/qs*mz**2*mmo**2-8*qel*
     & vmael*qmo*vmamo*mmo**2)
     & +sdet3cmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*stw**2*(4*qe
     & l*qmo/qs*mz**2*mmo**2+8*qel*qmo*ts-4*qel*qmo*vmamo/qs*mz**2*mmo**
     & 2-8*qel*qmo*vmamo*ts-4*qel*vmael*qmo/qs*mz**2*mmo**2-8*qel*vmael*
     & qmo*ts+8*qel*vmael*qmo*vmamo/qs*mz**2*mmo**2+16*qel*vmael*qmo*vma
     & mo*ts)
     & +sdet3cmots*sdet4imotsus*b0fqscc*dreal(propizqs)*stw**4*cfscheme*
     & (-16*ctw**2*qel**2*qmo**2)
     & +sdet3cmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*stw**4*cfscheme
     & *(16*ctw**2*qel**2*qmo**2)
     & +sdet3cmots*javqstselmoz*stw**2*(4*qel*qmo)
     & +sdet3cmots*c0irelmots*stw**2*(-4*qel*qmo)
     & +sdet3cmots*c0cmotsczmo*stw**2*(4*qel*qmo)
     & +sdet3cmous**3*sdet4imotsus**2*jaaqsuselmo*dreal(propizqs)*stw**4
     & *cfscheme*(-8*ctw**2*qel**2*qmo**2*us+8*ctw**2*qel**2*qmo**2*ts)
     & +sdet3cmous**2*sdet4imotsus**2*c0elelqszelc*dreal(propizqs)*stw**
     & 2*(-2*qel*qmo*vmamo*mz**2*mmo**2+2*qel*qmo*vmamo*us*mz**2-2*qel*q
     & mo*vmamo*qs*mmo**2+2*qel*qmo*vmamo*qs*us-2*qel*vmael*qmo*mz**2*mm
     & o**2+2*qel*vmael*qmo*us*mz**2-2*qel*vmael*qmo*qs*mmo**2+2*qel*vma
     & el*qmo*qs*us+4*qel*vmael*qmo*vmamo*mz**2*mmo**2-4*qel*vmael*qmo*v
     & mamo*us*mz**2+4*qel*vmael*qmo*vmamo*qs*mmo**2-4*qel*vmael*qmo*vma
     & mo*qs*us)
     & +sdet3cmous*sdet4imotsus**2*javqsuselmoz*dreal(propizqs)*stw**2*(
     & 2*qel*qmo*vmamo*mz**2*mmo**4-2*qel*qmo*vmamo*us**2*mz**2+2*qel*qm
     & o*vmamo*qs*mmo**4-2*qel*qmo*vmamo*qs*us**2+2*qel*vmael*qmo*mz**2*
     & mmo**4-2*qel*vmael*qmo*us**2*mz**2+2*qel*vmael*qmo*qs*mmo**4-2*qe
     & l*vmael*qmo*qs*us**2-4*qel*vmael*qmo*vmamo*mz**2*mmo**4+4*qel*vma
     & el*qmo*vmamo*us**2*mz**2-4*qel*vmael*qmo*vmamo*qs*mmo**4+4*qel*vm
     & ael*qmo*vmamo*qs*us**2)
     & +sdet3cmous*sdet4imotsus**2*c0momoqszmoc*dreal(propizqs)*stw**2*(
     & -2*qel*qmo*vmamo*mz**2*mmo**4-2*qel*qmo*vmamo*us*mz**2*mmo**2+2*q
     & el*qmo*vmamo*us**2*mz**2+2*qel*qmo*vmamo*ts*mz**2*mmo**2-2*qel*qm
     & o*vmamo*qs*mmo**4-2*qel*qmo*vmamo*qs*us*mmo**2+2*qel*qmo*vmamo*qs
     & *us**2+2*qel*qmo*vmamo*qs*ts*mmo**2-2*qel*vmael*qmo*mz**2*mmo**4-
     & 2*qel*vmael*qmo*us*mz**2*mmo**2+2*qel*vmael*qmo*us**2*mz**2+2*qel
     & *vmael*qmo*ts*mz**2*mmo**2-2*qel*vmael*qmo*qs*mmo**4-2*qel*vmael*
     & qmo*qs*us*mmo**2+2*qel*vmael*qmo*qs*us**2+2*qel*vmael*qmo*qs*ts*m
     & mo**2+4*qel*vmael*qmo*vmamo*mz**2*mmo**4+4*qel*vmael*qmo*vmamo*us
     & *mz**2*mmo**2-4*qel*vmael*qmo*vmamo*us**2*mz**2-4*qel*vmael*qmo*v
     & mamo*ts*mz**2*mmo**2+4*qel*vmael*qmo*vmamo*qs*mmo**4+4*qel*vmael*
     & qmo*vmamo*qs*us*mmo**2-4*qel*vmael*qmo*vmamo*qs*us**2-4*qel*vmael
     & *qmo*vmamo*qs*ts*mmo**2)
     & +sdet3cmous*sdet4imotsus**2*c0momoqscmoc*dreal(propizqs)*stw**4*c
     & fscheme*(64*ctw**2*qel**2*qmo**2*qs*mmo**4+16*ctw**2*qel**2*qmo**
     & 2*qs**2*mmo**2)
     & +sdet3cmous*sdet4imotsus**2*c0elelqszelc*dreal(propizqs)*stw**2*(
     & 2*qel*qmo*vmamo*us*mz**2*mmo**2-2*qel*qmo*vmamo*ts*mz**2*mmo**2+2
     & *qel*qmo*vmamo*qs*us*mmo**2-2*qel*qmo*vmamo*qs*ts*mmo**2+2*qel*vm
     & ael*qmo*us*mz**2*mmo**2-2*qel*vmael*qmo*ts*mz**2*mmo**2+2*qel*vma
     & el*qmo*qs*us*mmo**2-2*qel*vmael*qmo*qs*ts*mmo**2-4*qel*vmael*qmo*
     & vmamo*us*mz**2*mmo**2+4*qel*vmael*qmo*vmamo*ts*mz**2*mmo**2-4*qel
     & *vmael*qmo*vmamo*qs*us*mmo**2+4*qel*vmael*qmo*vmamo*qs*ts*mmo**2)
     &
     & +sdet3cmous*sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*stw**2*(4
     & *qel*qmo*vmamo*mz**2*mmo**4-4*qel*qmo*vmamo*us**2*mz**2+4*qel*qmo
     & *vmamo*qs*mmo**4-4*qel*qmo*vmamo*qs*us**2+4*qel*vmael*qmo*mz**2*m
     & mo**4-4*qel*vmael*qmo*us**2*mz**2+4*qel*vmael*qmo*qs*mmo**4-4*qel
     & *vmael*qmo*qs*us**2-8*qel*vmael*qmo*vmamo*mz**2*mmo**4+8*qel*vmae
     & l*qmo*vmamo*us**2*mz**2-8*qel*vmael*qmo*vmamo*qs*mmo**4+8*qel*vma
     & el*qmo*vmamo*qs*us**2)
     & +sdet3cmous*sdet4imotsus*javqsuselmoz*dreal(propizqs)*stw**2*(-4*
     & qel*qmo*vmamo*us-4*qel*vmael*qmo*us+8*qel*vmael*qmo*vmamo*us)
     & +sdet3cmous*sdet4imotsus*c0momoqszmoc*dreal(propizqs)*stw**2*(4*q
     & el*qmo*vmamo/qs*mz**2*mmo**2+4*qel*qmo*vmamo*mmo**2+4*qel*vmael*q
     & mo/qs*mz**2*mmo**2+4*qel*vmael*qmo*mmo**2-8*qel*vmael*qmo*vmamo/q
     & s*mz**2*mmo**2-8*qel*vmael*qmo*vmamo*mmo**2)
     & +sdet3cmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*stw**2*(-4*q
     & el*qmo*vmamo/qs*mz**2*mmo**2-8*qel*qmo*vmamo*us-4*qel*vmael*qmo/q
     & s*mz**2*mmo**2-8*qel*vmael*qmo*us+8*qel*vmael*qmo*vmamo/qs*mz**2*
     & mmo**2+16*qel*vmael*qmo*vmamo*us)
     & +sdet3cmous*sdet4imotsus*b0fqscc*dreal(propizqs)*stw**4*cfscheme*
     & (-16*ctw**2*qel**2*qmo**2)
     & +sdet3cmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*stw**4*cfscheme
     & *(16*ctw**2*qel**2*qmo**2)
     & +sdet3cmous*javqsuselmoz*stw**2*(-4*qel*qmo)
     & +sdet3cmous*c0irelmous*stw**2*(4*qel*qmo)
     & +sdet3cmous*c0cmousczmo*stw**2*(-4*qel*qmo)
     & +sdet3icmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*stw**2*(4*q
     & el*qmo*ts*mz**2*mmo**2-4*qel*qmo*vmamo*ts*mz**2*mmo**2-4*qel*vmae
     & l*qmo*ts*mz**2*mmo**2+8*qel*vmael*qmo*vmamo*ts*mz**2*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*stw**2*(4*qel*
     & qmo*mmo**4+4*qel*qmo*ts*mmo**2-4*qel*qmo*vmamo*mmo**4-4*qel*qmo*v
     & mamo*ts*mmo**2-4*qel*vmael*qmo*mmo**4-4*qel*vmael*qmo*ts*mmo**2+8
     & *qel*vmael*qmo*vmamo*mmo**4+8*qel*vmael*qmo*vmamo*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0fmomoc*dreal(propizqs)*stw**2*(4*qel*
     & qmo*mmo**4+4*qel*qmo*ts*mmo**2-4*qel*qmo*vmamo*mmo**4-4*qel*qmo*v
     & mamo*ts*mmo**2-4*qel*vmael*qmo*mmo**4-4*qel*vmael*qmo*ts*mmo**2+8
     & *qel*vmael*qmo*vmamo*mmo**4+8*qel*vmael*qmo*vmamo*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*stw**2*(-8*qel
     & *qmo*mmo**4-8*qel*qmo*ts*mmo**2+8*qel*qmo*vmamo*mmo**4+8*qel*qmo*
     & vmamo*ts*mmo**2+8*qel*vmael*qmo*mmo**4+8*qel*vmael*qmo*ts*mmo**2-
     & 16*qel*vmael*qmo*vmamo*mmo**4-16*qel*vmael*qmo*vmamo*ts*mmo**2)
     & +sdet3icmots*c0cmotsczmo*dreal(propizqs)*stw**2*(4*qel*qmo/qs*mz*
     & *2*mmo**2-4*qel*qmo*vmamo/qs*mz**2*mmo**2-4*qel*vmael*qmo/qs*mz**
     & 2*mmo**2+8*qel*vmael*qmo*vmamo/qs*mz**2*mmo**2)
     & +sdet3icmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*stw**2*(-4*
     & qel*qmo*vmamo*us*mz**2*mmo**2-4*qel*vmael*qmo*us*mz**2*mmo**2+8*q
     & el*vmael*qmo*vmamo*us*mz**2*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*stw**2*(-4*qel
     & *qmo*vmamo*mmo**4-4*qel*qmo*vmamo*us*mmo**2-4*qel*vmael*qmo*mmo**
     & 4-4*qel*vmael*qmo*us*mmo**2+8*qel*vmael*qmo*vmamo*mmo**4+8*qel*vm
     & ael*qmo*vmamo*us*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fmomoc*dreal(propizqs)*stw**2*(-4*qel
     & *qmo*vmamo*mmo**4-4*qel*qmo*vmamo*us*mmo**2-4*qel*vmael*qmo*mmo**
     & 4-4*qel*vmael*qmo*us*mmo**2+8*qel*vmael*qmo*vmamo*mmo**4+8*qel*vm
     & ael*qmo*vmamo*us*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*stw**2*(8*qel*
     & qmo*vmamo*mmo**4+8*qel*qmo*vmamo*us*mmo**2+8*qel*vmael*qmo*mmo**4
     & +8*qel*vmael*qmo*us*mmo**2-16*qel*vmael*qmo*vmamo*mmo**4-16*qel*v
     & mael*qmo*vmamo*us*mmo**2)
     & +sdet3icmous*c0cmousczmo*dreal(propizqs)*stw**2*(-4*qel*qmo*vmamo
     & /qs*mz**2*mmo**2-4*qel*vmael*qmo/qs*mz**2*mmo**2+8*qel*vmael*qmo*
     & vmamo/qs*mz**2*mmo**2)
     & +sdet4imotsus**2*c0momoqscmoc*dreal(propizqs)*stw**4*cfscheme*(32
     & *ctw**2*qel**2*qmo**2*qs*us**2*mmo**2-64*ctw**2*qel**2*qmo**2*qs*
     & ts*us*mmo**2+32*ctw**2*qel**2*qmo**2*qs*ts**2*mmo**2+8*ctw**2*qel
     & **2*qmo**2*qs**2*us**2-16*ctw**2*qel**2*qmo**2*qs**2*ts*us+8*ctw*
     & *2*qel**2*qmo**2*qs**2*ts**2)
     & +sdet4imotsus**2*c0elelqscelc*dreal(propizqs)*stw**4*cfscheme*(8*
     & ctw**2*qel**2*qmo**2*qs**2*us**2-16*ctw**2*qel**2*qmo**2*qs**2*ts
     & *us+8*ctw**2*qel**2*qmo**2*qs**2*ts**2)
     & +sdet4imotsus*javqstselmoz*dreal(propizqs)*stw**2*(2*qel*qmo*mmo*
     & *4+2*qel*qmo*ts*mmo**2-4*qel*qmo*vmamo*mmo**4-4*qel*qmo*vmamo*ts*
     & mmo**2-4*qel*vmael*qmo*mmo**4-4*qel*vmael*qmo*ts*mmo**2+8*qel*vma
     & el*qmo*vmamo*mmo**4+8*qel*vmael*qmo*vmamo*ts*mmo**2)
     & +sdet4imotsus*javqsuselmoz*dreal(propizqs)*stw**2*(2*qel*qmo*mmo*
     & *4+2*qel*qmo*us*mmo**2-4*qel*qmo*vmamo*mmo**4-4*qel*qmo*vmamo*us*
     & mmo**2-4*qel*vmael*qmo*mmo**4-4*qel*vmael*qmo*us*mmo**2+8*qel*vma
     & el*qmo*vmamo*mmo**4+8*qel*vmael*qmo*vmamo*us*mmo**2)
     & +sdet4imotsus*c0momoqszmoc*dreal(propizqs)*stw**2*(-2*qel*qmo/qs*
     & us*mz**2*mmo**2+2*qel*qmo/qs*ts*mz**2*mmo**2+8*qel*qmo*mmo**4-2*q
     & el*qmo*us*mmo**2+10*qel*qmo*ts*mmo**2-2*qel*qmo*ts*mz**2+2*qel*qm
     & o*qs*ts-16*qel*qmo*vmamo*mmo**4-8*qel*qmo*vmamo*us*mmo**2+2*qel*q
     & mo*vmamo*us*mz**2-8*qel*qmo*vmamo*ts*mmo**2+2*qel*qmo*vmamo*ts*mz
     & **2-2*qel*qmo*vmamo*qs*us-2*qel*qmo*vmamo*qs*ts-16*qel*vmael*qmo*
     & mmo**4-8*qel*vmael*qmo*us*mmo**2+2*qel*vmael*qmo*us*mz**2-8*qel*v
     & mael*qmo*ts*mmo**2+2*qel*vmael*qmo*ts*mz**2-2*qel*vmael*qmo*qs*us
     & -2*qel*vmael*qmo*qs*ts+32*qel*vmael*qmo*vmamo*mmo**4+16*qel*vmael
     & *qmo*vmamo*us*mmo**2-4*qel*vmael*qmo*vmamo*us*mz**2+16*qel*vmael*
     & qmo*vmamo*ts*mmo**2-4*qel*vmael*qmo*vmamo*ts*mz**2+4*qel*vmael*qm
     & o*vmamo*qs*us+4*qel*vmael*qmo*vmamo*qs*ts)
     & +sdet4imotsus*c0momoqscmoc*dreal(propizqs)*stw**4*cfscheme*(32*ct
     & w**2*qel**2*qmo**2*qs*mmo**2)
     & +sdet4imotsus*c0elelqszelc*dreal(propizqs)*stw**2*(-2*qel*qmo*mz*
     & *2*mmo**2-2*qel*qmo*ts*mz**2+2*qel*qmo*qs*mmo**2+2*qel*qmo*qs*ts+
     & 4*qel*qmo*vmamo*mz**2*mmo**2+2*qel*qmo*vmamo*us*mz**2+2*qel*qmo*v
     & mamo*ts*mz**2-4*qel*qmo*vmamo*qs*mmo**2-2*qel*qmo*vmamo*qs*us-2*q
     & el*qmo*vmamo*qs*ts+4*qel*vmael*qmo*mz**2*mmo**2+2*qel*vmael*qmo*u
     & s*mz**2+2*qel*vmael*qmo*ts*mz**2-4*qel*vmael*qmo*qs*mmo**2-2*qel*
     & vmael*qmo*qs*us-2*qel*vmael*qmo*qs*ts-8*qel*vmael*qmo*vmamo*mz**2
     & *mmo**2-4*qel*vmael*qmo*vmamo*us*mz**2-4*qel*vmael*qmo*vmamo*ts*m
     & z**2+8*qel*vmael*qmo*vmamo*qs*mmo**2+4*qel*vmael*qmo*vmamo*qs*us+
     & 4*qel*vmael*qmo*vmamo*qs*ts)
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*stw**2*(4*qel*qmo*mmo**
     & 4+4*qel*qmo*ts*mmo**2-8*qel*qmo*vmamo*mmo**4-8*qel*qmo*vmamo*ts*m
     & mo**2-8*qel*vmael*qmo*mmo**4-8*qel*vmael*qmo*ts*mmo**2+16*qel*vma
     & el*qmo*vmamo*mmo**4+16*qel*vmael*qmo*vmamo*ts*mmo**2)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*stw**2*(4*qel*qmo*mmo**
     & 4+4*qel*qmo*us*mmo**2-8*qel*qmo*vmamo*mmo**4-8*qel*qmo*vmamo*us*m
     & mo**2-8*qel*vmael*qmo*mmo**4-8*qel*vmael*qmo*us*mmo**2+16*qel*vma
     & el*qmo*vmamo*mmo**4+16*qel*vmael*qmo*vmamo*us*mmo**2)
     & +sdet4imotsus*b0fmomoc*dreal(propizqs)*stw**4*cfscheme*(64*ctw**2
     & *qel**2*qmo**2*mmo**2)
     & +sdet4imotsus*b0fqszc*dreal(propizqs)*stw**2*(-4*qel*qmo*mmo**2-4
     & *qel*qmo*ts+8*qel*qmo*vmamo*mmo**2+4*qel*qmo*vmamo*us+4*qel*qmo*v
     & mamo*ts+8*qel*vmael*qmo*mmo**2+4*qel*vmael*qmo*us+4*qel*vmael*qmo
     & *ts-16*qel*vmael*qmo*vmamo*mmo**2-8*qel*vmael*qmo*vmamo*us-8*qel*
     & vmael*qmo*vmamo*ts)
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*stw**2*(4*qel*qmo*mmo**2+4
     & *qel*qmo*ts-4*qel*qmo*vmamo*mmo**2-4*qel*qmo*vmamo*ts-4*qel*vmael
     & *qmo*mmo**2-4*qel*vmael*qmo*ts+8*qel*vmael*qmo*vmamo*mmo**2+8*qel
     & *vmael*qmo*vmamo*ts)
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*stw**4*cfscheme*(-32*ctw**
     & 2*qel**2*qmo**2*mmo**2)
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*stw**2*(-4*qel*qmo*vmamo*m
     & mo**2-4*qel*qmo*vmamo*us-4*qel*vmael*qmo*mmo**2-4*qel*vmael*qmo*u
     & s+8*qel*vmael*qmo*vmamo*mmo**2+8*qel*vmael*qmo*vmamo*us)
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*stw**4*cfscheme*(-32*ctw**
     & 2*qel**2*qmo**2*mmo**2)
     & +c0irmomoqs*stw**2*(-4*qmo**2*mmo**2-2*qmo**2*qs)
     & +c0irelelqs*stw**2*(-2*qel**2*qs)
     & +a0fel*stw**2*(-3*qel**2)
     & +a0fmo*stw**2*(-3*qmo**2-2*det3imomoqs*qmo**2*qs*mmo**2)
     & +b0fqsmomo*stw**2*(-3*qmo**2-2*det3imomoqs*qmo**2*qs*mmo**2)
     & +b0fqscc*stw**2*(-3*qel**2)
     & +lnlamom*stw**2*(2*qmo**2)
     & +lnlaelm*stw**2*(2*qel**2)

      ff_qed_ql =
     & +stw**2*(-qmo**2-qel**2+2*det3imomoqs*qmo**2*qs*mmo**2)
     & +sdet3cmots**3*sdet4imotsus**2*jaaqstselmo*dreal(propizqs)*stw**2
     & *cfscheme*(-2*ctw**2*qel*qmo**2*us+2*ctw**2*qel*qmo**2*ts)
     & +sdet3cmots**2*sdet4imotsus**2*c0elelqszelc*dreal(propizqs)*stw**
     & 2*(2*qel*qmo*vmamo*mz**2*mmo**2-2*qel*qmo*vmamo*ts*mz**2+2*qel*qm
     & o*vmamo*qs*mmo**2-2*qel*qmo*vmamo*qs*ts)
     & +sdet3cmots*sdet4imotsus**2*javqstselmoz*dreal(propizqs)*stw**2*(
     & -2*qel*qmo*vmamo*mz**2*mmo**4+2*qel*qmo*vmamo*ts**2*mz**2-2*qel*q
     & mo*vmamo*qs*mmo**4+2*qel*qmo*vmamo*qs*ts**2)
     & +sdet3cmots*sdet4imotsus**2*c0momoqszmoc*dreal(propizqs)*stw**2*(
     & 2*qel*qmo*vmamo*mz**2*mmo**4-2*qel*qmo*vmamo*us*mz**2*mmo**2+2*qe
     & l*qmo*vmamo*ts*mz**2*mmo**2-2*qel*qmo*vmamo*ts**2*mz**2+2*qel*qmo
     & *vmamo*qs*mmo**4-2*qel*qmo*vmamo*qs*us*mmo**2+2*qel*qmo*vmamo*qs*
     & ts*mmo**2-2*qel*qmo*vmamo*qs*ts**2)
     & +sdet3cmots*sdet4imotsus**2*c0momoqscmoc*dreal(propizqs)*stw**2*c
     & fscheme*(-16*ctw**2*qel*qmo**2*qs*mmo**4-4*ctw**2*qel*qmo**2*qs**
     & 2*mmo**2)
     & +sdet3cmots*sdet4imotsus**2*c0elelqszelc*dreal(propizqs)*stw**2*(
     & 2*qel*qmo*vmamo*us*mz**2*mmo**2-2*qel*qmo*vmamo*ts*mz**2*mmo**2+2
     & *qel*qmo*vmamo*qs*us*mmo**2-2*qel*qmo*vmamo*qs*ts*mmo**2)
     & +sdet3cmots*sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*stw**2*(-
     & 4*qel*qmo*vmamo*mz**2*mmo**4+4*qel*qmo*vmamo*ts**2*mz**2-4*qel*qm
     & o*vmamo*qs*mmo**4+4*qel*qmo*vmamo*qs*ts**2)
     & +sdet3cmots*sdet4imotsus*javqstselmoz*dreal(propizqs)*stw**2*(4*q
     & el*qmo*vmamo*ts)
     & +sdet3cmots*sdet4imotsus*c0momoqszmoc*dreal(propizqs)*stw**2*(-4*
     & qel*qmo*vmamo/qs*mz**2*mmo**2-4*qel*qmo*vmamo*mmo**2)
     & +sdet3cmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*stw**2*(4*qe
     & l*qmo*vmamo/qs*mz**2*mmo**2+8*qel*qmo*vmamo*ts)
     & +sdet3cmots*sdet4imotsus*b0fqscc*dreal(propizqs)*stw**2*cfscheme*
     & (4*ctw**2*qel*qmo**2)
     & +sdet3cmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*stw**2*cfscheme
     & *(-4*ctw**2*qel*qmo**2)
     & +sdet3cmots*javqstselmoz*stw**2*(4*qel*qmo)
     & +sdet3cmots*c0irelmots*stw**2*(-4*qel*qmo)
     & +sdet3cmots*c0cmotsczmo*stw**2*(4*qel*qmo)
     & +sdet3cmous**3*sdet4imotsus**2*jaaqsuselmo*dreal(propizqs)*stw**2
     & *cfscheme*(2*ctw**2*qel*qmo**2*us-2*ctw**2*qel*qmo**2*ts)
     & +sdet3cmous**2*sdet4imotsus**2*c0elelqszelc*dreal(propizqs)*stw**
     & 2*(-2*qel*qmo*mz**2*mmo**2+2*qel*qmo*us*mz**2-2*qel*qmo*qs*mmo**2
     & +2*qel*qmo*qs*us+2*qel*qmo*vmamo*mz**2*mmo**2-2*qel*qmo*vmamo*us*
     & mz**2+2*qel*qmo*vmamo*qs*mmo**2-2*qel*qmo*vmamo*qs*us)
     & +sdet3cmous*sdet4imotsus**2*javqsuselmoz*dreal(propizqs)*stw**2*(
     & 2*qel*qmo*mz**2*mmo**4-2*qel*qmo*us**2*mz**2+2*qel*qmo*qs*mmo**4-
     & 2*qel*qmo*qs*us**2-2*qel*qmo*vmamo*mz**2*mmo**4+2*qel*qmo*vmamo*u
     & s**2*mz**2-2*qel*qmo*vmamo*qs*mmo**4+2*qel*qmo*vmamo*qs*us**2)
     & +sdet3cmous*sdet4imotsus**2*c0momoqszmoc*dreal(propizqs)*stw**2*(
     & -2*qel*qmo*mz**2*mmo**4-2*qel*qmo*us*mz**2*mmo**2+2*qel*qmo*us**2
     & *mz**2+2*qel*qmo*ts*mz**2*mmo**2-2*qel*qmo*qs*mmo**4-2*qel*qmo*qs
     & *us*mmo**2+2*qel*qmo*qs*us**2+2*qel*qmo*qs*ts*mmo**2+2*qel*qmo*vm
     & amo*mz**2*mmo**4+2*qel*qmo*vmamo*us*mz**2*mmo**2-2*qel*qmo*vmamo*
     & us**2*mz**2-2*qel*qmo*vmamo*ts*mz**2*mmo**2+2*qel*qmo*vmamo*qs*mm
     & o**4+2*qel*qmo*vmamo*qs*us*mmo**2-2*qel*qmo*vmamo*qs*us**2-2*qel*
     & qmo*vmamo*qs*ts*mmo**2)
     & +sdet3cmous*sdet4imotsus**2*c0momoqscmoc*dreal(propizqs)*stw**2*c
     & fscheme*(-16*ctw**2*qel*qmo**2*qs*mmo**4-4*ctw**2*qel*qmo**2*qs**
     & 2*mmo**2)
     & +sdet3cmous*sdet4imotsus**2*c0elelqszelc*dreal(propizqs)*stw**2*(
     & 2*qel*qmo*us*mz**2*mmo**2-2*qel*qmo*ts*mz**2*mmo**2+2*qel*qmo*qs*
     & us*mmo**2-2*qel*qmo*qs*ts*mmo**2-2*qel*qmo*vmamo*us*mz**2*mmo**2+
     & 2*qel*qmo*vmamo*ts*mz**2*mmo**2-2*qel*qmo*vmamo*qs*us*mmo**2+2*qe
     & l*qmo*vmamo*qs*ts*mmo**2)
     & +sdet3cmous*sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*stw**2*(4
     & *qel*qmo*mz**2*mmo**4-4*qel*qmo*us**2*mz**2+4*qel*qmo*qs*mmo**4-4
     & *qel*qmo*qs*us**2-4*qel*qmo*vmamo*mz**2*mmo**4+4*qel*qmo*vmamo*us
     & **2*mz**2-4*qel*qmo*vmamo*qs*mmo**4+4*qel*qmo*vmamo*qs*us**2)
     & +sdet3cmous*sdet4imotsus*javqsuselmoz*dreal(propizqs)*stw**2*(-4*
     & qel*qmo*us+4*qel*qmo*vmamo*us)
     & +sdet3cmous*sdet4imotsus*c0momoqszmoc*dreal(propizqs)*stw**2*(4*q
     & el*qmo/qs*mz**2*mmo**2+4*qel*qmo*mmo**2-4*qel*qmo*vmamo/qs*mz**2*
     & mmo**2-4*qel*qmo*vmamo*mmo**2)
     & +sdet3cmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*stw**2*(-4*q
     & el*qmo/qs*mz**2*mmo**2-8*qel*qmo*us+4*qel*qmo*vmamo/qs*mz**2*mmo*
     & *2+8*qel*qmo*vmamo*us)
     & +sdet3cmous*sdet4imotsus*b0fqscc*dreal(propizqs)*stw**2*cfscheme*
     & (4*ctw**2*qel*qmo**2)
     & +sdet3cmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*stw**2*cfscheme
     & *(-4*ctw**2*qel*qmo**2)
     & +sdet3cmous*javqsuselmoz*stw**2*(-4*qel*qmo)
     & +sdet3cmous*c0irelmous*stw**2*(4*qel*qmo)
     & +sdet3cmous*c0cmousczmo*stw**2*(-4*qel*qmo)
     & +sdet3icmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*stw**2*(4*q
     & el*qmo*vmamo*ts*mz**2*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*stw**2*(4*qel*
     & qmo*vmamo*mmo**4+4*qel*qmo*vmamo*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0fmomoc*dreal(propizqs)*stw**2*(4*qel*
     & qmo*vmamo*mmo**4+4*qel*qmo*vmamo*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*stw**2*(-8*qel
     & *qmo*vmamo*mmo**4-8*qel*qmo*vmamo*ts*mmo**2)
     & +sdet3icmots*c0cmotsczmo*dreal(propizqs)*stw**2*(4*qel*qmo*vmamo/
     & qs*mz**2*mmo**2)
     & +sdet3icmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*stw**2*(-4*
     & qel*qmo*us*mz**2*mmo**2+4*qel*qmo*vmamo*us*mz**2*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*stw**2*(-4*qel
     & *qmo*mmo**4-4*qel*qmo*us*mmo**2+4*qel*qmo*vmamo*mmo**4+4*qel*qmo*
     & vmamo*us*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fmomoc*dreal(propizqs)*stw**2*(-4*qel
     & *qmo*mmo**4-4*qel*qmo*us*mmo**2+4*qel*qmo*vmamo*mmo**4+4*qel*qmo*
     & vmamo*us*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*stw**2*(8*qel*
     & qmo*mmo**4+8*qel*qmo*us*mmo**2-8*qel*qmo*vmamo*mmo**4-8*qel*qmo*v
     & mamo*us*mmo**2)
     & +sdet3icmous*c0cmousczmo*dreal(propizqs)*stw**2*(-4*qel*qmo/qs*mz
     & **2*mmo**2+4*qel*qmo*vmamo/qs*mz**2*mmo**2)
     & +sdet4imotsus**2*c0momoqscmoc*dreal(propizqs)*stw**2*cfscheme*(-8
     & *ctw**2*qel*qmo**2*qs*us**2*mmo**2+16*ctw**2*qel*qmo**2*qs*ts*us*
     & mmo**2-8*ctw**2*qel*qmo**2*qs*ts**2*mmo**2-2*ctw**2*qel*qmo**2*qs
     & **2*us**2+4*ctw**2*qel*qmo**2*qs**2*ts*us-2*ctw**2*qel*qmo**2*qs*
     & *2*ts**2)
     & +sdet4imotsus**2*c0elelqscelc*dreal(propizqs)*stw**2*cfscheme*(-2
     & *ctw**2*qel*qmo**2*qs**2*us**2+4*ctw**2*qel*qmo**2*qs**2*ts*us-2*
     & ctw**2*qel*qmo**2*qs**2*ts**2)
     & +sdet4imotsus*javqstselmoz*dreal(propizqs)*stw**2*(-2*qel*qmo*mmo
     & **4-2*qel*qmo*ts*mmo**2+4*qel*qmo*vmamo*mmo**4+4*qel*qmo*vmamo*ts
     & *mmo**2)
     & +sdet4imotsus*javqsuselmoz*dreal(propizqs)*stw**2*(-2*qel*qmo*mmo
     & **4-2*qel*qmo*us*mmo**2+4*qel*qmo*vmamo*mmo**4+4*qel*qmo*vmamo*us
     & *mmo**2)
     & +sdet4imotsus*c0momoqszmoc*dreal(propizqs)*stw**2*(-2*qel*qmo/qs*
     & us*mz**2*mmo**2+2*qel*qmo/qs*ts*mz**2*mmo**2-8*qel*qmo*mmo**4-10*
     & qel*qmo*us*mmo**2+2*qel*qmo*us*mz**2+2*qel*qmo*ts*mmo**2-2*qel*qm
     & o*qs*us+16*qel*qmo*vmamo*mmo**4+8*qel*qmo*vmamo*us*mmo**2-2*qel*q
     & mo*vmamo*us*mz**2+8*qel*qmo*vmamo*ts*mmo**2-2*qel*qmo*vmamo*ts*mz
     & **2+2*qel*qmo*vmamo*qs*us+2*qel*qmo*vmamo*qs*ts)
     & +sdet4imotsus*c0momoqscmoc*dreal(propizqs)*stw**2*cfscheme*(-8*ct
     & w**2*qel*qmo**2*qs*mmo**2)
     & +sdet4imotsus*c0elelqszelc*dreal(propizqs)*stw**2*(2*qel*qmo*mz**
     & 2*mmo**2+2*qel*qmo*us*mz**2-2*qel*qmo*qs*mmo**2-2*qel*qmo*qs*us-4
     & *qel*qmo*vmamo*mz**2*mmo**2-2*qel*qmo*vmamo*us*mz**2-2*qel*qmo*vm
     & amo*ts*mz**2+4*qel*qmo*vmamo*qs*mmo**2+2*qel*qmo*vmamo*qs*us+2*qe
     & l*qmo*vmamo*qs*ts)
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*stw**2*(-4*qel*qmo*mmo*
     & *4-4*qel*qmo*ts*mmo**2+8*qel*qmo*vmamo*mmo**4+8*qel*qmo*vmamo*ts*
     & mmo**2)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*stw**2*(-4*qel*qmo*mmo*
     & *4-4*qel*qmo*us*mmo**2+8*qel*qmo*vmamo*mmo**4+8*qel*qmo*vmamo*us*
     & mmo**2)
     & +sdet4imotsus*b0fmomoc*dreal(propizqs)*stw**2*cfscheme*(-16*ctw**
     & 2*qel*qmo**2*mmo**2)
     & +sdet4imotsus*b0fqszc*dreal(propizqs)*stw**2*(4*qel*qmo*mmo**2+4*
     & qel*qmo*us-8*qel*qmo*vmamo*mmo**2-4*qel*qmo*vmamo*us-4*qel*qmo*vm
     & amo*ts)
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*stw**2*(4*qel*qmo*vmamo*mm
     & o**2+4*qel*qmo*vmamo*ts)
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*stw**2*cfscheme*(8*ctw**2*
     & qel*qmo**2*mmo**2)
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*stw**2*(-4*qel*qmo*mmo**2-
     & 4*qel*qmo*us+4*qel*qmo*vmamo*mmo**2+4*qel*qmo*vmamo*us)
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*stw**2*cfscheme*(8*ctw**2*
     & qel*qmo**2*mmo**2)
     & +c0irmomoqs*stw**2*(-4*qmo**2*mmo**2-2*qmo**2*qs)
     & +c0irelelqs*stw**2*(-2*qel**2*qs)
     & +a0fel*stw**2*(-3*qel**2)
     & +a0fmo*stw**2*(-3*qmo**2-2*det3imomoqs*qmo**2*qs*mmo**2)
     & +b0fqsmomo*stw**2*(-3*qmo**2-2*det3imomoqs*qmo**2*qs*mmo**2)
     & +b0fqscc*stw**2*(-3*qel**2)
     & +lnlamom*stw**2*(2*qmo**2)
     & +lnlaelm*stw**2*(2*qel**2)

      ff_qed_lq =
     & +stw**2*(-qmo**2-qel**2)
     & +sdet3cmots**3*sdet4imotsus**2*jaaqstselmo*dreal(propizqs)*stw**2
     & *cfscheme*(-2*ctw**2*qel**2*qmo*us+2*ctw**2*qel**2*qmo*ts)
     & +sdet3cmots**2*sdet4imotsus**2*c0elelqszelc*dreal(propizqs)*stw**
     & 2*(2*qel*vmael*qmo*mz**2*mmo**2-2*qel*vmael*qmo*ts*mz**2+2*qel*vm
     & ael*qmo*qs*mmo**2-2*qel*vmael*qmo*qs*ts)
     & +sdet3cmots*sdet4imotsus**2*javqstselmoz*dreal(propizqs)*stw**2*(
     & -2*qel*vmael*qmo*ts*mz**2*mmo**2+2*qel*vmael*qmo*ts**2*mz**2-2*qe
     & l*vmael*qmo*qs*ts*mmo**2+2*qel*vmael*qmo*qs*ts**2)
     & +sdet3cmots*sdet4imotsus**2*javqstselmoz*dreal(propizqs)*(qel*mz*
     & *2*mmo**4-qel*ts*mz**2*mmo**2+qel*qs*mmo**4-qel*qs*ts*mmo**2-qel*
     & vmamo*mz**2*mmo**4+qel*vmamo*ts*mz**2*mmo**2-qel*vmamo*qs*mmo**4+
     & qel*vmamo*qs*ts*mmo**2-qel*vmael*mz**2*mmo**4+qel*vmael*ts*mz**2*
     & mmo**2-qel*vmael*qs*mmo**4+qel*vmael*qs*ts*mmo**2+qel*vmael*vmamo
     & *mz**2*mmo**4-qel*vmael*vmamo*ts*mz**2*mmo**2+qel*vmael*vmamo*qs*
     & mmo**4-qel*vmael*vmamo*qs*ts*mmo**2)
     & +sdet3cmots*sdet4imotsus**2*c0momoqszmoc*dreal(propizqs)*stw**2*(
     & -2*qel*vmael*qmo*mz**2*mmo**4+4*qel*vmael*qmo*ts*mz**2*mmo**2-2*q
     & el*vmael*qmo*ts**2*mz**2-2*qel*vmael*qmo*qs*mmo**4+4*qel*vmael*qm
     & o*qs*ts*mmo**2-2*qel*vmael*qmo*qs*ts**2)
     & +sdet3cmots*sdet4imotsus**2*c0momoqszmoc*dreal(propizqs)*(-2*qel*
     & mz**2*mmo**4+qel*us*mz**2*mmo**2+qel*ts*mz**2*mmo**2-2*qel*qs*mmo
     & **4+qel*qs*us*mmo**2+qel*qs*ts*mmo**2+2*qel*vmamo*mz**2*mmo**4-qe
     & l*vmamo*us*mz**2*mmo**2-qel*vmamo*ts*mz**2*mmo**2+2*qel*vmamo*qs*
     & mmo**4-qel*vmamo*qs*us*mmo**2-qel*vmamo*qs*ts*mmo**2+2*qel*vmael*
     & mz**2*mmo**4-qel*vmael*us*mz**2*mmo**2-qel*vmael*ts*mz**2*mmo**2+
     & 2*qel*vmael*qs*mmo**4-qel*vmael*qs*us*mmo**2-qel*vmael*qs*ts*mmo*
     & *2-2*qel*vmael*vmamo*mz**2*mmo**4+qel*vmael*vmamo*us*mz**2*mmo**2
     & +qel*vmael*vmamo*ts*mz**2*mmo**2-2*qel*vmael*vmamo*qs*mmo**4+qel*
     & vmael*vmamo*qs*us*mmo**2+qel*vmael*vmamo*qs*ts*mmo**2)
     & +sdet3cmots*sdet4imotsus**2*c0momoqscmoc*dreal(propizqs)*stw**2*c
     & fscheme*(-16*ctw**2*qel**2*qmo*qs*mmo**4-4*ctw**2*qel**2*qmo*qs**
     & 2*mmo**2)
     & +sdet3cmots*sdet4imotsus**2*c0elelqszelc*dreal(propizqs)*(-qel*us
     & *mz**2*mmo**2+qel*ts*mz**2*mmo**2-qel*qs*us*mmo**2+qel*qs*ts*mmo*
     & *2+qel*vmamo*us*mz**2*mmo**2-qel*vmamo*ts*mz**2*mmo**2+qel*vmamo*
     & qs*us*mmo**2-qel*vmamo*qs*ts*mmo**2+qel*vmael*us*mz**2*mmo**2-qel
     & *vmael*ts*mz**2*mmo**2+qel*vmael*qs*us*mmo**2-qel*vmael*qs*ts*mmo
     & **2-qel*vmael*vmamo*us*mz**2*mmo**2+qel*vmael*vmamo*ts*mz**2*mmo*
     & *2-qel*vmael*vmamo*qs*us*mmo**2+qel*vmael*vmamo*qs*ts*mmo**2)
     & +sdet3cmots*sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*stw**2*(-
     & 4*qel*vmael*qmo*ts*mz**2*mmo**2+4*qel*vmael*qmo*ts**2*mz**2-4*qel
     & *vmael*qmo*qs*ts*mmo**2+4*qel*vmael*qmo*qs*ts**2)
     & +sdet3cmots*sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*(2*qel*mz
     & **2*mmo**4-2*qel*ts*mz**2*mmo**2+2*qel*qs*mmo**4-2*qel*qs*ts*mmo*
     & *2-2*qel*vmamo*mz**2*mmo**4+2*qel*vmamo*ts*mz**2*mmo**2-2*qel*vma
     & mo*qs*mmo**4+2*qel*vmamo*qs*ts*mmo**2-2*qel*vmael*mz**2*mmo**4+2*
     & qel*vmael*ts*mz**2*mmo**2-2*qel*vmael*qs*mmo**4+2*qel*vmael*qs*ts
     & *mmo**2+2*qel*vmael*vmamo*mz**2*mmo**4-2*qel*vmael*vmamo*ts*mz**2
     & *mmo**2+2*qel*vmael*vmamo*qs*mmo**4-2*qel*vmael*vmamo*qs*ts*mmo**
     & 2)
     & +sdet3cmots*sdet4imotsus*javqstselmoz*dreal(propizqs)*stw**2*(-2*
     & qel*vmael*qmo/qs*mz**2*mmo**2-4*qel*vmael*qmo*mmo**2+4*qel*vmael*
     & qmo*ts)
     & +sdet3cmots*sdet4imotsus*javqstselmoz*dreal(propizqs)*(-qel/qs*mz
     & **2*mmo**2-2*qel*mmo**2+qel*vmamo/qs*mz**2*mmo**2+2*qel*vmamo*mmo
     & **2+qel*vmael/qs*mz**2*mmo**2+2*qel*vmael*mmo**2-qel*vmael*vmamo/
     & qs*mz**2*mmo**2-2*qel*vmael*vmamo*mmo**2)
     & +sdet3cmots*sdet4imotsus*c0momoqszmoc*dreal(propizqs)*stw**2*(4*q
     & el*vmael*qmo*mmo**2)
     & +sdet3cmots*sdet4imotsus*c0momoqszmoc*dreal(propizqs)*(2*qel/qs*m
     & z**2*mmo**2+4*qel*mmo**2-2*qel*vmamo/qs*mz**2*mmo**2-4*qel*vmamo*
     & mmo**2-2*qel*vmael/qs*mz**2*mmo**2-4*qel*vmael*mmo**2+2*qel*vmael
     & *vmamo/qs*mz**2*mmo**2+4*qel*vmael*vmamo*mmo**2)
     & +sdet3cmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*stw**2*(-8*q
     & el*vmael*qmo*mmo**2+8*qel*vmael*qmo*ts)
     & +sdet3cmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*(-2*qel/qs*m
     & z**2*mmo**2-4*qel*mmo**2+2*qel*vmamo/qs*mz**2*mmo**2+4*qel*vmamo*
     & mmo**2+2*qel*vmael/qs*mz**2*mmo**2+4*qel*vmael*mmo**2-2*qel*vmael
     & *vmamo/qs*mz**2*mmo**2-4*qel*vmael*vmamo*mmo**2)
     & +sdet3cmots*sdet4imotsus*b0fqscc*dreal(propizqs)*stw**2*cfscheme*
     & (4*ctw**2*qel**2*qmo)
     & +sdet3cmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*stw**2*cfscheme
     & *(-4*ctw**2*qel**2*qmo)
     & +sdet3cmots*javqstselmoz*stw**2*(4*qel*qmo)
     & +sdet3cmots*c0irelmots*stw**2*(-4*qel*qmo)
     & +sdet3cmots*c0cmotsczmo*stw**2*(4*qel*qmo)
     & +sdet3cmous**3*sdet4imotsus**2*jaaqsuselmo*dreal(propizqs)*stw**2
     & *cfscheme*(2*ctw**2*qel**2*qmo*us-2*ctw**2*qel**2*qmo*ts)
     & +sdet3cmous**2*sdet4imotsus**2*c0elelqszelc*dreal(propizqs)*stw**
     & 2*(-2*qel*qmo*mz**2*mmo**2+2*qel*qmo*us*mz**2-2*qel*qmo*qs*mmo**2
     & +2*qel*qmo*qs*us+2*qel*vmael*qmo*mz**2*mmo**2-2*qel*vmael*qmo*us*
     & mz**2+2*qel*vmael*qmo*qs*mmo**2-2*qel*vmael*qmo*qs*us)
     & +sdet3cmous*sdet4imotsus**2*javqsuselmoz*dreal(propizqs)*stw**2*(
     & 2*qel*qmo*us*mz**2*mmo**2-2*qel*qmo*us**2*mz**2+2*qel*qmo*qs*us*m
     & mo**2-2*qel*qmo*qs*us**2-2*qel*vmael*qmo*us*mz**2*mmo**2+2*qel*vm
     & ael*qmo*us**2*mz**2-2*qel*vmael*qmo*qs*us*mmo**2+2*qel*vmael*qmo*
     & qs*us**2)
     & +sdet3cmous*sdet4imotsus**2*javqsuselmoz*dreal(propizqs)*(-qel*vm
     & ael*mz**2*mmo**4+qel*vmael*us*mz**2*mmo**2-qel*vmael*qs*mmo**4+qe
     & l*vmael*qs*us*mmo**2+qel*vmael*vmamo*mz**2*mmo**4-qel*vmael*vmamo
     & *us*mz**2*mmo**2+qel*vmael*vmamo*qs*mmo**4-qel*vmael*vmamo*qs*us*
     & mmo**2)
     & +sdet3cmous*sdet4imotsus**2*c0momoqszmoc*dreal(propizqs)*stw**2*(
     & 2*qel*qmo*mz**2*mmo**4-4*qel*qmo*us*mz**2*mmo**2+2*qel*qmo*us**2*
     & mz**2+2*qel*qmo*qs*mmo**4-4*qel*qmo*qs*us*mmo**2+2*qel*qmo*qs*us*
     & *2-2*qel*vmael*qmo*mz**2*mmo**4+4*qel*vmael*qmo*us*mz**2*mmo**2-2
     & *qel*vmael*qmo*us**2*mz**2-2*qel*vmael*qmo*qs*mmo**4+4*qel*vmael*
     & qmo*qs*us*mmo**2-2*qel*vmael*qmo*qs*us**2)
     & +sdet3cmous*sdet4imotsus**2*c0momoqszmoc*dreal(propizqs)*(2*qel*v
     & mael*mz**2*mmo**4-qel*vmael*us*mz**2*mmo**2-qel*vmael*ts*mz**2*mm
     & o**2+2*qel*vmael*qs*mmo**4-qel*vmael*qs*us*mmo**2-qel*vmael*qs*ts
     & *mmo**2-2*qel*vmael*vmamo*mz**2*mmo**4+qel*vmael*vmamo*us*mz**2*m
     & mo**2+qel*vmael*vmamo*ts*mz**2*mmo**2-2*qel*vmael*vmamo*qs*mmo**4
     & +qel*vmael*vmamo*qs*us*mmo**2+qel*vmael*vmamo*qs*ts*mmo**2)
     & +sdet3cmous*sdet4imotsus**2*c0momoqscmoc*dreal(propizqs)*stw**2*c
     & fscheme*(-16*ctw**2*qel**2*qmo*qs*mmo**4-4*ctw**2*qel**2*qmo*qs**
     & 2*mmo**2)
     & +sdet3cmous*sdet4imotsus**2*c0elelqszelc*dreal(propizqs)*(-qel*vm
     & ael*us*mz**2*mmo**2+qel*vmael*ts*mz**2*mmo**2-qel*vmael*qs*us*mmo
     & **2+qel*vmael*qs*ts*mmo**2+qel*vmael*vmamo*us*mz**2*mmo**2-qel*vm
     & ael*vmamo*ts*mz**2*mmo**2+qel*vmael*vmamo*qs*us*mmo**2-qel*vmael*
     & vmamo*qs*ts*mmo**2)
     & +sdet3cmous*sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*stw**2*(4
     & *qel*qmo*us*mz**2*mmo**2-4*qel*qmo*us**2*mz**2+4*qel*qmo*qs*us*mm
     & o**2-4*qel*qmo*qs*us**2-4*qel*vmael*qmo*us*mz**2*mmo**2+4*qel*vma
     & el*qmo*us**2*mz**2-4*qel*vmael*qmo*qs*us*mmo**2+4*qel*vmael*qmo*q
     & s*us**2)
     & +sdet3cmous*sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*(-2*qel*v
     & mael*mz**2*mmo**4+2*qel*vmael*us*mz**2*mmo**2-2*qel*vmael*qs*mmo*
     & *4+2*qel*vmael*qs*us*mmo**2+2*qel*vmael*vmamo*mz**2*mmo**4-2*qel*
     & vmael*vmamo*us*mz**2*mmo**2+2*qel*vmael*vmamo*qs*mmo**4-2*qel*vma
     & el*vmamo*qs*us*mmo**2)
     & +sdet3cmous*sdet4imotsus*javqsuselmoz*dreal(propizqs)*stw**2*(2*q
     & el*qmo/qs*mz**2*mmo**2+4*qel*qmo*mmo**2-4*qel*qmo*us-2*qel*vmael*
     & qmo/qs*mz**2*mmo**2-4*qel*vmael*qmo*mmo**2+4*qel*vmael*qmo*us)
     & +sdet3cmous*sdet4imotsus*javqsuselmoz*dreal(propizqs)*(qel*vmael/
     & qs*mz**2*mmo**2+2*qel*vmael*mmo**2-qel*vmael*vmamo/qs*mz**2*mmo**
     & 2-2*qel*vmael*vmamo*mmo**2)
     & +sdet3cmous*sdet4imotsus*c0momoqszmoc*dreal(propizqs)*stw**2*(-4*
     & qel*qmo*mmo**2+4*qel*vmael*qmo*mmo**2)
     & +sdet3cmous*sdet4imotsus*c0momoqszmoc*dreal(propizqs)*(-2*qel*vma
     & el/qs*mz**2*mmo**2-4*qel*vmael*mmo**2+2*qel*vmael*vmamo/qs*mz**2*
     & mmo**2+4*qel*vmael*vmamo*mmo**2)
     & +sdet3cmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*stw**2*(8*qe
     & l*qmo*mmo**2-8*qel*qmo*us-8*qel*vmael*qmo*mmo**2+8*qel*vmael*qmo*
     & us)
     & +sdet3cmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*(2*qel*vmael
     & /qs*mz**2*mmo**2+4*qel*vmael*mmo**2-2*qel*vmael*vmamo/qs*mz**2*mm
     & o**2-4*qel*vmael*vmamo*mmo**2)
     & +sdet3cmous*sdet4imotsus*b0fqscc*dreal(propizqs)*stw**2*cfscheme*
     & (4*ctw**2*qel**2*qmo)
     & +sdet3cmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*stw**2*cfscheme
     & *(-4*ctw**2*qel**2*qmo)
     & +sdet3cmous*javqsuselmoz*stw**2*(-4*qel*qmo)
     & +sdet3cmous*c0irelmous*stw**2*(4*qel*qmo)
     & +sdet3cmous*c0cmousczmo*stw**2*(-4*qel*qmo)
     & +sdet3icmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*stw**2*(4*q
     & el*vmael*qmo*ts*mz**2*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*stw**2*(4*qel*
     & vmael*qmo*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*(-2*qel*mmo**4
     & +2*qel*vmamo*mmo**4+2*qel*vmael*mmo**4-2*qel*vmael*vmamo*mmo**4)
     & +sdet3icmots*sdet4imotsus*b0fmomoc*dreal(propizqs)*stw**2*(4*qel*
     & vmael*qmo*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0fmomoc*dreal(propizqs)*(-2*qel*mmo**4
     & +2*qel*vmamo*mmo**4+2*qel*vmael*mmo**4-2*qel*vmael*vmamo*mmo**4)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*stw**2*(-8*qel
     & *vmael*qmo*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*(4*qel*mmo**4-
     & 4*qel*vmamo*mmo**4-4*qel*vmael*mmo**4+4*qel*vmael*vmamo*mmo**4)
     & +sdet3icmots*c0cmotsczmo*dreal(propizqs)*(-2*qel/qs*mz**2*mmo**2+
     & 2*qel*vmamo/qs*mz**2*mmo**2+2*qel*vmael/qs*mz**2*mmo**2-2*qel*vma
     & el*vmamo/qs*mz**2*mmo**2)
     & +sdet3icmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*stw**2*(-4*
     & qel*qmo*us*mz**2*mmo**2+4*qel*vmael*qmo*us*mz**2*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*stw**2*(-4*qel
     & *qmo*us*mmo**2+4*qel*vmael*qmo*us*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*(2*qel*vmael*m
     & mo**4-2*qel*vmael*vmamo*mmo**4)
     & +sdet3icmous*sdet4imotsus*b0fmomoc*dreal(propizqs)*stw**2*(-4*qel
     & *qmo*us*mmo**2+4*qel*vmael*qmo*us*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fmomoc*dreal(propizqs)*(2*qel*vmael*m
     & mo**4-2*qel*vmael*vmamo*mmo**4)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*stw**2*(8*qel*
     & qmo*us*mmo**2-8*qel*vmael*qmo*us*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*(-4*qel*vmael*
     & mmo**4+4*qel*vmael*vmamo*mmo**4)
     & +sdet3icmous*c0cmousczmo*dreal(propizqs)*(2*qel*vmael/qs*mz**2*mm
     & o**2-2*qel*vmael*vmamo/qs*mz**2*mmo**2)
     & +sdet4imotsus**2*c0momoqscmoc*dreal(propizqs)*stw**2*cfscheme*(-8
     & *ctw**2*qel**2*qmo*qs*us**2*mmo**2+16*ctw**2*qel**2*qmo*qs*ts*us*
     & mmo**2-8*ctw**2*qel**2*qmo*qs*ts**2*mmo**2-2*ctw**2*qel**2*qmo*qs
     & **2*us**2+4*ctw**2*qel**2*qmo*qs**2*ts*us-2*ctw**2*qel**2*qmo*qs*
     & *2*ts**2)
     & +sdet4imotsus**2*c0elelqscelc*dreal(propizqs)*stw**2*cfscheme*(-2
     & *ctw**2*qel**2*qmo*qs**2*us**2+4*ctw**2*qel**2*qmo*qs**2*ts*us-2*
     & ctw**2*qel**2*qmo*qs**2*ts**2)
     & +sdet4imotsus*javqstselmoz*dreal(propizqs)*stw**2*(-2*qel*qmo*mmo
     & **4+4*qel*vmael*qmo*mmo**4)
     & +sdet4imotsus*javqstselmoz*dreal(propizqs)*(-qel*ts*mmo**2+qel*vm
     & amo*ts*mmo**2+2*qel*vmael*ts*mmo**2-2*qel*vmael*vmamo*ts*mmo**2)
     & +sdet4imotsus*javqsuselmoz*dreal(propizqs)*stw**2*(-2*qel*qmo*mmo
     & **4+4*qel*vmael*qmo*mmo**4)
     & +sdet4imotsus*javqsuselmoz*dreal(propizqs)*(-qel*us*mmo**2+qel*vm
     & amo*us*mmo**2+2*qel*vmael*us*mmo**2-2*qel*vmael*vmamo*us*mmo**2)
     & +sdet4imotsus*c0momoqszmoc*dreal(propizqs)*stw**2*(-8*qel*qmo*us*
     & mmo**2+2*qel*qmo*us*mz**2-2*qel*qmo*qs*us+8*qel*vmael*qmo*us*mmo*
     & *2-2*qel*vmael*qmo*us*mz**2+8*qel*vmael*qmo*ts*mmo**2-2*qel*vmael
     & *qmo*ts*mz**2+2*qel*vmael*qmo*qs*us+2*qel*vmael*qmo*qs*ts)
     & +sdet4imotsus*c0momoqszmoc*dreal(propizqs)*(qel/qs*us*mz**2*mmo**
     & 2-qel/qs*ts*mz**2*mmo**2-4*qel*mmo**4+qel*us*mmo**2-qel*ts*mmo**2
     & -qel*vmamo/qs*us*mz**2*mmo**2+qel*vmamo/qs*ts*mz**2*mmo**2+4*qel*
     & vmamo*mmo**4-qel*vmamo*us*mmo**2+qel*vmamo*ts*mmo**2+8*qel*vmael*
     & mmo**4-8*qel*vmael*vmamo*mmo**4)
     & +sdet4imotsus*c0momoqscmoc*dreal(propizqs)*stw**2*cfscheme*(-8*ct
     & w**2*qel**2*qmo*qs*mmo**2)
     & +sdet4imotsus*c0elelqszelc*dreal(propizqs)*stw**2*(2*qel*qmo*us*m
     & z**2-2*qel*qmo*qs*us-2*qel*vmael*qmo*us*mz**2-2*qel*vmael*qmo*ts*
     & mz**2+2*qel*vmael*qmo*qs*us+2*qel*vmael*qmo*qs*ts)
     & +sdet4imotsus*c0elelqszelc*dreal(propizqs)*(qel*mz**2*mmo**2-qel*
     & qs*mmo**2-qel*vmamo*mz**2*mmo**2+qel*vmamo*qs*mmo**2-2*qel*vmael*
     & mz**2*mmo**2+2*qel*vmael*qs*mmo**2+2*qel*vmael*vmamo*mz**2*mmo**2
     & -2*qel*vmael*vmamo*qs*mmo**2)
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*stw**2*(-4*qel*qmo*mmo*
     & *4+8*qel*vmael*qmo*mmo**4)
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*(-2*qel*ts*mmo**2+2*qel
     & *vmamo*ts*mmo**2+4*qel*vmael*ts*mmo**2-4*qel*vmael*vmamo*ts*mmo**
     & 2)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*stw**2*(-4*qel*qmo*mmo*
     & *4+8*qel*vmael*qmo*mmo**4)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*(-2*qel*us*mmo**2+2*qel
     & *vmamo*us*mmo**2+4*qel*vmael*us*mmo**2-4*qel*vmael*vmamo*us*mmo**
     & 2)
     & +sdet4imotsus*b0fmomoc*dreal(propizqs)*stw**2*cfscheme*(-16*ctw**
     & 2*qel**2*qmo*mmo**2)
     & +sdet4imotsus*b0fqszc*dreal(propizqs)*stw**2*(4*qel*qmo*us-4*qel*
     & vmael*qmo*us-4*qel*vmael*qmo*ts)
     & +sdet4imotsus*b0fqszc*dreal(propizqs)*(2*qel*mmo**2-2*qel*vmamo*m
     & mo**2-4*qel*vmael*mmo**2+4*qel*vmael*vmamo*mmo**2)
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*stw**2*(4*qel*vmael*qmo*ts
     & )
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*stw**2*cfscheme*(8*ctw**2*
     & qel**2*qmo*mmo**2)
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*(-2*qel*mmo**2+2*qel*vmamo
     & *mmo**2+2*qel*vmael*mmo**2-2*qel*vmael*vmamo*mmo**2)
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*stw**2*(-4*qel*qmo*us+4*qe
     & l*vmael*qmo*us)
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*stw**2*cfscheme*(8*ctw**2*
     & qel**2*qmo*mmo**2)
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*(2*qel*vmael*mmo**2-2*qel*
     & vmael*vmamo*mmo**2)
     & +javqstselmoz*dreal(propizqs)*stw**2*(2*qel*qmo/qs*mmo**2-4*qel*v
     & mael*qmo/qs*mmo**2)
     & +javqstselmoz*dreal(propizqs)*(-qel/qs*mmo**2+qel*vmamo/qs*mmo**2
     & +2*qel*vmael/qs*mmo**2-2*qel*vmael*vmamo/qs*mmo**2)
     & +javqsuselmoz*dreal(propizqs)*stw**2*(2*qel*qmo/qs*mmo**2-4*qel*v
     & mael*qmo/qs*mmo**2)
     & +javqsuselmoz*dreal(propizqs)*(-qel/qs*mmo**2+qel*vmamo/qs*mmo**2
     & +2*qel*vmael/qs*mmo**2-2*qel*vmael*vmamo/qs*mmo**2)
     & +c0irmomoqs*stw**2*(-4*qmo**2*mmo**2-2*qmo**2*qs)
     & +c0irelelqs*stw**2*(-2*qel**2*qs)
     & +a0fel*stw**2*(-3*qel**2)
     & +a0fmo*stw**2*(-3*qmo**2)
     & +a0fmo*(1d0/2*det3imomoqs*qmo*qs*mmo**2)
     & +b0fqsmomo*stw**2*(-3*qmo**2)
     & +b0fqsmomo*(1d0/2*det3imomoqs*qmo*qs*mmo**2)
     & +b0fqscc*stw**2*(-3*qel**2)
     & +lnlamom*stw**2*(2*qmo**2)
     & +lnlaelm*stw**2*(2*qel**2)-1d0/2*det3imomoqs*qmo*qs*mmo**2

      ff_qed_qq =
     & +stw**2*(-qmo**2-qel**2)
     & +prop1zqs*sdet3cmots*c0irmoelts*cfscheme*(-4*ctw**2*qel*qmo/qs)
     & +prop1zqs*sdet3cmous*c0irmoelus*cfscheme*(4*ctw**2*qel*qmo/qs)
     & +prop1zqs*c0irmomoqs*cfscheme*(-4*ctw**2*qmo**2/qs*mmo**2-2*ctw**
     & 2*qmo**2)
     & +prop1zqs*c0irelelqs*cfscheme*(-2*ctw**2*qel**2)
     & +prop1zqs*lnlamom*cfscheme*(2*ctw**2*qmo**2/qs)
     & +prop1zqs*lnlaelm*cfscheme*(2*ctw**2*qel**2/qs)
     & +sdet3cmots**3*sdet4imotsus**2*jaaqstselmo*dreal(propizqs)*cfsche
     & me*(ctw**2*qel*qmo*mmo**2-ctw**2*qel*qmo*ts)
     & +sdet3cmots**2*sdet4imotsus**2*c0elelqszelc*dreal(propizqs)*stw**
     & 2*(2*qel*qmo*mz**2*mmo**2-2*qel*qmo*ts*mz**2+2*qel*qmo*qs*mmo**2-
     & 2*qel*qmo*qs*ts)
     & +sdet3cmots*sdet4imotsus**2*javqstselmoz*dreal(propizqs)*stw**2*(
     & -2*qel*qmo*ts*mz**2*mmo**2+2*qel*qmo*ts**2*mz**2-2*qel*qmo*qs*ts*
     & mmo**2+2*qel*qmo*qs*ts**2)
     & +sdet3cmots*sdet4imotsus**2*c0momoqszmoc*dreal(propizqs)*stw**2*(
     & -2*qel*qmo*mz**2*mmo**4+4*qel*qmo*ts*mz**2*mmo**2-2*qel*qmo*ts**2
     & *mz**2-2*qel*qmo*qs*mmo**4+4*qel*qmo*qs*ts*mmo**2-2*qel*qmo*qs*ts
     & **2)
     & +sdet3cmots*sdet4imotsus**2*c0momoqscmoc*dreal(propizqs)*cfscheme
     & *(8*ctw**2*qel*qmo*qs*mmo**4+2*ctw**2*qel*qmo*qs**2*mmo**2)
     & +sdet3cmots*sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*stw**2*(-
     & 4*qel*qmo*ts*mz**2*mmo**2+4*qel*qmo*ts**2*mz**2-4*qel*qmo*qs*ts*m
     & mo**2+4*qel*qmo*qs*ts**2)
     & +sdet3cmots*sdet4imotsus*jaaqstselmo*dreal(propizqs)*cfscheme*(ct
     & w**2*qel*qmo*ts)
     & +sdet3cmots*sdet4imotsus*javqstselmoz*dreal(propizqs)*stw**2*(-2*
     & qel*qmo/qs*mz**2*mmo**2-4*qel*qmo*mmo**2+4*qel*qmo*ts)
     & +sdet3cmots*sdet4imotsus*c0momoqszmoc*dreal(propizqs)*stw**2*(4*q
     & el*qmo*mmo**2)
     & +sdet3cmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*stw**2*(-8*q
     & el*qmo*mmo**2+8*qel*qmo*ts)
     & +sdet3cmots*sdet4imotsus*b0fqscc*dreal(propizqs)*cfscheme*(-2*ctw
     & **2*qel*qmo)
     & +sdet3cmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*cfscheme*(2*ctw
     & **2*qel*qmo)
     & +sdet3cmots*jaaqstselmo*dreal(propizqs)*cfscheme*(2*ctw**2*qel*qm
     & o/qs)
     & +sdet3cmots*javqstselmoz*stw**2*(4*qel*qmo)
     & +sdet3cmots*c0irelmots*stw**2*(-4*qel*qmo)
     & +sdet3cmots*c0cmotsczmo*stw**2*(4*qel*qmo)
     & +sdet3cmous**3*sdet4imotsus**2*jaaqsuselmo*dreal(propizqs)*cfsche
     & me*(-ctw**2*qel*qmo*mmo**2+ctw**2*qel*qmo*ts)
     & +sdet3cmous*sdet4imotsus**2*javqsuselmoz*dreal(propizqs)*(-qel*mz
     & **2*mmo**4+qel*us*mz**2*mmo**2-qel*qs*mmo**4+qel*qs*us*mmo**2+qel
     & *vmamo*mz**2*mmo**4-qel*vmamo*us*mz**2*mmo**2+qel*vmamo*qs*mmo**4
     & -qel*vmamo*qs*us*mmo**2)
     & +sdet3cmous*sdet4imotsus**2*c0momoqszmoc*dreal(propizqs)*(2*qel*m
     & z**2*mmo**4-qel*us*mz**2*mmo**2-qel*ts*mz**2*mmo**2+2*qel*qs*mmo*
     & *4-qel*qs*us*mmo**2-qel*qs*ts*mmo**2-2*qel*vmamo*mz**2*mmo**4+qel
     & *vmamo*us*mz**2*mmo**2+qel*vmamo*ts*mz**2*mmo**2-2*qel*vmamo*qs*m
     & mo**4+qel*vmamo*qs*us*mmo**2+qel*vmamo*qs*ts*mmo**2)
     & +sdet3cmous*sdet4imotsus**2*c0elelqszelc*dreal(propizqs)*(-qel*us
     & *mz**2*mmo**2+qel*ts*mz**2*mmo**2-qel*qs*us*mmo**2+qel*qs*ts*mmo*
     & *2+qel*vmamo*us*mz**2*mmo**2-qel*vmamo*ts*mz**2*mmo**2+qel*vmamo*
     & qs*us*mmo**2-qel*vmamo*qs*ts*mmo**2)
     & +sdet3cmous*sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*(-2*qel*m
     & z**2*mmo**4+2*qel*us*mz**2*mmo**2-2*qel*qs*mmo**4+2*qel*qs*us*mmo
     & **2+2*qel*vmamo*mz**2*mmo**4-2*qel*vmamo*us*mz**2*mmo**2+2*qel*vm
     & amo*qs*mmo**4-2*qel*vmamo*qs*us*mmo**2)
     & +sdet3cmous*sdet4imotsus*jaaqsuselmo*dreal(propizqs)*cfscheme*(-c
     & tw**2*qel*qmo*us)
     & +sdet3cmous*sdet4imotsus*javqsuselmoz*dreal(propizqs)*(qel/qs*mz*
     & *2*mmo**2+2*qel*mmo**2-qel*vmamo/qs*mz**2*mmo**2-2*qel*vmamo*mmo*
     & *2)
     & +sdet3cmous*sdet4imotsus*c0momoqszmoc*dreal(propizqs)*(-2*qel/qs*
     & mz**2*mmo**2-4*qel*mmo**2+2*qel*vmamo/qs*mz**2*mmo**2+4*qel*vmamo
     & *mmo**2)
     & +sdet3cmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*(2*qel/qs*mz
     & **2*mmo**2+4*qel*mmo**2-2*qel*vmamo/qs*mz**2*mmo**2-4*qel*vmamo*m
     & mo**2)
     & +sdet3cmous*jaaqsuselmo*dreal(propizqs)*cfscheme*(-2*ctw**2*qel*q
     & mo/qs)
     & +sdet3cmous*javqsuselmoz*stw**2*(-4*qel*qmo)
     & +sdet3cmous*c0irelmous*stw**2*(4*qel*qmo)
     & +sdet3cmous*c0cmousczmo*stw**2*(-4*qel*qmo)
     & +sdet3icmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*stw**2*(4*q
     & el*qmo*ts*mz**2*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*stw**2*(4*qel*
     & qmo*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0fmomoc*dreal(propizqs)*cfscheme*(4*ct
     & w**2*qel*qmo*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0fmomoc*dreal(propizqs)*stw**2*(4*qel*
     & qmo*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*cfscheme*(-4*c
     & tw**2*qel*qmo*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*stw**2*(-8*qel
     & *qmo*ts*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*(2*qel*mmo**4-
     & 2*qel*vmamo*mmo**4)
     & +sdet3icmous*sdet4imotsus*b0fmomoc*dreal(propizqs)*cfscheme*(-4*c
     & tw**2*qel*qmo*us*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fmomoc*dreal(propizqs)*(2*qel*mmo**4-
     & 2*qel*vmamo*mmo**4)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*cfscheme*(4*ct
     & w**2*qel*qmo*us*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*(-4*qel*mmo**4
     & +4*qel*vmamo*mmo**4)
     & +sdet3icmous*c0cmousczmo*dreal(propizqs)*(2*qel/qs*mz**2*mmo**2-2
     & *qel*vmamo/qs*mz**2*mmo**2)
     & +sdet4imotsus**2*c0momoqscmoc*dreal(propizqs)*cfscheme*(4*ctw**2*
     & qel*qmo*qs*us*mmo**4-4*ctw**2*qel*qmo*qs*ts*mmo**4-4*ctw**2*qel*q
     & mo*qs*ts*us*mmo**2+4*ctw**2*qel*qmo*qs*ts**2*mmo**2+ctw**2*qel*qm
     & o*qs**2*us*mmo**2-ctw**2*qel*qmo*qs**2*ts*mmo**2-ctw**2*qel*qmo*q
     & s**2*ts*us+ctw**2*qel*qmo*qs**2*ts**2)
     & +sdet4imotsus**2*c0elelqscelc*dreal(propizqs)*cfscheme*(ctw**2*qe
     & l*qmo*qs**2*us*mmo**2-ctw**2*qel*qmo*qs**2*ts*mmo**2-ctw**2*qel*q
     & mo*qs**2*ts*us+ctw**2*qel*qmo*qs**2*ts**2)
     & +sdet4imotsus*javqstselmoz*dreal(propizqs)*stw**2*(2*qel*qmo*mmo*
     & *4)
     & +sdet4imotsus*javqstselmoz*dreal(propizqs)*(qel*ts*mmo**2-qel*vma
     & mo*ts*mmo**2)
     & +sdet4imotsus*javqsuselmoz*dreal(propizqs)*stw**2*(2*qel*qmo*mmo*
     & *4)
     & +sdet4imotsus*javqsuselmoz*dreal(propizqs)*(qel*us*mmo**2-qel*vma
     & mo*us*mmo**2)
     & +sdet4imotsus*c0momoqszmoc*dreal(propizqs)*stw**2*(8*qel*qmo*ts*m
     & mo**2-2*qel*qmo*ts*mz**2+2*qel*qmo*qs*ts)
     & +sdet4imotsus*c0momoqszmoc*dreal(propizqs)*(qel/qs*us*mz**2*mmo**
     & 2-qel/qs*ts*mz**2*mmo**2+4*qel*mmo**4+qel*us*mmo**2-qel*ts*mmo**2
     & -qel*vmamo/qs*us*mz**2*mmo**2+qel*vmamo/qs*ts*mz**2*mmo**2-4*qel*
     & vmamo*mmo**4-qel*vmamo*us*mmo**2+qel*vmamo*ts*mmo**2)
     & +sdet4imotsus*c0momoqscmoc*dreal(propizqs)*cfscheme*(-4*ctw**2*qe
     & l*qmo*us*mmo**2+4*ctw**2*qel*qmo*ts*mmo**2+2*ctw**2*qel*qmo*qs*mm
     & o**2-ctw**2*qel*qmo*qs*us+ctw**2*qel*qmo*qs*ts)
     & +sdet4imotsus*c0elelqszelc*dreal(propizqs)*stw**2*(-2*qel*qmo*ts*
     & mz**2+2*qel*qmo*qs*ts)
     & +sdet4imotsus*c0elelqszelc*dreal(propizqs)*(-qel*mz**2*mmo**2+qel
     & *qs*mmo**2+qel*vmamo*mz**2*mmo**2-qel*vmamo*qs*mmo**2)
     & +sdet4imotsus*c0elelqscelc*dreal(propizqs)*cfscheme*(-ctw**2*qel*
     & qmo*qs*us+ctw**2*qel*qmo*qs*ts)
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*stw**2*(4*qel*qmo*mmo**
     & 4)
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*(2*qel*ts*mmo**2-2*qel*
     & vmamo*ts*mmo**2)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*stw**2*(4*qel*qmo*mmo**
     & 4)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*(2*qel*us*mmo**2-2*qel*
     & vmamo*us*mmo**2)
     & +sdet4imotsus*b0fmomoc*dreal(propizqs)*cfscheme*(4*ctw**2*qel*qmo
     & *mmo**2)
     & +sdet4imotsus*b0fqszc*dreal(propizqs)*stw**2*(-4*qel*qmo*ts)
     & +sdet4imotsus*b0fqszc*dreal(propizqs)*(-2*qel*mmo**2+2*qel*vmamo*
     & mmo**2)
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*cfscheme*(-2*ctw**2*qel*qm
     & o*mmo**2)
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*stw**2*(4*qel*qmo*ts)
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*cfscheme*(-2*ctw**2*qel*qm
     & o*mmo**2)
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*(2*qel*mmo**2-2*qel*vmamo*
     & mmo**2)
     & +javqstselmoz*dreal(propizqs)*stw**2*(-2*qel*qmo/qs*mmo**2)
     & +javqstselmoz*dreal(propizqs)*(qel/qs*mmo**2-qel*vmamo/qs*mmo**2)
     & +javqsuselmoz*dreal(propizqs)*stw**2*(-2*qel*qmo/qs*mmo**2)
     & +javqsuselmoz*dreal(propizqs)*(qel/qs*mmo**2-qel*vmamo/qs*mmo**2)
     & +c0irmomoqs*stw**2*(-4*qmo**2*mmo**2-2*qmo**2*qs)
     & +c0irelelqs*stw**2*(-2*qel**2*qs)
     & +a0fel*stw**2*(-3*qel**2)
     & +a0fel*dreal(propizqs)*cfscheme*(-3*ctw**2*qel**2/qs)
     & +a0fmo*stw**2*(-3*qmo**2)
     & +a0fmo*dreal(propizqs)*cfscheme*(-3*ctw**2*qmo**2/qs)
     & +a0fmo*(1d0/2*det3imomoqs*qmo*qs*mmo**2)
     & +b0fqsmomo*stw**2*(-3*qmo**2)
     & +b0fqsmomo*dreal(propizqs)*cfscheme*(-3*ctw**2*qmo**2/qs)
     & +b0fqsmomo*(1d0/2*det3imomoqs*qmo*qs*mmo**2)
     & +b0fqscc*stw**2*(-3*qel**2)
     & +b0fqscc*dreal(propizqs)*cfscheme*(-3*ctw**2*qel**2/qs)
     & +lnlamom*stw**2*(2*qmo**2)
     & +lnlaelm*stw**2*(2*qel**2)
     & +dreal(propizqs)*cfscheme*(-ctw**2*qmo**2/qs-ctw**2*qel**2/qs)-1d
     & 0/2*det3imomoqs*qmo*qs*mmo**2

      ff_qed_ld =
     & +stw**2*(-1d0/2*det3imomoqs*qmo**2*qs+det3imomoqs*qmo**2*vmamo*qs
     & )
     & +sdet3cmots**2*sdet4imotsus**2*c0elelqszelc*dreal(propizqs)*stw**
     & 2*(4*qel*qmo*mz**2+4*qel*qmo*qs-4*qel*qmo*vmamo*mz**2-4*qel*qmo*v
     & mamo*qs-4*qel*vmael*qmo*mz**2-4*qel*vmael*qmo*qs)
     & +sdet3cmots**2*sdet4imotsus*javqstselmoz*dreal(propizqs)*stw**2*(
     & 2*qel*qmo/qs-4*qel*vmael*qmo/qs)
     & +sdet3cmots*sdet4imotsus**2*javqstselmoz*dreal(propizqs)*stw**2*(
     & -4*qel*qmo*ts*mz**2-4*qel*qmo*qs*ts+4*qel*qmo*vmamo*ts*mz**2+4*qe
     & l*qmo*vmamo*qs*ts+4*qel*vmael*qmo*ts*mz**2+4*qel*vmael*qmo*qs*ts)
     &
     & +sdet3cmots*sdet4imotsus**2*c0momoqszmoc*dreal(propizqs)*stw**2*(
     & -4*qel*qmo*mz**2*mmo**2+4*qel*qmo*ts*mz**2-4*qel*qmo*qs*mmo**2+4*
     & qel*qmo*qs*ts+4*qel*qmo*vmamo*mz**2*mmo**2-4*qel*qmo*vmamo*ts*mz*
     & *2+4*qel*qmo*vmamo*qs*mmo**2-4*qel*qmo*vmamo*qs*ts+4*qel*vmael*qm
     & o*mz**2*mmo**2-4*qel*vmael*qmo*ts*mz**2+4*qel*vmael*qmo*qs*mmo**2
     & -4*qel*vmael*qmo*qs*ts)
     & +sdet3cmots*sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*stw**2*(-
     & 8*qel*qmo*ts*mz**2-8*qel*qmo*qs*ts+8*qel*qmo*vmamo*ts*mz**2+8*qel
     & *qmo*vmamo*qs*ts+8*qel*vmael*qmo*ts*mz**2+8*qel*vmael*qmo*qs*ts)
     & +sdet3cmots*sdet4imotsus*javqstselmoz*dreal(propizqs)*stw**2*(-2*
     & qel*qmo/qs*mz**2-4*qel*qmo+2*qel*qmo*vmamo/qs*mz**2+4*qel*qmo*vma
     & mo+2*qel*vmael*qmo/qs*mz**2+4*qel*vmael*qmo)
     & +sdet3cmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*stw**2*(-8*q
     & el*qmo+8*qel*qmo*vmamo+8*qel*vmael*qmo)
     & +sdet3cmous**2*sdet4imotsus**2*c0elelqszelc*dreal(propizqs)*stw**
     & 2*(4*qel*qmo*vmamo*mz**2+4*qel*qmo*vmamo*qs-4*qel*vmael*qmo*mz**2
     & -4*qel*vmael*qmo*qs)
     & +sdet3cmous**2*sdet4imotsus*javqsuselmoz*dreal(propizqs)*stw**2*(
     & 2*qel*qmo/qs-4*qel*vmael*qmo/qs)
     & +sdet3cmous*sdet4imotsus**2*javqsuselmoz*dreal(propizqs)*stw**2*(
     & -4*qel*qmo*vmamo*us*mz**2-4*qel*qmo*vmamo*qs*us+4*qel*vmael*qmo*u
     & s*mz**2+4*qel*vmael*qmo*qs*us)
     & +sdet3cmous*sdet4imotsus**2*c0momoqszmoc*dreal(propizqs)*stw**2*(
     & -4*qel*qmo*vmamo*mz**2*mmo**2+4*qel*qmo*vmamo*us*mz**2-4*qel*qmo*
     & vmamo*qs*mmo**2+4*qel*qmo*vmamo*qs*us+4*qel*vmael*qmo*mz**2*mmo**
     & 2-4*qel*vmael*qmo*us*mz**2+4*qel*vmael*qmo*qs*mmo**2-4*qel*vmael*
     & qmo*qs*us)
     & +sdet3cmous*sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*stw**2*(-
     & 8*qel*qmo*vmamo*us*mz**2-8*qel*qmo*vmamo*qs*us+8*qel*vmael*qmo*us
     & *mz**2+8*qel*vmael*qmo*qs*us)
     & +sdet3cmous*sdet4imotsus*javqsuselmoz*dreal(propizqs)*stw**2*(-2*
     & qel*qmo*vmamo/qs*mz**2-4*qel*qmo*vmamo+2*qel*vmael*qmo/qs*mz**2+4
     & *qel*vmael*qmo)
     & +sdet3cmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*stw**2*(-8*q
     & el*qmo*vmamo+8*qel*vmael*qmo)
     & +sdet3icmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*stw**2*(4*q
     & el*qmo*ts*mz**2-4*qel*qmo*vmamo*ts*mz**2-4*qel*vmael*qmo*ts*mz**2
     & )
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*stw**2*(4*qel*
     & qmo*ts-4*qel*qmo*vmamo*ts-4*qel*vmael*qmo*ts)
     & +sdet3icmots*sdet4imotsus*b0fmomoc*dreal(propizqs)*stw**2*(4*qel*
     & qmo*ts-4*qel*qmo*vmamo*ts-4*qel*vmael*qmo*ts)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*stw**2*(-8*qel
     & *qmo*ts+8*qel*qmo*vmamo*ts+8*qel*vmael*qmo*ts)
     & +sdet3icmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*stw**2*(4*q
     & el*qmo*vmamo*us*mz**2-4*qel*vmael*qmo*us*mz**2)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*stw**2*(4*qel*
     & qmo*vmamo*us-4*qel*vmael*qmo*us)
     & +sdet3icmous*sdet4imotsus*b0fmomoc*dreal(propizqs)*stw**2*(4*qel*
     & qmo*vmamo*us-4*qel*vmael*qmo*us)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*stw**2*(-8*qel
     & *qmo*vmamo*us+8*qel*vmael*qmo*us)
     & +sdet4imotsus*c0momoqszmoc*dreal(propizqs)*stw**2*(-2*qel*qmo*mz*
     & *2-2*qel*qmo*qs+4*qel*vmael*qmo*mz**2+4*qel*vmael*qmo*qs+4*det3im
     & omoqs*qel*qmo*qs*mmo**4-det3imomoqs*qel*qmo*qs*mz**2*mmo**2-4*det
     & 3imomoqs*qel*qmo*qs*ts*mmo**2+det3imomoqs*qel*qmo*qs*ts*mz**2-4*d
     & et3imomoqs*qel*qmo*vmamo*qs*us*mmo**2+det3imomoqs*qel*qmo*vmamo*q
     & s*us*mz**2+4*det3imomoqs*qel*qmo*vmamo*qs*ts*mmo**2-det3imomoqs*q
     & el*qmo*vmamo*qs*ts*mz**2-8*det3imomoqs*qel*vmael*qmo*qs*mmo**4+2*
     & det3imomoqs*qel*vmael*qmo*qs*mz**2*mmo**2+4*det3imomoqs*qel*vmael
     & *qmo*qs*us*mmo**2-det3imomoqs*qel*vmael*qmo*qs*us*mz**2+4*det3imo
     & moqs*qel*vmael*qmo*qs*ts*mmo**2-det3imomoqs*qel*vmael*qmo*qs*ts*m
     & z**2)
     & +sdet4imotsus*c0elelqszelc*dreal(propizqs)*stw**2*(2*qel*qmo*mz**
     & 2-2*qel*qmo*qs-4*qel*vmael*qmo*mz**2+4*qel*vmael*qmo*qs)
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*stw**2*(-4*qel*qmo*ts+8
     & *qel*vmael*qmo*ts)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*stw**2*(-4*qel*qmo*us+8
     & *qel*vmael*qmo*us)
     & +sdet4imotsus*b0fmozmo*dreal(propizqs)*stw**2*(det3imomoqs*qel*qm
     & o*qs*mmo**2-det3imomoqs*qel*qmo*qs*ts-det3imomoqs*qel*qmo*vmamo*q
     & s*us+det3imomoqs*qel*qmo*vmamo*qs*ts-2*det3imomoqs*qel*vmael*qmo*
     & qs*mmo**2+det3imomoqs*qel*vmael*qmo*qs*us+det3imomoqs*qel*vmael*q
     & mo*qs*ts)
     & +sdet4imotsus*b0fmomoc*dreal(propizqs)*stw**2*(det3imomoqs*qel*qm
     & o*qs*mmo**2-det3imomoqs*qel*qmo*qs*ts-det3imomoqs*qel*qmo*vmamo*q
     & s*us+det3imomoqs*qel*qmo*vmamo*qs*ts-2*det3imomoqs*qel*vmael*qmo*
     & qs*mmo**2+det3imomoqs*qel*vmael*qmo*qs*us+det3imomoqs*qel*vmael*q
     & mo*qs*ts)
     & +sdet4imotsus*b0fqszc*dreal(propizqs)*stw**2*(-2*det3imomoqs*qel*
     & qmo*qs*mmo**2+2*det3imomoqs*qel*qmo*qs*ts+2*det3imomoqs*qel*qmo*v
     & mamo*qs*us-2*det3imomoqs*qel*qmo*vmamo*qs*ts+4*det3imomoqs*qel*vm
     & ael*qmo*qs*mmo**2-2*det3imomoqs*qel*vmael*qmo*qs*us-2*det3imomoqs
     & *qel*vmael*qmo*qs*ts)
     & +a0fmo*stw**2*(1d0/2*det3imomoqs*qmo**2*qs-det3imomoqs*qmo**2*vma
     & mo*qs)
     & +b0fqsmomo*stw**2*(1d0/2*det3imomoqs*qmo**2*qs-det3imomoqs*qmo**2
     & *vmamo*qs)

      ff_qed_qd =
     & +stw**2*(-1d0/2*det3imomoqs*qmo**2*qs+det3imomoqs*qmo**2*vmamo*qs
     & )
     & +sdet3cmots**3*sdet4imotsus**2*jaaqstselmo*dreal(propizqs)*stw**2
     & *cfscheme*(4*ctw**2*qel*qmo**2)
     & +sdet3cmots**2*sdet4imotsus**2*c0elelqszelc*dreal(propizqs)*stw**
     & 2*(-4*qel*qmo*vmamo*mz**2-4*qel*qmo*vmamo*qs)
     & +sdet3cmots**2*sdet4imotsus*javqstselmoz*dreal(propizqs)*stw**2*(
     & -2*qel*qmo/qs)
     & +sdet3cmots*sdet4imotsus**2*javqstselmoz*dreal(propizqs)*stw**2*(
     & 4*qel*qmo*vmamo*ts*mz**2+4*qel*qmo*vmamo*qs*ts)
     & +sdet3cmots*sdet4imotsus**2*c0momoqszmoc*dreal(propizqs)*stw**2*(
     & 4*qel*qmo*vmamo*mz**2*mmo**2-4*qel*qmo*vmamo*ts*mz**2+4*qel*qmo*v
     & mamo*qs*mmo**2-4*qel*qmo*vmamo*qs*ts)
     & +sdet3cmots*sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*stw**2*(8
     & *qel*qmo*vmamo*ts*mz**2+8*qel*qmo*vmamo*qs*ts)
     & +sdet3cmots*sdet4imotsus*javqstselmoz*dreal(propizqs)*stw**2*(2*q
     & el*qmo*vmamo/qs*mz**2+4*qel*qmo*vmamo)
     & +sdet3cmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*stw**2*(8*qe
     & l*qmo*vmamo)
     & +sdet3cmous**3*sdet4imotsus**2*jaaqsuselmo*dreal(propizqs)*stw**2
     & *cfscheme*(-4*ctw**2*qel*qmo**2)
     & +sdet3cmous**2*sdet4imotsus**2*c0elelqszelc*dreal(propizqs)*stw**
     & 2*(-4*qel*qmo*mz**2-4*qel*qmo*qs+4*qel*qmo*vmamo*mz**2+4*qel*qmo*
     & vmamo*qs)
     & +sdet3cmous**2*sdet4imotsus*javqsuselmoz*dreal(propizqs)*stw**2*(
     & -2*qel*qmo/qs)
     & +sdet3cmous*sdet4imotsus**2*javqsuselmoz*dreal(propizqs)*stw**2*(
     & 4*qel*qmo*us*mz**2+4*qel*qmo*qs*us-4*qel*qmo*vmamo*us*mz**2-4*qel
     & *qmo*vmamo*qs*us)
     & +sdet3cmous*sdet4imotsus**2*c0momoqszmoc*dreal(propizqs)*stw**2*(
     & 4*qel*qmo*mz**2*mmo**2-4*qel*qmo*us*mz**2+4*qel*qmo*qs*mmo**2-4*q
     & el*qmo*qs*us-4*qel*qmo*vmamo*mz**2*mmo**2+4*qel*qmo*vmamo*us*mz**
     & 2-4*qel*qmo*vmamo*qs*mmo**2+4*qel*qmo*vmamo*qs*us)
     & +sdet3cmous*sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*stw**2*(8
     & *qel*qmo*us*mz**2+8*qel*qmo*qs*us-8*qel*qmo*vmamo*us*mz**2-8*qel*
     & qmo*vmamo*qs*us)
     & +sdet3cmous*sdet4imotsus*javqsuselmoz*dreal(propizqs)*stw**2*(2*q
     & el*qmo/qs*mz**2+4*qel*qmo-2*qel*qmo*vmamo/qs*mz**2-4*qel*qmo*vmam
     & o)
     & +sdet3cmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*stw**2*(8*qe
     & l*qmo-8*qel*qmo*vmamo)
     & +sdet3icmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*stw**2*(-4*
     & qel*qmo*vmamo*ts*mz**2)
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*stw**2*(-4*qel
     & *qmo*vmamo*ts)
     & +sdet3icmots*sdet4imotsus*b0fmomoc*dreal(propizqs)*stw**2*(-4*qel
     & *qmo*vmamo*ts)
     & +sdet3icmots*sdet4imotsus*b0fmomoc*dreal(propizqs)*stw**2*cfschem
     & e*(8*ctw**2*qel*qmo**2*ts)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*stw**2*(8*qel*
     & qmo*vmamo*ts)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*stw**2*cfschem
     & e*(-8*ctw**2*qel*qmo**2*ts)
     & +sdet3icmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*stw**2*(-4*
     & qel*qmo*us*mz**2+4*qel*qmo*vmamo*us*mz**2)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*stw**2*(-4*qel
     & *qmo*us+4*qel*qmo*vmamo*us)
     & +sdet3icmous*sdet4imotsus*b0fmomoc*dreal(propizqs)*stw**2*(-4*qel
     & *qmo*us+4*qel*qmo*vmamo*us)
     & +sdet3icmous*sdet4imotsus*b0fmomoc*dreal(propizqs)*stw**2*cfschem
     & e*(-8*ctw**2*qel*qmo**2*us)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*stw**2*(8*qel*
     & qmo*us-8*qel*qmo*vmamo*us)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*stw**2*cfschem
     & e*(8*ctw**2*qel*qmo**2*us)
     & +sdet4imotsus**2*c0momoqscmoc*dreal(propizqs)*stw**2*cfscheme*(8*
     & ctw**2*qel*qmo**2*qs*us*mmo**2-8*ctw**2*qel*qmo**2*qs*ts*mmo**2+4
     & *ctw**2*qel*qmo**2*qs**2*us-4*ctw**2*qel*qmo**2*qs**2*ts)
     & +sdet4imotsus**2*c0elelqscelc*dreal(propizqs)*stw**2*cfscheme*(4*
     & ctw**2*qel*qmo**2*qs**2*us-4*ctw**2*qel*qmo**2*qs**2*ts)
     & +sdet4imotsus*c0momoqszmoc*dreal(propizqs)*stw**2*(2*qel*qmo*mz**
     & 2+2*qel*qmo*qs-4*det3imomoqs*qel*qmo*qs*mmo**4+det3imomoqs*qel*qm
     & o*qs*mz**2*mmo**2+4*det3imomoqs*qel*qmo*qs*us*mmo**2-det3imomoqs*
     & qel*qmo*qs*us*mz**2-4*det3imomoqs*qel*qmo*vmamo*qs*us*mmo**2+det3
     & imomoqs*qel*qmo*vmamo*qs*us*mz**2+4*det3imomoqs*qel*qmo*vmamo*qs*
     & ts*mmo**2-det3imomoqs*qel*qmo*vmamo*qs*ts*mz**2)
     & +sdet4imotsus*c0momoqscmoc*dreal(propizqs)*stw**2*cfscheme*(4*det
     & 3imomoqs*ctw**2*qel*qmo**2*qs*us*mmo**2-4*det3imomoqs*ctw**2*qel*
     & qmo**2*qs*ts*mmo**2)
     & +sdet4imotsus*c0elelqszelc*dreal(propizqs)*stw**2*(-2*qel*qmo*mz*
     & *2+2*qel*qmo*qs)
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*stw**2*(4*qel*qmo*ts)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*stw**2*(4*qel*qmo*us)
     & +sdet4imotsus*b0fmozmo*dreal(propizqs)*stw**2*(-det3imomoqs*qel*q
     & mo*qs*mmo**2+det3imomoqs*qel*qmo*qs*us-det3imomoqs*qel*qmo*vmamo*
     & qs*us+det3imomoqs*qel*qmo*vmamo*qs*ts)
     & +sdet4imotsus*b0fmomoc*dreal(propizqs)*stw**2*(-det3imomoqs*qel*q
     & mo*qs*mmo**2+det3imomoqs*qel*qmo*qs*us-det3imomoqs*qel*qmo*vmamo*
     & qs*us+det3imomoqs*qel*qmo*vmamo*qs*ts)
     & +sdet4imotsus*b0fmomoc*dreal(propizqs)*stw**2*cfscheme*(2*det3imo
     & moqs*ctw**2*qel*qmo**2*qs*us-2*det3imomoqs*ctw**2*qel*qmo**2*qs*t
     & s)
     & +sdet4imotsus*b0fqszc*dreal(propizqs)*stw**2*(2*det3imomoqs*qel*q
     & mo*qs*mmo**2-2*det3imomoqs*qel*qmo*qs*us+2*det3imomoqs*qel*qmo*vm
     & amo*qs*us-2*det3imomoqs*qel*qmo*vmamo*qs*ts)
     & +sdet4imotsus*b0fqscc*dreal(propizqs)*stw**2*cfscheme*(-2*det3imo
     & moqs*ctw**2*qel*qmo**2*qs*us+2*det3imomoqs*ctw**2*qel*qmo**2*qs*t
     & s)
     & +a0fmo*stw**2*(1d0/2*det3imomoqs*qmo**2*qs-det3imomoqs*qmo**2*vma
     & mo*qs)
     & +a0fmo*dreal(propizqs)*stw**2*cfscheme*(2*det3imomoqs*ctw**2*qmo*
     & *3)
     & +b0fqsmomo*stw**2*(1d0/2*det3imomoqs*qmo**2*qs-det3imomoqs*qmo**2
     & *vmamo*qs)
     & +b0fqsmomo*dreal(propizqs)*stw**2*cfscheme*(2*det3imomoqs*ctw**2*
     & qmo**3)
     & +dreal(propizqs)*stw**2*cfscheme*(-2*det3imomoqs*ctw**2*qmo**3)

      ff_ew_ll =
     & +1d0/stw**2*(deltarhofer+deltarhobos)
     & +sdet3cmots**2*sdet4imotsus**2*d0ccmomoqstszczmo*dreal(propizqs)*
     & (pxx2zqsc**2/ctw**2*mmo**2+1d0/4*pxx2zqsc**2/ctw**2*qs-2*pxx2zqsc
     & **2/ctw**2*vmamo*mmo**2-1d0/2*pxx2zqsc**2/ctw**2*vmamo*qs+pxx2zqs
     & c**2/ctw**2*vmamo**2*mmo**2+1d0/4*pxx2zqsc**2/ctw**2*vmamo**2*qs-
     & 2*pxx2zqsc**2/ctw**2*vmael*mmo**2-1d0/2*pxx2zqsc**2/ctw**2*vmael*
     & qs+4*pxx2zqsc**2/ctw**2*vmael*vmamo*mmo**2+pxx2zqsc**2/ctw**2*vma
     & el*vmamo*qs-2*pxx2zqsc**2/ctw**2*vmael*vmamo**2*mmo**2-1d0/2*pxx2
     & zqsc**2/ctw**2*vmael*vmamo**2*qs+pxx2zqsc**2/ctw**2*vmael**2*mmo*
     & *2+1d0/4*pxx2zqsc**2/ctw**2*vmael**2*qs-2*pxx2zqsc**2/ctw**2*vmae
     & l**2*vmamo*mmo**2-1d0/2*pxx2zqsc**2/ctw**2*vmael**2*vmamo*qs+2*px
     & x2zqsc**2/ctw**2*vmael**2*vmamo**2*mmo**2+1d0/2*pxx2zqsc**2/ctw**
     & 2*vmael**2*vmamo**2*qs)
     & +sdet3cmots**2*sdet4imotsus**2*c0ccqszcz*dreal(propizqs)*(1d0/4*p
     & xx2zqsc/ctw**2*mmo**2-1d0/4*pxx2zqsc/ctw**2*ts-1d0/2*pxx2zqsc/ctw
     & **2*vmamo*mmo**2+1d0/2*pxx2zqsc/ctw**2*vmamo*ts+1d0/4*pxx2zqsc/ct
     & w**2*vmamo**2*mmo**2-1d0/4*pxx2zqsc/ctw**2*vmamo**2*ts-1d0/2*pxx2
     & zqsc/ctw**2*vmael*mmo**2+1d0/2*pxx2zqsc/ctw**2*vmael*ts+pxx2zqsc/
     & ctw**2*vmael*vmamo*mmo**2-pxx2zqsc/ctw**2*vmael*vmamo*ts-1d0/2*px
     & x2zqsc/ctw**2*vmael*vmamo**2*mmo**2+1d0/2*pxx2zqsc/ctw**2*vmael*v
     & mamo**2*ts+1d0/4*pxx2zqsc/ctw**2*vmael**2*mmo**2-1d0/4*pxx2zqsc/c
     & tw**2*vmael**2*ts-1d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo*mmo**2+1d0
     & /2*pxx2zqsc/ctw**2*vmael**2*vmamo*ts+1d0/2*pxx2zqsc/ctw**2*vmael*
     & *2*vmamo**2*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo**2*ts)
     & +sdet3cmots*sdet4imotsus**2*d0ccmomoqstszczmo*dreal(propizqs)*(1d
     & 0/4*pxx2zqsc**2/ctw**2*mmo**4-1d0/4*pxx2zqsc**2/ctw**2*ts*mmo**2-
     & 1d0/2*pxx2zqsc**2/ctw**2*vmamo*mmo**4+1d0/2*pxx2zqsc**2/ctw**2*vm
     & amo*ts*mmo**2+1d0/4*pxx2zqsc**2/ctw**2*vmamo**2*mmo**4-1d0/4*pxx2
     & zqsc**2/ctw**2*vmamo**2*ts*mmo**2-1d0/2*pxx2zqsc**2/ctw**2*vmael*
     & mmo**4+1d0/2*pxx2zqsc**2/ctw**2*vmael*ts*mmo**2+pxx2zqsc**2/ctw**
     & 2*vmael*vmamo*mmo**4-pxx2zqsc**2/ctw**2*vmael*vmamo*ts*mmo**2-1d0
     & /2*pxx2zqsc**2/ctw**2*vmael*vmamo**2*mmo**4+1d0/2*pxx2zqsc**2/ctw
     & **2*vmael*vmamo**2*ts*mmo**2+1d0/4*pxx2zqsc**2/ctw**2*vmael**2*mm
     & o**4-1d0/4*pxx2zqsc**2/ctw**2*vmael**2*ts*mmo**2-1d0/2*pxx2zqsc**
     & 2/ctw**2*vmael**2*vmamo*mmo**4+1d0/2*pxx2zqsc**2/ctw**2*vmael**2*
     & vmamo*ts*mmo**2+1d0/2*pxx2zqsc**2/ctw**2*vmael**2*vmamo**2*mmo**4
     & -1d0/2*pxx2zqsc**2/ctw**2*vmael**2*vmamo**2*ts*mmo**2)
     & +sdet3cmots*sdet4imotsus**2*c0momoqszmoz*dreal(propizqs)*(pxx2zqs
     & c/ctw**2*mmo**4+pxx2zqsc/ctw**2*ts*mmo**2+1d0/4*pxx2zqsc/ctw**2*q
     & s*mmo**2+1d0/4*pxx2zqsc/ctw**2*qs*ts-2*pxx2zqsc/ctw**2*vmamo*mmo*
     & *4-2*pxx2zqsc/ctw**2*vmamo*ts*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmamo*
     & qs*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmamo*qs*ts+pxx2zqsc/ctw**2*vmamo
     & **2*mmo**4+pxx2zqsc/ctw**2*vmamo**2*ts*mmo**2+1d0/4*pxx2zqsc/ctw*
     & *2*vmamo**2*qs*mmo**2+1d0/4*pxx2zqsc/ctw**2*vmamo**2*qs*ts-2*pxx2
     & zqsc/ctw**2*vmael*mmo**4-2*pxx2zqsc/ctw**2*vmael*ts*mmo**2-1d0/2*
     & pxx2zqsc/ctw**2*vmael*qs*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael*qs*ts
     & +4*pxx2zqsc/ctw**2*vmael*vmamo*mmo**4+4*pxx2zqsc/ctw**2*vmael*vma
     & mo*ts*mmo**2+pxx2zqsc/ctw**2*vmael*vmamo*qs*mmo**2+pxx2zqsc/ctw**
     & 2*vmael*vmamo*qs*ts-2*pxx2zqsc/ctw**2*vmael*vmamo**2*mmo**4-2*pxx
     & 2zqsc/ctw**2*vmael*vmamo**2*ts*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael
     & *vmamo**2*qs*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael*vmamo**2*qs*ts+px
     & x2zqsc/ctw**2*vmael**2*mmo**4+pxx2zqsc/ctw**2*vmael**2*ts*mmo**2+
     & 1d0/4*pxx2zqsc/ctw**2*vmael**2*qs*mmo**2+1d0/4*pxx2zqsc/ctw**2*vm
     & ael**2*qs*ts-2*pxx2zqsc/ctw**2*vmael**2*vmamo*mmo**4-2*pxx2zqsc/c
     & tw**2*vmael**2*vmamo*ts*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael**2*vma
     & mo*qs*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo*qs*ts+2*pxx2zqs
     & c/ctw**2*vmael**2*vmamo**2*mmo**4+2*pxx2zqsc/ctw**2*vmael**2*vmam
     & o**2*ts*mmo**2+1d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo**2*qs*mmo**2+
     & 1d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo**2*qs*ts)
     & +sdet3cmots*sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*(-1d0/2*p
     & xx2zqsc/ctw**2*mmo**4+1d0/2*pxx2zqsc/ctw**2*ts**2+pxx2zqsc/ctw**2
     & *vmamo*mmo**4-pxx2zqsc/ctw**2*vmamo*ts**2-1d0/2*pxx2zqsc/ctw**2*v
     & mamo**2*mmo**4+1d0/2*pxx2zqsc/ctw**2*vmamo**2*ts**2+pxx2zqsc/ctw*
     & *2*vmael*mmo**4-pxx2zqsc/ctw**2*vmael*ts**2-2*pxx2zqsc/ctw**2*vma
     & el*vmamo*mmo**4+2*pxx2zqsc/ctw**2*vmael*vmamo*ts**2+pxx2zqsc/ctw*
     & *2*vmael*vmamo**2*mmo**4-pxx2zqsc/ctw**2*vmael*vmamo**2*ts**2-1d0
     & /2*pxx2zqsc/ctw**2*vmael**2*mmo**4+1d0/2*pxx2zqsc/ctw**2*vmael**2
     & *ts**2+pxx2zqsc/ctw**2*vmael**2*vmamo*mmo**4-pxx2zqsc/ctw**2*vmae
     & l**2*vmamo*ts**2-pxx2zqsc/ctw**2*vmael**2*vmamo**2*mmo**4+pxx2zqs
     & c/ctw**2*vmael**2*vmamo**2*ts**2)
     & +sdet3cmots*sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*(-1d0/
     & 8/ctw**2*qs*mmo**2+1d0/8/ctw**2*qs*ts+1d0/4/ctw**2*vmamo*qs*mmo**
     & 2-1d0/4/ctw**2*vmamo*qs*ts-1d0/8/ctw**2*vmamo**2*qs*mmo**2+1d0/8/
     & ctw**2*vmamo**2*qs*ts+1d0/4/ctw**2*vmael*qs*mmo**2-1d0/4/ctw**2*v
     & mael*qs*ts-1d0/2/ctw**2*vmael*vmamo*qs*mmo**2+1d0/2/ctw**2*vmael*
     & vmamo*qs*ts+1d0/4/ctw**2*vmael*vmamo**2*qs*mmo**2-1d0/4/ctw**2*vm
     & ael*vmamo**2*qs*ts-1d0/8/ctw**2*vmael**2*qs*mmo**2+1d0/8/ctw**2*v
     & mael**2*qs*ts+1d0/4/ctw**2*vmael**2*vmamo*qs*mmo**2-1d0/4/ctw**2*
     & vmael**2*vmamo*qs*ts-1d0/4/ctw**2*vmael**2*vmamo**2*qs*mmo**2+1d0
     & /4/ctw**2*vmael**2*vmamo**2*qs*ts-pxx2zqsc/ctw**2*mmo**2+2*pxx2zq
     & sc/ctw**2*vmamo*mmo**2-pxx2zqsc/ctw**2*vmamo**2*mmo**2+2*pxx2zqsc
     & /ctw**2*vmael*mmo**2-4*pxx2zqsc/ctw**2*vmael*vmamo*mmo**2+2*pxx2z
     & qsc/ctw**2*vmael*vmamo**2*mmo**2-pxx2zqsc/ctw**2*vmael**2*mmo**2+
     & 2*pxx2zqsc/ctw**2*vmael**2*vmamo*mmo**2-2*pxx2zqsc/ctw**2*vmael**
     & 2*vmamo**2*mmo**2+1d0/8*pxx2zqsc**2/ctw**2-1d0/4*pxx2zqsc**2/ctw*
     & *2*vmamo+1d0/8*pxx2zqsc**2/ctw**2*vmamo**2-1d0/4*pxx2zqsc**2/ctw*
     & *2*vmael+1d0/2*pxx2zqsc**2/ctw**2*vmael*vmamo-1d0/4*pxx2zqsc**2/c
     & tw**2*vmael*vmamo**2+1d0/8*pxx2zqsc**2/ctw**2*vmael**2-1d0/4*pxx2
     & zqsc**2/ctw**2*vmael**2*vmamo+1d0/4*pxx2zqsc**2/ctw**2*vmael**2*v
     & mamo**2)
     & +sdet3cmots*sdet4imotsus*c0ccqszcz*dreal(propizqs)*(-1d0/2/ctw**2
     & *mmo**2-1d0/2/ctw**2*ts+2/ctw**2*vmamo*mmo**2+1d0/ctw**2*vmamo*ts
     & -3d0/2/ctw**2*vmamo**2*mmo**2-1d0/2/ctw**2*vmamo**2*ts+1d0/ctw**2
     & *vmael*mmo**2+1d0/ctw**2*vmael*ts-4/ctw**2*vmael*vmamo*mmo**2-2/c
     & tw**2*vmael*vmamo*ts+3/ctw**2*vmael*vmamo**2*mmo**2+1d0/ctw**2*vm
     & ael*vmamo**2*ts-1d0/2/ctw**2*vmael**2*mmo**2-1d0/2/ctw**2*vmael**
     & 2*ts+3/ctw**2*vmael**2*vmamo*mmo**2+1d0/ctw**2*vmael**2*vmamo*ts-
     & 3/ctw**2*vmael**2*vmamo**2*mmo**2-1d0/ctw**2*vmael**2*vmamo**2*ts
     & )
     & +sdet3cmots*d0ccmomoqstszczmo*dreal(propizqs)*(1d0/2/ctw**2*vmamo
     & **2-1d0/ctw**2*vmael*vmamo**2+1d0/2/ctw**2*vmael**2-1d0/ctw**2*vm
     & ael**2*vmamo+1d0/ctw**2*vmael**2*vmamo**2)
     & +sdet3cmous**2*sdet4imotsus**2*d0ccmomoqsuszczmo*dreal(propizqs)*
     & (pxx2zqsc**2/ctw**2*vmamo**2*mmo**2+1d0/4*pxx2zqsc**2/ctw**2*vmam
     & o**2*qs-2*pxx2zqsc**2/ctw**2*vmael*vmamo**2*mmo**2-1d0/2*pxx2zqsc
     & **2/ctw**2*vmael*vmamo**2*qs+pxx2zqsc**2/ctw**2*vmael**2*mmo**2+1
     & d0/4*pxx2zqsc**2/ctw**2*vmael**2*qs-2*pxx2zqsc**2/ctw**2*vmael**2
     & *vmamo*mmo**2-1d0/2*pxx2zqsc**2/ctw**2*vmael**2*vmamo*qs+2*pxx2zq
     & sc**2/ctw**2*vmael**2*vmamo**2*mmo**2+1d0/2*pxx2zqsc**2/ctw**2*vm
     & ael**2*vmamo**2*qs)
     & +sdet3cmous**2*sdet4imotsus**2*c0ccqszcz*dreal(propizqs)*(1d0/4*p
     & xx2zqsc/ctw**2*vmamo**2*mmo**2-1d0/4*pxx2zqsc/ctw**2*vmamo**2*us-
     & 1d0/2*pxx2zqsc/ctw**2*vmael*vmamo**2*mmo**2+1d0/2*pxx2zqsc/ctw**2
     & *vmael*vmamo**2*us+1d0/4*pxx2zqsc/ctw**2*vmael**2*mmo**2-1d0/4*px
     & x2zqsc/ctw**2*vmael**2*us-1d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo*mm
     & o**2+1d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo*us+1d0/2*pxx2zqsc/ctw**
     & 2*vmael**2*vmamo**2*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo**
     & 2*us)
     & +sdet3cmous*sdet4imotsus**2*d0ccmomoqsuszczmo*dreal(propizqs)*(1d
     & 0/4*pxx2zqsc**2/ctw**2*vmamo**2*mmo**4-1d0/4*pxx2zqsc**2/ctw**2*v
     & mamo**2*us*mmo**2-1d0/2*pxx2zqsc**2/ctw**2*vmael*vmamo**2*mmo**4+
     & 1d0/2*pxx2zqsc**2/ctw**2*vmael*vmamo**2*us*mmo**2+1d0/4*pxx2zqsc*
     & *2/ctw**2*vmael**2*mmo**4-1d0/4*pxx2zqsc**2/ctw**2*vmael**2*us*mm
     & o**2-1d0/2*pxx2zqsc**2/ctw**2*vmael**2*vmamo*mmo**4+1d0/2*pxx2zqs
     & c**2/ctw**2*vmael**2*vmamo*us*mmo**2+1d0/2*pxx2zqsc**2/ctw**2*vma
     & el**2*vmamo**2*mmo**4-1d0/2*pxx2zqsc**2/ctw**2*vmael**2*vmamo**2*
     & us*mmo**2)
     & +sdet3cmous*sdet4imotsus**2*c0momoqszmoz*dreal(propizqs)*(pxx2zqs
     & c/ctw**2*vmamo**2*mmo**4+pxx2zqsc/ctw**2*vmamo**2*us*mmo**2+1d0/4
     & *pxx2zqsc/ctw**2*vmamo**2*qs*mmo**2+1d0/4*pxx2zqsc/ctw**2*vmamo**
     & 2*qs*us-2*pxx2zqsc/ctw**2*vmael*vmamo**2*mmo**4-2*pxx2zqsc/ctw**2
     & *vmael*vmamo**2*us*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael*vmamo**2*qs
     & *mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael*vmamo**2*qs*us+pxx2zqsc/ctw**
     & 2*vmael**2*mmo**4+pxx2zqsc/ctw**2*vmael**2*us*mmo**2+1d0/4*pxx2zq
     & sc/ctw**2*vmael**2*qs*mmo**2+1d0/4*pxx2zqsc/ctw**2*vmael**2*qs*us
     & -2*pxx2zqsc/ctw**2*vmael**2*vmamo*mmo**4-2*pxx2zqsc/ctw**2*vmael*
     & *2*vmamo*us*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo*qs*mmo**2
     & -1d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo*qs*us+2*pxx2zqsc/ctw**2*vma
     & el**2*vmamo**2*mmo**4+2*pxx2zqsc/ctw**2*vmael**2*vmamo**2*us*mmo*
     & *2+1d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo**2*qs*mmo**2+1d0/2*pxx2zq
     & sc/ctw**2*vmael**2*vmamo**2*qs*us)
     & +sdet3cmous*sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*(-1d0/2*p
     & xx2zqsc/ctw**2*vmamo**2*mmo**4+1d0/2*pxx2zqsc/ctw**2*vmamo**2*us*
     & *2+pxx2zqsc/ctw**2*vmael*vmamo**2*mmo**4-pxx2zqsc/ctw**2*vmael*vm
     & amo**2*us**2-1d0/2*pxx2zqsc/ctw**2*vmael**2*mmo**4+1d0/2*pxx2zqsc
     & /ctw**2*vmael**2*us**2+pxx2zqsc/ctw**2*vmael**2*vmamo*mmo**4-pxx2
     & zqsc/ctw**2*vmael**2*vmamo*us**2-pxx2zqsc/ctw**2*vmael**2*vmamo**
     & 2*mmo**4+pxx2zqsc/ctw**2*vmael**2*vmamo**2*us**2)
     & +sdet3cmous*sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*(-1d0/
     & 8/ctw**2*vmamo**2*qs*mmo**2+1d0/8/ctw**2*vmamo**2*qs*us+1d0/4/ctw
     & **2*vmael*vmamo**2*qs*mmo**2-1d0/4/ctw**2*vmael*vmamo**2*qs*us-1d
     & 0/8/ctw**2*vmael**2*qs*mmo**2+1d0/8/ctw**2*vmael**2*qs*us+1d0/4/c
     & tw**2*vmael**2*vmamo*qs*mmo**2-1d0/4/ctw**2*vmael**2*vmamo*qs*us-
     & 1d0/4/ctw**2*vmael**2*vmamo**2*qs*mmo**2+1d0/4/ctw**2*vmael**2*vm
     & amo**2*qs*us-pxx2zqsc/ctw**2*vmamo**2*mmo**2+2*pxx2zqsc/ctw**2*vm
     & ael*vmamo**2*mmo**2-pxx2zqsc/ctw**2*vmael**2*mmo**2+2*pxx2zqsc/ct
     & w**2*vmael**2*vmamo*mmo**2-2*pxx2zqsc/ctw**2*vmael**2*vmamo**2*mm
     & o**2+1d0/8*pxx2zqsc**2/ctw**2*vmamo**2-1d0/4*pxx2zqsc**2/ctw**2*v
     & mael*vmamo**2+1d0/8*pxx2zqsc**2/ctw**2*vmael**2-1d0/4*pxx2zqsc**2
     & /ctw**2*vmael**2*vmamo+1d0/4*pxx2zqsc**2/ctw**2*vmael**2*vmamo**2
     & )
     & +sdet3cmous*sdet4imotsus*c0ccqszcz*dreal(propizqs)*(1d0/ctw**2*vm
     & amo*mmo**2-3d0/2/ctw**2*vmamo**2*mmo**2-1d0/2/ctw**2*vmamo**2*us-
     & 2/ctw**2*vmael*vmamo*mmo**2+3/ctw**2*vmael*vmamo**2*mmo**2+1d0/ct
     & w**2*vmael*vmamo**2*us-1d0/2/ctw**2*vmael**2*mmo**2-1d0/2/ctw**2*
     & vmael**2*us+3/ctw**2*vmael**2*vmamo*mmo**2+1d0/ctw**2*vmael**2*vm
     & amo*us-3/ctw**2*vmael**2*vmamo**2*mmo**2-1d0/ctw**2*vmael**2*vmam
     & o**2*us)
     & +sdet3cmous*d0ccmomoqsuszczmo*dreal(propizqs)*(1d0/2/ctw**2-1d0/c
     & tw**2*vmamo+1d0/2/ctw**2*vmamo**2-1d0/ctw**2*vmael+2/ctw**2*vmael
     & *vmamo-1d0/ctw**2*vmael*vmamo**2+1d0/2/ctw**2*vmael**2-1d0/ctw**2
     & *vmael**2*vmamo+1d0/ctw**2*vmael**2*vmamo**2)
     & +sdet3imomoqs*c0momoqswcw*dreal(propizqs)*(-7d0/2*mw**2*rmow*rwz+
     & 3*mw**2*rmow**2*rwz+1d0/2*mw**2*rmow**3*rwz)
     & +sdet3imomoqs*c0momoqswcw*(2*mw**4*rwz+11*mw**4*rmow*rwz-26*mw**4
     & *rmow**2*rwz+11*mw**4*rmow**3*rwz+2*mw**4*rmow**4*rwz)
     & +sdet3imomoqs*c0momoqszmoh*(-3d0/4*mw**4*rmow/rwz**2-1d0/2*mw**4*
     & rmow/rwz*rhw+1d0/4*mw**4*rmow*rhw**2+2*mw**4*rmow**2/rwz-2*mw**4*
     & rmow**2*rhw+4*mw**4*rmow**3)
     & +sdet3imomoqs*c0momoqsmozmo*(-7d0/2*mw**4/rwz**3+9*mw**4/rwz**2-6
     & *mw**4/rwz-55d0/4*mw**4*rmow/rwz**2+36*mw**4*rmow/rwz-24*mw**4*rm
     & ow)
     & +sdet3imomoqs*c0momoqsmohmo*(1d0/4*mw**4*rmow*rhw**2-2*mw**4*rmow
     & **2*rhw)
     & +sdet3imomoqs*c0momoqscwc*(mw**4+11d0/2*mw**4*rmow+6*mw**4*rmow**
     & 2+3d0/2*mw**4*rmow**3)
     & +sdet3imomoqs*b0fmowc*dreal(propizqs)*(2*rmow*rwz)
     & +sdet3imomoqs*b0fmowc*(mw**2-2*mw**2*rwz+6*mw**2*rmow-13*mw**2*rm
     & ow*rwz+2*mw**2*rmow**2+7*mw**2*rmow**2*rwz)
     & +sdet3imomoqs*b0fmozmo*(-7d0/2*mw**2/rwz**2+9*mw**2/rwz-6*mw**2-1
     & 3*mw**2*rmow/rwz+36*mw**2*rmow-1d0/4*mw**2*rmow*rhw-24*mw**2*rmow
     & *rwz+mw**2*rmow**2)
     & +sdet3imomoqs*b0fmohmo*(3d0/4*mw**2*rmow/rwz-mw**2*rmow**2)
     & +sdet3imomoqs*b0fqsww*dreal(propizqs)*(-7d0/2*rmow*rwz-1d0/2*rmow
     & **2*rwz)
     & +sdet3imomoqs*b0fqsww*(2*mw**2*rwz+13*mw**2*rmow*rwz-13*mw**2*rmo
     & w**2*rwz-2*mw**2*rmow**3*rwz)
     & +sdet3imomoqs*b0fqszh*(-3d0/2*mw**2*rmow/rwz+1d0/2*mw**2*rmow*rhw
     & -2*mw**2*rmow**2)
     & +sdet3imomoqs*b0fqsmomo*(7d0/2*mw**2/rwz**2-9*mw**2/rwz+6*mw**2+5
     & 5d0/4*mw**2*rmow/rwz-36*mw**2*rmow-1d0/4*mw**2*rmow*rhw+24*mw**2*
     & rmow*rwz+2*mw**2*rmow**2)
     & +sdet3imomoqs*b0fqscc*(-mw**2-9d0/2*mw**2*rmow-3d0/2*mw**2*rmow**
     & 2)
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*(1d0/ctw**2*mm
     & o**4+1d0/ctw**2*ts*mmo**2-2/ctw**2*vmamo*mmo**4-2/ctw**2*vmamo*ts
     & *mmo**2+1d0/ctw**2*vmamo**2*mmo**4+1d0/ctw**2*vmamo**2*ts*mmo**2-
     & 2/ctw**2*vmael*mmo**4-2/ctw**2*vmael*ts*mmo**2+4/ctw**2*vmael*vma
     & mo*mmo**4+4/ctw**2*vmael*vmamo*ts*mmo**2-2/ctw**2*vmael*vmamo**2*
     & mmo**4-2/ctw**2*vmael*vmamo**2*ts*mmo**2+1d0/ctw**2*vmael**2*mmo*
     & *4+1d0/ctw**2*vmael**2*ts*mmo**2-2/ctw**2*vmael**2*vmamo*mmo**4-2
     & /ctw**2*vmael**2*vmamo*ts*mmo**2+2/ctw**2*vmael**2*vmamo**2*mmo**
     & 4+2/ctw**2*vmael**2*vmamo**2*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*(-1d0/ctw**2*m
     & mo**4-1d0/ctw**2*ts*mmo**2+2/ctw**2*vmamo*mmo**4+2/ctw**2*vmamo*t
     & s*mmo**2-1d0/ctw**2*vmamo**2*mmo**4-1d0/ctw**2*vmamo**2*ts*mmo**2
     & +2/ctw**2*vmael*mmo**4+2/ctw**2*vmael*ts*mmo**2-4/ctw**2*vmael*vm
     & amo*mmo**4-4/ctw**2*vmael*vmamo*ts*mmo**2+2/ctw**2*vmael*vmamo**2
     & *mmo**4+2/ctw**2*vmael*vmamo**2*ts*mmo**2-1d0/ctw**2*vmael**2*mmo
     & **4-1d0/ctw**2*vmael**2*ts*mmo**2+2/ctw**2*vmael**2*vmamo*mmo**4+
     & 2/ctw**2*vmael**2*vmamo*ts*mmo**2-2/ctw**2*vmael**2*vmamo**2*mmo*
     & *4-2/ctw**2*vmael**2*vmamo**2*ts*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*(1d0/ctw**2*vm
     & amo**2*mmo**4+1d0/ctw**2*vmamo**2*us*mmo**2-2/ctw**2*vmael*vmamo*
     & *2*mmo**4-2/ctw**2*vmael*vmamo**2*us*mmo**2+1d0/ctw**2*vmael**2*m
     & mo**4+1d0/ctw**2*vmael**2*us*mmo**2-2/ctw**2*vmael**2*vmamo*mmo**
     & 4-2/ctw**2*vmael**2*vmamo*us*mmo**2+2/ctw**2*vmael**2*vmamo**2*mm
     & o**4+2/ctw**2*vmael**2*vmamo**2*us*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*(-1d0/ctw**2*v
     & mamo**2*mmo**4-1d0/ctw**2*vmamo**2*us*mmo**2+2/ctw**2*vmael*vmamo
     & **2*mmo**4+2/ctw**2*vmael*vmamo**2*us*mmo**2-1d0/ctw**2*vmael**2*
     & mmo**4-1d0/ctw**2*vmael**2*us*mmo**2+2/ctw**2*vmael**2*vmamo*mmo*
     & *4+2/ctw**2*vmael**2*vmamo*us*mmo**2-2/ctw**2*vmael**2*vmamo**2*m
     & mo**4-2/ctw**2*vmael**2*vmamo**2*us*mmo**2)
     & +sdet4imotsus**2*d0ccmomoqstswcwc*dreal(propizqs)*(4*mw**10*rmow*
     & *3*rwz-4*mw**10*rmow**4*rwz+mw**10*rmow**5*rwz+4*ts*mw**8*rmow**2
     & *rwz-8*ts*mw**8*rmow**3*rwz+3*ts*mw**8*rmow**4*rwz-4*ts**2*mw**6*
     & rmow*rwz+2*ts**2*mw**6*rmow**3*rwz-4*ts**3*mw**4*rwz+8*ts**3*mw**
     & 4*rmow*rwz-2*ts**3*mw**4*rmow**2*rwz+4*ts**4*mw**2*rwz-3*ts**4*mw
     & **2*rmow*rwz-ts**5*rwz)
     & +sdet4imotsus**2*d0ccmomoqstszczmo*dreal(propizqs)*(1d0/4*pxx2zqs
     & c**2/ctw**2*us*mmo**4-1d0/4*pxx2zqsc**2/ctw**2*ts*mmo**4-1d0/2*px
     & x2zqsc**2/ctw**2*vmamo*us*mmo**4+1d0/2*pxx2zqsc**2/ctw**2*vmamo*t
     & s*mmo**4+1d0/4*pxx2zqsc**2/ctw**2*vmamo**2*us*mmo**4-1d0/4*pxx2zq
     & sc**2/ctw**2*vmamo**2*ts*mmo**4-1d0/2*pxx2zqsc**2/ctw**2*vmael*us
     & *mmo**4+1d0/2*pxx2zqsc**2/ctw**2*vmael*ts*mmo**4+pxx2zqsc**2/ctw*
     & *2*vmael*vmamo*us*mmo**4-pxx2zqsc**2/ctw**2*vmael*vmamo*ts*mmo**4
     & -1d0/2*pxx2zqsc**2/ctw**2*vmael*vmamo**2*us*mmo**4+1d0/2*pxx2zqsc
     & **2/ctw**2*vmael*vmamo**2*ts*mmo**4+1d0/4*pxx2zqsc**2/ctw**2*vmae
     & l**2*us*mmo**4-1d0/4*pxx2zqsc**2/ctw**2*vmael**2*ts*mmo**4-1d0/2*
     & pxx2zqsc**2/ctw**2*vmael**2*vmamo*us*mmo**4+1d0/2*pxx2zqsc**2/ctw
     & **2*vmael**2*vmamo*ts*mmo**4+1d0/2*pxx2zqsc**2/ctw**2*vmael**2*vm
     & amo**2*us*mmo**4-1d0/2*pxx2zqsc**2/ctw**2*vmael**2*vmamo**2*ts*mm
     & o**4)
     & +sdet4imotsus**2*d0ccmomoqsuszczmo*dreal(propizqs)*(-1d0/4*pxx2zq
     & sc**2/ctw**2*vmamo**2*us*mmo**4+1d0/4*pxx2zqsc**2/ctw**2*vmamo**2
     & *ts*mmo**4+1d0/2*pxx2zqsc**2/ctw**2*vmael*vmamo**2*us*mmo**4-1d0/
     & 2*pxx2zqsc**2/ctw**2*vmael*vmamo**2*ts*mmo**4-1d0/4*pxx2zqsc**2/c
     & tw**2*vmael**2*us*mmo**4+1d0/4*pxx2zqsc**2/ctw**2*vmael**2*ts*mmo
     & **4+1d0/2*pxx2zqsc**2/ctw**2*vmael**2*vmamo*us*mmo**4-1d0/2*pxx2z
     & qsc**2/ctw**2*vmael**2*vmamo*ts*mmo**4-1d0/2*pxx2zqsc**2/ctw**2*v
     & mael**2*vmamo**2*us*mmo**4+1d0/2*pxx2zqsc**2/ctw**2*vmael**2*vmam
     & o**2*ts*mmo**4)
     & +sdet4imotsus**2*c0momoqswcw*dreal(propizqs)*(-2/ts*mw**10*rmow**
     & 4*rwz+1d0/ts*mw**10*rmow**5*rwz+mw**8*rmow**4*rwz+4*ts*mw**6*rmow
     & **2*rwz-2*ts*mw**6*rmow**3*rwz-2*ts**2*mw**4*rmow**2*rwz-2*ts**3*
     & mw**2*rwz+ts**3*mw**2*rmow*rwz+ts**4*rwz)
     & +sdet4imotsus**2*c0cmotscwc*dreal(propizqs)*(-4*mw**8*rmow**3*rwz
     & +2*mw**8*rmow**4*rwz-4*ts*mw**6*rmow**2*rwz+4*ts*mw**6*rmow**3*rw
     & z+4*ts**2*mw**4*rmow*rwz+4*ts**3*mw**2*rwz-4*ts**3*mw**2*rmow*rwz
     & -2*ts**4*rwz)
     & +sdet4imotsus**2*c0ccqswcw*dreal(propizqs)*(2/ts*mw**10*rmow**4*r
     & wz-1d0/ts*mw**10*rmow**5*rwz+4*mw**8*rmow**3*rwz-3*mw**8*rmow**4*
     & rwz-2*ts*mw**6*rmow**3*rwz-4*ts**2*mw**4*rmow*rwz+2*ts**2*mw**4*r
     & mow**2*rwz-2*ts**3*mw**2*rwz+3*ts**3*mw**2*rmow*rwz+ts**4*rwz)
     & +sdet4imotsus**2*c0ccqszcz*dreal(propizqs)*(-1d0/4*pxx2zqsc/ctw**
     & 2*qs*mmo**4+1d0/4*pxx2zqsc/ctw**2*qs*ts*mmo**2+1d0/2*pxx2zqsc/ctw
     & **2*vmamo*qs*mmo**4-1d0/2*pxx2zqsc/ctw**2*vmamo*qs*ts*mmo**2-1d0/
     & 2*pxx2zqsc/ctw**2*vmamo**2*qs*mmo**4+1d0/4*pxx2zqsc/ctw**2*vmamo*
     & *2*qs*us*mmo**2+1d0/4*pxx2zqsc/ctw**2*vmamo**2*qs*ts*mmo**2+1d0/2
     & *pxx2zqsc/ctw**2*vmael*qs*mmo**4-1d0/2*pxx2zqsc/ctw**2*vmael*qs*t
     & s*mmo**2-pxx2zqsc/ctw**2*vmael*vmamo*qs*mmo**4+pxx2zqsc/ctw**2*vm
     & ael*vmamo*qs*ts*mmo**2+pxx2zqsc/ctw**2*vmael*vmamo**2*qs*mmo**4-1
     & d0/2*pxx2zqsc/ctw**2*vmael*vmamo**2*qs*us*mmo**2-1d0/2*pxx2zqsc/c
     & tw**2*vmael*vmamo**2*qs*ts*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael**2*
     & qs*mmo**4+1d0/4*pxx2zqsc/ctw**2*vmael**2*qs*us*mmo**2+1d0/4*pxx2z
     & qsc/ctw**2*vmael**2*qs*ts*mmo**2+pxx2zqsc/ctw**2*vmael**2*vmamo*q
     & s*mmo**4-1d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo*qs*us*mmo**2-1d0/2*
     & pxx2zqsc/ctw**2*vmael**2*vmamo*qs*ts*mmo**2-pxx2zqsc/ctw**2*vmael
     & **2*vmamo**2*qs*mmo**4+1d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo**2*qs
     & *us*mmo**2+1d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo**2*qs*ts*mmo**2)
     & +sdet4imotsus*d0ccmomoqstswcwc*dreal(propizqs)*(2*mw**6*rmow*rwz-
     & 2*mw**6*rmow**2*rwz+mw**6*rmow**3*rwz-2*ts*mw**4*rwz-2*ts*mw**4*r
     & mow*rwz+2*ts*mw**4*rmow**2*rwz+ts**2*mw**2*rmow*rwz)
     & +sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*(-1d0/8/ctw**2*qs
     & *us*mmo**2+1d0/8/ctw**2*qs*ts*mmo**2+1d0/4/ctw**2*vmamo*qs*us*mmo
     & **2-1d0/4/ctw**2*vmamo*qs*ts*mmo**2-1d0/8/ctw**2*vmamo**2*qs*us*m
     & mo**2+1d0/8/ctw**2*vmamo**2*qs*ts*mmo**2+1d0/4/ctw**2*vmael*qs*us
     & *mmo**2-1d0/4/ctw**2*vmael*qs*ts*mmo**2-1d0/2/ctw**2*vmael*vmamo*
     & qs*us*mmo**2+1d0/2/ctw**2*vmael*vmamo*qs*ts*mmo**2+1d0/4/ctw**2*v
     & mael*vmamo**2*qs*us*mmo**2-1d0/4/ctw**2*vmael*vmamo**2*qs*ts*mmo*
     & *2-1d0/8/ctw**2*vmael**2*qs*us*mmo**2+1d0/8/ctw**2*vmael**2*qs*ts
     & *mmo**2+1d0/4/ctw**2*vmael**2*vmamo*qs*us*mmo**2-1d0/4/ctw**2*vma
     & el**2*vmamo*qs*ts*mmo**2-1d0/4/ctw**2*vmael**2*vmamo**2*qs*us*mmo
     & **2+1d0/4/ctw**2*vmael**2*vmamo**2*qs*ts*mmo**2+3d0/4*pxx2zqsc/ct
     & w**2*mmo**4-3d0/4*pxx2zqsc/ctw**2*ts**2-1d0/4*pxx2zqsc/ctw**2*qs*
     & mmo**2-pxx2zqsc/ctw**2*vmamo*mmo**4+1d0/2*pxx2zqsc/ctw**2*vmamo*t
     & s*mmo**2+3d0/2*pxx2zqsc/ctw**2*vmamo*ts**2+1d0/2*pxx2zqsc/ctw**2*
     & vmamo*qs*mmo**2+1d0/4*pxx2zqsc/ctw**2*vmamo**2*mmo**4-1d0/2*pxx2z
     & qsc/ctw**2*vmamo**2*ts*mmo**2-3d0/4*pxx2zqsc/ctw**2*vmamo**2*ts**
     & 2-1d0/4*pxx2zqsc/ctw**2*vmamo**2*qs*mmo**2-3d0/2*pxx2zqsc/ctw**2*
     & vmael*mmo**4+3d0/2*pxx2zqsc/ctw**2*vmael*ts**2+1d0/2*pxx2zqsc/ctw
     & **2*vmael*qs*mmo**2+2*pxx2zqsc/ctw**2*vmael*vmamo*mmo**4-pxx2zqsc
     & /ctw**2*vmael*vmamo*ts*mmo**2-3*pxx2zqsc/ctw**2*vmael*vmamo*ts**2
     & -pxx2zqsc/ctw**2*vmael*vmamo*qs*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmae
     & l*vmamo**2*mmo**4+pxx2zqsc/ctw**2*vmael*vmamo**2*ts*mmo**2+3d0/2*
     & pxx2zqsc/ctw**2*vmael*vmamo**2*ts**2+1d0/2*pxx2zqsc/ctw**2*vmael*
     & vmamo**2*qs*mmo**2+3d0/4*pxx2zqsc/ctw**2*vmael**2*mmo**4-3d0/4*px
     & x2zqsc/ctw**2*vmael**2*ts**2-1d0/4*pxx2zqsc/ctw**2*vmael**2*qs*mm
     & o**2-1d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo*mmo**4+pxx2zqsc/ctw**2*
     & vmael**2*vmamo*ts*mmo**2+3d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo*ts*
     & *2+1d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo*qs*mmo**2+1d0/2*pxx2zqsc/
     & ctw**2*vmael**2*vmamo**2*mmo**4-pxx2zqsc/ctw**2*vmael**2*vmamo**2
     & *ts*mmo**2-3d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo**2*ts**2-1d0/2*px
     & x2zqsc/ctw**2*vmael**2*vmamo**2*qs*mmo**2+1d0/2*pxx2zqsc**2/ctw**
     & 2*mmo**2-pxx2zqsc**2/ctw**2*vmamo*mmo**2+1d0/2*pxx2zqsc**2/ctw**2
     & *vmamo**2*mmo**2-pxx2zqsc**2/ctw**2*vmael*mmo**2+2*pxx2zqsc**2/ct
     & w**2*vmael*vmamo*mmo**2-pxx2zqsc**2/ctw**2*vmael*vmamo**2*mmo**2+
     & 1d0/2*pxx2zqsc**2/ctw**2*vmael**2*mmo**2-pxx2zqsc**2/ctw**2*vmael
     & **2*vmamo*mmo**2+pxx2zqsc**2/ctw**2*vmael**2*vmamo**2*mmo**2)
     & +sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*(1d0/8/ctw**2*vma
     & mo**2*qs*us*mmo**2-1d0/8/ctw**2*vmamo**2*qs*ts*mmo**2-1d0/4/ctw**
     & 2*vmael*vmamo**2*qs*us*mmo**2+1d0/4/ctw**2*vmael*vmamo**2*qs*ts*m
     & mo**2+1d0/8/ctw**2*vmael**2*qs*us*mmo**2-1d0/8/ctw**2*vmael**2*qs
     & *ts*mmo**2-1d0/4/ctw**2*vmael**2*vmamo*qs*us*mmo**2+1d0/4/ctw**2*
     & vmael**2*vmamo*qs*ts*mmo**2+1d0/4/ctw**2*vmael**2*vmamo**2*qs*us*
     & mmo**2-1d0/4/ctw**2*vmael**2*vmamo**2*qs*ts*mmo**2+1d0/2*pxx2zqsc
     & /ctw**2*vmamo*mmo**4+1d0/2*pxx2zqsc/ctw**2*vmamo*us*mmo**2+1d0/4*
     & pxx2zqsc/ctw**2*vmamo**2*mmo**4-1d0/2*pxx2zqsc/ctw**2*vmamo**2*us
     & *mmo**2-3d0/4*pxx2zqsc/ctw**2*vmamo**2*us**2-1d0/4*pxx2zqsc/ctw**
     & 2*vmamo**2*qs*mmo**2-pxx2zqsc/ctw**2*vmael*vmamo*mmo**4-pxx2zqsc/
     & ctw**2*vmael*vmamo*us*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael*vmamo**2
     & *mmo**4+pxx2zqsc/ctw**2*vmael*vmamo**2*us*mmo**2+3d0/2*pxx2zqsc/c
     & tw**2*vmael*vmamo**2*us**2+1d0/2*pxx2zqsc/ctw**2*vmael*vmamo**2*q
     & s*mmo**2+3d0/4*pxx2zqsc/ctw**2*vmael**2*mmo**4-3d0/4*pxx2zqsc/ctw
     & **2*vmael**2*us**2-1d0/4*pxx2zqsc/ctw**2*vmael**2*qs*mmo**2-1d0/2
     & *pxx2zqsc/ctw**2*vmael**2*vmamo*mmo**4+pxx2zqsc/ctw**2*vmael**2*v
     & mamo*us*mmo**2+3d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo*us**2+1d0/2*p
     & xx2zqsc/ctw**2*vmael**2*vmamo*qs*mmo**2+1d0/2*pxx2zqsc/ctw**2*vma
     & el**2*vmamo**2*mmo**4-pxx2zqsc/ctw**2*vmael**2*vmamo**2*us*mmo**2
     & -3d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo**2*us**2-1d0/2*pxx2zqsc/ctw
     & **2*vmael**2*vmamo**2*qs*mmo**2+1d0/2*pxx2zqsc**2/ctw**2*vmamo**2
     & *mmo**2-pxx2zqsc**2/ctw**2*vmael*vmamo**2*mmo**2+1d0/2*pxx2zqsc**
     & 2/ctw**2*vmael**2*mmo**2-pxx2zqsc**2/ctw**2*vmael**2*vmamo*mmo**2
     & +pxx2zqsc**2/ctw**2*vmael**2*vmamo**2*mmo**2)
     & +sdet4imotsus*c0momoqswcw*dreal(propizqs)*(-2/ts*mw**6*rmow**2*rw
     & z+1d0/ts*mw**6*rmow**3*rwz+2*mw**4*rmow**2*rwz-2*ts*mw**2*rwz+ts*
     & mw**2*rmow*rwz)
     & +sdet4imotsus*c0momoqszmoz*dreal(propizqs)*(1d0/2/ctw**2*mmo**4-1
     & d0/2/ctw**2*ts**2-1d0/ctw**2*vmamo*mmo**4+1d0/ctw**2*vmamo*ts**2+
     & 1d0/ctw**2*vmamo**2*mmo**4-1d0/2/ctw**2*vmamo**2*us**2-1d0/2/ctw*
     & *2*vmamo**2*ts**2-1d0/ctw**2*vmael*mmo**4+1d0/ctw**2*vmael*ts**2+
     & 2/ctw**2*vmael*vmamo*mmo**4-2/ctw**2*vmael*vmamo*ts**2-2/ctw**2*v
     & mael*vmamo**2*mmo**4+1d0/ctw**2*vmael*vmamo**2*us**2+1d0/ctw**2*v
     & mael*vmamo**2*ts**2+1d0/ctw**2*vmael**2*mmo**4-1d0/2/ctw**2*vmael
     & **2*us**2-1d0/2/ctw**2*vmael**2*ts**2-2/ctw**2*vmael**2*vmamo*mmo
     & **4+1d0/ctw**2*vmael**2*vmamo*us**2+1d0/ctw**2*vmael**2*vmamo*ts*
     & *2+2/ctw**2*vmael**2*vmamo**2*mmo**4-1d0/ctw**2*vmael**2*vmamo**2
     & *us**2-1d0/ctw**2*vmael**2*vmamo**2*ts**2+1d0/2*pxx2zqsc/ctw**2*m
     & mo**2-pxx2zqsc/ctw**2*vmamo*mmo**2+pxx2zqsc/ctw**2*vmamo**2*mmo**
     & 2-pxx2zqsc/ctw**2*vmael*mmo**2+2*pxx2zqsc/ctw**2*vmael*vmamo*mmo*
     & *2-2*pxx2zqsc/ctw**2*vmael*vmamo**2*mmo**2+pxx2zqsc/ctw**2*vmael*
     & *2*mmo**2-2*pxx2zqsc/ctw**2*vmael**2*vmamo*mmo**2+2*pxx2zqsc/ctw*
     & *2*vmael**2*vmamo**2*mmo**2)
     & +sdet4imotsus*c0cmotscwc*dreal(propizqs)*(2*ts*mw**2*rmow*rwz+2*t
     & s**2*rwz)
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*(1d0/ctw**2*ts*mmo**2+1
     & d0/ctw**2*ts**2-1d0/ctw**2*vmamo*mmo**4-3/ctw**2*vmamo*ts*mmo**2-
     & 2/ctw**2*vmamo*ts**2+1d0/ctw**2*vmamo**2*mmo**4+2/ctw**2*vmamo**2
     & *ts*mmo**2+1d0/ctw**2*vmamo**2*ts**2-2/ctw**2*vmael*ts*mmo**2-2/c
     & tw**2*vmael*ts**2+2/ctw**2*vmael*vmamo*mmo**4+6/ctw**2*vmael*vmam
     & o*ts*mmo**2+4/ctw**2*vmael*vmamo*ts**2-2/ctw**2*vmael*vmamo**2*mm
     & o**4-4/ctw**2*vmael*vmamo**2*ts*mmo**2-2/ctw**2*vmael*vmamo**2*ts
     & **2+1d0/ctw**2*vmael**2*ts*mmo**2+1d0/ctw**2*vmael**2*ts**2-2/ctw
     & **2*vmael**2*vmamo*mmo**4-4/ctw**2*vmael**2*vmamo*ts*mmo**2-2/ctw
     & **2*vmael**2*vmamo*ts**2+2/ctw**2*vmael**2*vmamo**2*mmo**4+4/ctw*
     & *2*vmael**2*vmamo**2*ts*mmo**2+2/ctw**2*vmael**2*vmamo**2*ts**2)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*(-1d0/ctw**2*vmamo*mmo*
     & *4-1d0/ctw**2*vmamo*us*mmo**2+1d0/ctw**2*vmamo**2*mmo**4+2/ctw**2
     & *vmamo**2*us*mmo**2+1d0/ctw**2*vmamo**2*us**2+2/ctw**2*vmael*vmam
     & o*mmo**4+2/ctw**2*vmael*vmamo*us*mmo**2-2/ctw**2*vmael*vmamo**2*m
     & mo**4-4/ctw**2*vmael*vmamo**2*us*mmo**2-2/ctw**2*vmael*vmamo**2*u
     & s**2+1d0/ctw**2*vmael**2*us*mmo**2+1d0/ctw**2*vmael**2*us**2-2/ct
     & w**2*vmael**2*vmamo*mmo**4-4/ctw**2*vmael**2*vmamo*us*mmo**2-2/ct
     & w**2*vmael**2*vmamo*us**2+2/ctw**2*vmael**2*vmamo**2*mmo**4+4/ctw
     & **2*vmael**2*vmamo**2*us*mmo**2+2/ctw**2*vmael**2*vmamo**2*us**2)
     &
     & +sdet4imotsus*c0ccqswcw*dreal(propizqs)*(2/ts*mw**6*rmow**2*rwz-1
     & d0/ts*mw**6*rmow**3*rwz-2*mw**4*rmow**2*rwz-2*ts*mw**2*rwz-ts*mw*
     & *2*rmow*rwz)
     & +sdet4imotsus*c0ccqszcz*dreal(propizqs)*(1d0/4*pxx2zqsc/ctw**2*mm
     & o**2-1d0/4*pxx2zqsc/ctw**2*ts-1d0/2*pxx2zqsc/ctw**2*vmamo*mmo**2+
     & 1d0/2*pxx2zqsc/ctw**2*vmamo*ts+1d0/2*pxx2zqsc/ctw**2*vmamo**2*mmo
     & **2-1d0/4*pxx2zqsc/ctw**2*vmamo**2*us-1d0/4*pxx2zqsc/ctw**2*vmamo
     & **2*ts-1d0/2*pxx2zqsc/ctw**2*vmael*mmo**2+1d0/2*pxx2zqsc/ctw**2*v
     & mael*ts+pxx2zqsc/ctw**2*vmael*vmamo*mmo**2-pxx2zqsc/ctw**2*vmael*
     & vmamo*ts-pxx2zqsc/ctw**2*vmael*vmamo**2*mmo**2+1d0/2*pxx2zqsc/ctw
     & **2*vmael*vmamo**2*us+1d0/2*pxx2zqsc/ctw**2*vmael*vmamo**2*ts+1d0
     & /2*pxx2zqsc/ctw**2*vmael**2*mmo**2-1d0/4*pxx2zqsc/ctw**2*vmael**2
     & *us-1d0/4*pxx2zqsc/ctw**2*vmael**2*ts-pxx2zqsc/ctw**2*vmael**2*vm
     & amo*mmo**2+1d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo*us+1d0/2*pxx2zqsc
     & /ctw**2*vmael**2*vmamo*ts+pxx2zqsc/ctw**2*vmael**2*vmamo**2*mmo**
     & 2-1d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo**2*us-1d0/2*pxx2zqsc/ctw**
     & 2*vmael**2*vmamo**2*ts)
     & +sdet4imotsus*b0fmowc*dreal(propizqs)*(4*mw**2*rmow*rwz)
     & +sdet4imotsus*b0fqsww*dreal(propizqs)*(-2*mw**2*rmow*rwz-2*ts*rwz
     & )
     & +sdet4imotsus*b0fqszz*dreal(propizqs)*(-1d0/2/ctw**2*mmo**2-1d0/2
     & /ctw**2*ts+1d0/ctw**2*vmamo*mmo**2+1d0/ctw**2*vmamo*ts-1d0/ctw**2
     & *vmamo**2*mmo**2-1d0/2/ctw**2*vmamo**2*us-1d0/2/ctw**2*vmamo**2*t
     & s+1d0/ctw**2*vmael*mmo**2+1d0/ctw**2*vmael*ts-2/ctw**2*vmael*vmam
     & o*mmo**2-2/ctw**2*vmael*vmamo*ts+2/ctw**2*vmael*vmamo**2*mmo**2+1
     & d0/ctw**2*vmael*vmamo**2*us+1d0/ctw**2*vmael*vmamo**2*ts-1d0/ctw*
     & *2*vmael**2*mmo**2-1d0/2/ctw**2*vmael**2*us-1d0/2/ctw**2*vmael**2
     & *ts+2/ctw**2*vmael**2*vmamo*mmo**2+1d0/ctw**2*vmael**2*vmamo*us+1
     & d0/ctw**2*vmael**2*vmamo*ts-2/ctw**2*vmael**2*vmamo**2*mmo**2-1d0
     & /ctw**2*vmael**2*vmamo**2*us-1d0/ctw**2*vmael**2*vmamo**2*ts)
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*(1d0/2/ctw**2*mmo**2+1d0/2
     & /ctw**2*ts-1d0/ctw**2*vmamo*mmo**2-1d0/ctw**2*vmamo*ts+1d0/2/ctw*
     & *2*vmamo**2*mmo**2+1d0/2/ctw**2*vmamo**2*ts-1d0/ctw**2*vmael*mmo*
     & *2-1d0/ctw**2*vmael*ts+2/ctw**2*vmael*vmamo*mmo**2+2/ctw**2*vmael
     & *vmamo*ts-1d0/ctw**2*vmael*vmamo**2*mmo**2-1d0/ctw**2*vmael*vmamo
     & **2*ts+1d0/2/ctw**2*vmael**2*mmo**2+1d0/2/ctw**2*vmael**2*ts-1d0/
     & ctw**2*vmael**2*vmamo*mmo**2-1d0/ctw**2*vmael**2*vmamo*ts+1d0/ctw
     & **2*vmael**2*vmamo**2*mmo**2+1d0/ctw**2*vmael**2*vmamo**2*ts)
     & +sdet4imotsus*b0ftscc*dreal(propizqs)*(-2*mw**2*rmow*rwz+2*ts*rwz
     & )
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*(1d0/2/ctw**2*vmamo**2*mmo
     & **2+1d0/2/ctw**2*vmamo**2*us-1d0/ctw**2*vmael*vmamo**2*mmo**2-1d0
     & /ctw**2*vmael*vmamo**2*us+1d0/2/ctw**2*vmael**2*mmo**2+1d0/2/ctw*
     & *2*vmael**2*us-1d0/ctw**2*vmael**2*vmamo*mmo**2-1d0/ctw**2*vmael*
     & *2*vmamo*us+1d0/ctw**2*vmael**2*vmamo**2*mmo**2+1d0/ctw**2*vmael*
     & *2*vmamo**2*us)
     & +d0ccmomoqstswcwc*dreal(propizqs)*(-ts*rwz)
     & +d0ccmomoqstszczmo*dreal(propizqs)*(-1d0/2/ctw**2*mmo**2-1d0/2/ct
     & w**2*mz**2-1d0/2/ctw**2*ts-1d0/8/ctw**2*qs+1d0/ctw**2*vmamo*mmo**
     & 2+1d0/ctw**2*vmamo*mz**2+1d0/ctw**2*vmamo*ts+1d0/4/ctw**2*vmamo*q
     & s-1d0/2/ctw**2*vmamo**2*mmo**2-1d0/2/ctw**2*vmamo**2*mz**2-1d0/2/
     & ctw**2*vmamo**2*ts-1d0/8/ctw**2*vmamo**2*qs+1d0/ctw**2*vmael*mmo*
     & *2+1d0/ctw**2*vmael*mz**2+1d0/ctw**2*vmael*ts+1d0/4/ctw**2*vmael*
     & qs-2/ctw**2*vmael*vmamo*mmo**2-2/ctw**2*vmael*vmamo*mz**2-2/ctw**
     & 2*vmael*vmamo*ts-1d0/2/ctw**2*vmael*vmamo*qs+1d0/ctw**2*vmael*vma
     & mo**2*mmo**2+1d0/ctw**2*vmael*vmamo**2*mz**2+1d0/ctw**2*vmael*vma
     & mo**2*ts+1d0/4/ctw**2*vmael*vmamo**2*qs-1d0/2/ctw**2*vmael**2*mmo
     & **2-1d0/2/ctw**2*vmael**2*mz**2-1d0/2/ctw**2*vmael**2*ts-1d0/8/ct
     & w**2*vmael**2*qs+1d0/ctw**2*vmael**2*vmamo*mmo**2+1d0/ctw**2*vmae
     & l**2*vmamo*mz**2+1d0/ctw**2*vmael**2*vmamo*ts+1d0/4/ctw**2*vmael*
     & *2*vmamo*qs-1d0/ctw**2*vmael**2*vmamo**2*mmo**2-1d0/ctw**2*vmael*
     & *2*vmamo**2*mz**2-1d0/ctw**2*vmael**2*vmamo**2*ts-1d0/4/ctw**2*vm
     & ael**2*vmamo**2*qs)
     & +d0ccmomoqsuszczmo*dreal(propizqs)*(-1d0/2/ctw**2*vmamo**2*mmo**2
     & -1d0/2/ctw**2*vmamo**2*us+1d0/8/ctw**2*vmamo**2*qs+1d0/ctw**2*vma
     & el*vmamo**2*mmo**2+1d0/ctw**2*vmael*vmamo**2*us-1d0/4/ctw**2*vmae
     & l*vmamo**2*qs-1d0/2/ctw**2*vmael**2*mmo**2-1d0/2/ctw**2*vmael**2*
     & us+1d0/8/ctw**2*vmael**2*qs+1d0/ctw**2*vmael**2*vmamo*mmo**2+1d0/
     & ctw**2*vmael**2*vmamo*us-1d0/4/ctw**2*vmael**2*vmamo*qs-1d0/ctw**
     & 2*vmael**2*vmamo**2*mmo**2-1d0/ctw**2*vmael**2*vmamo**2*us+1d0/4/
     & ctw**2*vmael**2*vmamo**2*qs-1d0/4*pxx2zqsc/ctw**2*vmamo**2+1d0/2*
     & pxx2zqsc/ctw**2*vmael*vmamo**2-1d0/4*pxx2zqsc/ctw**2*vmael**2+1d0
     & /2*pxx2zqsc/ctw**2*vmael**2*vmamo-1d0/2*pxx2zqsc/ctw**2*vmael**2*
     & vmamo**2)
     & +c0momoqswcw*dreal(propizqs)*(rwz)
     & +c0momoqswcw*(-4*mw**2*rwz+15d0/2*mw**2*rmow*rwz-3*mw**2*rmow**2*
     & rwz-1d0/2*mw**2*rmow**3*rwz)
     & +c0momoqszmoz*dreal(propizqs)*(-1d0/2/ctw**2+1d0/ctw**2*vmamo-1d0
     & /ctw**2*vmamo**2+1d0/ctw**2*vmael-2/ctw**2*vmael*vmamo+2/ctw**2*v
     & mael*vmamo**2-1d0/ctw**2*vmael**2+2/ctw**2*vmael**2*vmamo-2/ctw**
     & 2*vmael**2*vmamo**2)
     & +c0momoqszmoh*(-1d0/4/qs*mw**4*rmow/rwz**2+1d0/2/qs*mw**4*rmow/rw
     & z*rhw-1d0/4/qs*mw**4*rmow*rhw**2+mw**2*rmow/rwz-mw**2*rmow**2)
     & +c0momoqsmozmo*(7*mw**2/rwz**2-18*mw**2/rwz+12*mw**2-5d0/2*mw**2*
     & rmow/rwz+6*mw**2*rmow-4*mw**2*rmow*rwz-7d0/2*qs/rwz+9*qs-6*qs*rwz
     & )
     & +c0momoqsmohmo*(mw**2*rmow**2)
     & +c0momoqscwc*(-2*mw**2-mw**2*rmow-1d0/2*mw**2*rmow**2+qs)
     & +c0ccqswcw*dreal(propizqs)*(rwz)
     & +c0ccqswcw*(2/qs*mw**4*rwz-4*mw**2*rwz)
     & +c0ccqszcz*dreal(propizqs)*(-1d0/2/ctw**2+1d0/ctw**2*vmamo-1d0/ct
     & w**2*vmamo**2+1d0/ctw**2*vmael-2/ctw**2*vmael*vmamo+2/ctw**2*vmae
     & l*vmamo**2-1d0/ctw**2*vmael**2+2/ctw**2*vmael**2*vmamo-2/ctw**2*v
     & mael**2*vmamo**2)
     & +c0ccqscwc*(1d0/qs*mw**4-2*mw**2+qs)
     & +c0ccqsczc*(-7d0/2/qs*mw**4/rwz**3+9/qs*mw**4/rwz**2-6/qs*mw**4/r
     & wz+7*mw**2/rwz**2-18*mw**2/rwz+12*mw**2-7d0/2*qs/rwz+9*qs-6*qs*rw
     & z)
     & +a0fw*dreal(propzqs)*(3*mw**2/rwz/rhw+1d0/6*mw**2/rwz-8d0/3*mw**2
     & -4*mw**2*rwz)
     & +a0fw*(7d0/4-1d0/qs*mw**2+2/qs*mw**2*rwz+1d0/2*rwz)
     & +a0fz*dreal(propzqs)*(3d0/2*mw**2/rwz**3/rhw+1d0/6*mw**2/rwz**2-1
     & d0/12*mw**2/rwz*rhw)
     & +a0fz*(27d0/2+41d0/12/qs*mw**2/rwz**2-9/qs*mw**2/rwz+1d0/12/qs*mw
     & **2/rwz*rhw+6/qs*mw**2-43d0/8/rwz-9*rwz)
     & +a0fh*dreal(propzqs)*(1d0/2*mw**2/rwz*rhw+1d0/12*mw**2*rhw**2)
     & +a0fh*(1d0/12/qs*mw**2/rwz*rhw-1d0/12/qs*mw**2*rhw**2-1d0/8*rhw)
     & +a0fmo*(3d0/2-1d0/2/rwz-rwz+1d0/4*rmow)
     & +b0fmowc*(-5d0/4+5d0/2*rwz-1d0/2*rmow-3d0/2*rmow*rwz)
     & +b0fmozmo*(-12-1d0/4/qs*mw**2*rmow/rwz+1d0/4/qs*mw**2*rmow*rhw+37
     & d0/8/rwz+8*rwz)
     & +b0fmohmo*(1d0/4/qs*mw**2*rmow/rwz-1d0/4/qs*mw**2*rmow*rhw-1d0/8*
     & rhw)
     & +b0fqsww*dreal(propzqs)*(1d0/12*mw**2/rwz**2+4d0/3*mw**2/rwz-17d0
     & /3*mw**2-4*mw**2*rwz)
     & +b0fqsww*dreal(propizqs)*(5d0/3/mw**2*rwz+1d0/4/mw**2*rmow*rwz-1d
     & 0/12*qs/mw**4*rwz)
     & +b0fqsww*(-4d0/3+2/qs*mw**2*rwz-1d0/12/rwz+rwz+3*rmow*rwz+1d0/2*r
     & mow**2*rwz+1d0/12*qs/mw**2-5d0/3*qs/mw**2*rwz-1d0/4*qs/mw**2*rmow
     & *rwz+1d0/12*qs**2/mw**4*rwz)
     & +b0fqszh*dreal(propzqs)*(mw**2/rwz**2-1d0/3*mw**2/rwz*rhw+1d0/12*
     & mw**2*rhw**2)
     & +b0fqszh*(-1d0/12/qs*mw**2/rwz**2+1d0/6/qs*mw**2/rwz*rhw-1d0/12/q
     & s*mw**2*rhw**2-1d0/12/rwz+1d0/2*rmow)
     & +b0fqsmomo*(27d0/2-21d0/4/rwz-9*rwz-1d0/4*rmow)
     & +b0fqscc*(33d0/2+7d0/2/qs*mw**2/rwz**2-9/qs*mw**2/rwz+5/qs*mw**2-
     & 21d0/4/rwz-9*rwz+1d0/4*rmow)
     & +dreal(propzqs)*(mw**2/rwz**3/rhw-1d0/18*mw**2/rwz**2+2*mw**2/rwz
     & /rhw-5d0/9*mw**2/rwz-mw**2/rwz*zmzzzbos-1d0/6*mw**2/rwz*rhw-8d0/3
     & *mw**2-4*mw**2*rwz)
     & +dreal(b0pmozmo)*(-5d0/4*mw**2/rwz**2+3*mw**2/rwz-2*mw**2-7d0/4*m
     & w**2*rmow/rwz+6*mw**2*rmow-4*mw**2*rmow*rwz)
     & +dreal(b0pmohmo)*(-1d0/4*mw**2*rmow*rhw+mw**2*rmow**2)
     & +dreal(b0pmocw)*(-1d0/2*mw**2+1d0/4*mw**2*rmow+1d0/4*mw**2*rmow**
     & 2)
     & +b0d1momoz*(-3d0/2+1d0/2/rwz+rwz)
     & +b0dwmocw*(-1+rwz)
     & +139d0/18-197d0/72/rwz+caldzfer-2*deltarhofer-za1fer-2*deltarhobo
     & s-za1bos+2*rwz+3d0/4*rmow-1d0/2*rmow*rwz

      ff_ew_ql =
     & +sdet3cmots**2*sdet4imotsus**2*d0ccmomoqstszczmo*dreal(propizqs)*
     & (pxx2zqsc**2/ctw**2*vmael*vmamo**2*mmo**2+1d0/4*pxx2zqsc**2/ctw**
     & 2*vmael*vmamo**2*qs)
     & +sdet3cmots**2*sdet4imotsus**2*c0ccqszcz*dreal(propizqs)*(1d0/4*p
     & xx2zqsc/ctw**2*vmael*vmamo**2*mmo**2-1d0/4*pxx2zqsc/ctw**2*vmael*
     & vmamo**2*ts)
     & +sdet3cmots*sdet4imotsus**2*d0ccmomoqstszczmo*dreal(propizqs)*(1d
     & 0/4*pxx2zqsc**2/ctw**2*vmael*vmamo**2*mmo**4-1d0/4*pxx2zqsc**2/ct
     & w**2*vmael*vmamo**2*ts*mmo**2)
     & +sdet3cmots*sdet4imotsus**2*c0momoqszmoz*dreal(propizqs)*(pxx2zqs
     & c/ctw**2*vmael*vmamo**2*mmo**4+pxx2zqsc/ctw**2*vmael*vmamo**2*ts*
     & mmo**2+1d0/4*pxx2zqsc/ctw**2*vmael*vmamo**2*qs*mmo**2+1d0/4*pxx2z
     & qsc/ctw**2*vmael*vmamo**2*qs*ts)
     & +sdet3cmots*sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*(-1d0/2*p
     & xx2zqsc/ctw**2*vmael*vmamo**2*mmo**4+1d0/2*pxx2zqsc/ctw**2*vmael*
     & vmamo**2*ts**2)
     & +sdet3cmots*sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*(-1d0/
     & 8/ctw**2*vmael*vmamo**2*qs*mmo**2+1d0/8/ctw**2*vmael*vmamo**2*qs*
     & ts-pxx2zqsc/ctw**2*vmael*vmamo**2*mmo**2+1d0/8*pxx2zqsc**2/ctw**2
     & *vmael*vmamo**2)
     & +sdet3cmots*sdet4imotsus*c0ccqszcz*dreal(propizqs)*(1d0/ctw**2*vm
     & ael*vmamo*mmo**2-3d0/2/ctw**2*vmael*vmamo**2*mmo**2-1d0/2/ctw**2*
     & vmael*vmamo**2*ts)
     & +sdet3cmots*d0ccmomoqstszczmo*dreal(propizqs)*(1d0/2/ctw**2*vmael
     & -1d0/ctw**2*vmael*vmamo+1d0/2/ctw**2*vmael*vmamo**2)
     & +sdet3cmous**2*sdet4imotsus**2*d0ccmomoqsuszczmo*dreal(propizqs)*
     & (pxx2zqsc**2/ctw**2*vmael*mmo**2+1d0/4*pxx2zqsc**2/ctw**2*vmael*q
     & s-2*pxx2zqsc**2/ctw**2*vmael*vmamo*mmo**2-1d0/2*pxx2zqsc**2/ctw**
     & 2*vmael*vmamo*qs+pxx2zqsc**2/ctw**2*vmael*vmamo**2*mmo**2+1d0/4*p
     & xx2zqsc**2/ctw**2*vmael*vmamo**2*qs)
     & +sdet3cmous**2*sdet4imotsus**2*c0ccqszcz*dreal(propizqs)*(1d0/4*p
     & xx2zqsc/ctw**2*vmael*mmo**2-1d0/4*pxx2zqsc/ctw**2*vmael*us-1d0/2*
     & pxx2zqsc/ctw**2*vmael*vmamo*mmo**2+1d0/2*pxx2zqsc/ctw**2*vmael*vm
     & amo*us+1d0/4*pxx2zqsc/ctw**2*vmael*vmamo**2*mmo**2-1d0/4*pxx2zqsc
     & /ctw**2*vmael*vmamo**2*us)
     & +sdet3cmous*sdet4imotsus**2*d0ccmomoqsuszczmo*dreal(propizqs)*(1d
     & 0/4*pxx2zqsc**2/ctw**2*vmael*mmo**4-1d0/4*pxx2zqsc**2/ctw**2*vmae
     & l*us*mmo**2-1d0/2*pxx2zqsc**2/ctw**2*vmael*vmamo*mmo**4+1d0/2*pxx
     & 2zqsc**2/ctw**2*vmael*vmamo*us*mmo**2+1d0/4*pxx2zqsc**2/ctw**2*vm
     & ael*vmamo**2*mmo**4-1d0/4*pxx2zqsc**2/ctw**2*vmael*vmamo**2*us*mm
     & o**2)
     & +sdet3cmous*sdet4imotsus**2*c0momoqszmoz*dreal(propizqs)*(pxx2zqs
     & c/ctw**2*vmael*mmo**4+pxx2zqsc/ctw**2*vmael*us*mmo**2+1d0/4*pxx2z
     & qsc/ctw**2*vmael*qs*mmo**2+1d0/4*pxx2zqsc/ctw**2*vmael*qs*us-2*px
     & x2zqsc/ctw**2*vmael*vmamo*mmo**4-2*pxx2zqsc/ctw**2*vmael*vmamo*us
     & *mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael*vmamo*qs*mmo**2-1d0/2*pxx2zqs
     & c/ctw**2*vmael*vmamo*qs*us+pxx2zqsc/ctw**2*vmael*vmamo**2*mmo**4+
     & pxx2zqsc/ctw**2*vmael*vmamo**2*us*mmo**2+1d0/4*pxx2zqsc/ctw**2*vm
     & ael*vmamo**2*qs*mmo**2+1d0/4*pxx2zqsc/ctw**2*vmael*vmamo**2*qs*us
     & )
     & +sdet3cmous*sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*(-1d0/2*p
     & xx2zqsc/ctw**2*vmael*mmo**4+1d0/2*pxx2zqsc/ctw**2*vmael*us**2+pxx
     & 2zqsc/ctw**2*vmael*vmamo*mmo**4-pxx2zqsc/ctw**2*vmael*vmamo*us**2
     & -1d0/2*pxx2zqsc/ctw**2*vmael*vmamo**2*mmo**4+1d0/2*pxx2zqsc/ctw**
     & 2*vmael*vmamo**2*us**2)
     & +sdet3cmous*sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*(-1d0/
     & 8/ctw**2*vmael*qs*mmo**2+1d0/8/ctw**2*vmael*qs*us+1d0/4/ctw**2*vm
     & ael*vmamo*qs*mmo**2-1d0/4/ctw**2*vmael*vmamo*qs*us-1d0/8/ctw**2*v
     & mael*vmamo**2*qs*mmo**2+1d0/8/ctw**2*vmael*vmamo**2*qs*us-pxx2zqs
     & c/ctw**2*vmael*mmo**2+2*pxx2zqsc/ctw**2*vmael*vmamo*mmo**2-pxx2zq
     & sc/ctw**2*vmael*vmamo**2*mmo**2+1d0/8*pxx2zqsc**2/ctw**2*vmael-1d
     & 0/4*pxx2zqsc**2/ctw**2*vmael*vmamo+1d0/8*pxx2zqsc**2/ctw**2*vmael
     & *vmamo**2)
     & +sdet3cmous*sdet4imotsus*c0ccqszcz*dreal(propizqs)*(-1d0/2/ctw**2
     & *vmael*mmo**2-1d0/2/ctw**2*vmael*us+2/ctw**2*vmael*vmamo*mmo**2+1
     & d0/ctw**2*vmael*vmamo*us-3d0/2/ctw**2*vmael*vmamo**2*mmo**2-1d0/2
     & /ctw**2*vmael*vmamo**2*us)
     & +sdet3cmous*d0ccmomoqsuszczmo*dreal(propizqs)*(1d0/2/ctw**2*vmael
     & *vmamo**2)
     & +sdet3imomoqs*c0momoqswcw*(-2/qs*mw**6+11d0/4*mw**4-13d0/2*mw**4*
     & rmow+11d0/4*mw**4*rmow**2+1d0/2*mw**4*rmow**3)
     & +sdet3imomoqs*c0momoqszmoh*(-3d0/4*mw**4*rmow/rwz**2-1d0/2*mw**4*
     & rmow/rwz*rhw+1d0/4*mw**4*rmow*rhw**2+2*mw**4*rmow**2/rwz-2*mw**4*
     & rmow**2*rhw+4*mw**4*rmow**3)
     & +sdet3imomoqs*c0momoqsmozmo*(-3/qs*mw**6/rwz**3+4/qs*mw**6/rwz**2
     & -7d0/2*mw**4/rwz**3+9*mw**4/rwz**2-6*mw**4/rwz-55d0/4*mw**4*rmow/
     & rwz**2+24*mw**4*rmow/rwz-8*mw**4*rmow)
     & +sdet3imomoqs*c0momoqsmohmo*(1d0/4*mw**4*rmow*rhw**2-2*mw**4*rmow
     & **2*rhw)
     & +sdet3imomoqs*c0momoqscwc*(mw**4+11d0/2*mw**4*rmow+6*mw**4*rmow**
     & 2+3d0/2*mw**4*rmow**3)
     & +sdet3imomoqs*b0fmowc*(2/qs*mw**4-9d0/4*mw**2+31d0/4*mw**2*rmow+2
     & *mw**2*rmow**2)
     & +sdet3imomoqs*b0fmozmo*(-3/qs*mw**4/rwz**2+4/qs*mw**4/rwz-7d0/2*m
     & w**2/rwz**2+9*mw**2/rwz-6*mw**2-13*mw**2*rmow/rwz+24*mw**2*rmow-1
     & d0/4*mw**2*rmow*rhw-8*mw**2*rmow*rwz+mw**2*rmow**2)
     & +sdet3imomoqs*b0fmohmo*(3d0/4*mw**2*rmow/rwz-mw**2*rmow**2)
     & +sdet3imomoqs*b0fqsww*(-2/qs*mw**4+13d0/4*mw**2-13d0/4*mw**2*rmow
     & -1d0/2*mw**2*rmow**2)
     & +sdet3imomoqs*b0fqszh*(-3d0/2*mw**2*rmow/rwz+1d0/2*mw**2*rmow*rhw
     & -2*mw**2*rmow**2)
     & +sdet3imomoqs*b0fqsmomo*(3/qs*mw**4/rwz**2-4/qs*mw**4/rwz+7d0/2*m
     & w**2/rwz**2-9*mw**2/rwz+6*mw**2+55d0/4*mw**2*rmow/rwz-24*mw**2*rm
     & ow-1d0/4*mw**2*rmow*rhw+8*mw**2*rmow*rwz+2*mw**2*rmow**2)
     & +sdet3imomoqs*b0fqscc*(-mw**2-9d0/2*mw**2*rmow-3d0/2*mw**2*rmow**
     & 2)
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*(1d0/ctw**2*vm
     & ael*vmamo**2*mmo**4+1d0/ctw**2*vmael*vmamo**2*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*(-1d0/ctw**2*v
     & mael*vmamo**2*mmo**4-1d0/ctw**2*vmael*vmamo**2*ts*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*(1d0/ctw**2*vm
     & ael*mmo**4+1d0/ctw**2*vmael*us*mmo**2-2/ctw**2*vmael*vmamo*mmo**4
     & -2/ctw**2*vmael*vmamo*us*mmo**2+1d0/ctw**2*vmael*vmamo**2*mmo**4+
     & 1d0/ctw**2*vmael*vmamo**2*us*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*(-1d0/ctw**2*v
     & mael*mmo**4-1d0/ctw**2*vmael*us*mmo**2+2/ctw**2*vmael*vmamo*mmo**
     & 4+2/ctw**2*vmael*vmamo*us*mmo**2-1d0/ctw**2*vmael*vmamo**2*mmo**4
     & -1d0/ctw**2*vmael*vmamo**2*us*mmo**2)
     & +sdet4imotsus**2*d0ccmomoqstszczmo*dreal(propizqs)*(1d0/4*pxx2zqs
     & c**2/ctw**2*vmael*vmamo**2*us*mmo**4-1d0/4*pxx2zqsc**2/ctw**2*vma
     & el*vmamo**2*ts*mmo**4)
     & +sdet4imotsus**2*d0ccmomoqsuszczmo*dreal(propizqs)*(-1d0/4*pxx2zq
     & sc**2/ctw**2*vmael*us*mmo**4+1d0/4*pxx2zqsc**2/ctw**2*vmael*ts*mm
     & o**4+1d0/2*pxx2zqsc**2/ctw**2*vmael*vmamo*us*mmo**4-1d0/2*pxx2zqs
     & c**2/ctw**2*vmael*vmamo*ts*mmo**4-1d0/4*pxx2zqsc**2/ctw**2*vmael*
     & vmamo**2*us*mmo**4+1d0/4*pxx2zqsc**2/ctw**2*vmael*vmamo**2*ts*mmo
     & **4)
     & +sdet4imotsus**2*c0ccqszcz*dreal(propizqs)*(-1d0/4*pxx2zqsc/ctw**
     & 2*vmael*qs*mmo**4+1d0/4*pxx2zqsc/ctw**2*vmael*qs*us*mmo**2+1d0/2*
     & pxx2zqsc/ctw**2*vmael*vmamo*qs*mmo**4-1d0/2*pxx2zqsc/ctw**2*vmael
     & *vmamo*qs*us*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael*vmamo**2*qs*mmo**
     & 4+1d0/4*pxx2zqsc/ctw**2*vmael*vmamo**2*qs*us*mmo**2+1d0/4*pxx2zqs
     & c/ctw**2*vmael*vmamo**2*qs*ts*mmo**2)
     & +sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*(-1d0/8/ctw**2*vm
     & ael*vmamo**2*qs*us*mmo**2+1d0/8/ctw**2*vmael*vmamo**2*qs*ts*mmo**
     & 2+1d0/2*pxx2zqsc/ctw**2*vmael*vmamo*mmo**4+1d0/2*pxx2zqsc/ctw**2*
     & vmael*vmamo*ts*mmo**2+1d0/4*pxx2zqsc/ctw**2*vmael*vmamo**2*mmo**4
     & -1d0/2*pxx2zqsc/ctw**2*vmael*vmamo**2*ts*mmo**2-3d0/4*pxx2zqsc/ct
     & w**2*vmael*vmamo**2*ts**2-1d0/4*pxx2zqsc/ctw**2*vmael*vmamo**2*qs
     & *mmo**2+1d0/2*pxx2zqsc**2/ctw**2*vmael*vmamo**2*mmo**2)
     & +sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*(1d0/8/ctw**2*vma
     & el*qs*us*mmo**2-1d0/8/ctw**2*vmael*qs*ts*mmo**2-1d0/4/ctw**2*vmae
     & l*vmamo*qs*us*mmo**2+1d0/4/ctw**2*vmael*vmamo*qs*ts*mmo**2+1d0/8/
     & ctw**2*vmael*vmamo**2*qs*us*mmo**2-1d0/8/ctw**2*vmael*vmamo**2*qs
     & *ts*mmo**2+3d0/4*pxx2zqsc/ctw**2*vmael*mmo**4-3d0/4*pxx2zqsc/ctw*
     & *2*vmael*us**2-1d0/4*pxx2zqsc/ctw**2*vmael*qs*mmo**2-pxx2zqsc/ctw
     & **2*vmael*vmamo*mmo**4+1d0/2*pxx2zqsc/ctw**2*vmael*vmamo*us*mmo**
     & 2+3d0/2*pxx2zqsc/ctw**2*vmael*vmamo*us**2+1d0/2*pxx2zqsc/ctw**2*v
     & mael*vmamo*qs*mmo**2+1d0/4*pxx2zqsc/ctw**2*vmael*vmamo**2*mmo**4-
     & 1d0/2*pxx2zqsc/ctw**2*vmael*vmamo**2*us*mmo**2-3d0/4*pxx2zqsc/ctw
     & **2*vmael*vmamo**2*us**2-1d0/4*pxx2zqsc/ctw**2*vmael*vmamo**2*qs*
     & mmo**2+1d0/2*pxx2zqsc**2/ctw**2*vmael*mmo**2-pxx2zqsc**2/ctw**2*v
     & mael*vmamo*mmo**2+1d0/2*pxx2zqsc**2/ctw**2*vmael*vmamo**2*mmo**2)
     &
     & +sdet4imotsus*c0momoqszmoz*dreal(propizqs)*(1d0/2/ctw**2*vmael*mm
     & o**4-1d0/2/ctw**2*vmael*us**2-1d0/ctw**2*vmael*vmamo*mmo**4+1d0/c
     & tw**2*vmael*vmamo*us**2+1d0/ctw**2*vmael*vmamo**2*mmo**4-1d0/2/ct
     & w**2*vmael*vmamo**2*us**2-1d0/2/ctw**2*vmael*vmamo**2*ts**2+1d0/2
     & *pxx2zqsc/ctw**2*vmael*mmo**2-pxx2zqsc/ctw**2*vmael*vmamo*mmo**2+
     & pxx2zqsc/ctw**2*vmael*vmamo**2*mmo**2)
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*(-1d0/ctw**2*vmael*vmam
     & o*mmo**4-1d0/ctw**2*vmael*vmamo*ts*mmo**2+1d0/ctw**2*vmael*vmamo*
     & *2*mmo**4+2/ctw**2*vmael*vmamo**2*ts*mmo**2+1d0/ctw**2*vmael*vmam
     & o**2*ts**2)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*(1d0/ctw**2*vmael*us*mm
     & o**2+1d0/ctw**2*vmael*us**2-1d0/ctw**2*vmael*vmamo*mmo**4-3/ctw**
     & 2*vmael*vmamo*us*mmo**2-2/ctw**2*vmael*vmamo*us**2+1d0/ctw**2*vma
     & el*vmamo**2*mmo**4+2/ctw**2*vmael*vmamo**2*us*mmo**2+1d0/ctw**2*v
     & mael*vmamo**2*us**2)
     & +sdet4imotsus*c0ccqszcz*dreal(propizqs)*(1d0/4*pxx2zqsc/ctw**2*vm
     & ael*mmo**2-1d0/4*pxx2zqsc/ctw**2*vmael*us-1d0/2*pxx2zqsc/ctw**2*v
     & mael*vmamo*mmo**2+1d0/2*pxx2zqsc/ctw**2*vmael*vmamo*us+1d0/2*pxx2
     & zqsc/ctw**2*vmael*vmamo**2*mmo**2-1d0/4*pxx2zqsc/ctw**2*vmael*vma
     & mo**2*us-1d0/4*pxx2zqsc/ctw**2*vmael*vmamo**2*ts)
     & +sdet4imotsus*b0fqszz*dreal(propizqs)*(-1d0/2/ctw**2*vmael*mmo**2
     & -1d0/2/ctw**2*vmael*us+1d0/ctw**2*vmael*vmamo*mmo**2+1d0/ctw**2*v
     & mael*vmamo*us-1d0/ctw**2*vmael*vmamo**2*mmo**2-1d0/2/ctw**2*vmael
     & *vmamo**2*us-1d0/2/ctw**2*vmael*vmamo**2*ts)
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*(1d0/2/ctw**2*vmael*vmamo*
     & *2*mmo**2+1d0/2/ctw**2*vmael*vmamo**2*ts)
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*(1d0/2/ctw**2*vmael*mmo**2
     & +1d0/2/ctw**2*vmael*us-1d0/ctw**2*vmael*vmamo*mmo**2-1d0/ctw**2*v
     & mael*vmamo*us+1d0/2/ctw**2*vmael*vmamo**2*mmo**2+1d0/2/ctw**2*vma
     & el*vmamo**2*us)
     & +d0ccmomoqstszczmo*dreal(propizqs)*(-1d0/2/ctw**2*vmael*vmamo**2*
     & mmo**2-1d0/2/ctw**2*vmael*vmamo**2*mz**2-1d0/2/ctw**2*vmael*vmamo
     & **2*ts-1d0/8/ctw**2*vmael*vmamo**2*qs)
     & +d0ccmomoqsuszczmo*dreal(propizqs)*(-1d0/2/ctw**2*vmael*mmo**2-1d
     & 0/2/ctw**2*vmael*us+1d0/8/ctw**2*vmael*qs+1d0/ctw**2*vmael*vmamo*
     & mmo**2+1d0/ctw**2*vmael*vmamo*us-1d0/4/ctw**2*vmael*vmamo*qs-1d0/
     & 2/ctw**2*vmael*vmamo**2*mmo**2-1d0/2/ctw**2*vmael*vmamo**2*us+1d0
     & /8/ctw**2*vmael*vmamo**2*qs-1d0/4*pxx2zqsc/ctw**2*vmael+1d0/2*pxx
     & 2zqsc/ctw**2*vmael*vmamo-1d0/4*pxx2zqsc/ctw**2*vmael*vmamo**2)
     & +c0momoqswcw*(5d0/4/qs*mw**4-1d0/qs*mw**4*rmow+1d0/4/qs*mw**4*rmo
     & w**2)
     & +c0momoqszmoz*dreal(propizqs)*(-1d0/2/ctw**2*vmael+1d0/ctw**2*vma
     & el*vmamo-1d0/ctw**2*vmael*vmamo**2)
     & +c0momoqszmoh*(-1d0/4/qs*mw**4*rmow/rwz**2+1d0/2/qs*mw**4*rmow/rw
     & z*rhw-1d0/4/qs*mw**4*rmow*rhw**2+mw**2*rmow/rwz-mw**2*rmow**2)
     & +c0momoqsmozmo*(3/qs*mw**4/rwz**2-4/qs*mw**4/rwz+7*mw**2/rwz**2-1
     & 5*mw**2/rwz+8*mw**2-5d0/2*mw**2*rmow/rwz+6*mw**2*rmow-4*mw**2*rmo
     & w*rwz-7d0/2*qs/rwz+6*qs-2*qs*rwz)
     & +c0momoqsmohmo*(mw**2*rmow**2)
     & +c0momoqscwc*(-2*mw**2-mw**2*rmow-1d0/2*mw**2*rmow**2+qs)
     & +c0ccqszcz*dreal(propizqs)*(-1d0/2/ctw**2*vmael+1d0/ctw**2*vmael*
     & vmamo-1d0/ctw**2*vmael*vmamo**2)
     & +c0ccqsczc*(-2/qs*mw**4/rwz**3+4/qs*mw**4/rwz**2-2/qs*mw**4/rwz+4
     & *mw**2/rwz**2-8*mw**2/rwz+4*mw**2-2*qs/rwz+4*qs-2*qs*rwz)
     & +a0fw*dreal(propzqs)*(3*mw**2/rwz/rhw+1d0/6*mw**2/rwz-8d0/3*mw**2
     & -4*mw**2*rwz)
     & +a0fw*(1d0/4-1d0/6/qs*mw**2+4/qs*mw**2*rwz)
     & +a0fz*dreal(propzqs)*(3d0/2*mw**2/rwz**3/rhw+1d0/6*mw**2/rwz**2-1
     & d0/12*mw**2/rwz*rhw)
     & +a0fz*(6+23d0/12/qs*mw**2/rwz**2-4/qs*mw**2/rwz+1d0/12/qs*mw**2/r
     & wz*rhw+2/qs*mw**2-25d0/8/rwz-3*rwz)
     & +a0fh*dreal(propzqs)*(1d0/2*mw**2/rwz*rhw+1d0/12*mw**2*rhw**2)
     & +a0fh*(1d0/12/qs*mw**2/rwz*rhw-1d0/12/qs*mw**2*rhw**2-1d0/8*rhw)
     & +a0fmo*(-3d0/2/qs*mw**2/rwz+2/qs*mw**2-1d0/2/rwz+rwz+1d0/4*rmow)
     & +b0fmowc*(-5d0/4+3d0/4/qs*mw**2-1d0/4/qs*mw**2*rmow-1d0/2*rmow)
     & +b0fmozmo*(-9-1d0/4/qs*mw**2*rmow/rwz+1d0/4/qs*mw**2*rmow*rhw+37d
     & 0/8/rwz+4*rwz)
     & +b0fmohmo*(1d0/4/qs*mw**2*rmow/rwz-1d0/4/qs*mw**2*rmow*rhw-1d0/8*
     & rhw)
     & +b0fqsww*dreal(propzqs)*(1d0/12*mw**2/rwz**2+4d0/3*mw**2/rwz-17d0
     & /3*mw**2-4*mw**2*rwz)
     & +b0fqsww*(1d0/6-11d0/12/qs*mw**2+4/qs*mw**2*rwz+1d0/4/qs*mw**2*rm
     & ow-1d0/12/rwz+1d0/4*rmow)
     & +b0fqszh*dreal(propzqs)*(mw**2/rwz**2-1d0/3*mw**2/rwz*rhw+1d0/12*
     & mw**2*rhw**2)
     & +b0fqszh*(-1d0/12/qs*mw**2/rwz**2+1d0/6/qs*mw**2/rwz*rhw-1d0/12/q
     & s*mw**2*rhw**2-1d0/12/rwz+1d0/2*rmow)
     & +b0fqsmomo*(9-3d0/2/qs*mw**2/rwz+2/qs*mw**2-21d0/4/rwz-3*rwz-1d0/
     & 4*rmow)
     & +b0fqscc*(15d0/2+2/qs*mw**2/rwz**2-4/qs*mw**2/rwz+2/qs*mw**2-3/rw
     & z-3*rwz+1d0/4*rmow)
     & +dreal(propzqs)*(mw**2/rwz**3/rhw-1d0/18*mw**2/rwz**2+2*mw**2/rwz
     & /rhw-5d0/9*mw**2/rwz-mw**2/rwz*zmzzzbos-1d0/6*mw**2/rwz*rhw-8d0/3
     & *mw**2-4*mw**2*rwz)
     & +dreal(b0pmozmo)*(-5d0/4*mw**2/rwz**2+3*mw**2/rwz-2*mw**2-7d0/4*m
     & w**2*rmow/rwz+6*mw**2*rmow-4*mw**2*rmow*rwz)
     & +dreal(b0pmohmo)*(-1d0/4*mw**2*rmow*rhw+mw**2*rmow**2)
     & +dreal(b0pmocw)*(-1d0/2*mw**2+1d0/4*mw**2*rmow+1d0/4*mw**2*rmow**
     & 2)
     & +b0d1momoz*(3d0/2/qs*mw**2/rwz-2/qs*mw**2+1d0/2/rwz-rwz)
     & +b0dwmocw*(-1-1d0/qs*mw**2)
     & +83d0/18-3d0/2/qs*mw**2/rwz+1d0/3/qs*mw**2+4/qs*mw**2*rwz+1d0/2/q
     & s*mw**2*rmow-85d0/36/rwz-pizgfer+caldzfer-deltarhofer-za1fer-delt
     & arhobos-za1bos-3d0/2*rwz+3d0/4*rmow

      ff_ew_lq =
     & +sdet3cmots**2*sdet4imotsus**2*d0ccmomoqstszczmo*dreal(propizqs)*
     & (pxx2zqsc**2/ctw**2*vmael**2*vmamo*mmo**2+1d0/4*pxx2zqsc**2/ctw**
     & 2*vmael**2*vmamo*qs)
     & +sdet3cmots**2*sdet4imotsus**2*c0ccqszcz*dreal(propizqs)*(1d0/4*p
     & xx2zqsc/ctw**2*vmael**2*vmamo*mmo**2-1d0/4*pxx2zqsc/ctw**2*vmael*
     & *2*vmamo*ts)
     & +sdet3cmots*sdet4imotsus**2*d0ccmomoqstszczmo*dreal(propizqs)*(1d
     & 0/4*pxx2zqsc**2/ctw**2/vmamo*mmo**4-1d0/4*pxx2zqsc**2/ctw**2/vmam
     & o*ts*mmo**2-1d0/2*pxx2zqsc**2/ctw**2*mmo**4+1d0/2*pxx2zqsc**2/ctw
     & **2*ts*mmo**2+1d0/4*pxx2zqsc**2/ctw**2*vmamo*mmo**4-1d0/4*pxx2zqs
     & c**2/ctw**2*vmamo*ts*mmo**2-1d0/2*pxx2zqsc**2/ctw**2*vmael/vmamo*
     & mmo**4+1d0/2*pxx2zqsc**2/ctw**2*vmael/vmamo*ts*mmo**2+pxx2zqsc**2
     & /ctw**2*vmael*mmo**4-pxx2zqsc**2/ctw**2*vmael*ts*mmo**2-1d0/2*pxx
     & 2zqsc**2/ctw**2*vmael*vmamo*mmo**4+1d0/2*pxx2zqsc**2/ctw**2*vmael
     & *vmamo*ts*mmo**2+1d0/4*pxx2zqsc**2/ctw**2*vmael**2/vmamo*mmo**4-1
     & d0/4*pxx2zqsc**2/ctw**2*vmael**2/vmamo*ts*mmo**2-1d0/2*pxx2zqsc**
     & 2/ctw**2*vmael**2*mmo**4+1d0/2*pxx2zqsc**2/ctw**2*vmael**2*ts*mmo
     & **2+1d0/4*pxx2zqsc**2/ctw**2*vmael**2*vmamo*mmo**4-1d0/4*pxx2zqsc
     & **2/ctw**2*vmael**2*vmamo*ts*mmo**2)
     & +sdet3cmots*sdet4imotsus**2*c0momoqszmoz*dreal(propizqs)*(pxx2zqs
     & c/ctw**2/vmamo*mmo**4+1d0/4*pxx2zqsc/ctw**2/vmamo*qs*mmo**2-2*pxx
     & 2zqsc/ctw**2*mmo**4-1d0/2*pxx2zqsc/ctw**2*qs*mmo**2+pxx2zqsc/ctw*
     & *2*vmamo*mmo**4+1d0/4*pxx2zqsc/ctw**2*vmamo*qs*mmo**2-2*pxx2zqsc/
     & ctw**2*vmael/vmamo*mmo**4-1d0/2*pxx2zqsc/ctw**2*vmael/vmamo*qs*mm
     & o**2+4*pxx2zqsc/ctw**2*vmael*mmo**4+pxx2zqsc/ctw**2*vmael*qs*mmo*
     & *2-2*pxx2zqsc/ctw**2*vmael*vmamo*mmo**4-1d0/2*pxx2zqsc/ctw**2*vma
     & el*vmamo*qs*mmo**2+pxx2zqsc/ctw**2*vmael**2/vmamo*mmo**4+1d0/4*px
     & x2zqsc/ctw**2*vmael**2/vmamo*qs*mmo**2-2*pxx2zqsc/ctw**2*vmael**2
     & *mmo**4-1d0/2*pxx2zqsc/ctw**2*vmael**2*qs*mmo**2+pxx2zqsc/ctw**2*
     & vmael**2*vmamo*mmo**4+pxx2zqsc/ctw**2*vmael**2*vmamo*ts*mmo**2+1d
     & 0/4*pxx2zqsc/ctw**2*vmael**2*vmamo*qs*mmo**2+1d0/4*pxx2zqsc/ctw**
     & 2*vmael**2*vmamo*qs*ts)
     & +sdet3cmots*sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*(-1d0/2*p
     & xx2zqsc/ctw**2/vmamo*mmo**4+1d0/2*pxx2zqsc/ctw**2/vmamo*ts*mmo**2
     & +pxx2zqsc/ctw**2*mmo**4-pxx2zqsc/ctw**2*ts*mmo**2-1d0/2*pxx2zqsc/
     & ctw**2*vmamo*mmo**4+1d0/2*pxx2zqsc/ctw**2*vmamo*ts*mmo**2+pxx2zqs
     & c/ctw**2*vmael/vmamo*mmo**4-pxx2zqsc/ctw**2*vmael/vmamo*ts*mmo**2
     & -2*pxx2zqsc/ctw**2*vmael*mmo**4+2*pxx2zqsc/ctw**2*vmael*ts*mmo**2
     & +pxx2zqsc/ctw**2*vmael*vmamo*mmo**4-pxx2zqsc/ctw**2*vmael*vmamo*t
     & s*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael**2/vmamo*mmo**4+1d0/2*pxx2zq
     & sc/ctw**2*vmael**2/vmamo*ts*mmo**2+pxx2zqsc/ctw**2*vmael**2*mmo**
     & 4-pxx2zqsc/ctw**2*vmael**2*ts*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael*
     & *2*vmamo*mmo**4+1d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo*ts**2)
     & +sdet3cmots*sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*(-1d0/
     & 8/ctw**2*vmael**2*vmamo*qs*mmo**2+1d0/8/ctw**2*vmael**2*vmamo*qs*
     & ts-pxx2zqsc/ctw**2/vmamo*mmo**2+2*pxx2zqsc/ctw**2*mmo**2-pxx2zqsc
     & /ctw**2*vmamo*mmo**2+2*pxx2zqsc/ctw**2*vmael/vmamo*mmo**2-4*pxx2z
     & qsc/ctw**2*vmael*mmo**2+2*pxx2zqsc/ctw**2*vmael*vmamo*mmo**2-pxx2
     & zqsc/ctw**2*vmael**2/vmamo*mmo**2+2*pxx2zqsc/ctw**2*vmael**2*mmo*
     & *2-pxx2zqsc/ctw**2*vmael**2*vmamo*mmo**2+1d0/8*pxx2zqsc**2/ctw**2
     & *vmael**2*vmamo)
     & +sdet3cmots*sdet4imotsus*c0ccqszcz*dreal(propizqs)*(-1d0/2/ctw**2
     & /vmamo*mmo**2+1d0/ctw**2*mmo**2-1d0/2/ctw**2*vmamo*mmo**2+1d0/ctw
     & **2*vmael/vmamo*mmo**2-2/ctw**2*vmael*mmo**2+1d0/ctw**2*vmael*vma
     & mo*mmo**2-1d0/2/ctw**2*vmael**2/vmamo*mmo**2+2/ctw**2*vmael**2*mm
     & o**2-3d0/2/ctw**2*vmael**2*vmamo*mmo**2-1d0/2/ctw**2*vmael**2*vma
     & mo*ts)
     & +sdet3cmots*d0ccmomoqstszczmo*dreal(propizqs)*(1d0/2/ctw**2*vmamo
     & -1d0/ctw**2*vmael*vmamo+1d0/2/ctw**2*vmael**2*vmamo)
     & +sdet3cmous**2*sdet4imotsus**2*d0ccmomoqsuszczmo*dreal(propizqs)*
     & (pxx2zqsc**2/ctw**2*vmamo*mmo**2+1d0/4*pxx2zqsc**2/ctw**2*vmamo*q
     & s-2*pxx2zqsc**2/ctw**2*vmael*vmamo*mmo**2-1d0/2*pxx2zqsc**2/ctw**
     & 2*vmael*vmamo*qs+pxx2zqsc**2/ctw**2*vmael**2*vmamo*mmo**2+1d0/4*p
     & xx2zqsc**2/ctw**2*vmael**2*vmamo*qs)
     & +sdet3cmous**2*sdet4imotsus**2*c0ccqszcz*dreal(propizqs)*(1d0/4*p
     & xx2zqsc/ctw**2*vmamo*mmo**2-1d0/4*pxx2zqsc/ctw**2*vmamo*us-1d0/2*
     & pxx2zqsc/ctw**2*vmael*vmamo*mmo**2+1d0/2*pxx2zqsc/ctw**2*vmael*vm
     & amo*us+1d0/4*pxx2zqsc/ctw**2*vmael**2*vmamo*mmo**2-1d0/4*pxx2zqsc
     & /ctw**2*vmael**2*vmamo*us)
     & +sdet3cmous*sdet4imotsus**2*d0ccmomoqsuszczmo*dreal(propizqs)*(1d
     & 0/4*pxx2zqsc**2/ctw**2*vmael**2/vmamo*mmo**4-1d0/4*pxx2zqsc**2/ct
     & w**2*vmael**2/vmamo*us*mmo**2-1d0/2*pxx2zqsc**2/ctw**2*vmael**2*m
     & mo**4+1d0/2*pxx2zqsc**2/ctw**2*vmael**2*us*mmo**2+1d0/4*pxx2zqsc*
     & *2/ctw**2*vmael**2*vmamo*mmo**4-1d0/4*pxx2zqsc**2/ctw**2*vmael**2
     & *vmamo*us*mmo**2)
     & +sdet3cmous*sdet4imotsus**2*c0momoqszmoz*dreal(propizqs)*(pxx2zqs
     & c/ctw**2*vmamo*us*mmo**2+1d0/4*pxx2zqsc/ctw**2*vmamo*qs*us-2*pxx2
     & zqsc/ctw**2*vmael*vmamo*us*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael*vma
     & mo*qs*us+pxx2zqsc/ctw**2*vmael**2/vmamo*mmo**4+1d0/4*pxx2zqsc/ctw
     & **2*vmael**2/vmamo*qs*mmo**2-2*pxx2zqsc/ctw**2*vmael**2*mmo**4-1d
     & 0/2*pxx2zqsc/ctw**2*vmael**2*qs*mmo**2+pxx2zqsc/ctw**2*vmael**2*v
     & mamo*mmo**4+pxx2zqsc/ctw**2*vmael**2*vmamo*us*mmo**2+1d0/4*pxx2zq
     & sc/ctw**2*vmael**2*vmamo*qs*mmo**2+1d0/4*pxx2zqsc/ctw**2*vmael**2
     & *vmamo*qs*us)
     & +sdet3cmous*sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*(-1d0/2*p
     & xx2zqsc/ctw**2*vmamo*us*mmo**2+1d0/2*pxx2zqsc/ctw**2*vmamo*us**2+
     & pxx2zqsc/ctw**2*vmael*vmamo*us*mmo**2-pxx2zqsc/ctw**2*vmael*vmamo
     & *us**2-1d0/2*pxx2zqsc/ctw**2*vmael**2/vmamo*mmo**4+1d0/2*pxx2zqsc
     & /ctw**2*vmael**2/vmamo*us*mmo**2+pxx2zqsc/ctw**2*vmael**2*mmo**4-
     & pxx2zqsc/ctw**2*vmael**2*us*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael**2
     & *vmamo*mmo**4+1d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo*us**2)
     & +sdet3cmous*sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*(-1d0/
     & 8/ctw**2*vmamo*qs*mmo**2+1d0/8/ctw**2*vmamo*qs*us+1d0/4/ctw**2*vm
     & ael*vmamo*qs*mmo**2-1d0/4/ctw**2*vmael*vmamo*qs*us-1d0/8/ctw**2*v
     & mael**2*vmamo*qs*mmo**2+1d0/8/ctw**2*vmael**2*vmamo*qs*us-pxx2zqs
     & c/ctw**2*vmael**2/vmamo*mmo**2+2*pxx2zqsc/ctw**2*vmael**2*mmo**2-
     & pxx2zqsc/ctw**2*vmael**2*vmamo*mmo**2+1d0/8*pxx2zqsc**2/ctw**2*vm
     & amo-1d0/4*pxx2zqsc**2/ctw**2*vmael*vmamo+1d0/8*pxx2zqsc**2/ctw**2
     & *vmael**2*vmamo)
     & +sdet3cmous*sdet4imotsus*c0ccqszcz*dreal(propizqs)*(1d0/ctw**2*mm
     & o**2-1d0/ctw**2*vmamo*mmo**2-1d0/2/ctw**2*vmamo*us-2/ctw**2*vmael
     & *mmo**2+2/ctw**2*vmael*vmamo*mmo**2+1d0/ctw**2*vmael*vmamo*us-1d0
     & /2/ctw**2*vmael**2/vmamo*mmo**2+2/ctw**2*vmael**2*mmo**2-3d0/2/ct
     & w**2*vmael**2*vmamo*mmo**2-1d0/2/ctw**2*vmael**2*vmamo*us)
     & +sdet3cmous*d0ccmomoqsuszczmo*dreal(propizqs)*(1d0/2/ctw**2*vmael
     & **2*vmamo)
     & +sdet3imomoqs*c0momoqswcw*dreal(propizqs)*(-3d0/2/vmamo*mw**2*rmo
     & w*rwz+1d0/vmamo*mw**2*rmow**2*rwz+1d0/2/vmamo*mw**2*rmow**3*rwz)
     & +sdet3imomoqs*c0momoqswcw*(7/vmamo*mw**4*rmow*rwz-12/vmamo*mw**4*
     & rmow**2*rwz+3/vmamo*mw**4*rmow**3*rwz+2/vmamo*mw**4*rmow**4*rwz)
     & +sdet3imomoqs*c0momoqszmoh*(-3d0/8/vmamo*mw**4*rmow/rwz**2-1d0/4/
     & vmamo*mw**4*rmow/rwz*rhw+1d0/8/vmamo*mw**4*rmow*rhw**2+1d0/vmamo*
     & mw**4*rmow**2/rwz-1d0/vmamo*mw**4*rmow**2*rhw+2/vmamo*mw**4*rmow*
     & *3)
     & +sdet3imomoqs*c0momoqsmozmo*(-3d0/4/vmamo*mw**4*rmow/rwz**2-2*mw*
     & *4/rwz**3+4*mw**4/rwz**2-2*mw**4/rwz-13d0/4*mw**4*rmow/rwz**2+6*m
     & w**4*rmow/rwz)
     & +sdet3imomoqs*c0momoqsmohmo*(1d0/4/vmamo*mw**4*rmow*rhw**2-1d0/vm
     & amo*mw**4*rmow**2*rhw-1d0/4*mw**4*rmow*rhw**2)
     & +sdet3imomoqs*c0momoqscwc*(3d0/2/vmamo*mw**4*rmow+2/vmamo*mw**4*r
     & mow**2+1d0/2/vmamo*mw**4*rmow**3)
     & +sdet3imomoqs*b0fmowc*dreal(propizqs)*(1d0/vmamo*rmow*rwz)
     & +sdet3imomoqs*b0fmowc*(2/vmamo*mw**2*rmow-7/vmamo*mw**2*rmow*rwz+
     & 1d0/vmamo*mw**2*rmow**2+3/vmamo*mw**2*rmow**2*rwz)
     & +sdet3imomoqs*b0fmozmo*(-3d0/8/vmamo*mw**2*rmow/rwz-1d0/8/vmamo*m
     & w**2*rmow*rhw+1d0/2/vmamo*mw**2*rmow**2-2*mw**2/rwz**2+4*mw**2/rw
     & z-2*mw**2-13d0/4*mw**2*rmow/rwz+6*mw**2*rmow)
     & +sdet3imomoqs*b0fmohmo*(3d0/8/vmamo*mw**2*rmow/rwz+1d0/8/vmamo*mw
     & **2*rmow*rhw-1d0/2/vmamo*mw**2*rmow**2-1d0/4*mw**2*rmow*rhw)
     & +sdet3imomoqs*b0fqsww*dreal(propizqs)*(-3d0/2/vmamo*rmow*rwz-1d0/
     & 2/vmamo*rmow**2*rwz)
     & +sdet3imomoqs*b0fqsww*(7/vmamo*mw**2*rmow*rwz-5/vmamo*mw**2*rmow*
     & *2*rwz-2/vmamo*mw**2*rmow**3*rwz)
     & +sdet3imomoqs*b0fqszh*(-3d0/4/vmamo*mw**2*rmow/rwz+1d0/4/vmamo*mw
     & **2*rmow*rhw-1d0/vmamo*mw**2*rmow**2)
     & +sdet3imomoqs*b0fqsmomo*(3d0/4/vmamo*mw**2*rmow/rwz-1d0/4/vmamo*m
     & w**2*rmow*rhw+1d0/vmamo*mw**2*rmow**2+2*mw**2/rwz**2-4*mw**2/rwz+
     & 2*mw**2+13d0/4*mw**2*rmow/rwz-6*mw**2*rmow+1d0/4*mw**2*rmow*rhw)
     & +sdet3imomoqs*b0fqscc*(-3d0/2/vmamo*mw**2*rmow-1d0/2/vmamo*mw**2*
     & rmow**2)
     & +sdet3icmots*sdet4imotsus*c0cmotscwc*dreal(propizqs)*(4/vmamo*ts*
     & *2*mw**2*rwz)
     & +sdet3icmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*(-1d0/2*pxx
     & 2zqsc/ctw**2/vmamo*ts*mmo**2+pxx2zqsc/ctw**2*ts*mmo**2-1d0/2*pxx2
     & zqsc/ctw**2*vmamo*ts*mmo**2+pxx2zqsc/ctw**2*vmael/vmamo*ts*mmo**2
     & -2*pxx2zqsc/ctw**2*vmael*ts*mmo**2+pxx2zqsc/ctw**2*vmael*vmamo*ts
     & *mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael**2/vmamo*ts*mmo**2+pxx2zqsc/c
     & tw**2*vmael**2*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0fmowc*dreal(propizqs)*(4/vmamo*ts**2*
     & rwz)
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*(1d0/ctw**2/vm
     & amo*mmo**4-2/ctw**2*mmo**4+1d0/ctw**2*vmamo*mmo**4-2/ctw**2*vmael
     & /vmamo*mmo**4+4/ctw**2*vmael*mmo**4-2/ctw**2*vmael*vmamo*mmo**4+1
     & d0/ctw**2*vmael**2/vmamo*mmo**4-2/ctw**2*vmael**2*mmo**4+1d0/ctw*
     & *2*vmael**2*vmamo*mmo**4+1d0/ctw**2*vmael**2*vmamo*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*(-1d0/ctw**2/v
     & mamo*mmo**4+2/ctw**2*mmo**4-1d0/ctw**2*vmamo*mmo**4+2/ctw**2*vmae
     & l/vmamo*mmo**4-4/ctw**2*vmael*mmo**4+2/ctw**2*vmael*vmamo*mmo**4-
     & 1d0/ctw**2*vmael**2/vmamo*mmo**4+2/ctw**2*vmael**2*mmo**4-1d0/ctw
     & **2*vmael**2*vmamo*mmo**4-1d0/ctw**2*vmael**2*vmamo*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0ftscc*dreal(propizqs)*(-4/vmamo*ts**2
     & *rwz)
     & +sdet3icmots*c0cmotsczmo*dreal(propizqs)*(-1d0/2/ctw**2/vmamo*mmo
     & **2+1d0/ctw**2*mmo**2-1d0/2/ctw**2*vmamo*mmo**2+1d0/ctw**2*vmael/
     & vmamo*mmo**2-2/ctw**2*vmael*mmo**2+1d0/ctw**2*vmael*vmamo*mmo**2-
     & 1d0/2/ctw**2*vmael**2/vmamo*mmo**2+1d0/ctw**2*vmael**2*mmo**2)
     & +sdet3icmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*(1d0/2*pxx2
     & zqsc/ctw**2*vmamo*us*mmo**2-pxx2zqsc/ctw**2*vmael*vmamo*us*mmo**2
     & -1d0/2*pxx2zqsc/ctw**2*vmael**2/vmamo*us*mmo**2+pxx2zqsc/ctw**2*v
     & mael**2*us*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*(1d0/ctw**2*vm
     & amo*us*mmo**2-2/ctw**2*vmael*vmamo*us*mmo**2+1d0/ctw**2*vmael**2/
     & vmamo*mmo**4-2/ctw**2*vmael**2*mmo**4+1d0/ctw**2*vmael**2*vmamo*m
     & mo**4+1d0/ctw**2*vmael**2*vmamo*us*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*(-1d0/ctw**2*v
     & mamo*us*mmo**2+2/ctw**2*vmael*vmamo*us*mmo**2-1d0/ctw**2*vmael**2
     & /vmamo*mmo**4+2/ctw**2*vmael**2*mmo**4-1d0/ctw**2*vmael**2*vmamo*
     & mmo**4-1d0/ctw**2*vmael**2*vmamo*us*mmo**2)
     & +sdet3icmous*c0cmousczmo*dreal(propizqs)*(1d0/2/ctw**2*vmamo*mmo*
     & *2-1d0/ctw**2*vmael*vmamo*mmo**2-1d0/2/ctw**2*vmael**2/vmamo*mmo*
     & *2+1d0/ctw**2*vmael**2*mmo**2)
     & +sdet4imotsus**2*d0ccmomoqstswcwc*dreal(propizqs)*(4/vmamo*mw**10
     & *rmow**3*rwz-4/vmamo*mw**10*rmow**4*rwz+1d0/vmamo*mw**10*rmow**5*
     & rwz-4/vmamo*ts*mw**8*rmow**3*rwz+2/vmamo*ts*mw**8*rmow**4*rwz-4/v
     & mamo*ts**2*mw**6*rmow*rwz+4/vmamo*ts**2*mw**6*rmow**2*rwz+4/vmamo
     & *ts**3*mw**4*rmow*rwz-2/vmamo*ts**3*mw**4*rmow**2*rwz-1d0/vmamo*t
     & s**4*mw**2*rmow*rwz)
     & +sdet4imotsus**2*d0ccmomoqstszczmo*dreal(propizqs)*(1d0/4*pxx2zqs
     & c**2/ctw**2*vmael**2*vmamo*us*mmo**4-1d0/4*pxx2zqsc**2/ctw**2*vma
     & el**2*vmamo*ts*mmo**4)
     & +sdet4imotsus**2*d0ccmomoqsuszczmo*dreal(propizqs)*(-1d0/4*pxx2zq
     & sc**2/ctw**2*vmamo*us*mmo**4+1d0/4*pxx2zqsc**2/ctw**2*vmamo*ts*mm
     & o**4+1d0/2*pxx2zqsc**2/ctw**2*vmael*vmamo*us*mmo**4-1d0/2*pxx2zqs
     & c**2/ctw**2*vmael*vmamo*ts*mmo**4-1d0/4*pxx2zqsc**2/ctw**2*vmael*
     & *2*vmamo*us*mmo**4+1d0/4*pxx2zqsc**2/ctw**2*vmael**2*vmamo*ts*mmo
     & **4)
     & +sdet4imotsus**2*c0momoqswcw*dreal(propizqs)*(-2/vmamo/ts*mw**10*
     & rmow**4*rwz+1d0/vmamo/ts*mw**10*rmow**5*rwz+2/vmamo*mw**8*rmow**3
     & *rwz+2/vmamo*ts*mw**6*rmow**2*rwz-2/vmamo*ts*mw**6*rmow**3*rwz-2/
     & vmamo*ts**2*mw**4*rmow*rwz+1d0/vmamo*ts**3*mw**2*rmow*rwz)
     & +sdet4imotsus**2*c0cmotscwc*dreal(propizqs)*(-4/vmamo*mw**8*rmow*
     & *3*rwz+2/vmamo*mw**8*rmow**4*rwz+2/vmamo*ts*mw**6*rmow**3*rwz+4/v
     & mamo*ts**2*mw**4*rmow*rwz-2/vmamo*ts**2*mw**4*rmow**2*rwz-2/vmamo
     & *ts**3*mw**2*rmow*rwz)
     & +sdet4imotsus**2*c0ccqswcw*dreal(propizqs)*(2/vmamo/ts*mw**10*rmo
     & w**4*rwz-1d0/vmamo/ts*mw**10*rmow**5*rwz+2/vmamo*mw**8*rmow**3*rw
     & z-2/vmamo*mw**8*rmow**4*rwz-2/vmamo*ts*mw**6*rmow**2*rwz-2/vmamo*
     & ts**2*mw**4*rmow*rwz+2/vmamo*ts**2*mw**4*rmow**2*rwz+1d0/vmamo*ts
     & **3*mw**2*rmow*rwz)
     & +sdet4imotsus**2*c0ccqszcz*dreal(propizqs)*(-1d0/4*pxx2zqsc/ctw**
     & 2/vmamo*qs*mmo**4+1d0/4*pxx2zqsc/ctw**2/vmamo*qs*ts*mmo**2+1d0/2*
     & pxx2zqsc/ctw**2*qs*mmo**4-1d0/2*pxx2zqsc/ctw**2*qs*ts*mmo**2-1d0/
     & 4*pxx2zqsc/ctw**2*vmamo*qs*mmo**4+1d0/4*pxx2zqsc/ctw**2*vmamo*qs*
     & ts*mmo**2+1d0/2*pxx2zqsc/ctw**2*vmael/vmamo*qs*mmo**4-1d0/2*pxx2z
     & qsc/ctw**2*vmael/vmamo*qs*ts*mmo**2-pxx2zqsc/ctw**2*vmael*qs*mmo*
     & *4+pxx2zqsc/ctw**2*vmael*qs*ts*mmo**2+1d0/2*pxx2zqsc/ctw**2*vmael
     & *vmamo*qs*mmo**4-1d0/2*pxx2zqsc/ctw**2*vmael*vmamo*qs*ts*mmo**2-1
     & d0/2*pxx2zqsc/ctw**2*vmael**2/vmamo*qs*mmo**4+1d0/4*pxx2zqsc/ctw*
     & *2*vmael**2/vmamo*qs*us*mmo**2+1d0/4*pxx2zqsc/ctw**2*vmael**2/vma
     & mo*qs*ts*mmo**2+pxx2zqsc/ctw**2*vmael**2*qs*mmo**4-1d0/2*pxx2zqsc
     & /ctw**2*vmael**2*qs*us*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael**2*qs*t
     & s*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo*qs*mmo**4+1d0/4*pxx
     & 2zqsc/ctw**2*vmael**2*vmamo*qs*us*mmo**2+1d0/4*pxx2zqsc/ctw**2*vm
     & ael**2*vmamo*qs*ts*mmo**2)
     & +sdet4imotsus*d0ccmomoqstswcwc*dreal(propizqs)*(2/vmamo*mw**6*rmo
     & w*rwz-2/vmamo*mw**6*rmow**2*rwz+1d0/vmamo*mw**6*rmow**3*rwz-4/vma
     & mo*ts*mw**4*rmow*rwz+2/vmamo*ts*mw**4*rmow**2*rwz+1d0/vmamo*ts**2
     & *mw**2*rmow*rwz)
     & +sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*(-1d0/8/ctw**2/vm
     & amo*qs*us*mmo**2+1d0/8/ctw**2/vmamo*qs*ts*mmo**2+1d0/4/ctw**2*qs*
     & us*mmo**2-1d0/4/ctw**2*qs*ts*mmo**2-1d0/8/ctw**2*vmamo*qs*us*mmo*
     & *2+1d0/8/ctw**2*vmamo*qs*ts*mmo**2+1d0/4/ctw**2*vmael/vmamo*qs*us
     & *mmo**2-1d0/4/ctw**2*vmael/vmamo*qs*ts*mmo**2-1d0/2/ctw**2*vmael*
     & qs*us*mmo**2+1d0/2/ctw**2*vmael*qs*ts*mmo**2+1d0/4/ctw**2*vmael*v
     & mamo*qs*us*mmo**2-1d0/4/ctw**2*vmael*vmamo*qs*ts*mmo**2-1d0/8/ctw
     & **2*vmael**2/vmamo*qs*us*mmo**2+1d0/8/ctw**2*vmael**2/vmamo*qs*ts
     & *mmo**2+1d0/4/ctw**2*vmael**2*qs*us*mmo**2-1d0/4/ctw**2*vmael**2*
     & qs*ts*mmo**2-1d0/8/ctw**2*vmael**2*vmamo*qs*us*mmo**2+1d0/8/ctw**
     & 2*vmael**2*vmamo*qs*ts*mmo**2+1d0/2*pxx2zqsc/ctw**2/vmamo*mmo**4-
     & 1d0/4*pxx2zqsc/ctw**2/vmamo*qs*mmo**2-1d0/2*pxx2zqsc/ctw**2*mmo**
     & 4+1d0/2*pxx2zqsc/ctw**2*qs*mmo**2-1d0/4*pxx2zqsc/ctw**2*vmamo*qs*
     & mmo**2-pxx2zqsc/ctw**2*vmael/vmamo*mmo**4+1d0/2*pxx2zqsc/ctw**2*v
     & mael/vmamo*qs*mmo**2+pxx2zqsc/ctw**2*vmael*mmo**4-pxx2zqsc/ctw**2
     & *vmael*qs*mmo**2+1d0/2*pxx2zqsc/ctw**2*vmael*vmamo*qs*mmo**2+1d0/
     & 2*pxx2zqsc/ctw**2*vmael**2/vmamo*mmo**4-1d0/4*pxx2zqsc/ctw**2*vma
     & el**2/vmamo*qs*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael**2*mmo**4+1d0/2
     & *pxx2zqsc/ctw**2*vmael**2*ts*mmo**2+1d0/2*pxx2zqsc/ctw**2*vmael**
     & 2*qs*mmo**2+1d0/4*pxx2zqsc/ctw**2*vmael**2*vmamo*mmo**4-1d0/2*pxx
     & 2zqsc/ctw**2*vmael**2*vmamo*ts*mmo**2-3d0/4*pxx2zqsc/ctw**2*vmael
     & **2*vmamo*ts**2-1d0/4*pxx2zqsc/ctw**2*vmael**2*vmamo*qs*mmo**2+1d
     & 0/8*pxx2zqsc**2/ctw**2/vmamo*mmo**2-1d0/4*pxx2zqsc**2/ctw**2*mmo*
     & *2+1d0/8*pxx2zqsc**2/ctw**2*vmamo*mmo**2-1d0/4*pxx2zqsc**2/ctw**2
     & *vmael/vmamo*mmo**2+1d0/2*pxx2zqsc**2/ctw**2*vmael*mmo**2-1d0/4*p
     & xx2zqsc**2/ctw**2*vmael*vmamo*mmo**2+1d0/8*pxx2zqsc**2/ctw**2*vma
     & el**2/vmamo*mmo**2-1d0/4*pxx2zqsc**2/ctw**2*vmael**2*mmo**2+1d0/2
     & *pxx2zqsc**2/ctw**2*vmael**2*vmamo*mmo**2)
     & +sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*(1d0/8/ctw**2*vma
     & el**2/vmamo*qs*us*mmo**2-1d0/8/ctw**2*vmael**2/vmamo*qs*ts*mmo**2
     & -1d0/4/ctw**2*vmael**2*qs*us*mmo**2+1d0/4/ctw**2*vmael**2*qs*ts*m
     & mo**2+1d0/8/ctw**2*vmael**2*vmamo*qs*us*mmo**2-1d0/8/ctw**2*vmael
     & **2*vmamo*qs*ts*mmo**2+1d0/2*pxx2zqsc/ctw**2*us*mmo**2+1d0/4*pxx2
     & zqsc/ctw**2*vmamo*mmo**4-1d0/2*pxx2zqsc/ctw**2*vmamo*us*mmo**2-3d
     & 0/4*pxx2zqsc/ctw**2*vmamo*us**2-pxx2zqsc/ctw**2*vmael*us*mmo**2-1
     & d0/2*pxx2zqsc/ctw**2*vmael*vmamo*mmo**4+pxx2zqsc/ctw**2*vmael*vma
     & mo*us*mmo**2+3d0/2*pxx2zqsc/ctw**2*vmael*vmamo*us**2+1d0/2*pxx2zq
     & sc/ctw**2*vmael**2/vmamo*mmo**4-1d0/4*pxx2zqsc/ctw**2*vmael**2/vm
     & amo*qs*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael**2*mmo**4+1d0/2*pxx2zqs
     & c/ctw**2*vmael**2*us*mmo**2+1d0/2*pxx2zqsc/ctw**2*vmael**2*qs*mmo
     & **2+1d0/4*pxx2zqsc/ctw**2*vmael**2*vmamo*mmo**4-1d0/2*pxx2zqsc/ct
     & w**2*vmael**2*vmamo*us*mmo**2-3d0/4*pxx2zqsc/ctw**2*vmael**2*vmam
     & o*us**2-1d0/4*pxx2zqsc/ctw**2*vmael**2*vmamo*qs*mmo**2+3d0/8*pxx2
     & zqsc**2/ctw**2*vmamo*mmo**2-3d0/4*pxx2zqsc**2/ctw**2*vmael*vmamo*
     & mmo**2+1d0/8*pxx2zqsc**2/ctw**2*vmael**2/vmamo*mmo**2-1d0/4*pxx2z
     & qsc**2/ctw**2*vmael**2*mmo**2+1d0/2*pxx2zqsc**2/ctw**2*vmael**2*v
     & mamo*mmo**2)
     & +sdet4imotsus*c0momoqswcw*dreal(propizqs)*(-2/vmamo/ts*mw**6*rmow
     & **2*rwz+1d0/vmamo/ts*mw**6*rmow**3*rwz+2/vmamo*mw**4*rmow**2*rwz-
     & 1d0/vmamo*ts*mw**2*rmow*rwz)
     & +sdet4imotsus*c0momoqszmoz*dreal(propizqs)*(1d0/2/ctw**2/vmamo*mm
     & o**4-1d0/2/ctw**2/vmamo*ts*mmo**2-1d0/ctw**2*mmo**4+1d0/ctw**2*ts
     & *mmo**2+1d0/2/ctw**2*vmamo*mmo**4+1d0/2/ctw**2*vmamo*us*mmo**2-1d
     & 0/2/ctw**2*vmamo*us**2-1d0/2/ctw**2*vmamo*ts*mmo**2-1d0/ctw**2*vm
     & ael/vmamo*mmo**4+1d0/ctw**2*vmael/vmamo*ts*mmo**2+2/ctw**2*vmael*
     & mmo**4-2/ctw**2*vmael*ts*mmo**2-1d0/ctw**2*vmael*vmamo*mmo**4-1d0
     & /ctw**2*vmael*vmamo*us*mmo**2+1d0/ctw**2*vmael*vmamo*us**2+1d0/ct
     & w**2*vmael*vmamo*ts*mmo**2+1d0/ctw**2*vmael**2/vmamo*mmo**4-1d0/2
     & /ctw**2*vmael**2/vmamo*us*mmo**2-1d0/2/ctw**2*vmael**2/vmamo*ts*m
     & mo**2-2/ctw**2*vmael**2*mmo**4+1d0/ctw**2*vmael**2*us*mmo**2+1d0/
     & ctw**2*vmael**2*ts*mmo**2+1d0/ctw**2*vmael**2*vmamo*mmo**4-1d0/2/
     & ctw**2*vmael**2*vmamo*us**2-1d0/2/ctw**2*vmael**2*vmamo*ts**2+1d0
     & /4*pxx2zqsc/ctw**2/vmamo*mmo**2-1d0/2*pxx2zqsc/ctw**2*mmo**2+1d0/
     & 2*pxx2zqsc/ctw**2*vmamo*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael/vmamo*
     & mmo**2+pxx2zqsc/ctw**2*vmael*mmo**2-pxx2zqsc/ctw**2*vmael*vmamo*m
     & mo**2+1d0/2*pxx2zqsc/ctw**2*vmael**2/vmamo*mmo**2-pxx2zqsc/ctw**2
     & *vmael**2*mmo**2+pxx2zqsc/ctw**2*vmael**2*vmamo*mmo**2)
     & +sdet4imotsus*c0cmotscwc*dreal(propizqs)*(-4/vmamo*ts*mw**2*rwz+4
     & /vmamo*ts*mw**2*rmow*rwz)
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*(1d0/ctw**2/vmamo*ts*mm
     & o**2-1d0/ctw**2*mmo**4-2/ctw**2*ts*mmo**2+1d0/ctw**2*vmamo*mmo**4
     & +1d0/ctw**2*vmamo*ts*mmo**2-2/ctw**2*vmael/vmamo*ts*mmo**2+2/ctw*
     & *2*vmael*mmo**4+4/ctw**2*vmael*ts*mmo**2-2/ctw**2*vmael*vmamo*mmo
     & **4-2/ctw**2*vmael*vmamo*ts*mmo**2+1d0/ctw**2*vmael**2/vmamo*ts*m
     & mo**2-1d0/ctw**2*vmael**2*mmo**4-3/ctw**2*vmael**2*ts*mmo**2+1d0/
     & ctw**2*vmael**2*vmamo*mmo**4+2/ctw**2*vmael**2*vmamo*ts*mmo**2+1d
     & 0/ctw**2*vmael**2*vmamo*ts**2)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*(-1d0/ctw**2*us*mmo**2+
     & 1d0/ctw**2*vmamo*us*mmo**2+1d0/ctw**2*vmamo*us**2+2/ctw**2*vmael*
     & us*mmo**2-2/ctw**2*vmael*vmamo*us*mmo**2-2/ctw**2*vmael*vmamo*us*
     & *2+1d0/ctw**2*vmael**2/vmamo*us*mmo**2-1d0/ctw**2*vmael**2*mmo**4
     & -3/ctw**2*vmael**2*us*mmo**2+1d0/ctw**2*vmael**2*vmamo*mmo**4+2/c
     & tw**2*vmael**2*vmamo*us*mmo**2+1d0/ctw**2*vmael**2*vmamo*us**2)
     & +sdet4imotsus*c0ccqswcw*dreal(propizqs)*(2/vmamo/ts*mw**6*rmow**2
     & *rwz-1d0/vmamo/ts*mw**6*rmow**3*rwz-2/vmamo*mw**4*rmow**2*rwz-1d0
     & /vmamo*ts*mw**2*rmow*rwz)
     & +sdet4imotsus*c0ccqszcz*dreal(propizqs)*(1d0/4*pxx2zqsc/ctw**2/vm
     & amo*mmo**2-1d0/2*pxx2zqsc/ctw**2*mmo**2+1d0/4*pxx2zqsc/ctw**2*vma
     & mo*mmo**2-1d0/4*pxx2zqsc/ctw**2*vmamo*us-1d0/2*pxx2zqsc/ctw**2*vm
     & ael/vmamo*mmo**2+pxx2zqsc/ctw**2*vmael*mmo**2-1d0/2*pxx2zqsc/ctw*
     & *2*vmael*vmamo*mmo**2+1d0/2*pxx2zqsc/ctw**2*vmael*vmamo*us+1d0/2*
     & pxx2zqsc/ctw**2*vmael**2/vmamo*mmo**2-pxx2zqsc/ctw**2*vmael**2*mm
     & o**2+1d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo*mmo**2-1d0/4*pxx2zqsc/c
     & tw**2*vmael**2*vmamo*us-1d0/4*pxx2zqsc/ctw**2*vmael**2*vmamo*ts)
     & +sdet4imotsus*b0fmowc*dreal(propizqs)*(4/vmamo*mw**2*rmow*rwz-4/v
     & mamo*ts*rwz)
     & +sdet4imotsus*b0fqsww*dreal(propizqs)*(-2/vmamo*mw**2*rmow*rwz)
     & +sdet4imotsus*b0fqszz*dreal(propizqs)*(-1d0/2/ctw**2/vmamo*mmo**2
     & +1d0/ctw**2*mmo**2-1d0/2/ctw**2*vmamo*mmo**2-1d0/2/ctw**2*vmamo*u
     & s+1d0/ctw**2*vmael/vmamo*mmo**2-2/ctw**2*vmael*mmo**2+1d0/ctw**2*
     & vmael*vmamo*mmo**2+1d0/ctw**2*vmael*vmamo*us-1d0/ctw**2*vmael**2/
     & vmamo*mmo**2+2/ctw**2*vmael**2*mmo**2-1d0/ctw**2*vmael**2*vmamo*m
     & mo**2-1d0/2/ctw**2*vmael**2*vmamo*us-1d0/2/ctw**2*vmael**2*vmamo*
     & ts)
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*(1d0/2/ctw**2/vmamo*mmo**2
     & -1d0/ctw**2*mmo**2+1d0/2/ctw**2*vmamo*mmo**2-1d0/ctw**2*vmael/vma
     & mo*mmo**2+2/ctw**2*vmael*mmo**2-1d0/ctw**2*vmael*vmamo*mmo**2+1d0
     & /2/ctw**2*vmael**2/vmamo*mmo**2-1d0/ctw**2*vmael**2*mmo**2+1d0/2/
     & ctw**2*vmael**2*vmamo*mmo**2+1d0/2/ctw**2*vmael**2*vmamo*ts)
     & +sdet4imotsus*b0ftscc*dreal(propizqs)*(-2/vmamo*mw**2*rmow*rwz+4/
     & vmamo*ts*rwz)
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*(1d0/2/ctw**2*vmamo*us-1d0
     & /ctw**2*vmael*vmamo*us+1d0/2/ctw**2*vmael**2/vmamo*mmo**2-1d0/ctw
     & **2*vmael**2*mmo**2+1d0/2/ctw**2*vmael**2*vmamo*mmo**2+1d0/2/ctw*
     & *2*vmael**2*vmamo*us)
     & +d0ccmomoqstszczmo*dreal(propizqs)*(-1d0/2/ctw**2/vmamo*mmo**2+1d
     & 0/2/ctw**2*mmo**2+1d0/ctw**2*vmael/vmamo*mmo**2-1d0/ctw**2*vmael*
     & mmo**2-1d0/2/ctw**2*vmael**2/vmamo*mmo**2+1d0/ctw**2*vmael**2*mmo
     & **2-1d0/2/ctw**2*vmael**2*vmamo*mmo**2-1d0/2/ctw**2*vmael**2*vmam
     & o*mz**2-1d0/2/ctw**2*vmael**2*vmamo*ts-1d0/8/ctw**2*vmael**2*vmam
     & o*qs)
     & +d0ccmomoqsuszczmo*dreal(propizqs)*(1d0/2/ctw**2*mmo**2-1d0/2/ctw
     & **2*vmamo*mmo**2-1d0/2/ctw**2*vmamo*us+1d0/8/ctw**2*vmamo*qs-1d0/
     & ctw**2*vmael*mmo**2+1d0/ctw**2*vmael*vmamo*mmo**2+1d0/ctw**2*vmae
     & l*vmamo*us-1d0/4/ctw**2*vmael*vmamo*qs-1d0/2/ctw**2*vmael**2/vmam
     & o*mmo**2+1d0/ctw**2*vmael**2*mmo**2-1d0/2/ctw**2*vmael**2*vmamo*m
     & mo**2-1d0/2/ctw**2*vmael**2*vmamo*us+1d0/8/ctw**2*vmael**2*vmamo*
     & qs-1d0/4*pxx2zqsc/ctw**2*vmamo+1d0/2*pxx2zqsc/ctw**2*vmael*vmamo-
     & 1d0/4*pxx2zqsc/ctw**2*vmael**2*vmamo)
     & +c0momoqswcw*(3d0/2/vmamo*mw**2*rmow*rwz-1d0/vmamo*mw**2*rmow**2*
     & rwz-1d0/2/vmamo*mw**2*rmow**3*rwz)
     & +c0momoqszmoz*dreal(propizqs)*(-1d0/2/ctw**2*vmamo+1d0/ctw**2*vma
     & el*vmamo-1d0/ctw**2*vmael**2*vmamo)
     & +c0momoqszmoh*(3d0/8/vmamo/qs*mw**4*rmow/rwz**2-1d0/4/vmamo/qs*mw
     & **4*rmow/rwz*rhw-1d0/8/vmamo/qs*mw**4*rmow*rhw**2-1d0/2/vmamo*mw*
     & *2*rmow**2-1d0/qs*mw**4*rmow/rwz**2+1d0/qs*mw**4*rmow/rwz*rhw+mw*
     & *2*rmow/rwz)
     & +c0momoqsmozmo*(1d0/2/vmamo*mw**2*rmow/rwz+4*mw**2/rwz**2-8*mw**2
     & /rwz+4*mw**2-7d0/2*mw**2*rmow/rwz+6*mw**2*rmow-4*mw**2*rmow*rwz-2
     & *qs/rwz+4*qs-2*qs*rwz)
     & +c0momoqsmohmo*(mw**2*rmow**2)
     & +c0momoqscwc*(-1d0/vmamo*mw**2*rmow)
     & +c0ccqswcw*(-2/qs**2*mw**6+4/qs*mw**4)
     & +c0ccqszcz*dreal(propizqs)*(-1d0/2/ctw**2*vmamo+1d0/ctw**2*vmael*
     & vmamo-1d0/ctw**2*vmael**2*vmamo)
     & +c0ccqscwc*(1d0/qs*mw**4-2*mw**2+qs)
     & +c0ccqsczc*(-3/qs**2*mw**6/rwz**3+4/qs**2*mw**6/rwz**2-7d0/2/qs*m
     & w**4/rwz**3+12/qs*mw**4/rwz**2-10/qs*mw**4/rwz+7*mw**2/rwz**2-15*
     & mw**2/rwz+8*mw**2-7d0/2*qs/rwz+6*qs-2*qs*rwz)
     & +a0fw*dreal(propzqs)*(3*mw**2/rwz/rhw+1d0/6*mw**2/rwz-8d0/3*mw**2
     & -4*mw**2*rwz)
     & +a0fw*(3d0/2-2/qs**2*mw**4+4d0/3/qs*mw**2+4/qs*mw**2*rwz)
     & +a0fz*dreal(propzqs)*(3d0/2*mw**2/rwz**3/rhw+1d0/6*mw**2/rwz**2-1
     & d0/12*mw**2/rwz*rhw)
     & +a0fz*(9+3/qs**2*mw**4/rwz**2-4/qs**2*mw**4/rwz+41d0/12/qs*mw**2/
     & rwz**2-21d0/2/qs*mw**2/rwz+1d0/12/qs*mw**2/rwz*rhw+8/qs*mw**2-43d
     & 0/8/rwz-3*rwz)
     & +a0fh*dreal(propzqs)*(1d0/2*mw**2/rwz*rhw+1d0/12*mw**2*rhw**2)
     & +a0fh*(1d0/12/qs*mw**2/rwz*rhw-1d0/12/qs*mw**2*rhw**2-1d0/8*rhw)
     & +a0fmo*(-1+1d0/4/rwz+rwz+1d0/4*rmow)
     & +b0fmowc*(-1d0/vmamo*rmow*rwz-1d0/4*rmow)
     & +b0fmozmo*(-7+3d0/8/vmamo/qs*mw**2*rmow/rwz+1d0/8/vmamo/qs*mw**2*
     & rmow*rhw-1d0/qs*mw**2*rmow/rwz+25d0/8/rwz+4*rwz)
     & +b0fmohmo*(-3d0/8/vmamo/qs*mw**2*rmow/rwz-1d0/8/vmamo/qs*mw**2*rm
     & ow*rhw+1d0/qs*mw**2*rmow/rwz-1d0/8*rhw)
     & +b0fqsww*dreal(propzqs)*(1d0/12*mw**2/rwz**2+4d0/3*mw**2/rwz-17d0
     & /3*mw**2-4*mw**2*rwz)
     & +b0fqsww*dreal(propizqs)*(1d0/4/vmamo/mw**2*rmow*rwz)
     & +b0fqsww*(1d0/6+1d0/vmamo*rmow*rwz+1d0/2/vmamo*rmow**2*rwz-1d0/4/
     & vmamo*qs/mw**2*rmow*rwz-2/qs**2*mw**4+7d0/3/qs*mw**2+4/qs*mw**2*r
     & wz-1d0/12/rwz)
     & +b0fqszh*dreal(propzqs)*(mw**2/rwz**2-1d0/3*mw**2/rwz*rhw+1d0/12*
     & mw**2*rhw**2)
     & +b0fqszh*(1d0/4/vmamo*rmow-1d0/12/qs*mw**2/rwz**2+1d0/6/qs*mw**2/
     & rwz*rhw-1d0/12/qs*mw**2*rhw**2-1d0/12/rwz)
     & +b0fqsmomo*(6-1d0/4/vmamo*rmow-3/rwz-3*rwz+1d0/4*rmow)
     & +b0fqscc*(21d0/2+1d0/4/vmamo*rmow+3/qs**2*mw**4/rwz**2-4/qs**2*mw
     & **4/rwz+7d0/2/qs*mw**2/rwz**2-21d0/2/qs*mw**2/rwz+7/qs*mw**2-21d0
     & /4/rwz-3*rwz)
     & +dreal(propzqs)*(mw**2/rwz**3/rhw-1d0/18*mw**2/rwz**2+2*mw**2/rwz
     & /rhw-5d0/9*mw**2/rwz-mw**2/rwz*zmzzzbos-1d0/6*mw**2/rwz*rhw-8d0/3
     & *mw**2-4*mw**2*rwz)
     & +dreal(b0pmozmo)*(-5d0/4*mw**2/rwz**2+3*mw**2/rwz-2*mw**2-7d0/4*m
     & w**2*rmow/rwz+6*mw**2*rmow-4*mw**2*rmow*rwz)
     & +dreal(b0pmohmo)*(-1d0/4*mw**2*rmow*rhw+mw**2*rmow**2)
     & +dreal(b0pmocw)*(-1d0/2*mw**2+1d0/4*mw**2*rmow+1d0/4*mw**2*rmow**
     & 2)
     & +b0d1momoz*(1-1d0/4/rwz-rwz)
     & +b0dwmocw*(-1d0/2)
     & +139d0/36+1d0/2/vmamo*rmow-1d0/2/vmamo*rmow*rwz-3d0/4/qs*mw**2/rw
     & z-7d0/6/qs*mw**2+4/qs*mw**2*rwz-143d0/72/rwz-pizgfer+caldzfer-del
     & tarhofer-za1fer-deltarhobos-za1bos-3d0/2*rwz-1d0/4*rmow

      ff_ew_qq =
     & +1d0/stw**2*(-1d0/qs*mw**2*za1bos-1d0/4/qs*mw**2*rmow-deltarhofer
     & -deltarhobos-za1bos-1d0/4*rmow)
     & +sdet3cmots**2*sdet4imotsus**2*d0ccmomoqstszczmo*dreal(propizqs)*
     & (pxx2zqsc**2/ctw**2*vmael*vmamo*mmo**2+1d0/4*pxx2zqsc**2/ctw**2*v
     & mael*vmamo*qs)
     & +sdet3cmots**2*sdet4imotsus**2*c0ccqszcz*dreal(propizqs)*(1d0/4*p
     & xx2zqsc/ctw**2*vmael*vmamo*mmo**2-1d0/4*pxx2zqsc/ctw**2*vmael*vma
     & mo*ts)
     & +sdet3cmots*sdet4imotsus**2*c0momoqszmoz*dreal(propizqs)*(pxx2zqs
     & c/ctw**2*vmael*vmamo*ts*mmo**2+1d0/4*pxx2zqsc/ctw**2*vmael*vmamo*
     & qs*ts)
     & +sdet3cmots*sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*(-1d0/2*p
     & xx2zqsc/ctw**2*vmael*vmamo*ts*mmo**2+1d0/2*pxx2zqsc/ctw**2*vmael*
     & vmamo*ts**2)
     & +sdet3cmots*sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*(-1d0/
     & 8/ctw**2*vmael*vmamo*qs*mmo**2+1d0/8/ctw**2*vmael*vmamo*qs*ts+1d0
     & /8*pxx2zqsc**2/ctw**2*vmael*vmamo)
     & +sdet3cmots*sdet4imotsus*c0ccqszcz*dreal(propizqs)*(1d0/ctw**2*vm
     & ael*mmo**2-1d0/ctw**2*vmael*vmamo*mmo**2-1d0/2/ctw**2*vmael*vmamo
     & *ts)
     & +sdet3cmous*sdet4imotsus**2*d0ccmomoqsuszczmo*dreal(propizqs)*(1d
     & 0/4*pxx2zqsc**2/ctw**2*vmael/vmamo*mmo**4-1d0/4*pxx2zqsc**2/ctw**
     & 2*vmael/vmamo*us*mmo**2-1d0/2*pxx2zqsc**2/ctw**2*vmael*mmo**4+1d0
     & /2*pxx2zqsc**2/ctw**2*vmael*us*mmo**2+1d0/4*pxx2zqsc**2/ctw**2*vm
     & ael*vmamo*mmo**4-1d0/4*pxx2zqsc**2/ctw**2*vmael*vmamo*us*mmo**2)
     & +sdet3cmous*sdet4imotsus**2*c0momoqszmoz*dreal(propizqs)*(pxx2zqs
     & c/ctw**2*vmael/vmamo*mmo**4+1d0/4*pxx2zqsc/ctw**2*vmael/vmamo*qs*
     & mmo**2-2*pxx2zqsc/ctw**2*vmael*mmo**4-1d0/2*pxx2zqsc/ctw**2*vmael
     & *qs*mmo**2+pxx2zqsc/ctw**2*vmael*vmamo*mmo**4+1d0/4*pxx2zqsc/ctw*
     & *2*vmael*vmamo*qs*mmo**2)
     & +sdet3cmous*sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*(-1d0/2*p
     & xx2zqsc/ctw**2*vmael/vmamo*mmo**4+1d0/2*pxx2zqsc/ctw**2*vmael/vma
     & mo*us*mmo**2+pxx2zqsc/ctw**2*vmael*mmo**4-pxx2zqsc/ctw**2*vmael*u
     & s*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael*vmamo*mmo**4+1d0/2*pxx2zqsc/
     & ctw**2*vmael*vmamo*us*mmo**2)
     & +sdet3cmous*sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*(-pxx2
     & zqsc/ctw**2*vmael/vmamo*mmo**2+2*pxx2zqsc/ctw**2*vmael*mmo**2-pxx
     & 2zqsc/ctw**2*vmael*vmamo*mmo**2)
     & +sdet3cmous*sdet4imotsus*c0ccqszcz*dreal(propizqs)*(-1d0/2/ctw**2
     & *vmael/vmamo*mmo**2+1d0/ctw**2*vmael*mmo**2-1d0/2/ctw**2*vmael*vm
     & amo*mmo**2)
     & +sdet3cmous*d0ccmomoqsuszczmo*dreal(propizqs)*(1d0/2/ctw**2*vmael
     & *vmamo)
     & +sdet3imomoqs*c0momoqswcw*(7d0/4/vmamo*mw**4-3/vmamo*mw**4*rmow+3
     & d0/4/vmamo*mw**4*rmow**2+1d0/2/vmamo*mw**4*rmow**3)
     & +sdet3imomoqs*c0momoqszmoh*(-3d0/8/vmamo*mw**4*rmow/rwz**2-1d0/4/
     & vmamo*mw**4*rmow/rwz*rhw+1d0/8/vmamo*mw**4*rmow*rhw**2+1d0/vmamo*
     & mw**4*rmow**2/rwz-1d0/vmamo*mw**4*rmow**2*rhw+2/vmamo*mw**4*rmow*
     & *3)
     & +sdet3imomoqs*c0momoqsmozmo/stw**2*(-3d0/16*mw**4+3d0/4*mw**4*rmo
     & w)
     & +sdet3imomoqs*c0momoqsmozmo*(-3d0/4/vmamo*mw**4*rmow/rwz**2-2/qs*
     & mw**6/rwz**3+2/qs*mw**6/rwz**2-2*mw**4/rwz**3+45d0/16*mw**4/rwz**
     & 2-3d0/16*mw**4/rwz-13d0/4*mw**4*rmow/rwz**2+11d0/4*mw**4*rmow/rwz
     & )
     & +sdet3imomoqs*c0momoqsmohmo/stw**2*(1d0/16*mw**4*rhw**2-1d0/4*mw*
     & *4*rmow*rhw**2)
     & +sdet3imomoqs*c0momoqsmohmo*(1d0/4/vmamo*mw**4*rmow*rhw**2-1d0/vm
     & amo*mw**4*rmow**2*rhw)
     & +sdet3imomoqs*c0momoqscwc*(3d0/2/vmamo*mw**4*rmow+2/vmamo*mw**4*r
     & mow**2+1d0/2/vmamo*mw**4*rmow**3)
     & +sdet3imomoqs*b0fmowc*(-7d0/4/vmamo*mw**2+11d0/4/vmamo*mw**2*rmow
     & +1d0/vmamo*mw**2*rmow**2)
     & +sdet3imomoqs*b0fmozmo/stw**2*(-3d0/16*mw**2+3d0/4*mw**2*rmow)
     & +sdet3imomoqs*b0fmozmo*(-3d0/8/vmamo*mw**2*rmow/rwz-1d0/8/vmamo*m
     & w**2*rmow*rhw+1d0/2/vmamo*mw**2*rmow**2-2/qs*mw**4/rwz**2+2/qs*mw
     & **4/rwz-2*mw**2/rwz**2+45d0/16*mw**2/rwz-13d0/4*mw**2*rmow/rwz+2*
     & mw**2*rmow)
     & +sdet3imomoqs*b0fmohmo/stw**2*(1d0/16*mw**2*rhw-1d0/4*mw**2*rmow*
     & rhw)
     & +sdet3imomoqs*b0fmohmo*(3d0/8/vmamo*mw**2*rmow/rwz+1d0/8/vmamo*mw
     & **2*rmow*rhw-1d0/2/vmamo*mw**2*rmow**2)
     & +sdet3imomoqs*b0fqsww*(7d0/4/vmamo*mw**2-5d0/4/vmamo*mw**2*rmow-1
     & d0/2/vmamo*mw**2*rmow**2)
     & +sdet3imomoqs*b0fqszh*(-3d0/4/vmamo*mw**2*rmow/rwz+1d0/4/vmamo*mw
     & **2*rmow*rhw-1d0/vmamo*mw**2*rmow**2)
     & +sdet3imomoqs*b0fqsmomo/stw**2*(3d0/16*mw**2-1d0/16*mw**2*rhw-3d0
     & /4*mw**2*rmow+1d0/4*mw**2*rmow*rhw)
     & +sdet3imomoqs*b0fqsmomo*(3d0/4/vmamo*mw**2*rmow/rwz-1d0/4/vmamo*m
     & w**2*rmow*rhw+1d0/vmamo*mw**2*rmow**2+2/qs*mw**4/rwz**2-2/qs*mw**
     & 4/rwz+2*mw**2/rwz**2-45d0/16*mw**2/rwz+13d0/4*mw**2*rmow/rwz-2*mw
     & **2*rmow)
     & +sdet3imomoqs*b0fqscc*(-3d0/2/vmamo*mw**2*rmow-1d0/2/vmamo*mw**2*
     & rmow**2)
     & +sdet3icmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*(1d0/2*pxx2
     & zqsc/ctw**2*vmael*vmamo*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*(1d0/ctw**2*vm
     & ael*vmamo*ts*mmo**2)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*(-1d0/ctw**2*v
     & mael*vmamo*ts*mmo**2)
     & +sdet3icmots*c0cmotsczmo*dreal(propizqs)*(1d0/2/ctw**2*vmael*vmam
     & o*mmo**2)
     & +sdet3icmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*(-1d0/2*pxx
     & 2zqsc/ctw**2*vmael/vmamo*us*mmo**2+pxx2zqsc/ctw**2*vmael*us*mmo**
     & 2-1d0/2*pxx2zqsc/ctw**2*vmael*vmamo*us*mmo**2)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*(1d0/ctw**2*vm
     & ael/vmamo*mmo**4-2/ctw**2*vmael*mmo**4+1d0/ctw**2*vmael*vmamo*mmo
     & **4)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*(-1d0/ctw**2*v
     & mael/vmamo*mmo**4+2/ctw**2*vmael*mmo**4-1d0/ctw**2*vmael*vmamo*mm
     & o**4)
     & +sdet3icmous*c0cmousczmo*dreal(propizqs)*(-1d0/2/ctw**2*vmael/vma
     & mo*mmo**2+1d0/ctw**2*vmael*mmo**2-1d0/2/ctw**2*vmael*vmamo*mmo**2
     & )
     & +sdet4imotsus**2*d0ccmomoqstszczmo*dreal(propizqs)*(1d0/4*pxx2zqs
     & c**2/ctw**2*vmael*vmamo*us*mmo**4-1d0/4*pxx2zqsc**2/ctw**2*vmael*
     & vmamo*ts*mmo**4)
     & +sdet4imotsus**2*c0ccqszcz*dreal(propizqs)*(-1d0/4*pxx2zqsc/ctw**
     & 2*vmael/vmamo*qs*mmo**4+1d0/4*pxx2zqsc/ctw**2*vmael/vmamo*qs*us*m
     & mo**2+1d0/2*pxx2zqsc/ctw**2*vmael*qs*mmo**4-1d0/2*pxx2zqsc/ctw**2
     & *vmael*qs*us*mmo**2-1d0/4*pxx2zqsc/ctw**2*vmael*vmamo*qs*mmo**4+1
     & d0/4*pxx2zqsc/ctw**2*vmael*vmamo*qs*us*mmo**2)
     & +sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*(1d0/2*pxx2zqsc/c
     & tw**2*vmael*ts*mmo**2+1d0/4*pxx2zqsc/ctw**2*vmael*vmamo*mmo**4-1d
     & 0/2*pxx2zqsc/ctw**2*vmael*vmamo*ts*mmo**2-3d0/4*pxx2zqsc/ctw**2*v
     & mael*vmamo*ts**2+3d0/8*pxx2zqsc**2/ctw**2*vmael*vmamo*mmo**2)
     & +sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*(1d0/8/ctw**2*vma
     & el/vmamo*qs*us*mmo**2-1d0/8/ctw**2*vmael/vmamo*qs*ts*mmo**2-1d0/4
     & /ctw**2*vmael*qs*us*mmo**2+1d0/4/ctw**2*vmael*qs*ts*mmo**2+1d0/8/
     & ctw**2*vmael*vmamo*qs*us*mmo**2-1d0/8/ctw**2*vmael*vmamo*qs*ts*mm
     & o**2+1d0/2*pxx2zqsc/ctw**2*vmael/vmamo*mmo**4-1d0/4*pxx2zqsc/ctw*
     & *2*vmael/vmamo*qs*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael*mmo**4+1d0/2
     & *pxx2zqsc/ctw**2*vmael*qs*mmo**2-1d0/4*pxx2zqsc/ctw**2*vmael*vmam
     & o*qs*mmo**2+1d0/8*pxx2zqsc**2/ctw**2*vmael/vmamo*mmo**2-1d0/4*pxx
     & 2zqsc**2/ctw**2*vmael*mmo**2+1d0/8*pxx2zqsc**2/ctw**2*vmael*vmamo
     & *mmo**2)
     & +sdet4imotsus*c0momoqszmoz*dreal(propizqs)*(1d0/2/ctw**2*vmael/vm
     & amo*mmo**4-1d0/2/ctw**2*vmael/vmamo*us*mmo**2-1d0/ctw**2*vmael*mm
     & o**4+1d0/ctw**2*vmael*us*mmo**2+1d0/2/ctw**2*vmael*vmamo*mmo**4-1
     & d0/2/ctw**2*vmael*vmamo*us*mmo**2+1d0/2/ctw**2*vmael*vmamo*ts*mmo
     & **2-1d0/2/ctw**2*vmael*vmamo*ts**2+1d0/4*pxx2zqsc/ctw**2*vmael/vm
     & amo*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael*mmo**2+1d0/2*pxx2zqsc/ctw*
     & *2*vmael*vmamo*mmo**2)
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*(-1d0/ctw**2*vmael*ts*m
     & mo**2+1d0/ctw**2*vmael*vmamo*ts*mmo**2+1d0/ctw**2*vmael*vmamo*ts*
     & *2)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*(1d0/ctw**2*vmael/vmamo
     & *us*mmo**2-1d0/ctw**2*vmael*mmo**4-2/ctw**2*vmael*us*mmo**2+1d0/c
     & tw**2*vmael*vmamo*mmo**4+1d0/ctw**2*vmael*vmamo*us*mmo**2)
     & +sdet4imotsus*c0ccqszcz*dreal(propizqs)*(1d0/4*pxx2zqsc/ctw**2*vm
     & ael/vmamo*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael*mmo**2+1d0/4*pxx2zqs
     & c/ctw**2*vmael*vmamo*mmo**2-1d0/4*pxx2zqsc/ctw**2*vmael*vmamo*ts)
     &
     & +sdet4imotsus*b0fqszz*dreal(propizqs)*(-1d0/2/ctw**2*vmael/vmamo*
     & mmo**2+1d0/ctw**2*vmael*mmo**2-1d0/2/ctw**2*vmael*vmamo*mmo**2-1d
     & 0/2/ctw**2*vmael*vmamo*ts)
     & +sdet4imotsus*b0ftsmoc*dreal(propizqs)*(1d0/2/ctw**2*vmael*vmamo*
     & ts)
     & +sdet4imotsus*b0fusmoc*dreal(propizqs)*(1d0/2/ctw**2*vmael/vmamo*
     & mmo**2-1d0/ctw**2*vmael*mmo**2+1d0/2/ctw**2*vmael*vmamo*mmo**2)
     & +d0ccmomoqstszczmo*dreal(propizqs)*(1d0/2/ctw**2*vmael*mmo**2-1d0
     & /2/ctw**2*vmael*vmamo*mmo**2-1d0/2/ctw**2*vmael*vmamo*mz**2-1d0/2
     & /ctw**2*vmael*vmamo*ts-1d0/8/ctw**2*vmael*vmamo*qs)
     & +d0ccmomoqsuszczmo*dreal(propizqs)*(-1d0/2/ctw**2*vmael/vmamo*mmo
     & **2+1d0/2/ctw**2*vmael*mmo**2)
     & +c0momoqswcw*(-7d0/4/vmamo/qs*mw**4+3d0/2/vmamo/qs*mw**4*rmow+1d0
     & /4/vmamo/qs*mw**4*rmow**2)
     & +c0momoqszmoz*dreal(propizqs)*(-1d0/2/ctw**2*vmael*vmamo)
     & +c0momoqszmoh*(3d0/8/vmamo/qs*mw**4*rmow/rwz**2-1d0/4/vmamo/qs*mw
     & **4*rmow/rwz*rhw-1d0/8/vmamo/qs*mw**4*rmow*rhw**2-1d0/2/vmamo*mw*
     & *2*rmow**2-1d0/qs*mw**4*rmow/rwz**2+1d0/qs*mw**4*rmow/rwz*rhw+mw*
     & *2*rmow/rwz)
     & +c0momoqsmozmo/stw**2*(3d0/16/qs*mw**4-1d0/2/qs*mw**4*rmow-1d0/2*
     & mw**2*rmow)
     & +c0momoqsmozmo*(1d0/2/vmamo*mw**2*rmow/rwz+51d0/16/qs*mw**4/rwz**
     & 2-61d0/16/qs*mw**4/rwz-5d0/2/qs*mw**4*rmow/rwz+4/qs*mw**4*rmow+4*
     & mw**2/rwz**2-6*mw**2/rwz+2*mw**2-7d0/2*mw**2*rmow/rwz+4*mw**2*rmo
     & w-2*qs/rwz+2*qs)
     & +c0momoqsmohmo/stw**2*(-1d0/16/qs*mw**4*rhw**2+1d0/qs*mw**4*rmow*
     & *2+mw**2*rmow**2)
     & +c0momoqscwc*(-1d0/vmamo*mw**2*rmow)
     & +c0ccqszcz*dreal(propizqs)*(-1d0/2/ctw**2*vmael*vmamo)
     & +c0ccqsczc*(-2/qs**2*mw**6/rwz**3+2/qs**2*mw**6/rwz**2-2/qs*mw**4
     & /rwz**3+6/qs*mw**4/rwz**2-4/qs*mw**4/rwz+4*mw**2/rwz**2-6*mw**2/r
     & wz+2*mw**2-2*qs/rwz+2*qs)
     & +a0fw*dreal(propzqs)*(3*mw**2/rwz/rhw+1d0/6*mw**2/rwz-8d0/3*mw**2
     & -4*mw**2*rwz)
     & +a0fw*(-4/qs**2*mw**4+8d0/3/qs*mw**2+4/qs*mw**2*rwz)
     & +a0fz/stw**2*(-1d0/8-1d0/8/qs*mw**2)
     & +a0fz*dreal(propzqs)*(3d0/2*mw**2/rwz**3/rhw+1d0/6*mw**2/rwz**2-1
     & d0/12*mw**2/rwz*rhw)
     & +a0fz*(3+2/qs**2*mw**4/rwz**2-2/qs**2*mw**4/rwz+23d0/12/qs*mw**2/
     & rwz**2-41d0/8/qs*mw**2/rwz+1d0/12/qs*mw**2/rwz*rhw+3/qs*mw**2-25d
     & 0/8/rwz)
     & +a0fh/stw**2*(-1d0/8/qs*mw**2*rhw-1d0/8*rhw)
     & +a0fh*dreal(propzqs)*(1d0/2*mw**2/rwz*rhw+1d0/12*mw**2*rhw**2)
     & +a0fh*(1d0/12/qs*mw**2/rwz*rhw-1d0/12/qs*mw**2*rhw**2)
     & +a0fmo/stw**2*(1d0/4+1d0/4/qs*mw**2+1d0/4/qs*mw**2*rmow+1d0/4*rmo
     & w)
     & +a0fmo*(-1+1d0/4/qs*mw**2/rwz-1d0/qs*mw**2+1d0/4/rwz)
     & +b0fmowc/stw**2*(-1d0/4/qs*mw**2*rmow-1d0/4*rmow)
     & +b0fmowc*(7d0/4/vmamo/qs*mw**2+1d0/4/vmamo/qs*mw**2*rmow)
     & +b0fmozmo/stw**2*(1d0/8+5d0/16/qs*mw**2)
     & +b0fmozmo*(-4+3d0/8/vmamo/qs*mw**2*rmow/rwz+1d0/8/vmamo/qs*mw**2*
     & rmow*rhw+37d0/16/qs*mw**2/rwz-4/qs*mw**2-1d0/qs*mw**2*rmow/rwz+25
     & d0/8/rwz)
     & +b0fmohmo/stw**2*(-3d0/16/qs*mw**2*rhw-1d0/8*rhw)
     & +b0fmohmo*(-3d0/8/vmamo/qs*mw**2*rmow/rwz-1d0/8/vmamo/qs*mw**2*rm
     & ow*rhw+1d0/qs*mw**2*rmow/rwz)
     & +b0fqsww*dreal(propzqs)*(1d0/12*mw**2/rwz**2+4d0/3*mw**2/rwz-17d0
     & /3*mw**2-4*mw**2*rwz)
     & +b0fqsww*(-7d0/4/vmamo/qs*mw**2+1d0/4/vmamo/qs*mw**2*rmow+1d0/4/v
     & mamo*rmow-4/qs**2*mw**4+17d0/3/qs*mw**2+4/qs*mw**2*rwz-1d0/12/rwz
     & )
     & +b0fqszh*dreal(propzqs)*(mw**2/rwz**2-1d0/3*mw**2/rwz*rhw+1d0/12*
     & mw**2*rhw**2)
     & +b0fqszh*(1d0/4/vmamo*rmow-1d0/12/qs*mw**2/rwz**2+1d0/6/qs*mw**2/
     & rwz*rhw-1d0/12/qs*mw**2*rhw**2-1d0/12/rwz)
     & +b0fqsmomo/stw**2*(-3d0/16/qs*mw**2+1d0/16/qs*mw**2*rhw+1d0/4/qs*
     & mw**2*rmow+1d0/4*rmow)
     & +b0fqsmomo*(3-1d0/4/vmamo*rmow-35d0/16/qs*mw**2/rwz+3/qs*mw**2-3/
     & rwz)
     & +b0fqscc*(3+1d0/4/vmamo*rmow+2/qs**2*mw**4/rwz**2-2/qs**2*mw**4/r
     & wz+2/qs*mw**2/rwz**2-5/qs*mw**2/rwz+3/qs*mw**2-3/rwz)
     & +dreal(propzqs)*(mw**2/rwz**3/rhw-1d0/18*mw**2/rwz**2+2*mw**2/rwz
     & /rhw-5d0/9*mw**2/rwz-mw**2/rwz*zmzzzbos-1d0/6*mw**2/rwz*rhw-8d0/3
     & *mw**2-4*mw**2*rwz)
     & +dreal(b0pmozmo)/stw**2*(-1d0/4/qs*mw**4+1d0/4/qs*mw**4*rmow-1d0/
     & 4*mw**2+1d0/4*mw**2*rmow)
     & +dreal(b0pmozmo)*(-5d0/4/qs*mw**4/rwz**2+7d0/4/qs*mw**4/rwz-7d0/4
     & /qs*mw**4*rmow/rwz+4/qs*mw**4*rmow-5d0/4*mw**2/rwz**2+7d0/4*mw**2
     & /rwz-7d0/4*mw**2*rmow/rwz+4*mw**2*rmow)
     & +dreal(b0pmohmo)/stw**2*(-1d0/4/qs*mw**4*rmow*rhw+1d0/qs*mw**4*rm
     & ow**2-1d0/4*mw**2*rmow*rhw+mw**2*rmow**2)
     & +dreal(b0pmocw)/stw**2*(-1d0/2/qs*mw**4+1d0/4/qs*mw**4*rmow+1d0/4
     & /qs*mw**4*rmow**2-1d0/2*mw**2+1d0/4*mw**2*rmow+1d0/4*mw**2*rmow**
     & 2)
     & +b0d1momoz/stw**2*(-1d0/4-1d0/4/qs*mw**2)
     & +b0d1momoz*(1-1d0/4/qs*mw**2/rwz+1d0/qs*mw**2-1d0/4/rwz)
     & +b0dwmocw/stw**2*(-1d0/2-1d0/2/qs*mw**2)
     & +3d0/2+1d0/2/vmamo/qs*mw**2*rmow+1d0/2/vmamo*rmow-4/qs**2*mw**4-3
     & d0/2/qs*mw**2/rwz+25d0/6/qs*mw**2+4/qs*mw**2*rwz-29d0/18/rwz-2*pi
     & zgfer+caldzfer-za1fer

      ff_ew_ld =
     & +sdet3cmots*sdet4imotsus**2*d0ccmomoqstszczmo*dreal(propizqs)*(1d
     & 0/2*pxx2zqsc**2/ctw**2*ts-pxx2zqsc**2/ctw**2*vmamo*ts+1d0/2*pxx2z
     & qsc**2/ctw**2*vmamo**2*ts-pxx2zqsc**2/ctw**2*vmael*ts+2*pxx2zqsc*
     & *2/ctw**2*vmael*vmamo*ts-pxx2zqsc**2/ctw**2*vmael*vmamo**2*ts+1d0
     & /2*pxx2zqsc**2/ctw**2*vmael**2*ts-pxx2zqsc**2/ctw**2*vmael**2*vma
     & mo*ts)
     & +sdet3cmots*sdet4imotsus**2*c0momoqszmoz*dreal(propizqs)*(-1d0/2*
     & pxx2zqsc/ctw**2*mmo**2+1d0/2*pxx2zqsc/ctw**2*ts+pxx2zqsc/ctw**2*v
     & mamo*mmo**2-pxx2zqsc/ctw**2*vmamo*ts-1d0/2*pxx2zqsc/ctw**2*vmamo*
     & *2*mmo**2+1d0/2*pxx2zqsc/ctw**2*vmamo**2*ts+pxx2zqsc/ctw**2*vmael
     & *mmo**2-pxx2zqsc/ctw**2*vmael*ts-2*pxx2zqsc/ctw**2*vmael*vmamo*mm
     & o**2+2*pxx2zqsc/ctw**2*vmael*vmamo*ts+pxx2zqsc/ctw**2*vmael*vmamo
     & **2*mmo**2-pxx2zqsc/ctw**2*vmael*vmamo**2*ts-1d0/2*pxx2zqsc/ctw**
     & 2*vmael**2*mmo**2+1d0/2*pxx2zqsc/ctw**2*vmael**2*ts+pxx2zqsc/ctw*
     & *2*vmael**2*vmamo*mmo**2-pxx2zqsc/ctw**2*vmael**2*vmamo*ts)
     & +sdet3cmots*sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*(-pxx2zqs
     & c/ctw**2*ts+2*pxx2zqsc/ctw**2*vmamo*ts-pxx2zqsc/ctw**2*vmamo**2*t
     & s+2*pxx2zqsc/ctw**2*vmael*ts-4*pxx2zqsc/ctw**2*vmael*vmamo*ts+2*p
     & xx2zqsc/ctw**2*vmael*vmamo**2*ts-pxx2zqsc/ctw**2*vmael**2*ts+2*px
     & x2zqsc/ctw**2*vmael**2*vmamo*ts)
     & +sdet3cmots*sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*(-1d0/
     & 4/ctw**2*qs+1d0/2/ctw**2*vmamo*qs-1d0/4/ctw**2*vmamo**2*qs+1d0/2/
     & ctw**2*vmael*qs-1d0/ctw**2*vmael*vmamo*qs+1d0/2/ctw**2*vmael*vmam
     & o**2*qs-1d0/4/ctw**2*vmael**2*qs+1d0/2/ctw**2*vmael**2*vmamo*qs+5
     & d0/4*pxx2zqsc/ctw**2-5d0/2*pxx2zqsc/ctw**2*vmamo+5d0/4*pxx2zqsc/c
     & tw**2*vmamo**2-5d0/2*pxx2zqsc/ctw**2*vmael+5*pxx2zqsc/ctw**2*vmae
     & l*vmamo-5d0/2*pxx2zqsc/ctw**2*vmael*vmamo**2+5d0/4*pxx2zqsc/ctw**
     & 2*vmael**2-5d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo)
     & +sdet3cmots*sdet4imotsus*c0ccqszcz*dreal(propizqs)*(1d0/2/ctw**2-
     & 1d0/ctw**2*vmamo+1d0/2/ctw**2*vmamo**2-1d0/ctw**2*vmael+2/ctw**2*
     & vmael*vmamo-1d0/ctw**2*vmael*vmamo**2+1d0/2/ctw**2*vmael**2-1d0/c
     & tw**2*vmael**2*vmamo)
     & +sdet3cmous*sdet4imotsus**2*d0ccmomoqsuszczmo*dreal(propizqs)*(-1
     & d0/2*pxx2zqsc**2/ctw**2*vmamo**2*us+pxx2zqsc**2/ctw**2*vmael*vmam
     & o**2*us+1d0/2*pxx2zqsc**2/ctw**2*vmael**2*us-pxx2zqsc**2/ctw**2*v
     & mael**2*vmamo*us)
     & +sdet3cmous*sdet4imotsus**2*c0momoqszmoz*dreal(propizqs)*(1d0/2*p
     & xx2zqsc/ctw**2*vmamo**2*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmamo**2*us-
     & pxx2zqsc/ctw**2*vmael*vmamo**2*mmo**2+pxx2zqsc/ctw**2*vmael*vmamo
     & **2*us-1d0/2*pxx2zqsc/ctw**2*vmael**2*mmo**2+1d0/2*pxx2zqsc/ctw**
     & 2*vmael**2*us+pxx2zqsc/ctw**2*vmael**2*vmamo*mmo**2-pxx2zqsc/ctw*
     & *2*vmael**2*vmamo*us)
     & +sdet3cmous*sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*(pxx2zqsc
     & /ctw**2*vmamo**2*us-2*pxx2zqsc/ctw**2*vmael*vmamo**2*us-pxx2zqsc/
     & ctw**2*vmael**2*us+2*pxx2zqsc/ctw**2*vmael**2*vmamo*us)
     & +sdet3cmous*sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*(1d0/4
     & /ctw**2*vmamo**2*qs-1d0/2/ctw**2*vmael*vmamo**2*qs-1d0/4/ctw**2*v
     & mael**2*qs+1d0/2/ctw**2*vmael**2*vmamo*qs-5d0/4*pxx2zqsc/ctw**2*v
     & mamo**2+5d0/2*pxx2zqsc/ctw**2*vmael*vmamo**2+5d0/4*pxx2zqsc/ctw**
     & 2*vmael**2-5d0/2*pxx2zqsc/ctw**2*vmael**2*vmamo)
     & +sdet3cmous*sdet4imotsus*c0ccqszcz*dreal(propizqs)*(-1d0/2/ctw**2
     & *vmamo**2+1d0/ctw**2*vmael*vmamo**2+1d0/2/ctw**2*vmael**2-1d0/ctw
     & **2*vmael**2*vmamo)
     & +sdet3imomoqs**2*c0momoqswcw*dreal(propizqs)*(-3*mw**2*rmow*rwz+6
     & *mw**2*rmow**2*rwz-3*mw**2*rmow**3*rwz)
     & +sdet3imomoqs**2*c0momoqswcw*(12*mw**4*rwz-18*mw**4*rmow*rwz-12*m
     & w**4*rmow**2*rwz+30*mw**4*rmow**3*rwz-12*mw**4*rmow**4*rwz)
     & +sdet3imomoqs**2*c0momoqsmozmo*(27*mw**4/rwz**3-90*mw**4/rwz**2+1
     & 08*mw**4/rwz-48*mw**4+9d0/2*mw**4*rmow/rwz**2-6*mw**4*rmow/rwz)
     & +sdet3imomoqs**2*c0momoqsmohmo*(9d0/2*mw**4*rmow*rhw**2-6*mw**4*r
     & mow*rwz*rhw**2)
     & +sdet3imomoqs**2*c0momoqscwc*(6*mw**4+15*mw**4*rmow+12*mw**4*rmow
     & **2+3*mw**4*rmow**3)
     & +sdet3imomoqs**2*b0fmowc*(6*mw**2-12*mw**2*rwz+12*mw**2*rmow+6*mw
     & **2*rmow*rwz+6*mw**2*rmow**2*rwz)
     & +sdet3imomoqs**2*b0fmozmo*(27*mw**2/rwz**2-90*mw**2/rwz+108*mw**2
     & -48*mw**2*rwz+9d0/2*mw**2*rmow/rwz-6*mw**2*rmow)
     & +sdet3imomoqs**2*b0fmohmo*(9d0/2*mw**2*rmow*rhw-6*mw**2*rmow*rwz*
     & rhw)
     & +sdet3imomoqs**2*b0fqsww*dreal(propizqs)*(-3*rmow*rwz+3*rmow**2*r
     & wz)
     & +sdet3imomoqs**2*b0fqsww*(12*mw**2*rwz-6*mw**2*rmow*rwz-18*mw**2*
     & rmow**2*rwz+12*mw**2*rmow**3*rwz)
     & +sdet3imomoqs**2*b0fqsmomo*(-27*mw**2/rwz**2+90*mw**2/rwz-108*mw*
     & *2+48*mw**2*rwz-9d0/2*mw**2*rmow/rwz+6*mw**2*rmow-9d0/2*mw**2*rmo
     & w*rhw+6*mw**2*rmow*rwz*rhw)
     & +sdet3imomoqs**2*b0fqscc*(-6*mw**2-9*mw**2*rmow-3*mw**2*rmow**2)
     & +sdet3imomoqs*sdet4imotsus*c0momoqswcw*dreal(propizqs)*(4/ts**4*m
     & w**12*rmow**5*rwz-4/ts**4*mw**12*rmow**6*rwz-4/ts**3*mw**10*rmow*
     & *4*rwz+4/ts**3*mw**10*rmow**5*rwz)
     & +sdet3imomoqs*sdet4imotsus*b0fmowc*dreal(propizqs)*(-4/ts**4*mw**
     & 10*rmow**5*rwz+4/ts**3*mw**8*rmow**4*rwz)
     & +sdet3imomoqs*sdet4imotsus*b0fqsww*dreal(propizqs)*(4/ts**4*mw**1
     & 0*rmow**5*rwz-4/ts**3*mw**8*rmow**4*rwz)
     & +sdet3imomoqs*c0momoqswcw*dreal(propizqs)*(4/ts**4*mw**8*rmow**3*
     & rwz-4/ts**4*mw**8*rmow**4*rwz+4/ts**3*mw**6*rmow**2*rwz-4/ts**3*m
     & w**6*rmow**3*rwz+4/ts**2*mw**4*rmow*rwz-4/ts**2*mw**4*rmow**2*rwz
     & +4/ts*mw**2*rwz-4/ts*mw**2*rmow*rwz+2*rwz-3*rmow*rwz+rmow**2*rwz)
     &
     & +sdet3imomoqs*c0momoqswcw*(-4*mw**2*rwz+17*mw**2*rmow*rwz-20*mw**
     & 2*rmow**2*rwz+7*mw**2*rmow**3*rwz)
     & +sdet3imomoqs*c0momoqszmoh*(-3d0/2*mw**2/rwz**2+2*mw**2/rwz-3d0/2
     & *mw**2/rwz*rhw+2*mw**2*rhw+6*mw**2*rmow/rwz-8*mw**2*rmow)
     & +sdet3imomoqs*c0momoqsmozmo*(-24*mw**2/rwz**2+68*mw**2/rwz-72*mw*
     & *2+32*mw**2*rwz-3d0/2*mw**2*rmow/rwz+2*mw**2*rmow)
     & +sdet3imomoqs*c0momoqsmohmo*(-9d0/2*mw**2*rmow*rhw+6*mw**2*rmow*r
     & wz*rhw)
     & +sdet3imomoqs*c0momoqscwc*(-8*mw**2-8*mw**2*rmow-mw**2*rmow**2)
     & +sdet3imomoqs*a0fw*(1-4/qs*mw**2+8/qs*mw**2*rwz-rwz)
     & +sdet3imomoqs*a0fz*(-1-18/qs*mw**2/rwz**2+60/qs*mw**2/rwz-72/qs*m
     & w**2+32/qs*mw**2*rwz+3d0/4/rwz)
     & +sdet3imomoqs*a0fh*(3d0/4*rhw-rwz*rhw)
     & +sdet3imomoqs*a0fmo*(15-9d0/2/rwz-18*rwz+8*rwz**2-3d0/2*rmow+2*rm
     & ow*rwz)
     & +sdet3imomoqs*b0fmowc*dreal(propizqs)*(-4/ts**4*mw**6*rmow**3*rwz
     & -4/ts**3*mw**4*rmow**2*rwz-4/ts**2*mw**2*rmow*rwz-4/ts*rwz-1d0/mw
     & **2*rwz)
     & +sdet3imomoqs*b0fmowc*(-5-4/qs*mw**2+8/qs*mw**2*rwz+5*rwz-5*rmow*
     & rwz)
     & +sdet3imomoqs*b0fmozmo*(35-18/qs*mw**2/rwz**2+60/qs*mw**2/rwz-72/
     & qs*mw**2+32/qs*mw**2*rwz-51d0/4/rwz-36*rwz+16*rwz**2)
     & +sdet3imomoqs*b0fmohmo*(-2+3d0/2/rwz+3d0/4*rhw-rwz*rhw-3*rmow+4*r
     & mow*rwz)
     & +sdet3imomoqs*b0fqsww*dreal(propizqs)*(4/ts**4*mw**6*rmow**3*rwz+
     & 4/ts**3*mw**4*rmow**2*rwz+4/ts**2*mw**2*rmow*rwz+4/ts*rwz+2/mw**2
     & *rwz-1d0/2/mw**2*rmow*rwz)
     & +sdet3imomoqs*b0fqsww*(-6*rwz+12*rmow*rwz-5*rmow**2*rwz)
     & +sdet3imomoqs*b0fqszh*(4-3/rwz)
     & +sdet3imomoqs*b0fqsmomo*(-23+21d0/2/rwz+18*rwz-8*rwz**2+3d0/2*rmo
     & w-2*rmow*rwz)
     & +sdet3imomoqs*b0fqscc*(5+1d0/2*rmow)
     & +sdet3imomoqs*(-14+9d0/2/rwz+20*rwz-8*rwz**2+3d0/2*rmow-rmow*rwz)
     & +sdet3icmots*sdet4imotsus*c0cmotscwc*dreal(propizqs)*(4*ts*mw**2*
     & rwz)
     & +sdet3icmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*(1d0/2*pxx2
     & zqsc/ctw**2*ts-pxx2zqsc/ctw**2*vmamo*ts+1d0/2*pxx2zqsc/ctw**2*vma
     & mo**2*ts-pxx2zqsc/ctw**2*vmael*ts+2*pxx2zqsc/ctw**2*vmael*vmamo*t
     & s-pxx2zqsc/ctw**2*vmael*vmamo**2*ts+1d0/2*pxx2zqsc/ctw**2*vmael**
     & 2*ts-pxx2zqsc/ctw**2*vmael**2*vmamo*ts)
     & +sdet3icmots*sdet4imotsus*b0fmowc*dreal(propizqs)*(4*ts*rwz)
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*(1d0/ctw**2*ts
     & -2/ctw**2*vmamo*ts+1d0/ctw**2*vmamo**2*ts-2/ctw**2*vmael*ts+4/ctw
     & **2*vmael*vmamo*ts-2/ctw**2*vmael*vmamo**2*ts+1d0/ctw**2*vmael**2
     & *ts-2/ctw**2*vmael**2*vmamo*ts)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*(-1d0/ctw**2*t
     & s+2/ctw**2*vmamo*ts-1d0/ctw**2*vmamo**2*ts+2/ctw**2*vmael*ts-4/ct
     & w**2*vmael*vmamo*ts+2/ctw**2*vmael*vmamo**2*ts-1d0/ctw**2*vmael**
     & 2*ts+2/ctw**2*vmael**2*vmamo*ts)
     & +sdet3icmots*sdet4imotsus*b0ftscc*dreal(propizqs)*(-4*ts*rwz)
     & +sdet3icmots*c0cmotsczmo*dreal(propizqs)*(1d0/2/ctw**2-1d0/ctw**2
     & *vmamo+1d0/2/ctw**2*vmamo**2-1d0/ctw**2*vmael+2/ctw**2*vmael*vmam
     & o-1d0/ctw**2*vmael*vmamo**2+1d0/2/ctw**2*vmael**2-1d0/ctw**2*vmae
     & l**2*vmamo)
     & +sdet3icmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*(-1d0/2*pxx
     & 2zqsc/ctw**2*vmamo**2*us+pxx2zqsc/ctw**2*vmael*vmamo**2*us+1d0/2*
     & pxx2zqsc/ctw**2*vmael**2*us-pxx2zqsc/ctw**2*vmael**2*vmamo*us)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*(-1d0/ctw**2*v
     & mamo**2*us+2/ctw**2*vmael*vmamo**2*us+1d0/ctw**2*vmael**2*us-2/ct
     & w**2*vmael**2*vmamo*us)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*(1d0/ctw**2*vm
     & amo**2*us-2/ctw**2*vmael*vmamo**2*us-1d0/ctw**2*vmael**2*us+2/ctw
     & **2*vmael**2*vmamo*us)
     & +sdet3icmous*c0cmousczmo*dreal(propizqs)*(-1d0/2/ctw**2*vmamo**2+
     & 1d0/ctw**2*vmael*vmamo**2+1d0/2/ctw**2*vmael**2-1d0/ctw**2*vmael*
     & *2*vmamo)
     & +sdet4imotsus**2*d0ccmomoqstswcwc*dreal(propizqs)*(8*ts*mw**6*rmo
     & w*rwz-8*ts*mw**6*rmow**2*rwz+2*ts*mw**6*rmow**3*rwz+8*ts**2*mw**4
     & *rwz-16*ts**2*mw**4*rmow*rwz+6*ts**2*mw**4*rmow**2*rwz-8*ts**3*mw
     & **2*rwz+6*ts**3*mw**2*rmow*rwz+2*ts**4*rwz)
     & +sdet4imotsus**2*c0momoqswcw*dreal(propizqs)*(-4*mw**6*rmow**2*rw
     & z+2*mw**6*rmow**3*rwz+2*ts*mw**4*rmow**2*rwz+4*ts**2*mw**2*rwz-2*
     & ts**2*mw**2*rmow*rwz-2*ts**3*rwz)
     & +sdet4imotsus**2*c0cmotscwc*dreal(propizqs)*(-8*ts*mw**4*rmow*rwz
     & +4*ts*mw**4*rmow**2*rwz-8*ts**2*mw**2*rwz+8*ts**2*mw**2*rmow*rwz+
     & 4*ts**3*rwz)
     & +sdet4imotsus**2*c0ccqswcw*dreal(propizqs)*(4*mw**6*rmow**2*rwz-2
     & *mw**6*rmow**3*rwz+8*ts*mw**4*rmow*rwz-6*ts*mw**4*rmow**2*rwz+4*t
     & s**2*mw**2*rwz-6*ts**2*mw**2*rmow*rwz-2*ts**3*rwz)
     & +sdet4imotsus**2*c0ccqszcz*dreal(propizqs)*(-1d0/2*pxx2zqsc/ctw**
     & 2*qs*ts+pxx2zqsc/ctw**2*vmamo*qs*ts+1d0/2*pxx2zqsc/ctw**2*vmamo**
     & 2*qs*us-1d0/2*pxx2zqsc/ctw**2*vmamo**2*qs*ts+pxx2zqsc/ctw**2*vmae
     & l*qs*ts-2*pxx2zqsc/ctw**2*vmael*vmamo*qs*ts-pxx2zqsc/ctw**2*vmael
     & *vmamo**2*qs*us+pxx2zqsc/ctw**2*vmael*vmamo**2*qs*ts-1d0/2*pxx2zq
     & sc/ctw**2*vmael**2*qs*us-1d0/2*pxx2zqsc/ctw**2*vmael**2*qs*ts+pxx
     & 2zqsc/ctw**2*vmael**2*vmamo*qs*us+pxx2zqsc/ctw**2*vmael**2*vmamo*
     & qs*ts)
     & +sdet4imotsus*d0ccmomoqstswcwc*dreal(propizqs)*(2*ts*mw**2*rwz)
     & +sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*(-1d0/2*pxx2zqsc/
     & ctw**2*mmo**2+pxx2zqsc/ctw**2*vmamo*mmo**2+1d0/2*pxx2zqsc/ctw**2*
     & vmamo*ts-1d0/2*pxx2zqsc/ctw**2*vmamo**2*mmo**2-1d0/2*pxx2zqsc/ctw
     & **2*vmamo**2*ts+pxx2zqsc/ctw**2*vmael*mmo**2-2*pxx2zqsc/ctw**2*vm
     & ael*vmamo*mmo**2-pxx2zqsc/ctw**2*vmael*vmamo*ts+pxx2zqsc/ctw**2*v
     & mael*vmamo**2*mmo**2+pxx2zqsc/ctw**2*vmael*vmamo**2*ts-1d0/2*pxx2
     & zqsc/ctw**2*vmael**2*mmo**2+pxx2zqsc/ctw**2*vmael**2*vmamo*mmo**2
     & )
     & +sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*(-1d0/2*pxx2zqsc/
     & ctw**2*vmamo*us+1d0/2*pxx2zqsc/ctw**2*vmamo**2*mmo**2+1d0/2*pxx2z
     & qsc/ctw**2*vmamo**2*us+pxx2zqsc/ctw**2*vmael*vmamo*us-pxx2zqsc/ct
     & w**2*vmael*vmamo**2*mmo**2-pxx2zqsc/ctw**2*vmael*vmamo**2*us-1d0/
     & 2*pxx2zqsc/ctw**2*vmael**2*mmo**2+pxx2zqsc/ctw**2*vmael**2*vmamo*
     & mmo**2)
     & +sdet4imotsus*c0momoqswcw*dreal(propizqs)*(4/ts**3*mw**8*rmow**3*
     & rwz-4/ts**3*mw**8*rmow**4*rwz+4/ts**2*mw**6*rmow**2*rwz-4/ts**2*m
     & w**6*rmow**3*rwz+4/ts*mw**4*rmow*rwz-4/ts*mw**4*rmow**2*rwz+2*mw*
     & *2*rwz-4*mw**2*rmow*rwz)
     & +sdet4imotsus*c0momoqszmoz*dreal(propizqs)*(1d0/ctw**2*ts+1d0/4/c
     & tw**2*qs-1d0/2/ctw**2*vmamo*us-3d0/2/ctw**2*vmamo*ts-1d0/2/ctw**2
     & *vmamo*qs-1d0/2/ctw**2*vmamo**2*us+1d0/2/ctw**2*vmamo**2*ts-2/ctw
     & **2*vmael*ts-1d0/2/ctw**2*vmael*qs+1d0/ctw**2*vmael*vmamo*us+3/ct
     & w**2*vmael*vmamo*ts+1d0/ctw**2*vmael*vmamo*qs+1d0/ctw**2*vmael*vm
     & amo**2*us-1d0/ctw**2*vmael*vmamo**2*ts+1d0/ctw**2*vmael**2*us+1d0
     & /ctw**2*vmael**2*ts+1d0/2/ctw**2*vmael**2*qs-2/ctw**2*vmael**2*vm
     & amo*us-2/ctw**2*vmael**2*vmamo*ts-1d0/ctw**2*vmael**2*vmamo*qs-1d
     & 0/8*det3imomoqs*pxx2zqsc/ctw**2*qs*mmo**2+1d0/8*det3imomoqs*pxx2z
     & qsc/ctw**2*qs*ts+1d0/4*det3imomoqs*pxx2zqsc/ctw**2*vmamo*qs*mmo**
     & 2-1d0/4*det3imomoqs*pxx2zqsc/ctw**2*vmamo*qs*ts-1d0/8*det3imomoqs
     & *pxx2zqsc/ctw**2*vmamo**2*qs*us+1d0/8*det3imomoqs*pxx2zqsc/ctw**2
     & *vmamo**2*qs*ts+1d0/4*det3imomoqs*pxx2zqsc/ctw**2*vmael*qs*mmo**2
     & -1d0/4*det3imomoqs*pxx2zqsc/ctw**2*vmael*qs*ts-1d0/2*det3imomoqs*
     & pxx2zqsc/ctw**2*vmael*vmamo*qs*mmo**2+1d0/2*det3imomoqs*pxx2zqsc/
     & ctw**2*vmael*vmamo*qs*ts+1d0/4*det3imomoqs*pxx2zqsc/ctw**2*vmael*
     & vmamo**2*qs*us-1d0/4*det3imomoqs*pxx2zqsc/ctw**2*vmael*vmamo**2*q
     & s*ts-1d0/4*det3imomoqs*pxx2zqsc/ctw**2*vmael**2*qs*mmo**2+1d0/8*d
     & et3imomoqs*pxx2zqsc/ctw**2*vmael**2*qs*us+1d0/8*det3imomoqs*pxx2z
     & qsc/ctw**2*vmael**2*qs*ts+1d0/2*det3imomoqs*pxx2zqsc/ctw**2*vmael
     & **2*vmamo*qs*mmo**2-1d0/4*det3imomoqs*pxx2zqsc/ctw**2*vmael**2*vm
     & amo*qs*us-1d0/4*det3imomoqs*pxx2zqsc/ctw**2*vmael**2*vmamo*qs*ts-
     & 1d0/4*pxx2zqsc/ctw**2+1d0/2*pxx2zqsc/ctw**2*vmamo+1d0/2*pxx2zqsc/
     & ctw**2*vmael-pxx2zqsc/ctw**2*vmael*vmamo-1d0/2*pxx2zqsc/ctw**2*vm
     & ael**2+pxx2zqsc/ctw**2*vmael**2*vmamo)
     & +sdet4imotsus*c0cmotscwc*dreal(propizqs)*(-4*ts*rwz)
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*(-1d0/2/ctw**2*mmo**2-3
     & d0/2/ctw**2*ts+1d0/ctw**2*vmamo*mmo**2+2/ctw**2*vmamo*ts-1d0/2/ct
     & w**2*vmamo**2*mmo**2-1d0/2/ctw**2*vmamo**2*ts+1d0/ctw**2*vmael*mm
     & o**2+3/ctw**2*vmael*ts-2/ctw**2*vmael*vmamo*mmo**2-4/ctw**2*vmael
     & *vmamo*ts+1d0/ctw**2*vmael*vmamo**2*mmo**2+1d0/ctw**2*vmael*vmamo
     & **2*ts-1d0/2/ctw**2*vmael**2*mmo**2-3d0/2/ctw**2*vmael**2*ts+1d0/
     & ctw**2*vmael**2*vmamo*mmo**2+3/ctw**2*vmael**2*vmamo*ts)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*(1d0/ctw**2*vmamo*us+1d
     & 0/2/ctw**2*vmamo**2*mmo**2+1d0/2/ctw**2*vmamo**2*us-2/ctw**2*vmae
     & l*vmamo*us-1d0/ctw**2*vmael*vmamo**2*mmo**2-1d0/ctw**2*vmael*vmam
     & o**2*us-1d0/2/ctw**2*vmael**2*mmo**2-3d0/2/ctw**2*vmael**2*us+1d0
     & /ctw**2*vmael**2*vmamo*mmo**2+3/ctw**2*vmael**2*vmamo*us)
     & +sdet4imotsus*c0ccqswcw*dreal(propizqs)*(2*mw**2*rwz)
     & +sdet4imotsus*c0ccqszcz*dreal(propizqs)*(-1d0/4/ctw**2*qs-1d0/2/c
     & tw**2*vmamo*us+1d0/2/ctw**2*vmamo*ts+1d0/2/ctw**2*vmamo*qs+1d0/2/
     & ctw**2*vmamo**2*us-1d0/2/ctw**2*vmamo**2*ts+1d0/2/ctw**2*vmael*qs
     & +1d0/ctw**2*vmael*vmamo*us-1d0/ctw**2*vmael*vmamo*ts-1d0/ctw**2*v
     & mael*vmamo*qs-1d0/ctw**2*vmael*vmamo**2*us+1d0/ctw**2*vmael*vmamo
     & **2*ts-1d0/2/ctw**2*vmael**2*qs+1d0/ctw**2*vmael**2*vmamo*qs-1d0/
     & 4*pxx2zqsc/ctw**2+1d0/2*pxx2zqsc/ctw**2*vmamo+1d0/2*pxx2zqsc/ctw*
     & *2*vmael-pxx2zqsc/ctw**2*vmael*vmamo-1d0/2*pxx2zqsc/ctw**2*vmael*
     & *2+pxx2zqsc/ctw**2*vmael**2*vmamo)
     & +sdet4imotsus*b0fmowc*dreal(propizqs)*(-4/ts**3*mw**6*rmow**3*rwz
     & -4/ts**2*mw**4*rmow**2*rwz-4/ts*mw**2*rmow*rwz-4*rwz)
     & +sdet4imotsus*b0fmozmo*dreal(propizqs)*(1d0/4*det3imomoqs/ctw**2*
     & qs*mmo**2-1d0/4*det3imomoqs/ctw**2*qs*ts-1d0/2*det3imomoqs/ctw**2
     & *vmamo*qs*mmo**2+1d0/2*det3imomoqs/ctw**2*vmamo*qs*ts+1d0/4*det3i
     & momoqs/ctw**2*vmamo**2*qs*us-1d0/4*det3imomoqs/ctw**2*vmamo**2*qs
     & *ts-1d0/2*det3imomoqs/ctw**2*vmael*qs*mmo**2+1d0/2*det3imomoqs/ct
     & w**2*vmael*qs*ts+det3imomoqs/ctw**2*vmael*vmamo*qs*mmo**2-det3imo
     & moqs/ctw**2*vmael*vmamo*qs*ts-1d0/2*det3imomoqs/ctw**2*vmael*vmam
     & o**2*qs*us+1d0/2*det3imomoqs/ctw**2*vmael*vmamo**2*qs*ts+1d0/2*de
     & t3imomoqs/ctw**2*vmael**2*qs*mmo**2-1d0/4*det3imomoqs/ctw**2*vmae
     & l**2*qs*us-1d0/4*det3imomoqs/ctw**2*vmael**2*qs*ts-det3imomoqs/ct
     & w**2*vmael**2*vmamo*qs*mmo**2+1d0/2*det3imomoqs/ctw**2*vmael**2*v
     & mamo*qs*us+1d0/2*det3imomoqs/ctw**2*vmael**2*vmamo*qs*ts)
     & +sdet4imotsus*b0fqsww*dreal(propizqs)*(4/ts**3*mw**6*rmow**3*rwz+
     & 4/ts**2*mw**4*rmow**2*rwz+4/ts*mw**2*rmow*rwz+4*rwz)
     & +sdet4imotsus*b0fqszz*dreal(propizqs)*(-1d0/4*det3imomoqs/ctw**2*
     & qs*mmo**2+1d0/4*det3imomoqs/ctw**2*qs*ts+1d0/2*det3imomoqs/ctw**2
     & *vmamo*qs*mmo**2-1d0/2*det3imomoqs/ctw**2*vmamo*qs*ts-1d0/4*det3i
     & momoqs/ctw**2*vmamo**2*qs*us+1d0/4*det3imomoqs/ctw**2*vmamo**2*qs
     & *ts+1d0/2*det3imomoqs/ctw**2*vmael*qs*mmo**2-1d0/2*det3imomoqs/ct
     & w**2*vmael*qs*ts-det3imomoqs/ctw**2*vmael*vmamo*qs*mmo**2+det3imo
     & moqs/ctw**2*vmael*vmamo*qs*ts+1d0/2*det3imomoqs/ctw**2*vmael*vmam
     & o**2*qs*us-1d0/2*det3imomoqs/ctw**2*vmael*vmamo**2*qs*ts-1d0/2*de
     & t3imomoqs/ctw**2*vmael**2*qs*mmo**2+1d0/4*det3imomoqs/ctw**2*vmae
     & l**2*qs*us+1d0/4*det3imomoqs/ctw**2*vmael**2*qs*ts+det3imomoqs/ct
     & w**2*vmael**2*vmamo*qs*mmo**2-1d0/2*det3imomoqs/ctw**2*vmael**2*v
     & mamo*qs*us-1d0/2*det3imomoqs/ctw**2*vmael**2*vmamo*qs*ts)
     & +d0ccmomoqstszczmo*dreal(propizqs)*(1d0/2/ctw**2-1d0/2/ctw**2*vma
     & mo-1d0/ctw**2*vmael+1d0/ctw**2*vmael*vmamo+1d0/2/ctw**2*vmael**2-
     & 1d0/ctw**2*vmael**2*vmamo)
     & +d0ccmomoqsuszczmo*dreal(propizqs)*(-1d0/2/ctw**2*vmamo+1d0/ctw**
     & 2*vmael*vmamo+1d0/2/ctw**2*vmael**2-1d0/ctw**2*vmael**2*vmamo)
     & +c0momoqswcw*(-2*rwz+3*rmow*rwz-rmow**2*rwz)
     & +c0momoqszmoh*(3d0/2/qs*mw**2/rwz**2-2/qs*mw**2/rwz-3d0/2/qs*mw**
     & 2/rwz*rhw+2/qs*mw**2*rhw)
     & +c0momoqsmozmo*(-4+3/rwz)
     & +c0momoqscwc*(2)
     & +b0fmowc*(1d0/mw**2*rwz)
     & +b0fmozmo*(3d0/2/qs/rwz-2/qs)
     & +b0fmohmo*(-3d0/2/qs/rwz+2/qs)
     & +b0fqsww*(-2/mw**2*rwz+1d0/2/mw**2*rmow*rwz)
     & +b0d1momoz*(9d0/2/qs/rwz-15/qs+18/qs*rwz-8/qs*rwz**2)
     & +b0dwmocw*(1d0/qs-2/qs*rwz)

      ff_ew_qd =
     & +sdet3cmots*sdet4imotsus**2*d0ccmomoqstszczmo*dreal(propizqs)*(-1
     & d0/2*pxx2zqsc**2/ctw**2*vmael*vmamo**2*ts)
     & +sdet3cmots*sdet4imotsus**2*c0momoqszmoz*dreal(propizqs)*(1d0/2*p
     & xx2zqsc/ctw**2*vmael*vmamo**2*mmo**2-1d0/2*pxx2zqsc/ctw**2*vmael*
     & vmamo**2*ts)
     & +sdet3cmots*sdet4imotsus**2*c0cmotsczmo*dreal(propizqs)*(pxx2zqsc
     & /ctw**2*vmael*vmamo**2*ts)
     & +sdet3cmots*sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*(1d0/4
     & /ctw**2*vmael*vmamo**2*qs-5d0/4*pxx2zqsc/ctw**2*vmael*vmamo**2)
     & +sdet3cmots*sdet4imotsus*c0ccqszcz*dreal(propizqs)*(-1d0/2/ctw**2
     & *vmael*vmamo**2)
     & +sdet3cmous*sdet4imotsus**2*d0ccmomoqsuszczmo*dreal(propizqs)*(1d
     & 0/2*pxx2zqsc**2/ctw**2*vmael*us-pxx2zqsc**2/ctw**2*vmael*vmamo*us
     & +1d0/2*pxx2zqsc**2/ctw**2*vmael*vmamo**2*us)
     & +sdet3cmous*sdet4imotsus**2*c0momoqszmoz*dreal(propizqs)*(-1d0/2*
     & pxx2zqsc/ctw**2*vmael*mmo**2+1d0/2*pxx2zqsc/ctw**2*vmael*us+pxx2z
     & qsc/ctw**2*vmael*vmamo*mmo**2-pxx2zqsc/ctw**2*vmael*vmamo*us-1d0/
     & 2*pxx2zqsc/ctw**2*vmael*vmamo**2*mmo**2+1d0/2*pxx2zqsc/ctw**2*vma
     & el*vmamo**2*us)
     & +sdet3cmous*sdet4imotsus**2*c0cmousczmo*dreal(propizqs)*(-pxx2zqs
     & c/ctw**2*vmael*us+2*pxx2zqsc/ctw**2*vmael*vmamo*us-pxx2zqsc/ctw**
     & 2*vmael*vmamo**2*us)
     & +sdet3cmous*sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*(-1d0/
     & 4/ctw**2*vmael*qs+1d0/2/ctw**2*vmael*vmamo*qs-1d0/4/ctw**2*vmael*
     & vmamo**2*qs+5d0/4*pxx2zqsc/ctw**2*vmael-5d0/2*pxx2zqsc/ctw**2*vma
     & el*vmamo+5d0/4*pxx2zqsc/ctw**2*vmael*vmamo**2)
     & +sdet3cmous*sdet4imotsus*c0ccqszcz*dreal(propizqs)*(1d0/2/ctw**2*
     & vmael-1d0/ctw**2*vmael*vmamo+1d0/2/ctw**2*vmael*vmamo**2)
     & +sdet3imomoqs**2*c0momoqswcw*(-12/qs*mw**6-9d0/2*mw**4-3*mw**4*rm
     & ow+15d0/2*mw**4*rmow**2-3*mw**4*rmow**3)
     & +sdet3imomoqs**2*c0momoqsmozmo*(30/qs*mw**6/rwz**3-72/qs*mw**6/rw
     & z**2+48/qs*mw**6/rwz+27*mw**4/rwz**3-123d0/2*mw**4/rwz**2+36*mw**
     & 4/rwz+9d0/2*mw**4*rmow/rwz**2)
     & +sdet3imomoqs**2*c0momoqsmohmo*(-3d0/2*mw**4*rhw**2+9d0/2*mw**4*r
     & mow*rhw**2)
     & +sdet3imomoqs**2*c0momoqscwc*(6*mw**4+15*mw**4*rmow+12*mw**4*rmow
     & **2+3*mw**4*rmow**3)
     & +sdet3imomoqs**2*b0fmowc*(12/qs*mw**4+15d0/2*mw**2+27d0/2*mw**2*r
     & mow)
     & +sdet3imomoqs**2*b0fmozmo*(30/qs*mw**4/rwz**2-72/qs*mw**4/rwz+48/
     & qs*mw**4+27*mw**2/rwz**2-123d0/2*mw**2/rwz+36*mw**2+9d0/2*mw**2*r
     & mow/rwz)
     & +sdet3imomoqs**2*b0fmohmo*(-3d0/2*mw**2*rhw+9d0/2*mw**2*rmow*rhw)
     & +sdet3imomoqs**2*b0fqsww*(-12/qs*mw**4-3d0/2*mw**2-9d0/2*mw**2*rm
     & ow+3*mw**2*rmow**2)
     & +sdet3imomoqs**2*b0fqsmomo*(-30/qs*mw**4/rwz**2+72/qs*mw**4/rwz-4
     & 8/qs*mw**4-27*mw**2/rwz**2+123d0/2*mw**2/rwz-36*mw**2+3d0/2*mw**2
     & *rhw-9d0/2*mw**2*rmow/rwz-9d0/2*mw**2*rmow*rhw)
     & +sdet3imomoqs**2*b0fqscc*(-6*mw**2-9*mw**2*rmow-3*mw**2*rmow**2)
     & +sdet3imomoqs*c0momoqswcw*(17d0/2/qs*mw**4+7d0/2*mw**2-25d0/8*mw*
     & *2*rmow+mw**2*rmow**2)
     & +sdet3imomoqs*c0momoqszmoh*(-3d0/2*mw**2/rwz**2+2*mw**2/rwz-3d0/2
     & *mw**2/rwz*rhw+2*mw**2*rhw+6*mw**2*rmow/rwz-8*mw**2*rmow)
     & +sdet3imomoqs*c0momoqsmozmo*(-45d0/2/qs*mw**4/rwz**2+48/qs*mw**4/
     & rwz-32/qs*mw**4-24*mw**2/rwz**2+89d0/2*mw**2/rwz-24*mw**2-3d0/2*m
     & w**2*rmow/rwz)
     & +sdet3imomoqs*c0momoqsmohmo*(3d0/2/qs*mw**4*rhw**2+3d0/2*mw**2*rh
     & w-9d0/2*mw**2*rmow*rhw)
     & +sdet3imomoqs*c0momoqscwc*(-8*mw**2-8*mw**2*rmow-mw**2*rmow**2)
     & +sdet3imomoqs*a0fw*(1-8/qs**2*mw**4-3/qs*mw**2)
     & +sdet3imomoqs*a0fz*(-20/qs**2*mw**4/rwz**2+48/qs**2*mw**4/rwz-32/
     & qs**2*mw**4-18/qs*mw**2/rwz**2+41/qs*mw**2/rwz-24/qs*mw**2+3d0/4/
     & rwz)
     & +sdet3imomoqs*a0fh*(1d0/qs*mw**2*rhw+3d0/4*rhw)
     & +sdet3imomoqs*a0fmo*(21d0/2-5/qs*mw**2/rwz+12/qs*mw**2-8/qs*mw**2
     & *rwz-9d0/2/rwz-6*rwz-3d0/2*rmow)
     & +sdet3imomoqs*b0fmowc*(-47d0/8-8/qs**2*mw**4-21d0/2/qs*mw**2)
     & +sdet3imomoqs*b0fmozmo*(22-20/qs**2*mw**4/rwz**2+48/qs**2*mw**4/r
     & wz-32/qs**2*mw**4-18/qs*mw**2/rwz**2+57d0/2/qs*mw**2/rwz-16/qs*mw
     & **2*rwz-51d0/4/rwz-12*rwz)
     & +sdet3imomoqs*b0fmohmo*(-1+5d0/2/qs*mw**2*rhw+3d0/2/rwz+3d0/4*rhw
     & -3*rmow)
     & +sdet3imomoqs*b0fqsww*(15d0/8+15d0/2/qs*mw**2-1d0/2*rmow)
     & +sdet3imomoqs*b0fqszh*(4-3/rwz)
     & +sdet3imomoqs*b0fqsmomo*(-29d0/2+15d0/2/qs*mw**2/rwz-12/qs*mw**2-
     & 3d0/2/qs*mw**2*rhw+8/qs*mw**2*rwz+21d0/2/rwz+6*rwz+3d0/2*rmow)
     & +sdet3imomoqs*b0fqscc*(5+1d0/2*rmow)
     & +sdet3imomoqs*(-37d0/4+5/qs*mw**2/rwz-14/qs*mw**2+8/qs*mw**2*rwz+
     & 9d0/2/rwz+6*rwz+3d0/2*rmow)
     & +sdet3icmots*sdet4imotsus*c0cmotsczmo*dreal(propizqs)*(-1d0/2*pxx
     & 2zqsc/ctw**2*vmael*vmamo**2*ts)
     & +sdet3icmots*sdet4imotsus*b0fmozmo*dreal(propizqs)*(-1d0/ctw**2*v
     & mael*vmamo**2*ts)
     & +sdet3icmots*sdet4imotsus*b0ftsmoc*dreal(propizqs)*(1d0/ctw**2*vm
     & ael*vmamo**2*ts)
     & +sdet3icmots*c0cmotsczmo*dreal(propizqs)*(-1d0/2/ctw**2*vmael*vma
     & mo**2)
     & +sdet3icmous*sdet4imotsus*c0cmousczmo*dreal(propizqs)*(1d0/2*pxx2
     & zqsc/ctw**2*vmael*us-pxx2zqsc/ctw**2*vmael*vmamo*us+1d0/2*pxx2zqs
     & c/ctw**2*vmael*vmamo**2*us)
     & +sdet3icmous*sdet4imotsus*b0fmozmo*dreal(propizqs)*(1d0/ctw**2*vm
     & ael*us-2/ctw**2*vmael*vmamo*us+1d0/ctw**2*vmael*vmamo**2*us)
     & +sdet3icmous*sdet4imotsus*b0fusmoc*dreal(propizqs)*(-1d0/ctw**2*v
     & mael*us+2/ctw**2*vmael*vmamo*us-1d0/ctw**2*vmael*vmamo**2*us)
     & +sdet3icmous*c0cmousczmo*dreal(propizqs)*(1d0/2/ctw**2*vmael-1d0/
     & ctw**2*vmael*vmamo+1d0/2/ctw**2*vmael*vmamo**2)
     & +sdet4imotsus**2*c0ccqszcz*dreal(propizqs)*(-1d0/2*pxx2zqsc/ctw**
     & 2*vmael*qs*us+pxx2zqsc/ctw**2*vmael*vmamo*qs*us-1d0/2*pxx2zqsc/ct
     & w**2*vmael*vmamo**2*qs*us+1d0/2*pxx2zqsc/ctw**2*vmael*vmamo**2*qs
     & *ts)
     & +sdet4imotsus*d0ccmomoqstszczmo*dreal(propizqs)*(-1d0/2*pxx2zqsc/
     & ctw**2*vmael*vmamo*ts+1d0/2*pxx2zqsc/ctw**2*vmael*vmamo**2*mmo**2
     & +1d0/2*pxx2zqsc/ctw**2*vmael*vmamo**2*ts)
     & +sdet4imotsus*d0ccmomoqsuszczmo*dreal(propizqs)*(-1d0/2*pxx2zqsc/
     & ctw**2*vmael*mmo**2+pxx2zqsc/ctw**2*vmael*vmamo*mmo**2+1d0/2*pxx2
     & zqsc/ctw**2*vmael*vmamo*us-1d0/2*pxx2zqsc/ctw**2*vmael*vmamo**2*m
     & mo**2-1d0/2*pxx2zqsc/ctw**2*vmael*vmamo**2*us)
     & +sdet4imotsus*c0momoqszmoz*dreal(propizqs)*(1d0/ctw**2*vmael*us+1
     & d0/4/ctw**2*vmael*qs-3d0/2/ctw**2*vmael*vmamo*us-1d0/2/ctw**2*vma
     & el*vmamo*ts-1d0/2/ctw**2*vmael*vmamo*qs+1d0/2/ctw**2*vmael*vmamo*
     & *2*us-1d0/2/ctw**2*vmael*vmamo**2*ts-1d0/8*det3imomoqs*pxx2zqsc/c
     & tw**2*vmael*qs*mmo**2+1d0/8*det3imomoqs*pxx2zqsc/ctw**2*vmael*qs*
     & us+1d0/4*det3imomoqs*pxx2zqsc/ctw**2*vmael*vmamo*qs*mmo**2-1d0/4*
     & det3imomoqs*pxx2zqsc/ctw**2*vmael*vmamo*qs*us+1d0/8*det3imomoqs*p
     & xx2zqsc/ctw**2*vmael*vmamo**2*qs*us-1d0/8*det3imomoqs*pxx2zqsc/ct
     & w**2*vmael*vmamo**2*qs*ts-1d0/4*pxx2zqsc/ctw**2*vmael+1d0/2*pxx2z
     & qsc/ctw**2*vmael*vmamo)
     & +sdet4imotsus*c0cmotsczmo*dreal(propizqs)*(1d0/ctw**2*vmael*vmamo
     & *ts+1d0/2/ctw**2*vmael*vmamo**2*mmo**2+1d0/2/ctw**2*vmael*vmamo**
     & 2*ts)
     & +sdet4imotsus*c0cmousczmo*dreal(propizqs)*(-1d0/2/ctw**2*vmael*mm
     & o**2-3d0/2/ctw**2*vmael*us+1d0/ctw**2*vmael*vmamo*mmo**2+2/ctw**2
     & *vmael*vmamo*us-1d0/2/ctw**2*vmael*vmamo**2*mmo**2-1d0/2/ctw**2*v
     & mael*vmamo**2*us)
     & +sdet4imotsus*c0ccqszcz*dreal(propizqs)*(-1d0/4/ctw**2*vmael*qs+1
     & d0/2/ctw**2*vmael*vmamo*us-1d0/2/ctw**2*vmael*vmamo*ts+1d0/2/ctw*
     & *2*vmael*vmamo*qs-1d0/2/ctw**2*vmael*vmamo**2*us+1d0/2/ctw**2*vma
     & el*vmamo**2*ts-1d0/4*pxx2zqsc/ctw**2*vmael+1d0/2*pxx2zqsc/ctw**2*
     & vmael*vmamo)
     & +sdet4imotsus*b0fmozmo*dreal(propizqs)*(1d0/4*det3imomoqs/ctw**2*
     & vmael*qs*mmo**2-1d0/4*det3imomoqs/ctw**2*vmael*qs*us-1d0/2*det3im
     & omoqs/ctw**2*vmael*vmamo*qs*mmo**2+1d0/2*det3imomoqs/ctw**2*vmael
     & *vmamo*qs*us-1d0/4*det3imomoqs/ctw**2*vmael*vmamo**2*qs*us+1d0/4*
     & det3imomoqs/ctw**2*vmael*vmamo**2*qs*ts)
     & +sdet4imotsus*b0fqszz*dreal(propizqs)*(-1d0/4*det3imomoqs/ctw**2*
     & vmael*qs*mmo**2+1d0/4*det3imomoqs/ctw**2*vmael*qs*us+1d0/2*det3im
     & omoqs/ctw**2*vmael*vmamo*qs*mmo**2-1d0/2*det3imomoqs/ctw**2*vmael
     & *vmamo*qs*us+1d0/4*det3imomoqs/ctw**2*vmael*vmamo**2*qs*us-1d0/4*
     & det3imomoqs/ctw**2*vmael*vmamo**2*qs*ts)
     & +d0ccmomoqstszczmo*dreal(propizqs)*(-1d0/2/ctw**2*vmael*vmamo)
     & +d0ccmomoqsuszczmo*dreal(propizqs)*(1d0/2/ctw**2*vmael-1d0/2/ctw*
     & *2*vmael*vmamo)
     & +c0momoqswcw*(-3d0/2/qs*mw**2+1d0/8/qs*mw**2*rmow)
     & +c0momoqszmoh*(3d0/2/qs*mw**2/rwz**2-2/qs*mw**2/rwz-3d0/2/qs*mw**
     & 2/rwz*rhw+2/qs*mw**2*rhw)
     & +c0momoqsmozmo*(-2+3d0/2/qs*mw**2/rwz+3/rwz)
     & +c0momoqsmohmo*(-3d0/2/qs*mw**2*rhw)
     & +c0momoqscwc*(2)
     & +a0fmo*(-1d0/2/qs)
     & +b0fmowc*(-1d0/8/qs)
     & +b0fmozmo*(3d0/2/qs/rwz-2/qs)
     & +b0fmohmo*(-3d0/2/qs/rwz+1d0/qs)
     & +b0fqsww*(1d0/8/qs)
     & +b0fqsmomo*(1d0/2/qs)
     & +b0d1momoz*(5/qs**2*mw**2/rwz-12/qs**2*mw**2+8/qs**2*mw**2*rwz+9d
     & 0/2/qs/rwz-10/qs+6/qs*rwz)
     & +b0dwmocw*(2/qs**2*mw**2+1d0/qs)
     & +1d0/4/qs

      ffarray(1,1) = ff_qed_ll
      ffarray(1,2) = ff_ew_ll
      ffarray(1,3) = ff_qed_lq
      ffarray(1,4) = ff_ew_lq
      ffarray(1,5) = ff_qed_ql
      ffarray(1,6) = ff_ew_ql
      ffarray(1,7) = ff_qed_qq
      ffarray(1,8) = ff_ew_qq
      ffarray(1,9) = ff_qed_ld
      ffarray(1,10) = ff_ew_ld
      ffarray(1,11) = ff_qed_qd
      ffarray(1,12) = ff_ew_qd
      ffarray(1,13) = ff_qed_gg

      return
      end
