************************************************************************
* sanc_nc_v2.00 package.
************************************************************************
* File (nc_ff_12_12__20_20.F) is created on Сб янв 27 21:47:14 MSK 2018.
************************************************************************
* This is the FORTRAN module (nc_ff_12_12__20_20) to calculate 1-loop EW
* form factors for the el^- + el^- -> ta^- + ta^- process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2018.
*
* http://sanc.jinr.ru/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine nc_ff_12_12__20_20 (qs,ts,us)
      implicit none!
#include "looptools.h"
#include "s2n_declare.h"

      complex*16 ff_qed_ll,ff_qed_lq,ff_qed_ql,ff_qed_qq,ff_qed_ld
      complex*16 ff_qed_qd,ff_ew_ll,ff_ew_ld,ff_ew_lq,ff_ew_ql,ff_ew_qq
      complex*16 ff_ew_qd,ff_qed_gg

      real*8 det3itataqs
      real*8 a0fel,a0fta,a0fw,a0fz,a0fh
      real*8 lnlatam,lnlaelm
      complex*16 b0ptazta,b0ptahta,b0ptacw
      complex*16 b0fqscc,b0ftstac,b0fustac,b0ftazta,b0ftatac,b0fqszc,b0
     & fqstata,b0ftawc,b0ftahta,b0fqsww,b0fqszh,b0fqszz,b0ftscc
      complex*16 c0elelqszelc,c0tataqsztac,c0tataqsctac,c0ctatsczta,c0i
     & reltats,c0ctausczta,c0ireltaus,c0elelqscelc,c0irtataqs,c0irelelqs
     & ,c0irtaelts,c0irtaelus,c0ccqszcz,c0tataqsztaz,c0tataqswcw,c0tataq
     & sztah,c0tataqstazta,c0tataqstahta,c0tataqscwc,c0ctatscwc,c0ccqswc
     & w,c0ccqscwc,c0ccqsczc
      complex*16 b0d1tataz
      complex*16 b0dwtacw
      complex*16 d0cctataqstszczta,d0cctataqsuszczta,d0cctataqstswcwc
      complex*16 jaaqstselta,jaaqsuselta,javqstseltaz,javqsuseltaz
      real*8 sdet3ictats,sdet3ictaus,sdet4itatsus,sdet3itataqs
      real*8 sdet3ctats,sdet3ctaus
      real*8 pxx2zqsc
      complex*16 propzqs,propizqs,prop1zqs
      complex*16 b0fzww,b0fzzh
      real*8 der,errdersta,errdersys,deg,errdegsta,errdegsys

      common/unibos_bos/za1bos,zmzzzbos,zmwzwbos,zmhzhbos,deltarhobos
      common/unibos_fer/za1fer,zz1fer,zh1fer,zw1fer,zmsqrfer,
     & zmzzzfer,zmwzwfer,zmhzhfer,deltarhofer,tadfer
      common/unipro_fer/caldzfer,caldwfer,pizgfer,piggfer
      common/unipro_fer_d/piggferl,piggferh,piggfert
      common/unibos_fer_d/za1ferl,za1ferh,za1fert

      cmz2 = mz2

      if (irun.eq.0) then
         prop1zqs = (cmz2+qs)
      else
         prop1zqs = (dcmplx(mz**2,qs*wz/mz)+qs)
      endif
      propizqs = (rzm2+qs)
      propzqs = 1d0/propizqs
      det3itataqs = 1d0/(-1d0/4d0*((-rtam2)**2+(-rtam2)**2+(qs)**2
     & -2d0*(-rtam2)*(-rtam2)-2d0*(-rtam2)*(qs)
     & -2d0*(-rtam2)*(qs)))
      a0fel = log(relm2/thmu2) - 1d0
      a0fta = log(rtam2/thmu2) - 1d0
      a0fw = log(rwm2/thmu2) - 1d0
      a0fz = log(rzm2/thmu2) - 1d0
      a0fh = log(rhm2/thmu2) - 1d0
      lnlatam = log(rtam2/tlmu2)
      lnlaelm = log(relm2/tlmu2)
      b0ptazta = b0p(-rtam2,zm2,tam2)
      b0ptahta = b0p(-rtam2,hm2,tam2)
      b0ptacw = b0p(-rtam2,cm2,wm2)
      b0fqscc = b0f(qs,thmu2,cm2,cm2)
      b0ftstac = b0f(ts,thmu2,tam2,cm2)
      b0fustac = b0f(us,thmu2,tam2,cm2)
      b0ftazta = b0f(-rtam2,thmu2,zm2,tam2)
      b0ftatac = b0f(-rtam2,thmu2,tam2,cm2)
      b0fqszc = b0f(qs,thmu2,zm2,cm2)
      b0fqstata = b0f(qs,thmu2,tam2,tam2)
      b0ftawc = b0f(-rtam2,thmu2,wm2,cm2)
      b0ftahta = b0f(-rtam2,thmu2,hm2,tam2)
      b0fqsww = b0f(qs,thmu2,wm2,wm2)
      b0fqszh = b0f(qs,thmu2,zm2,hm2)
      b0fqszz = b0f(qs,thmu2,zm2,zm2)
      b0ftscc = b0f(ts,thmu2,cm2,cm2)
      c0elelqszelc = -c0(relm2,relm2,-qs,rzm2,relm2,0d0)
      c0tataqsztac = -c0(rtam2,rtam2,-qs,rzm2,rtam2,0d0)
      c0tataqsctac = -c0(rtam2,rtam2,-qs,0d0,rtam2,0d0)
      c0ctatsczta = -c0(0d0,rtam2,-ts,0d0,rzm2,rtam2)
      c0ireltats = c0ir(tlmu2,elm2,tam2,ts)
      c0ctausczta = -c0(0d0,rtam2,-us,0d0,rzm2,rtam2)
      c0ireltaus = c0ir(tlmu2,elm2,tam2,us)
      c0elelqscelc = -c0(relm2,relm2,-qs,0d0,relm2,0d0)
      c0irtataqs = c0ir(tlmu2,tam2,tam2,qs)
      c0irelelqs = c0ir(tlmu2,elm2,elm2,qs)
      c0irtaelts = c0ir(tlmu2,tam2,elm2,ts)
      c0irtaelus = c0ir(tlmu2,tam2,elm2,us)
      c0ccqszcz = -c0(0d0,0d0,-qs,rzm2,0d0,rzm2)
      c0tataqsztaz = -c0(rtam2,rtam2,-qs,rzm2,rtam2,rzm2)
      c0tataqswcw = -c0(rtam2,rtam2,-qs,rwm2,0d0,rwm2)
      c0tataqsztah = -c0(rtam2,rtam2,-qs,rzm2,rtam2,rhm2)
      c0tataqstazta = -c0(rtam2,rtam2,-qs,rtam2,rzm2,rtam2)
      c0tataqstahta = -c0(rtam2,rtam2,-qs,rtam2,rhm2,rtam2)
      c0tataqscwc = -c0(rtam2,rtam2,-qs,0d0,rwm2,0d0)
      c0ctatscwc = -c0(0d0,rtam2,-ts,0d0,rwm2,0d0)
      c0ccqswcw = -c0(0d0,0d0,-qs,rwm2,0d0,rwm2)
      c0ccqscwc = -c0(0d0,0d0,-qs,0d0,rwm2,0d0)
      c0ccqsczc = -c0(0d0,0d0,-qs,0d0,rzm2,0d0)
      b0d1tataz = b0d1(-rtam2,thmu2,tam2,zm2)
      b0dwtacw = b0dw(-rtam2,thmu2,cm2,wm2)
      d0cctataqstszczta =
     & d0(0d0,0d0,rtam2,rtam2,-qs,-ts,rzm2,0d0,rzm2,rtam2)
      d0cctataqsuszczta =
     & d0(0d0,0d0,rtam2,rtam2,-qs,-us,rzm2,0d0,rzm2,rtam2)
      d0cctataqstswcwc =
     & d0(0d0,0d0,rtam2,rtam2,-qs,-ts,rwm2,0d0,rwm2,0d0)
      jaaqstselta = jaa(qs,ts,elm2,tam2)
      jaaqsuselta = jaa(qs,us,elm2,tam2)
      javqstseltaz = jav(qs,ts,elm2,tam2,cmz2)
      javqsuseltaz = jav(qs,us,elm2,tam2,cmz2)
      sdet3ictats = 1d0/(ts+(mta)**2)
      sdet3ictaus = 1d0/(us+(mta)**2)
      sdet4itatsus = 1d0/(ts*us-mta**4)
      sdet3itataqs = 1d0/(qs+(mta+mta)**2)
      sdet3ctats = (ts+mta**2)
      sdet3ctaus = (us+mta**2)
      pxx2zqsc = (2*mz**2)+(qs)

      if (ifgg.le.2) then
         ff_qed_gg =
     &      -za1fer+stw**2*piggfer
      else
         call dhadr5x19(sqrt(-qs),0d0,der,errdersta,errdersys,deg,errdegsta,errdegsys)
         ff_qed_gg =
     &      -za1ferl+stw**2*piggferl-za1fert+stw**2*piggfert+der/alpha*4d0*pi*stw2
      endif

      ff_qed_ll =
     & +stw**2*(-qta**2-qel**2+2*det3itataqs*qta**2*qs*mta**2)
     & +sdet3ctats**3*sdet4itatsus**2*jaaqstselta*dreal(propizqs)*stw**4
     & *cfscheme*(8*ctw**2*qel**2*qta**2*us-8*ctw**2*qel**2*qta**2*ts)
     & +sdet3ctats**2*sdet4itatsus**2*c0elelqszelc*dreal(propizqs)*stw**
     & 2*(2*qel*qta*mz**2*mta**2-2*qel*qta*ts*mz**2+2*qel*qta*qs*mta**2-
     & 2*qel*qta*qs*ts-2*qel*qta*vmata*mz**2*mta**2+2*qel*qta*vmata*ts*m
     & z**2-2*qel*qta*vmata*qs*mta**2+2*qel*qta*vmata*qs*ts-2*qel*vmael*
     & qta*mz**2*mta**2+2*qel*vmael*qta*ts*mz**2-2*qel*vmael*qta*qs*mta*
     & *2+2*qel*vmael*qta*qs*ts+4*qel*vmael*qta*vmata*mz**2*mta**2-4*qel
     & *vmael*qta*vmata*ts*mz**2+4*qel*vmael*qta*vmata*qs*mta**2-4*qel*v
     & mael*qta*vmata*qs*ts)
     & +sdet3ctats*sdet4itatsus**2*javqstseltaz*dreal(propizqs)*stw**2*(
     & -2*qel*qta*mz**2*mta**4+2*qel*qta*ts**2*mz**2-2*qel*qta*qs*mta**4
     & +2*qel*qta*qs*ts**2+2*qel*qta*vmata*mz**2*mta**4-2*qel*qta*vmata*
     & ts**2*mz**2+2*qel*qta*vmata*qs*mta**4-2*qel*qta*vmata*qs*ts**2+2*
     & qel*vmael*qta*mz**2*mta**4-2*qel*vmael*qta*ts**2*mz**2+2*qel*vmae
     & l*qta*qs*mta**4-2*qel*vmael*qta*qs*ts**2-4*qel*vmael*qta*vmata*mz
     & **2*mta**4+4*qel*vmael*qta*vmata*ts**2*mz**2-4*qel*vmael*qta*vmat
     & a*qs*mta**4+4*qel*vmael*qta*vmata*qs*ts**2)
     & +sdet3ctats*sdet4itatsus**2*c0tataqsztac*dreal(propizqs)*stw**2*(
     & 2*qel*qta*mz**2*mta**4-2*qel*qta*us*mz**2*mta**2+2*qel*qta*ts*mz*
     & *2*mta**2-2*qel*qta*ts**2*mz**2+2*qel*qta*qs*mta**4-2*qel*qta*qs*
     & us*mta**2+2*qel*qta*qs*ts*mta**2-2*qel*qta*qs*ts**2-2*qel*qta*vma
     & ta*mz**2*mta**4+2*qel*qta*vmata*us*mz**2*mta**2-2*qel*qta*vmata*t
     & s*mz**2*mta**2+2*qel*qta*vmata*ts**2*mz**2-2*qel*qta*vmata*qs*mta
     & **4+2*qel*qta*vmata*qs*us*mta**2-2*qel*qta*vmata*qs*ts*mta**2+2*q
     & el*qta*vmata*qs*ts**2-2*qel*vmael*qta*mz**2*mta**4+2*qel*vmael*qt
     & a*us*mz**2*mta**2-2*qel*vmael*qta*ts*mz**2*mta**2+2*qel*vmael*qta
     & *ts**2*mz**2-2*qel*vmael*qta*qs*mta**4+2*qel*vmael*qta*qs*us*mta*
     & *2-2*qel*vmael*qta*qs*ts*mta**2+2*qel*vmael*qta*qs*ts**2+4*qel*vm
     & ael*qta*vmata*mz**2*mta**4-4*qel*vmael*qta*vmata*us*mz**2*mta**2+
     & 4*qel*vmael*qta*vmata*ts*mz**2*mta**2-4*qel*vmael*qta*vmata*ts**2
     & *mz**2+4*qel*vmael*qta*vmata*qs*mta**4-4*qel*vmael*qta*vmata*qs*u
     & s*mta**2+4*qel*vmael*qta*vmata*qs*ts*mta**2-4*qel*vmael*qta*vmata
     & *qs*ts**2)
     & +sdet3ctats*sdet4itatsus**2*c0tataqsctac*dreal(propizqs)*stw**4*c
     & fscheme*(64*ctw**2*qel**2*qta**2*qs*mta**4+16*ctw**2*qel**2*qta**
     & 2*qs**2*mta**2)
     & +sdet3ctats*sdet4itatsus**2*c0elelqszelc*dreal(propizqs)*stw**2*(
     & 2*qel*qta*us*mz**2*mta**2-2*qel*qta*ts*mz**2*mta**2+2*qel*qta*qs*
     & us*mta**2-2*qel*qta*qs*ts*mta**2-2*qel*qta*vmata*us*mz**2*mta**2+
     & 2*qel*qta*vmata*ts*mz**2*mta**2-2*qel*qta*vmata*qs*us*mta**2+2*qe
     & l*qta*vmata*qs*ts*mta**2-2*qel*vmael*qta*us*mz**2*mta**2+2*qel*vm
     & ael*qta*ts*mz**2*mta**2-2*qel*vmael*qta*qs*us*mta**2+2*qel*vmael*
     & qta*qs*ts*mta**2+4*qel*vmael*qta*vmata*us*mz**2*mta**2-4*qel*vmae
     & l*qta*vmata*ts*mz**2*mta**2+4*qel*vmael*qta*vmata*qs*us*mta**2-4*
     & qel*vmael*qta*vmata*qs*ts*mta**2)
     & +sdet3ctats*sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*stw**2*(-
     & 4*qel*qta*mz**2*mta**4+4*qel*qta*ts**2*mz**2-4*qel*qta*qs*mta**4+
     & 4*qel*qta*qs*ts**2+4*qel*qta*vmata*mz**2*mta**4-4*qel*qta*vmata*t
     & s**2*mz**2+4*qel*qta*vmata*qs*mta**4-4*qel*qta*vmata*qs*ts**2+4*q
     & el*vmael*qta*mz**2*mta**4-4*qel*vmael*qta*ts**2*mz**2+4*qel*vmael
     & *qta*qs*mta**4-4*qel*vmael*qta*qs*ts**2-8*qel*vmael*qta*vmata*mz*
     & *2*mta**4+8*qel*vmael*qta*vmata*ts**2*mz**2-8*qel*vmael*qta*vmata
     & *qs*mta**4+8*qel*vmael*qta*vmata*qs*ts**2)
     & +sdet3ctats*sdet4itatsus*javqstseltaz*dreal(propizqs)*stw**2*(4*q
     & el*qta*ts-4*qel*qta*vmata*ts-4*qel*vmael*qta*ts+8*qel*vmael*qta*v
     & mata*ts)
     & +sdet3ctats*sdet4itatsus*c0tataqsztac*dreal(propizqs)*stw**2*(-4*
     & qel*qta/qs*mz**2*mta**2-4*qel*qta*mta**2+4*qel*qta*vmata/qs*mz**2
     & *mta**2+4*qel*qta*vmata*mta**2+4*qel*vmael*qta/qs*mz**2*mta**2+4*
     & qel*vmael*qta*mta**2-8*qel*vmael*qta*vmata/qs*mz**2*mta**2-8*qel*
     & vmael*qta*vmata*mta**2)
     & +sdet3ctats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*stw**2*(4*qe
     & l*qta/qs*mz**2*mta**2+8*qel*qta*ts-4*qel*qta*vmata/qs*mz**2*mta**
     & 2-8*qel*qta*vmata*ts-4*qel*vmael*qta/qs*mz**2*mta**2-8*qel*vmael*
     & qta*ts+8*qel*vmael*qta*vmata/qs*mz**2*mta**2+16*qel*vmael*qta*vma
     & ta*ts)
     & +sdet3ctats*sdet4itatsus*b0fqscc*dreal(propizqs)*stw**4*cfscheme*
     & (-16*ctw**2*qel**2*qta**2)
     & +sdet3ctats*sdet4itatsus*b0ftstac*dreal(propizqs)*stw**4*cfscheme
     & *(16*ctw**2*qel**2*qta**2)
     & +sdet3ctats*javqstseltaz*stw**2*(4*qel*qta)
     & +sdet3ctats*c0ireltats*stw**2*(-4*qel*qta)
     & +sdet3ctats*c0ctatsczta*stw**2*(4*qel*qta)
     & +sdet3ctaus**3*sdet4itatsus**2*jaaqsuselta*dreal(propizqs)*stw**4
     & *cfscheme*(-8*ctw**2*qel**2*qta**2*us+8*ctw**2*qel**2*qta**2*ts)
     & +sdet3ctaus**2*sdet4itatsus**2*c0elelqszelc*dreal(propizqs)*stw**
     & 2*(-2*qel*qta*vmata*mz**2*mta**2+2*qel*qta*vmata*us*mz**2-2*qel*q
     & ta*vmata*qs*mta**2+2*qel*qta*vmata*qs*us-2*qel*vmael*qta*mz**2*mt
     & a**2+2*qel*vmael*qta*us*mz**2-2*qel*vmael*qta*qs*mta**2+2*qel*vma
     & el*qta*qs*us+4*qel*vmael*qta*vmata*mz**2*mta**2-4*qel*vmael*qta*v
     & mata*us*mz**2+4*qel*vmael*qta*vmata*qs*mta**2-4*qel*vmael*qta*vma
     & ta*qs*us)
     & +sdet3ctaus*sdet4itatsus**2*javqsuseltaz*dreal(propizqs)*stw**2*(
     & 2*qel*qta*vmata*mz**2*mta**4-2*qel*qta*vmata*us**2*mz**2+2*qel*qt
     & a*vmata*qs*mta**4-2*qel*qta*vmata*qs*us**2+2*qel*vmael*qta*mz**2*
     & mta**4-2*qel*vmael*qta*us**2*mz**2+2*qel*vmael*qta*qs*mta**4-2*qe
     & l*vmael*qta*qs*us**2-4*qel*vmael*qta*vmata*mz**2*mta**4+4*qel*vma
     & el*qta*vmata*us**2*mz**2-4*qel*vmael*qta*vmata*qs*mta**4+4*qel*vm
     & ael*qta*vmata*qs*us**2)
     & +sdet3ctaus*sdet4itatsus**2*c0tataqsztac*dreal(propizqs)*stw**2*(
     & -2*qel*qta*vmata*mz**2*mta**4-2*qel*qta*vmata*us*mz**2*mta**2+2*q
     & el*qta*vmata*us**2*mz**2+2*qel*qta*vmata*ts*mz**2*mta**2-2*qel*qt
     & a*vmata*qs*mta**4-2*qel*qta*vmata*qs*us*mta**2+2*qel*qta*vmata*qs
     & *us**2+2*qel*qta*vmata*qs*ts*mta**2-2*qel*vmael*qta*mz**2*mta**4-
     & 2*qel*vmael*qta*us*mz**2*mta**2+2*qel*vmael*qta*us**2*mz**2+2*qel
     & *vmael*qta*ts*mz**2*mta**2-2*qel*vmael*qta*qs*mta**4-2*qel*vmael*
     & qta*qs*us*mta**2+2*qel*vmael*qta*qs*us**2+2*qel*vmael*qta*qs*ts*m
     & ta**2+4*qel*vmael*qta*vmata*mz**2*mta**4+4*qel*vmael*qta*vmata*us
     & *mz**2*mta**2-4*qel*vmael*qta*vmata*us**2*mz**2-4*qel*vmael*qta*v
     & mata*ts*mz**2*mta**2+4*qel*vmael*qta*vmata*qs*mta**4+4*qel*vmael*
     & qta*vmata*qs*us*mta**2-4*qel*vmael*qta*vmata*qs*us**2-4*qel*vmael
     & *qta*vmata*qs*ts*mta**2)
     & +sdet3ctaus*sdet4itatsus**2*c0tataqsctac*dreal(propizqs)*stw**4*c
     & fscheme*(64*ctw**2*qel**2*qta**2*qs*mta**4+16*ctw**2*qel**2*qta**
     & 2*qs**2*mta**2)
     & +sdet3ctaus*sdet4itatsus**2*c0elelqszelc*dreal(propizqs)*stw**2*(
     & 2*qel*qta*vmata*us*mz**2*mta**2-2*qel*qta*vmata*ts*mz**2*mta**2+2
     & *qel*qta*vmata*qs*us*mta**2-2*qel*qta*vmata*qs*ts*mta**2+2*qel*vm
     & ael*qta*us*mz**2*mta**2-2*qel*vmael*qta*ts*mz**2*mta**2+2*qel*vma
     & el*qta*qs*us*mta**2-2*qel*vmael*qta*qs*ts*mta**2-4*qel*vmael*qta*
     & vmata*us*mz**2*mta**2+4*qel*vmael*qta*vmata*ts*mz**2*mta**2-4*qel
     & *vmael*qta*vmata*qs*us*mta**2+4*qel*vmael*qta*vmata*qs*ts*mta**2)
     &
     & +sdet3ctaus*sdet4itatsus**2*c0ctausczta*dreal(propizqs)*stw**2*(4
     & *qel*qta*vmata*mz**2*mta**4-4*qel*qta*vmata*us**2*mz**2+4*qel*qta
     & *vmata*qs*mta**4-4*qel*qta*vmata*qs*us**2+4*qel*vmael*qta*mz**2*m
     & ta**4-4*qel*vmael*qta*us**2*mz**2+4*qel*vmael*qta*qs*mta**4-4*qel
     & *vmael*qta*qs*us**2-8*qel*vmael*qta*vmata*mz**2*mta**4+8*qel*vmae
     & l*qta*vmata*us**2*mz**2-8*qel*vmael*qta*vmata*qs*mta**4+8*qel*vma
     & el*qta*vmata*qs*us**2)
     & +sdet3ctaus*sdet4itatsus*javqsuseltaz*dreal(propizqs)*stw**2*(-4*
     & qel*qta*vmata*us-4*qel*vmael*qta*us+8*qel*vmael*qta*vmata*us)
     & +sdet3ctaus*sdet4itatsus*c0tataqsztac*dreal(propizqs)*stw**2*(4*q
     & el*qta*vmata/qs*mz**2*mta**2+4*qel*qta*vmata*mta**2+4*qel*vmael*q
     & ta/qs*mz**2*mta**2+4*qel*vmael*qta*mta**2-8*qel*vmael*qta*vmata/q
     & s*mz**2*mta**2-8*qel*vmael*qta*vmata*mta**2)
     & +sdet3ctaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*stw**2*(-4*q
     & el*qta*vmata/qs*mz**2*mta**2-8*qel*qta*vmata*us-4*qel*vmael*qta/q
     & s*mz**2*mta**2-8*qel*vmael*qta*us+8*qel*vmael*qta*vmata/qs*mz**2*
     & mta**2+16*qel*vmael*qta*vmata*us)
     & +sdet3ctaus*sdet4itatsus*b0fqscc*dreal(propizqs)*stw**4*cfscheme*
     & (-16*ctw**2*qel**2*qta**2)
     & +sdet3ctaus*sdet4itatsus*b0fustac*dreal(propizqs)*stw**4*cfscheme
     & *(16*ctw**2*qel**2*qta**2)
     & +sdet3ctaus*javqsuseltaz*stw**2*(-4*qel*qta)
     & +sdet3ctaus*c0ireltaus*stw**2*(4*qel*qta)
     & +sdet3ctaus*c0ctausczta*stw**2*(-4*qel*qta)
     & +sdet3ictats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*stw**2*(4*q
     & el*qta*ts*mz**2*mta**2-4*qel*qta*vmata*ts*mz**2*mta**2-4*qel*vmae
     & l*qta*ts*mz**2*mta**2+8*qel*vmael*qta*vmata*ts*mz**2*mta**2)
     & +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*stw**2*(4*qel*
     & qta*mta**4+4*qel*qta*ts*mta**2-4*qel*qta*vmata*mta**4-4*qel*qta*v
     & mata*ts*mta**2-4*qel*vmael*qta*mta**4-4*qel*vmael*qta*ts*mta**2+8
     & *qel*vmael*qta*vmata*mta**4+8*qel*vmael*qta*vmata*ts*mta**2)
     & +sdet3ictats*sdet4itatsus*b0ftatac*dreal(propizqs)*stw**2*(4*qel*
     & qta*mta**4+4*qel*qta*ts*mta**2-4*qel*qta*vmata*mta**4-4*qel*qta*v
     & mata*ts*mta**2-4*qel*vmael*qta*mta**4-4*qel*vmael*qta*ts*mta**2+8
     & *qel*vmael*qta*vmata*mta**4+8*qel*vmael*qta*vmata*ts*mta**2)
     & +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*stw**2*(-8*qel
     & *qta*mta**4-8*qel*qta*ts*mta**2+8*qel*qta*vmata*mta**4+8*qel*qta*
     & vmata*ts*mta**2+8*qel*vmael*qta*mta**4+8*qel*vmael*qta*ts*mta**2-
     & 16*qel*vmael*qta*vmata*mta**4-16*qel*vmael*qta*vmata*ts*mta**2)
     & +sdet3ictats*c0ctatsczta*dreal(propizqs)*stw**2*(4*qel*qta/qs*mz*
     & *2*mta**2-4*qel*qta*vmata/qs*mz**2*mta**2-4*qel*vmael*qta/qs*mz**
     & 2*mta**2+8*qel*vmael*qta*vmata/qs*mz**2*mta**2)
     & +sdet3ictaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*stw**2*(-4*
     & qel*qta*vmata*us*mz**2*mta**2-4*qel*vmael*qta*us*mz**2*mta**2+8*q
     & el*vmael*qta*vmata*us*mz**2*mta**2)
     & +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*stw**2*(-4*qel
     & *qta*vmata*mta**4-4*qel*qta*vmata*us*mta**2-4*qel*vmael*qta*mta**
     & 4-4*qel*vmael*qta*us*mta**2+8*qel*vmael*qta*vmata*mta**4+8*qel*vm
     & ael*qta*vmata*us*mta**2)
     & +sdet3ictaus*sdet4itatsus*b0ftatac*dreal(propizqs)*stw**2*(-4*qel
     & *qta*vmata*mta**4-4*qel*qta*vmata*us*mta**2-4*qel*vmael*qta*mta**
     & 4-4*qel*vmael*qta*us*mta**2+8*qel*vmael*qta*vmata*mta**4+8*qel*vm
     & ael*qta*vmata*us*mta**2)
     & +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*stw**2*(8*qel*
     & qta*vmata*mta**4+8*qel*qta*vmata*us*mta**2+8*qel*vmael*qta*mta**4
     & +8*qel*vmael*qta*us*mta**2-16*qel*vmael*qta*vmata*mta**4-16*qel*v
     & mael*qta*vmata*us*mta**2)
     & +sdet3ictaus*c0ctausczta*dreal(propizqs)*stw**2*(-4*qel*qta*vmata
     & /qs*mz**2*mta**2-4*qel*vmael*qta/qs*mz**2*mta**2+8*qel*vmael*qta*
     & vmata/qs*mz**2*mta**2)
     & +sdet4itatsus**2*c0tataqsctac*dreal(propizqs)*stw**4*cfscheme*(32
     & *ctw**2*qel**2*qta**2*qs*us**2*mta**2-64*ctw**2*qel**2*qta**2*qs*
     & ts*us*mta**2+32*ctw**2*qel**2*qta**2*qs*ts**2*mta**2+8*ctw**2*qel
     & **2*qta**2*qs**2*us**2-16*ctw**2*qel**2*qta**2*qs**2*ts*us+8*ctw*
     & *2*qel**2*qta**2*qs**2*ts**2)
     & +sdet4itatsus**2*c0elelqscelc*dreal(propizqs)*stw**4*cfscheme*(8*
     & ctw**2*qel**2*qta**2*qs**2*us**2-16*ctw**2*qel**2*qta**2*qs**2*ts
     & *us+8*ctw**2*qel**2*qta**2*qs**2*ts**2)
     & +sdet4itatsus*javqstseltaz*dreal(propizqs)*stw**2*(2*qel*qta*mta*
     & *4+2*qel*qta*ts*mta**2-4*qel*qta*vmata*mta**4-4*qel*qta*vmata*ts*
     & mta**2-4*qel*vmael*qta*mta**4-4*qel*vmael*qta*ts*mta**2+8*qel*vma
     & el*qta*vmata*mta**4+8*qel*vmael*qta*vmata*ts*mta**2)
     & +sdet4itatsus*javqsuseltaz*dreal(propizqs)*stw**2*(2*qel*qta*mta*
     & *4+2*qel*qta*us*mta**2-4*qel*qta*vmata*mta**4-4*qel*qta*vmata*us*
     & mta**2-4*qel*vmael*qta*mta**4-4*qel*vmael*qta*us*mta**2+8*qel*vma
     & el*qta*vmata*mta**4+8*qel*vmael*qta*vmata*us*mta**2)
     & +sdet4itatsus*c0tataqsztac*dreal(propizqs)*stw**2*(-2*qel*qta/qs*
     & us*mz**2*mta**2+2*qel*qta/qs*ts*mz**2*mta**2+8*qel*qta*mta**4-2*q
     & el*qta*us*mta**2+10*qel*qta*ts*mta**2-2*qel*qta*ts*mz**2+2*qel*qt
     & a*qs*ts-16*qel*qta*vmata*mta**4-8*qel*qta*vmata*us*mta**2+2*qel*q
     & ta*vmata*us*mz**2-8*qel*qta*vmata*ts*mta**2+2*qel*qta*vmata*ts*mz
     & **2-2*qel*qta*vmata*qs*us-2*qel*qta*vmata*qs*ts-16*qel*vmael*qta*
     & mta**4-8*qel*vmael*qta*us*mta**2+2*qel*vmael*qta*us*mz**2-8*qel*v
     & mael*qta*ts*mta**2+2*qel*vmael*qta*ts*mz**2-2*qel*vmael*qta*qs*us
     & -2*qel*vmael*qta*qs*ts+32*qel*vmael*qta*vmata*mta**4+16*qel*vmael
     & *qta*vmata*us*mta**2-4*qel*vmael*qta*vmata*us*mz**2+16*qel*vmael*
     & qta*vmata*ts*mta**2-4*qel*vmael*qta*vmata*ts*mz**2+4*qel*vmael*qt
     & a*vmata*qs*us+4*qel*vmael*qta*vmata*qs*ts)
     & +sdet4itatsus*c0tataqsctac*dreal(propizqs)*stw**4*cfscheme*(32*ct
     & w**2*qel**2*qta**2*qs*mta**2)
     & +sdet4itatsus*c0elelqszelc*dreal(propizqs)*stw**2*(-2*qel*qta*mz*
     & *2*mta**2-2*qel*qta*ts*mz**2+2*qel*qta*qs*mta**2+2*qel*qta*qs*ts+
     & 4*qel*qta*vmata*mz**2*mta**2+2*qel*qta*vmata*us*mz**2+2*qel*qta*v
     & mata*ts*mz**2-4*qel*qta*vmata*qs*mta**2-2*qel*qta*vmata*qs*us-2*q
     & el*qta*vmata*qs*ts+4*qel*vmael*qta*mz**2*mta**2+2*qel*vmael*qta*u
     & s*mz**2+2*qel*vmael*qta*ts*mz**2-4*qel*vmael*qta*qs*mta**2-2*qel*
     & vmael*qta*qs*us-2*qel*vmael*qta*qs*ts-8*qel*vmael*qta*vmata*mz**2
     & *mta**2-4*qel*vmael*qta*vmata*us*mz**2-4*qel*vmael*qta*vmata*ts*m
     & z**2+8*qel*vmael*qta*vmata*qs*mta**2+4*qel*vmael*qta*vmata*qs*us+
     & 4*qel*vmael*qta*vmata*qs*ts)
     & +sdet4itatsus*c0ctatsczta*dreal(propizqs)*stw**2*(4*qel*qta*mta**
     & 4+4*qel*qta*ts*mta**2-8*qel*qta*vmata*mta**4-8*qel*qta*vmata*ts*m
     & ta**2-8*qel*vmael*qta*mta**4-8*qel*vmael*qta*ts*mta**2+16*qel*vma
     & el*qta*vmata*mta**4+16*qel*vmael*qta*vmata*ts*mta**2)
     & +sdet4itatsus*c0ctausczta*dreal(propizqs)*stw**2*(4*qel*qta*mta**
     & 4+4*qel*qta*us*mta**2-8*qel*qta*vmata*mta**4-8*qel*qta*vmata*us*m
     & ta**2-8*qel*vmael*qta*mta**4-8*qel*vmael*qta*us*mta**2+16*qel*vma
     & el*qta*vmata*mta**4+16*qel*vmael*qta*vmata*us*mta**2)
     & +sdet4itatsus*b0ftatac*dreal(propizqs)*stw**4*cfscheme*(64*ctw**2
     & *qel**2*qta**2*mta**2)
     & +sdet4itatsus*b0fqszc*dreal(propizqs)*stw**2*(-4*qel*qta*mta**2-4
     & *qel*qta*ts+8*qel*qta*vmata*mta**2+4*qel*qta*vmata*us+4*qel*qta*v
     & mata*ts+8*qel*vmael*qta*mta**2+4*qel*vmael*qta*us+4*qel*vmael*qta
     & *ts-16*qel*vmael*qta*vmata*mta**2-8*qel*vmael*qta*vmata*us-8*qel*
     & vmael*qta*vmata*ts)
     & +sdet4itatsus*b0ftstac*dreal(propizqs)*stw**2*(4*qel*qta*mta**2+4
     & *qel*qta*ts-4*qel*qta*vmata*mta**2-4*qel*qta*vmata*ts-4*qel*vmael
     & *qta*mta**2-4*qel*vmael*qta*ts+8*qel*vmael*qta*vmata*mta**2+8*qel
     & *vmael*qta*vmata*ts)
     & +sdet4itatsus*b0ftstac*dreal(propizqs)*stw**4*cfscheme*(-32*ctw**
     & 2*qel**2*qta**2*mta**2)
     & +sdet4itatsus*b0fustac*dreal(propizqs)*stw**2*(-4*qel*qta*vmata*m
     & ta**2-4*qel*qta*vmata*us-4*qel*vmael*qta*mta**2-4*qel*vmael*qta*u
     & s+8*qel*vmael*qta*vmata*mta**2+8*qel*vmael*qta*vmata*us)
     & +sdet4itatsus*b0fustac*dreal(propizqs)*stw**4*cfscheme*(-32*ctw**
     & 2*qel**2*qta**2*mta**2)
     & +c0irtataqs*stw**2*(-4*qta**2*mta**2-2*qta**2*qs)
     & +c0irelelqs*stw**2*(-2*qel**2*qs)
     & +a0fel*stw**2*(-3*qel**2)
     & +a0fta*stw**2*(-3*qta**2-2*det3itataqs*qta**2*qs*mta**2)
     & +b0fqstata*stw**2*(-3*qta**2-2*det3itataqs*qta**2*qs*mta**2)
     & +b0fqscc*stw**2*(-3*qel**2)
     & +lnlatam*stw**2*(2*qta**2)
     & +lnlaelm*stw**2*(2*qel**2)

      ff_qed_ql =
     & +stw**2*(-qta**2-qel**2+2*det3itataqs*qta**2*qs*mta**2)
     & +sdet3ctats**3*sdet4itatsus**2*jaaqstselta*dreal(propizqs)*stw**2
     & *cfscheme*(-2*ctw**2*qel*qta**2*us+2*ctw**2*qel*qta**2*ts)
     & +sdet3ctats**2*sdet4itatsus**2*c0elelqszelc*dreal(propizqs)*stw**
     & 2*(2*qel*qta*vmata*mz**2*mta**2-2*qel*qta*vmata*ts*mz**2+2*qel*qt
     & a*vmata*qs*mta**2-2*qel*qta*vmata*qs*ts)
     & +sdet3ctats*sdet4itatsus**2*javqstseltaz*dreal(propizqs)*stw**2*(
     & -2*qel*qta*vmata*mz**2*mta**4+2*qel*qta*vmata*ts**2*mz**2-2*qel*q
     & ta*vmata*qs*mta**4+2*qel*qta*vmata*qs*ts**2)
     & +sdet3ctats*sdet4itatsus**2*c0tataqsztac*dreal(propizqs)*stw**2*(
     & 2*qel*qta*vmata*mz**2*mta**4-2*qel*qta*vmata*us*mz**2*mta**2+2*qe
     & l*qta*vmata*ts*mz**2*mta**2-2*qel*qta*vmata*ts**2*mz**2+2*qel*qta
     & *vmata*qs*mta**4-2*qel*qta*vmata*qs*us*mta**2+2*qel*qta*vmata*qs*
     & ts*mta**2-2*qel*qta*vmata*qs*ts**2)
     & +sdet3ctats*sdet4itatsus**2*c0tataqsctac*dreal(propizqs)*stw**2*c
     & fscheme*(-16*ctw**2*qel*qta**2*qs*mta**4-4*ctw**2*qel*qta**2*qs**
     & 2*mta**2)
     & +sdet3ctats*sdet4itatsus**2*c0elelqszelc*dreal(propizqs)*stw**2*(
     & 2*qel*qta*vmata*us*mz**2*mta**2-2*qel*qta*vmata*ts*mz**2*mta**2+2
     & *qel*qta*vmata*qs*us*mta**2-2*qel*qta*vmata*qs*ts*mta**2)
     & +sdet3ctats*sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*stw**2*(-
     & 4*qel*qta*vmata*mz**2*mta**4+4*qel*qta*vmata*ts**2*mz**2-4*qel*qt
     & a*vmata*qs*mta**4+4*qel*qta*vmata*qs*ts**2)
     & +sdet3ctats*sdet4itatsus*javqstseltaz*dreal(propizqs)*stw**2*(4*q
     & el*qta*vmata*ts)
     & +sdet3ctats*sdet4itatsus*c0tataqsztac*dreal(propizqs)*stw**2*(-4*
     & qel*qta*vmata/qs*mz**2*mta**2-4*qel*qta*vmata*mta**2)
     & +sdet3ctats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*stw**2*(4*qe
     & l*qta*vmata/qs*mz**2*mta**2+8*qel*qta*vmata*ts)
     & +sdet3ctats*sdet4itatsus*b0fqscc*dreal(propizqs)*stw**2*cfscheme*
     & (4*ctw**2*qel*qta**2)
     & +sdet3ctats*sdet4itatsus*b0ftstac*dreal(propizqs)*stw**2*cfscheme
     & *(-4*ctw**2*qel*qta**2)
     & +sdet3ctats*javqstseltaz*stw**2*(4*qel*qta)
     & +sdet3ctats*c0ireltats*stw**2*(-4*qel*qta)
     & +sdet3ctats*c0ctatsczta*stw**2*(4*qel*qta)
     & +sdet3ctaus**3*sdet4itatsus**2*jaaqsuselta*dreal(propizqs)*stw**2
     & *cfscheme*(2*ctw**2*qel*qta**2*us-2*ctw**2*qel*qta**2*ts)
     & +sdet3ctaus**2*sdet4itatsus**2*c0elelqszelc*dreal(propizqs)*stw**
     & 2*(-2*qel*qta*mz**2*mta**2+2*qel*qta*us*mz**2-2*qel*qta*qs*mta**2
     & +2*qel*qta*qs*us+2*qel*qta*vmata*mz**2*mta**2-2*qel*qta*vmata*us*
     & mz**2+2*qel*qta*vmata*qs*mta**2-2*qel*qta*vmata*qs*us)
     & +sdet3ctaus*sdet4itatsus**2*javqsuseltaz*dreal(propizqs)*stw**2*(
     & 2*qel*qta*mz**2*mta**4-2*qel*qta*us**2*mz**2+2*qel*qta*qs*mta**4-
     & 2*qel*qta*qs*us**2-2*qel*qta*vmata*mz**2*mta**4+2*qel*qta*vmata*u
     & s**2*mz**2-2*qel*qta*vmata*qs*mta**4+2*qel*qta*vmata*qs*us**2)
     & +sdet3ctaus*sdet4itatsus**2*c0tataqsztac*dreal(propizqs)*stw**2*(
     & -2*qel*qta*mz**2*mta**4-2*qel*qta*us*mz**2*mta**2+2*qel*qta*us**2
     & *mz**2+2*qel*qta*ts*mz**2*mta**2-2*qel*qta*qs*mta**4-2*qel*qta*qs
     & *us*mta**2+2*qel*qta*qs*us**2+2*qel*qta*qs*ts*mta**2+2*qel*qta*vm
     & ata*mz**2*mta**4+2*qel*qta*vmata*us*mz**2*mta**2-2*qel*qta*vmata*
     & us**2*mz**2-2*qel*qta*vmata*ts*mz**2*mta**2+2*qel*qta*vmata*qs*mt
     & a**4+2*qel*qta*vmata*qs*us*mta**2-2*qel*qta*vmata*qs*us**2-2*qel*
     & qta*vmata*qs*ts*mta**2)
     & +sdet3ctaus*sdet4itatsus**2*c0tataqsctac*dreal(propizqs)*stw**2*c
     & fscheme*(-16*ctw**2*qel*qta**2*qs*mta**4-4*ctw**2*qel*qta**2*qs**
     & 2*mta**2)
     & +sdet3ctaus*sdet4itatsus**2*c0elelqszelc*dreal(propizqs)*stw**2*(
     & 2*qel*qta*us*mz**2*mta**2-2*qel*qta*ts*mz**2*mta**2+2*qel*qta*qs*
     & us*mta**2-2*qel*qta*qs*ts*mta**2-2*qel*qta*vmata*us*mz**2*mta**2+
     & 2*qel*qta*vmata*ts*mz**2*mta**2-2*qel*qta*vmata*qs*us*mta**2+2*qe
     & l*qta*vmata*qs*ts*mta**2)
     & +sdet3ctaus*sdet4itatsus**2*c0ctausczta*dreal(propizqs)*stw**2*(4
     & *qel*qta*mz**2*mta**4-4*qel*qta*us**2*mz**2+4*qel*qta*qs*mta**4-4
     & *qel*qta*qs*us**2-4*qel*qta*vmata*mz**2*mta**4+4*qel*qta*vmata*us
     & **2*mz**2-4*qel*qta*vmata*qs*mta**4+4*qel*qta*vmata*qs*us**2)
     & +sdet3ctaus*sdet4itatsus*javqsuseltaz*dreal(propizqs)*stw**2*(-4*
     & qel*qta*us+4*qel*qta*vmata*us)
     & +sdet3ctaus*sdet4itatsus*c0tataqsztac*dreal(propizqs)*stw**2*(4*q
     & el*qta/qs*mz**2*mta**2+4*qel*qta*mta**2-4*qel*qta*vmata/qs*mz**2*
     & mta**2-4*qel*qta*vmata*mta**2)
     & +sdet3ctaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*stw**2*(-4*q
     & el*qta/qs*mz**2*mta**2-8*qel*qta*us+4*qel*qta*vmata/qs*mz**2*mta*
     & *2+8*qel*qta*vmata*us)
     & +sdet3ctaus*sdet4itatsus*b0fqscc*dreal(propizqs)*stw**2*cfscheme*
     & (4*ctw**2*qel*qta**2)
     & +sdet3ctaus*sdet4itatsus*b0fustac*dreal(propizqs)*stw**2*cfscheme
     & *(-4*ctw**2*qel*qta**2)
     & +sdet3ctaus*javqsuseltaz*stw**2*(-4*qel*qta)
     & +sdet3ctaus*c0ireltaus*stw**2*(4*qel*qta)
     & +sdet3ctaus*c0ctausczta*stw**2*(-4*qel*qta)
     & +sdet3ictats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*stw**2*(4*q
     & el*qta*vmata*ts*mz**2*mta**2)
     & +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*stw**2*(4*qel*
     & qta*vmata*mta**4+4*qel*qta*vmata*ts*mta**2)
     & +sdet3ictats*sdet4itatsus*b0ftatac*dreal(propizqs)*stw**2*(4*qel*
     & qta*vmata*mta**4+4*qel*qta*vmata*ts*mta**2)
     & +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*stw**2*(-8*qel
     & *qta*vmata*mta**4-8*qel*qta*vmata*ts*mta**2)
     & +sdet3ictats*c0ctatsczta*dreal(propizqs)*stw**2*(4*qel*qta*vmata/
     & qs*mz**2*mta**2)
     & +sdet3ictaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*stw**2*(-4*
     & qel*qta*us*mz**2*mta**2+4*qel*qta*vmata*us*mz**2*mta**2)
     & +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*stw**2*(-4*qel
     & *qta*mta**4-4*qel*qta*us*mta**2+4*qel*qta*vmata*mta**4+4*qel*qta*
     & vmata*us*mta**2)
     & +sdet3ictaus*sdet4itatsus*b0ftatac*dreal(propizqs)*stw**2*(-4*qel
     & *qta*mta**4-4*qel*qta*us*mta**2+4*qel*qta*vmata*mta**4+4*qel*qta*
     & vmata*us*mta**2)
     & +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*stw**2*(8*qel*
     & qta*mta**4+8*qel*qta*us*mta**2-8*qel*qta*vmata*mta**4-8*qel*qta*v
     & mata*us*mta**2)
     & +sdet3ictaus*c0ctausczta*dreal(propizqs)*stw**2*(-4*qel*qta/qs*mz
     & **2*mta**2+4*qel*qta*vmata/qs*mz**2*mta**2)
     & +sdet4itatsus**2*c0tataqsctac*dreal(propizqs)*stw**2*cfscheme*(-8
     & *ctw**2*qel*qta**2*qs*us**2*mta**2+16*ctw**2*qel*qta**2*qs*ts*us*
     & mta**2-8*ctw**2*qel*qta**2*qs*ts**2*mta**2-2*ctw**2*qel*qta**2*qs
     & **2*us**2+4*ctw**2*qel*qta**2*qs**2*ts*us-2*ctw**2*qel*qta**2*qs*
     & *2*ts**2)
     & +sdet4itatsus**2*c0elelqscelc*dreal(propizqs)*stw**2*cfscheme*(-2
     & *ctw**2*qel*qta**2*qs**2*us**2+4*ctw**2*qel*qta**2*qs**2*ts*us-2*
     & ctw**2*qel*qta**2*qs**2*ts**2)
     & +sdet4itatsus*javqstseltaz*dreal(propizqs)*stw**2*(-2*qel*qta*mta
     & **4-2*qel*qta*ts*mta**2+4*qel*qta*vmata*mta**4+4*qel*qta*vmata*ts
     & *mta**2)
     & +sdet4itatsus*javqsuseltaz*dreal(propizqs)*stw**2*(-2*qel*qta*mta
     & **4-2*qel*qta*us*mta**2+4*qel*qta*vmata*mta**4+4*qel*qta*vmata*us
     & *mta**2)
     & +sdet4itatsus*c0tataqsztac*dreal(propizqs)*stw**2*(-2*qel*qta/qs*
     & us*mz**2*mta**2+2*qel*qta/qs*ts*mz**2*mta**2-8*qel*qta*mta**4-10*
     & qel*qta*us*mta**2+2*qel*qta*us*mz**2+2*qel*qta*ts*mta**2-2*qel*qt
     & a*qs*us+16*qel*qta*vmata*mta**4+8*qel*qta*vmata*us*mta**2-2*qel*q
     & ta*vmata*us*mz**2+8*qel*qta*vmata*ts*mta**2-2*qel*qta*vmata*ts*mz
     & **2+2*qel*qta*vmata*qs*us+2*qel*qta*vmata*qs*ts)
     & +sdet4itatsus*c0tataqsctac*dreal(propizqs)*stw**2*cfscheme*(-8*ct
     & w**2*qel*qta**2*qs*mta**2)
     & +sdet4itatsus*c0elelqszelc*dreal(propizqs)*stw**2*(2*qel*qta*mz**
     & 2*mta**2+2*qel*qta*us*mz**2-2*qel*qta*qs*mta**2-2*qel*qta*qs*us-4
     & *qel*qta*vmata*mz**2*mta**2-2*qel*qta*vmata*us*mz**2-2*qel*qta*vm
     & ata*ts*mz**2+4*qel*qta*vmata*qs*mta**2+2*qel*qta*vmata*qs*us+2*qe
     & l*qta*vmata*qs*ts)
     & +sdet4itatsus*c0ctatsczta*dreal(propizqs)*stw**2*(-4*qel*qta*mta*
     & *4-4*qel*qta*ts*mta**2+8*qel*qta*vmata*mta**4+8*qel*qta*vmata*ts*
     & mta**2)
     & +sdet4itatsus*c0ctausczta*dreal(propizqs)*stw**2*(-4*qel*qta*mta*
     & *4-4*qel*qta*us*mta**2+8*qel*qta*vmata*mta**4+8*qel*qta*vmata*us*
     & mta**2)
     & +sdet4itatsus*b0ftatac*dreal(propizqs)*stw**2*cfscheme*(-16*ctw**
     & 2*qel*qta**2*mta**2)
     & +sdet4itatsus*b0fqszc*dreal(propizqs)*stw**2*(4*qel*qta*mta**2+4*
     & qel*qta*us-8*qel*qta*vmata*mta**2-4*qel*qta*vmata*us-4*qel*qta*vm
     & ata*ts)
     & +sdet4itatsus*b0ftstac*dreal(propizqs)*stw**2*(4*qel*qta*vmata*mt
     & a**2+4*qel*qta*vmata*ts)
     & +sdet4itatsus*b0ftstac*dreal(propizqs)*stw**2*cfscheme*(8*ctw**2*
     & qel*qta**2*mta**2)
     & +sdet4itatsus*b0fustac*dreal(propizqs)*stw**2*(-4*qel*qta*mta**2-
     & 4*qel*qta*us+4*qel*qta*vmata*mta**2+4*qel*qta*vmata*us)
     & +sdet4itatsus*b0fustac*dreal(propizqs)*stw**2*cfscheme*(8*ctw**2*
     & qel*qta**2*mta**2)
     & +c0irtataqs*stw**2*(-4*qta**2*mta**2-2*qta**2*qs)
     & +c0irelelqs*stw**2*(-2*qel**2*qs)
     & +a0fel*stw**2*(-3*qel**2)
     & +a0fta*stw**2*(-3*qta**2-2*det3itataqs*qta**2*qs*mta**2)
     & +b0fqstata*stw**2*(-3*qta**2-2*det3itataqs*qta**2*qs*mta**2)
     & +b0fqscc*stw**2*(-3*qel**2)
     & +lnlatam*stw**2*(2*qta**2)
     & +lnlaelm*stw**2*(2*qel**2)

      ff_qed_lq =
     & +stw**2*(-qta**2-qel**2)
     & +sdet3ctats**3*sdet4itatsus**2*jaaqstselta*dreal(propizqs)*stw**2
     & *cfscheme*(-2*ctw**2*qel**2*qta*us+2*ctw**2*qel**2*qta*ts)
     & +sdet3ctats**2*sdet4itatsus**2*c0elelqszelc*dreal(propizqs)*stw**
     & 2*(2*qel*vmael*qta*mz**2*mta**2-2*qel*vmael*qta*ts*mz**2+2*qel*vm
     & ael*qta*qs*mta**2-2*qel*vmael*qta*qs*ts)
     & +sdet3ctats*sdet4itatsus**2*javqstseltaz*dreal(propizqs)*stw**2*(
     & -2*qel*vmael*qta*ts*mz**2*mta**2+2*qel*vmael*qta*ts**2*mz**2-2*qe
     & l*vmael*qta*qs*ts*mta**2+2*qel*vmael*qta*qs*ts**2)
     & +sdet3ctats*sdet4itatsus**2*javqstseltaz*dreal(propizqs)*(qel*mz*
     & *2*mta**4-qel*ts*mz**2*mta**2+qel*qs*mta**4-qel*qs*ts*mta**2-qel*
     & vmata*mz**2*mta**4+qel*vmata*ts*mz**2*mta**2-qel*vmata*qs*mta**4+
     & qel*vmata*qs*ts*mta**2-qel*vmael*mz**2*mta**4+qel*vmael*ts*mz**2*
     & mta**2-qel*vmael*qs*mta**4+qel*vmael*qs*ts*mta**2+qel*vmael*vmata
     & *mz**2*mta**4-qel*vmael*vmata*ts*mz**2*mta**2+qel*vmael*vmata*qs*
     & mta**4-qel*vmael*vmata*qs*ts*mta**2)
     & +sdet3ctats*sdet4itatsus**2*c0tataqsztac*dreal(propizqs)*stw**2*(
     & -2*qel*vmael*qta*mz**2*mta**4+4*qel*vmael*qta*ts*mz**2*mta**2-2*q
     & el*vmael*qta*ts**2*mz**2-2*qel*vmael*qta*qs*mta**4+4*qel*vmael*qt
     & a*qs*ts*mta**2-2*qel*vmael*qta*qs*ts**2)
     & +sdet3ctats*sdet4itatsus**2*c0tataqsztac*dreal(propizqs)*(-2*qel*
     & mz**2*mta**4+qel*us*mz**2*mta**2+qel*ts*mz**2*mta**2-2*qel*qs*mta
     & **4+qel*qs*us*mta**2+qel*qs*ts*mta**2+2*qel*vmata*mz**2*mta**4-qe
     & l*vmata*us*mz**2*mta**2-qel*vmata*ts*mz**2*mta**2+2*qel*vmata*qs*
     & mta**4-qel*vmata*qs*us*mta**2-qel*vmata*qs*ts*mta**2+2*qel*vmael*
     & mz**2*mta**4-qel*vmael*us*mz**2*mta**2-qel*vmael*ts*mz**2*mta**2+
     & 2*qel*vmael*qs*mta**4-qel*vmael*qs*us*mta**2-qel*vmael*qs*ts*mta*
     & *2-2*qel*vmael*vmata*mz**2*mta**4+qel*vmael*vmata*us*mz**2*mta**2
     & +qel*vmael*vmata*ts*mz**2*mta**2-2*qel*vmael*vmata*qs*mta**4+qel*
     & vmael*vmata*qs*us*mta**2+qel*vmael*vmata*qs*ts*mta**2)
     & +sdet3ctats*sdet4itatsus**2*c0tataqsctac*dreal(propizqs)*stw**2*c
     & fscheme*(-16*ctw**2*qel**2*qta*qs*mta**4-4*ctw**2*qel**2*qta*qs**
     & 2*mta**2)
     & +sdet3ctats*sdet4itatsus**2*c0elelqszelc*dreal(propizqs)*(-qel*us
     & *mz**2*mta**2+qel*ts*mz**2*mta**2-qel*qs*us*mta**2+qel*qs*ts*mta*
     & *2+qel*vmata*us*mz**2*mta**2-qel*vmata*ts*mz**2*mta**2+qel*vmata*
     & qs*us*mta**2-qel*vmata*qs*ts*mta**2+qel*vmael*us*mz**2*mta**2-qel
     & *vmael*ts*mz**2*mta**2+qel*vmael*qs*us*mta**2-qel*vmael*qs*ts*mta
     & **2-qel*vmael*vmata*us*mz**2*mta**2+qel*vmael*vmata*ts*mz**2*mta*
     & *2-qel*vmael*vmata*qs*us*mta**2+qel*vmael*vmata*qs*ts*mta**2)
     & +sdet3ctats*sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*stw**2*(-
     & 4*qel*vmael*qta*ts*mz**2*mta**2+4*qel*vmael*qta*ts**2*mz**2-4*qel
     & *vmael*qta*qs*ts*mta**2+4*qel*vmael*qta*qs*ts**2)
     & +sdet3ctats*sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*(2*qel*mz
     & **2*mta**4-2*qel*ts*mz**2*mta**2+2*qel*qs*mta**4-2*qel*qs*ts*mta*
     & *2-2*qel*vmata*mz**2*mta**4+2*qel*vmata*ts*mz**2*mta**2-2*qel*vma
     & ta*qs*mta**4+2*qel*vmata*qs*ts*mta**2-2*qel*vmael*mz**2*mta**4+2*
     & qel*vmael*ts*mz**2*mta**2-2*qel*vmael*qs*mta**4+2*qel*vmael*qs*ts
     & *mta**2+2*qel*vmael*vmata*mz**2*mta**4-2*qel*vmael*vmata*ts*mz**2
     & *mta**2+2*qel*vmael*vmata*qs*mta**4-2*qel*vmael*vmata*qs*ts*mta**
     & 2)
     & +sdet3ctats*sdet4itatsus*javqstseltaz*dreal(propizqs)*stw**2*(-2*
     & qel*vmael*qta/qs*mz**2*mta**2-4*qel*vmael*qta*mta**2+4*qel*vmael*
     & qta*ts)
     & +sdet3ctats*sdet4itatsus*javqstseltaz*dreal(propizqs)*(-qel/qs*mz
     & **2*mta**2-2*qel*mta**2+qel*vmata/qs*mz**2*mta**2+2*qel*vmata*mta
     & **2+qel*vmael/qs*mz**2*mta**2+2*qel*vmael*mta**2-qel*vmael*vmata/
     & qs*mz**2*mta**2-2*qel*vmael*vmata*mta**2)
     & +sdet3ctats*sdet4itatsus*c0tataqsztac*dreal(propizqs)*stw**2*(4*q
     & el*vmael*qta*mta**2)
     & +sdet3ctats*sdet4itatsus*c0tataqsztac*dreal(propizqs)*(2*qel/qs*m
     & z**2*mta**2+4*qel*mta**2-2*qel*vmata/qs*mz**2*mta**2-4*qel*vmata*
     & mta**2-2*qel*vmael/qs*mz**2*mta**2-4*qel*vmael*mta**2+2*qel*vmael
     & *vmata/qs*mz**2*mta**2+4*qel*vmael*vmata*mta**2)
     & +sdet3ctats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*stw**2*(-8*q
     & el*vmael*qta*mta**2+8*qel*vmael*qta*ts)
     & +sdet3ctats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*(-2*qel/qs*m
     & z**2*mta**2-4*qel*mta**2+2*qel*vmata/qs*mz**2*mta**2+4*qel*vmata*
     & mta**2+2*qel*vmael/qs*mz**2*mta**2+4*qel*vmael*mta**2-2*qel*vmael
     & *vmata/qs*mz**2*mta**2-4*qel*vmael*vmata*mta**2)
     & +sdet3ctats*sdet4itatsus*b0fqscc*dreal(propizqs)*stw**2*cfscheme*
     & (4*ctw**2*qel**2*qta)
     & +sdet3ctats*sdet4itatsus*b0ftstac*dreal(propizqs)*stw**2*cfscheme
     & *(-4*ctw**2*qel**2*qta)
     & +sdet3ctats*javqstseltaz*stw**2*(4*qel*qta)
     & +sdet3ctats*c0ireltats*stw**2*(-4*qel*qta)
     & +sdet3ctats*c0ctatsczta*stw**2*(4*qel*qta)
     & +sdet3ctaus**3*sdet4itatsus**2*jaaqsuselta*dreal(propizqs)*stw**2
     & *cfscheme*(2*ctw**2*qel**2*qta*us-2*ctw**2*qel**2*qta*ts)
     & +sdet3ctaus**2*sdet4itatsus**2*c0elelqszelc*dreal(propizqs)*stw**
     & 2*(-2*qel*qta*mz**2*mta**2+2*qel*qta*us*mz**2-2*qel*qta*qs*mta**2
     & +2*qel*qta*qs*us+2*qel*vmael*qta*mz**2*mta**2-2*qel*vmael*qta*us*
     & mz**2+2*qel*vmael*qta*qs*mta**2-2*qel*vmael*qta*qs*us)
     & +sdet3ctaus*sdet4itatsus**2*javqsuseltaz*dreal(propizqs)*stw**2*(
     & 2*qel*qta*us*mz**2*mta**2-2*qel*qta*us**2*mz**2+2*qel*qta*qs*us*m
     & ta**2-2*qel*qta*qs*us**2-2*qel*vmael*qta*us*mz**2*mta**2+2*qel*vm
     & ael*qta*us**2*mz**2-2*qel*vmael*qta*qs*us*mta**2+2*qel*vmael*qta*
     & qs*us**2)
     & +sdet3ctaus*sdet4itatsus**2*javqsuseltaz*dreal(propizqs)*(-qel*vm
     & ael*mz**2*mta**4+qel*vmael*us*mz**2*mta**2-qel*vmael*qs*mta**4+qe
     & l*vmael*qs*us*mta**2+qel*vmael*vmata*mz**2*mta**4-qel*vmael*vmata
     & *us*mz**2*mta**2+qel*vmael*vmata*qs*mta**4-qel*vmael*vmata*qs*us*
     & mta**2)
     & +sdet3ctaus*sdet4itatsus**2*c0tataqsztac*dreal(propizqs)*stw**2*(
     & 2*qel*qta*mz**2*mta**4-4*qel*qta*us*mz**2*mta**2+2*qel*qta*us**2*
     & mz**2+2*qel*qta*qs*mta**4-4*qel*qta*qs*us*mta**2+2*qel*qta*qs*us*
     & *2-2*qel*vmael*qta*mz**2*mta**4+4*qel*vmael*qta*us*mz**2*mta**2-2
     & *qel*vmael*qta*us**2*mz**2-2*qel*vmael*qta*qs*mta**4+4*qel*vmael*
     & qta*qs*us*mta**2-2*qel*vmael*qta*qs*us**2)
     & +sdet3ctaus*sdet4itatsus**2*c0tataqsztac*dreal(propizqs)*(2*qel*v
     & mael*mz**2*mta**4-qel*vmael*us*mz**2*mta**2-qel*vmael*ts*mz**2*mt
     & a**2+2*qel*vmael*qs*mta**4-qel*vmael*qs*us*mta**2-qel*vmael*qs*ts
     & *mta**2-2*qel*vmael*vmata*mz**2*mta**4+qel*vmael*vmata*us*mz**2*m
     & ta**2+qel*vmael*vmata*ts*mz**2*mta**2-2*qel*vmael*vmata*qs*mta**4
     & +qel*vmael*vmata*qs*us*mta**2+qel*vmael*vmata*qs*ts*mta**2)
     & +sdet3ctaus*sdet4itatsus**2*c0tataqsctac*dreal(propizqs)*stw**2*c
     & fscheme*(-16*ctw**2*qel**2*qta*qs*mta**4-4*ctw**2*qel**2*qta*qs**
     & 2*mta**2)
     & +sdet3ctaus*sdet4itatsus**2*c0elelqszelc*dreal(propizqs)*(-qel*vm
     & ael*us*mz**2*mta**2+qel*vmael*ts*mz**2*mta**2-qel*vmael*qs*us*mta
     & **2+qel*vmael*qs*ts*mta**2+qel*vmael*vmata*us*mz**2*mta**2-qel*vm
     & ael*vmata*ts*mz**2*mta**2+qel*vmael*vmata*qs*us*mta**2-qel*vmael*
     & vmata*qs*ts*mta**2)
     & +sdet3ctaus*sdet4itatsus**2*c0ctausczta*dreal(propizqs)*stw**2*(4
     & *qel*qta*us*mz**2*mta**2-4*qel*qta*us**2*mz**2+4*qel*qta*qs*us*mt
     & a**2-4*qel*qta*qs*us**2-4*qel*vmael*qta*us*mz**2*mta**2+4*qel*vma
     & el*qta*us**2*mz**2-4*qel*vmael*qta*qs*us*mta**2+4*qel*vmael*qta*q
     & s*us**2)
     & +sdet3ctaus*sdet4itatsus**2*c0ctausczta*dreal(propizqs)*(-2*qel*v
     & mael*mz**2*mta**4+2*qel*vmael*us*mz**2*mta**2-2*qel*vmael*qs*mta*
     & *4+2*qel*vmael*qs*us*mta**2+2*qel*vmael*vmata*mz**2*mta**4-2*qel*
     & vmael*vmata*us*mz**2*mta**2+2*qel*vmael*vmata*qs*mta**4-2*qel*vma
     & el*vmata*qs*us*mta**2)
     & +sdet3ctaus*sdet4itatsus*javqsuseltaz*dreal(propizqs)*stw**2*(2*q
     & el*qta/qs*mz**2*mta**2+4*qel*qta*mta**2-4*qel*qta*us-2*qel*vmael*
     & qta/qs*mz**2*mta**2-4*qel*vmael*qta*mta**2+4*qel*vmael*qta*us)
     & +sdet3ctaus*sdet4itatsus*javqsuseltaz*dreal(propizqs)*(qel*vmael/
     & qs*mz**2*mta**2+2*qel*vmael*mta**2-qel*vmael*vmata/qs*mz**2*mta**
     & 2-2*qel*vmael*vmata*mta**2)
     & +sdet3ctaus*sdet4itatsus*c0tataqsztac*dreal(propizqs)*stw**2*(-4*
     & qel*qta*mta**2+4*qel*vmael*qta*mta**2)
     & +sdet3ctaus*sdet4itatsus*c0tataqsztac*dreal(propizqs)*(-2*qel*vma
     & el/qs*mz**2*mta**2-4*qel*vmael*mta**2+2*qel*vmael*vmata/qs*mz**2*
     & mta**2+4*qel*vmael*vmata*mta**2)
     & +sdet3ctaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*stw**2*(8*qe
     & l*qta*mta**2-8*qel*qta*us-8*qel*vmael*qta*mta**2+8*qel*vmael*qta*
     & us)
     & +sdet3ctaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*(2*qel*vmael
     & /qs*mz**2*mta**2+4*qel*vmael*mta**2-2*qel*vmael*vmata/qs*mz**2*mt
     & a**2-4*qel*vmael*vmata*mta**2)
     & +sdet3ctaus*sdet4itatsus*b0fqscc*dreal(propizqs)*stw**2*cfscheme*
     & (4*ctw**2*qel**2*qta)
     & +sdet3ctaus*sdet4itatsus*b0fustac*dreal(propizqs)*stw**2*cfscheme
     & *(-4*ctw**2*qel**2*qta)
     & +sdet3ctaus*javqsuseltaz*stw**2*(-4*qel*qta)
     & +sdet3ctaus*c0ireltaus*stw**2*(4*qel*qta)
     & +sdet3ctaus*c0ctausczta*stw**2*(-4*qel*qta)
     & +sdet3ictats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*stw**2*(4*q
     & el*vmael*qta*ts*mz**2*mta**2)
     & +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*stw**2*(4*qel*
     & vmael*qta*ts*mta**2)
     & +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*(-2*qel*mta**4
     & +2*qel*vmata*mta**4+2*qel*vmael*mta**4-2*qel*vmael*vmata*mta**4)
     & +sdet3ictats*sdet4itatsus*b0ftatac*dreal(propizqs)*stw**2*(4*qel*
     & vmael*qta*ts*mta**2)
     & +sdet3ictats*sdet4itatsus*b0ftatac*dreal(propizqs)*(-2*qel*mta**4
     & +2*qel*vmata*mta**4+2*qel*vmael*mta**4-2*qel*vmael*vmata*mta**4)
     & +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*stw**2*(-8*qel
     & *vmael*qta*ts*mta**2)
     & +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*(4*qel*mta**4-
     & 4*qel*vmata*mta**4-4*qel*vmael*mta**4+4*qel*vmael*vmata*mta**4)
     & +sdet3ictats*c0ctatsczta*dreal(propizqs)*(-2*qel/qs*mz**2*mta**2+
     & 2*qel*vmata/qs*mz**2*mta**2+2*qel*vmael/qs*mz**2*mta**2-2*qel*vma
     & el*vmata/qs*mz**2*mta**2)
     & +sdet3ictaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*stw**2*(-4*
     & qel*qta*us*mz**2*mta**2+4*qel*vmael*qta*us*mz**2*mta**2)
     & +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*stw**2*(-4*qel
     & *qta*us*mta**2+4*qel*vmael*qta*us*mta**2)
     & +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*(2*qel*vmael*m
     & ta**4-2*qel*vmael*vmata*mta**4)
     & +sdet3ictaus*sdet4itatsus*b0ftatac*dreal(propizqs)*stw**2*(-4*qel
     & *qta*us*mta**2+4*qel*vmael*qta*us*mta**2)
     & +sdet3ictaus*sdet4itatsus*b0ftatac*dreal(propizqs)*(2*qel*vmael*m
     & ta**4-2*qel*vmael*vmata*mta**4)
     & +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*stw**2*(8*qel*
     & qta*us*mta**2-8*qel*vmael*qta*us*mta**2)
     & +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*(-4*qel*vmael*
     & mta**4+4*qel*vmael*vmata*mta**4)
     & +sdet3ictaus*c0ctausczta*dreal(propizqs)*(2*qel*vmael/qs*mz**2*mt
     & a**2-2*qel*vmael*vmata/qs*mz**2*mta**2)
     & +sdet4itatsus**2*c0tataqsctac*dreal(propizqs)*stw**2*cfscheme*(-8
     & *ctw**2*qel**2*qta*qs*us**2*mta**2+16*ctw**2*qel**2*qta*qs*ts*us*
     & mta**2-8*ctw**2*qel**2*qta*qs*ts**2*mta**2-2*ctw**2*qel**2*qta*qs
     & **2*us**2+4*ctw**2*qel**2*qta*qs**2*ts*us-2*ctw**2*qel**2*qta*qs*
     & *2*ts**2)
     & +sdet4itatsus**2*c0elelqscelc*dreal(propizqs)*stw**2*cfscheme*(-2
     & *ctw**2*qel**2*qta*qs**2*us**2+4*ctw**2*qel**2*qta*qs**2*ts*us-2*
     & ctw**2*qel**2*qta*qs**2*ts**2)
     & +sdet4itatsus*javqstseltaz*dreal(propizqs)*stw**2*(-2*qel*qta*mta
     & **4+4*qel*vmael*qta*mta**4)
     & +sdet4itatsus*javqstseltaz*dreal(propizqs)*(-qel*ts*mta**2+qel*vm
     & ata*ts*mta**2+2*qel*vmael*ts*mta**2-2*qel*vmael*vmata*ts*mta**2)
     & +sdet4itatsus*javqsuseltaz*dreal(propizqs)*stw**2*(-2*qel*qta*mta
     & **4+4*qel*vmael*qta*mta**4)
     & +sdet4itatsus*javqsuseltaz*dreal(propizqs)*(-qel*us*mta**2+qel*vm
     & ata*us*mta**2+2*qel*vmael*us*mta**2-2*qel*vmael*vmata*us*mta**2)
     & +sdet4itatsus*c0tataqsztac*dreal(propizqs)*stw**2*(-8*qel*qta*us*
     & mta**2+2*qel*qta*us*mz**2-2*qel*qta*qs*us+8*qel*vmael*qta*us*mta*
     & *2-2*qel*vmael*qta*us*mz**2+8*qel*vmael*qta*ts*mta**2-2*qel*vmael
     & *qta*ts*mz**2+2*qel*vmael*qta*qs*us+2*qel*vmael*qta*qs*ts)
     & +sdet4itatsus*c0tataqsztac*dreal(propizqs)*(qel/qs*us*mz**2*mta**
     & 2-qel/qs*ts*mz**2*mta**2-4*qel*mta**4+qel*us*mta**2-qel*ts*mta**2
     & -qel*vmata/qs*us*mz**2*mta**2+qel*vmata/qs*ts*mz**2*mta**2+4*qel*
     & vmata*mta**4-qel*vmata*us*mta**2+qel*vmata*ts*mta**2+8*qel*vmael*
     & mta**4-8*qel*vmael*vmata*mta**4)
     & +sdet4itatsus*c0tataqsctac*dreal(propizqs)*stw**2*cfscheme*(-8*ct
     & w**2*qel**2*qta*qs*mta**2)
     & +sdet4itatsus*c0elelqszelc*dreal(propizqs)*stw**2*(2*qel*qta*us*m
     & z**2-2*qel*qta*qs*us-2*qel*vmael*qta*us*mz**2-2*qel*vmael*qta*ts*
     & mz**2+2*qel*vmael*qta*qs*us+2*qel*vmael*qta*qs*ts)
     & +sdet4itatsus*c0elelqszelc*dreal(propizqs)*(qel*mz**2*mta**2-qel*
     & qs*mta**2-qel*vmata*mz**2*mta**2+qel*vmata*qs*mta**2-2*qel*vmael*
     & mz**2*mta**2+2*qel*vmael*qs*mta**2+2*qel*vmael*vmata*mz**2*mta**2
     & -2*qel*vmael*vmata*qs*mta**2)
     & +sdet4itatsus*c0ctatsczta*dreal(propizqs)*stw**2*(-4*qel*qta*mta*
     & *4+8*qel*vmael*qta*mta**4)
     & +sdet4itatsus*c0ctatsczta*dreal(propizqs)*(-2*qel*ts*mta**2+2*qel
     & *vmata*ts*mta**2+4*qel*vmael*ts*mta**2-4*qel*vmael*vmata*ts*mta**
     & 2)
     & +sdet4itatsus*c0ctausczta*dreal(propizqs)*stw**2*(-4*qel*qta*mta*
     & *4+8*qel*vmael*qta*mta**4)
     & +sdet4itatsus*c0ctausczta*dreal(propizqs)*(-2*qel*us*mta**2+2*qel
     & *vmata*us*mta**2+4*qel*vmael*us*mta**2-4*qel*vmael*vmata*us*mta**
     & 2)
     & +sdet4itatsus*b0ftatac*dreal(propizqs)*stw**2*cfscheme*(-16*ctw**
     & 2*qel**2*qta*mta**2)
     & +sdet4itatsus*b0fqszc*dreal(propizqs)*stw**2*(4*qel*qta*us-4*qel*
     & vmael*qta*us-4*qel*vmael*qta*ts)
     & +sdet4itatsus*b0fqszc*dreal(propizqs)*(2*qel*mta**2-2*qel*vmata*m
     & ta**2-4*qel*vmael*mta**2+4*qel*vmael*vmata*mta**2)
     & +sdet4itatsus*b0ftstac*dreal(propizqs)*stw**2*(4*qel*vmael*qta*ts
     & )
     & +sdet4itatsus*b0ftstac*dreal(propizqs)*stw**2*cfscheme*(8*ctw**2*
     & qel**2*qta*mta**2)
     & +sdet4itatsus*b0ftstac*dreal(propizqs)*(-2*qel*mta**2+2*qel*vmata
     & *mta**2+2*qel*vmael*mta**2-2*qel*vmael*vmata*mta**2)
     & +sdet4itatsus*b0fustac*dreal(propizqs)*stw**2*(-4*qel*qta*us+4*qe
     & l*vmael*qta*us)
     & +sdet4itatsus*b0fustac*dreal(propizqs)*stw**2*cfscheme*(8*ctw**2*
     & qel**2*qta*mta**2)
     & +sdet4itatsus*b0fustac*dreal(propizqs)*(2*qel*vmael*mta**2-2*qel*
     & vmael*vmata*mta**2)
     & +javqstseltaz*dreal(propizqs)*stw**2*(2*qel*qta/qs*mta**2-4*qel*v
     & mael*qta/qs*mta**2)
     & +javqstseltaz*dreal(propizqs)*(-qel/qs*mta**2+qel*vmata/qs*mta**2
     & +2*qel*vmael/qs*mta**2-2*qel*vmael*vmata/qs*mta**2)
     & +javqsuseltaz*dreal(propizqs)*stw**2*(2*qel*qta/qs*mta**2-4*qel*v
     & mael*qta/qs*mta**2)
     & +javqsuseltaz*dreal(propizqs)*(-qel/qs*mta**2+qel*vmata/qs*mta**2
     & +2*qel*vmael/qs*mta**2-2*qel*vmael*vmata/qs*mta**2)
     & +c0irtataqs*stw**2*(-4*qta**2*mta**2-2*qta**2*qs)
     & +c0irelelqs*stw**2*(-2*qel**2*qs)
     & +a0fel*stw**2*(-3*qel**2)
     & +a0fta*stw**2*(-3*qta**2)
     & +a0fta*(1d0/2*det3itataqs*qta*qs*mta**2)
     & +b0fqstata*stw**2*(-3*qta**2)
     & +b0fqstata*(1d0/2*det3itataqs*qta*qs*mta**2)
     & +b0fqscc*stw**2*(-3*qel**2)
     & +lnlatam*stw**2*(2*qta**2)
     & +lnlaelm*stw**2*(2*qel**2)-1d0/2*det3itataqs*qta*qs*mta**2

      ff_qed_qq =
     & +stw**2*(-qta**2-qel**2)
     & +prop1zqs*sdet3ctats*c0irtaelts*cfscheme*(-4*ctw**2*qel*qta/qs)
     & +prop1zqs*sdet3ctaus*c0irtaelus*cfscheme*(4*ctw**2*qel*qta/qs)
     & +prop1zqs*c0irtataqs*cfscheme*(-4*ctw**2*qta**2/qs*mta**2-2*ctw**
     & 2*qta**2)
     & +prop1zqs*c0irelelqs*cfscheme*(-2*ctw**2*qel**2)
     & +prop1zqs*lnlatam*cfscheme*(2*ctw**2*qta**2/qs)
     & +prop1zqs*lnlaelm*cfscheme*(2*ctw**2*qel**2/qs)
     & +sdet3ctats**3*sdet4itatsus**2*jaaqstselta*dreal(propizqs)*cfsche
     & me*(ctw**2*qel*qta*mta**2-ctw**2*qel*qta*ts)
     & +sdet3ctats**2*sdet4itatsus**2*c0elelqszelc*dreal(propizqs)*stw**
     & 2*(2*qel*qta*mz**2*mta**2-2*qel*qta*ts*mz**2+2*qel*qta*qs*mta**2-
     & 2*qel*qta*qs*ts)
     & +sdet3ctats*sdet4itatsus**2*javqstseltaz*dreal(propizqs)*stw**2*(
     & -2*qel*qta*ts*mz**2*mta**2+2*qel*qta*ts**2*mz**2-2*qel*qta*qs*ts*
     & mta**2+2*qel*qta*qs*ts**2)
     & +sdet3ctats*sdet4itatsus**2*c0tataqsztac*dreal(propizqs)*stw**2*(
     & -2*qel*qta*mz**2*mta**4+4*qel*qta*ts*mz**2*mta**2-2*qel*qta*ts**2
     & *mz**2-2*qel*qta*qs*mta**4+4*qel*qta*qs*ts*mta**2-2*qel*qta*qs*ts
     & **2)
     & +sdet3ctats*sdet4itatsus**2*c0tataqsctac*dreal(propizqs)*cfscheme
     & *(8*ctw**2*qel*qta*qs*mta**4+2*ctw**2*qel*qta*qs**2*mta**2)
     & +sdet3ctats*sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*stw**2*(-
     & 4*qel*qta*ts*mz**2*mta**2+4*qel*qta*ts**2*mz**2-4*qel*qta*qs*ts*m
     & ta**2+4*qel*qta*qs*ts**2)
     & +sdet3ctats*sdet4itatsus*jaaqstselta*dreal(propizqs)*cfscheme*(ct
     & w**2*qel*qta*ts)
     & +sdet3ctats*sdet4itatsus*javqstseltaz*dreal(propizqs)*stw**2*(-2*
     & qel*qta/qs*mz**2*mta**2-4*qel*qta*mta**2+4*qel*qta*ts)
     & +sdet3ctats*sdet4itatsus*c0tataqsztac*dreal(propizqs)*stw**2*(4*q
     & el*qta*mta**2)
     & +sdet3ctats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*stw**2*(-8*q
     & el*qta*mta**2+8*qel*qta*ts)
     & +sdet3ctats*sdet4itatsus*b0fqscc*dreal(propizqs)*cfscheme*(-2*ctw
     & **2*qel*qta)
     & +sdet3ctats*sdet4itatsus*b0ftstac*dreal(propizqs)*cfscheme*(2*ctw
     & **2*qel*qta)
     & +sdet3ctats*jaaqstselta*dreal(propizqs)*cfscheme*(2*ctw**2*qel*qt
     & a/qs)
     & +sdet3ctats*javqstseltaz*stw**2*(4*qel*qta)
     & +sdet3ctats*c0ireltats*stw**2*(-4*qel*qta)
     & +sdet3ctats*c0ctatsczta*stw**2*(4*qel*qta)
     & +sdet3ctaus**3*sdet4itatsus**2*jaaqsuselta*dreal(propizqs)*cfsche
     & me*(-ctw**2*qel*qta*mta**2+ctw**2*qel*qta*ts)
     & +sdet3ctaus*sdet4itatsus**2*javqsuseltaz*dreal(propizqs)*(-qel*mz
     & **2*mta**4+qel*us*mz**2*mta**2-qel*qs*mta**4+qel*qs*us*mta**2+qel
     & *vmata*mz**2*mta**4-qel*vmata*us*mz**2*mta**2+qel*vmata*qs*mta**4
     & -qel*vmata*qs*us*mta**2)
     & +sdet3ctaus*sdet4itatsus**2*c0tataqsztac*dreal(propizqs)*(2*qel*m
     & z**2*mta**4-qel*us*mz**2*mta**2-qel*ts*mz**2*mta**2+2*qel*qs*mta*
     & *4-qel*qs*us*mta**2-qel*qs*ts*mta**2-2*qel*vmata*mz**2*mta**4+qel
     & *vmata*us*mz**2*mta**2+qel*vmata*ts*mz**2*mta**2-2*qel*vmata*qs*m
     & ta**4+qel*vmata*qs*us*mta**2+qel*vmata*qs*ts*mta**2)
     & +sdet3ctaus*sdet4itatsus**2*c0elelqszelc*dreal(propizqs)*(-qel*us
     & *mz**2*mta**2+qel*ts*mz**2*mta**2-qel*qs*us*mta**2+qel*qs*ts*mta*
     & *2+qel*vmata*us*mz**2*mta**2-qel*vmata*ts*mz**2*mta**2+qel*vmata*
     & qs*us*mta**2-qel*vmata*qs*ts*mta**2)
     & +sdet3ctaus*sdet4itatsus**2*c0ctausczta*dreal(propizqs)*(-2*qel*m
     & z**2*mta**4+2*qel*us*mz**2*mta**2-2*qel*qs*mta**4+2*qel*qs*us*mta
     & **2+2*qel*vmata*mz**2*mta**4-2*qel*vmata*us*mz**2*mta**2+2*qel*vm
     & ata*qs*mta**4-2*qel*vmata*qs*us*mta**2)
     & +sdet3ctaus*sdet4itatsus*jaaqsuselta*dreal(propizqs)*cfscheme*(-c
     & tw**2*qel*qta*us)
     & +sdet3ctaus*sdet4itatsus*javqsuseltaz*dreal(propizqs)*(qel/qs*mz*
     & *2*mta**2+2*qel*mta**2-qel*vmata/qs*mz**2*mta**2-2*qel*vmata*mta*
     & *2)
     & +sdet3ctaus*sdet4itatsus*c0tataqsztac*dreal(propizqs)*(-2*qel/qs*
     & mz**2*mta**2-4*qel*mta**2+2*qel*vmata/qs*mz**2*mta**2+4*qel*vmata
     & *mta**2)
     & +sdet3ctaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*(2*qel/qs*mz
     & **2*mta**2+4*qel*mta**2-2*qel*vmata/qs*mz**2*mta**2-4*qel*vmata*m
     & ta**2)
     & +sdet3ctaus*jaaqsuselta*dreal(propizqs)*cfscheme*(-2*ctw**2*qel*q
     & ta/qs)
     & +sdet3ctaus*javqsuseltaz*stw**2*(-4*qel*qta)
     & +sdet3ctaus*c0ireltaus*stw**2*(4*qel*qta)
     & +sdet3ctaus*c0ctausczta*stw**2*(-4*qel*qta)
     & +sdet3ictats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*stw**2*(4*q
     & el*qta*ts*mz**2*mta**2)
     & +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*stw**2*(4*qel*
     & qta*ts*mta**2)
     & +sdet3ictats*sdet4itatsus*b0ftatac*dreal(propizqs)*cfscheme*(4*ct
     & w**2*qel*qta*ts*mta**2)
     & +sdet3ictats*sdet4itatsus*b0ftatac*dreal(propizqs)*stw**2*(4*qel*
     & qta*ts*mta**2)
     & +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*cfscheme*(-4*c
     & tw**2*qel*qta*ts*mta**2)
     & +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*stw**2*(-8*qel
     & *qta*ts*mta**2)
     & +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*(2*qel*mta**4-
     & 2*qel*vmata*mta**4)
     & +sdet3ictaus*sdet4itatsus*b0ftatac*dreal(propizqs)*cfscheme*(-4*c
     & tw**2*qel*qta*us*mta**2)
     & +sdet3ictaus*sdet4itatsus*b0ftatac*dreal(propizqs)*(2*qel*mta**4-
     & 2*qel*vmata*mta**4)
     & +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*cfscheme*(4*ct
     & w**2*qel*qta*us*mta**2)
     & +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*(-4*qel*mta**4
     & +4*qel*vmata*mta**4)
     & +sdet3ictaus*c0ctausczta*dreal(propizqs)*(2*qel/qs*mz**2*mta**2-2
     & *qel*vmata/qs*mz**2*mta**2)
     & +sdet4itatsus**2*c0tataqsctac*dreal(propizqs)*cfscheme*(4*ctw**2*
     & qel*qta*qs*us*mta**4-4*ctw**2*qel*qta*qs*ts*mta**4-4*ctw**2*qel*q
     & ta*qs*ts*us*mta**2+4*ctw**2*qel*qta*qs*ts**2*mta**2+ctw**2*qel*qt
     & a*qs**2*us*mta**2-ctw**2*qel*qta*qs**2*ts*mta**2-ctw**2*qel*qta*q
     & s**2*ts*us+ctw**2*qel*qta*qs**2*ts**2)
     & +sdet4itatsus**2*c0elelqscelc*dreal(propizqs)*cfscheme*(ctw**2*qe
     & l*qta*qs**2*us*mta**2-ctw**2*qel*qta*qs**2*ts*mta**2-ctw**2*qel*q
     & ta*qs**2*ts*us+ctw**2*qel*qta*qs**2*ts**2)
     & +sdet4itatsus*javqstseltaz*dreal(propizqs)*stw**2*(2*qel*qta*mta*
     & *4)
     & +sdet4itatsus*javqstseltaz*dreal(propizqs)*(qel*ts*mta**2-qel*vma
     & ta*ts*mta**2)
     & +sdet4itatsus*javqsuseltaz*dreal(propizqs)*stw**2*(2*qel*qta*mta*
     & *4)
     & +sdet4itatsus*javqsuseltaz*dreal(propizqs)*(qel*us*mta**2-qel*vma
     & ta*us*mta**2)
     & +sdet4itatsus*c0tataqsztac*dreal(propizqs)*stw**2*(8*qel*qta*ts*m
     & ta**2-2*qel*qta*ts*mz**2+2*qel*qta*qs*ts)
     & +sdet4itatsus*c0tataqsztac*dreal(propizqs)*(qel/qs*us*mz**2*mta**
     & 2-qel/qs*ts*mz**2*mta**2+4*qel*mta**4+qel*us*mta**2-qel*ts*mta**2
     & -qel*vmata/qs*us*mz**2*mta**2+qel*vmata/qs*ts*mz**2*mta**2-4*qel*
     & vmata*mta**4-qel*vmata*us*mta**2+qel*vmata*ts*mta**2)
     & +sdet4itatsus*c0tataqsctac*dreal(propizqs)*cfscheme*(-4*ctw**2*qe
     & l*qta*us*mta**2+4*ctw**2*qel*qta*ts*mta**2+2*ctw**2*qel*qta*qs*mt
     & a**2-ctw**2*qel*qta*qs*us+ctw**2*qel*qta*qs*ts)
     & +sdet4itatsus*c0elelqszelc*dreal(propizqs)*stw**2*(-2*qel*qta*ts*
     & mz**2+2*qel*qta*qs*ts)
     & +sdet4itatsus*c0elelqszelc*dreal(propizqs)*(-qel*mz**2*mta**2+qel
     & *qs*mta**2+qel*vmata*mz**2*mta**2-qel*vmata*qs*mta**2)
     & +sdet4itatsus*c0elelqscelc*dreal(propizqs)*cfscheme*(-ctw**2*qel*
     & qta*qs*us+ctw**2*qel*qta*qs*ts)
     & +sdet4itatsus*c0ctatsczta*dreal(propizqs)*stw**2*(4*qel*qta*mta**
     & 4)
     & +sdet4itatsus*c0ctatsczta*dreal(propizqs)*(2*qel*ts*mta**2-2*qel*
     & vmata*ts*mta**2)
     & +sdet4itatsus*c0ctausczta*dreal(propizqs)*stw**2*(4*qel*qta*mta**
     & 4)
     & +sdet4itatsus*c0ctausczta*dreal(propizqs)*(2*qel*us*mta**2-2*qel*
     & vmata*us*mta**2)
     & +sdet4itatsus*b0ftatac*dreal(propizqs)*cfscheme*(4*ctw**2*qel*qta
     & *mta**2)
     & +sdet4itatsus*b0fqszc*dreal(propizqs)*stw**2*(-4*qel*qta*ts)
     & +sdet4itatsus*b0fqszc*dreal(propizqs)*(-2*qel*mta**2+2*qel*vmata*
     & mta**2)
     & +sdet4itatsus*b0ftstac*dreal(propizqs)*cfscheme*(-2*ctw**2*qel*qt
     & a*mta**2)
     & +sdet4itatsus*b0ftstac*dreal(propizqs)*stw**2*(4*qel*qta*ts)
     & +sdet4itatsus*b0fustac*dreal(propizqs)*cfscheme*(-2*ctw**2*qel*qt
     & a*mta**2)
     & +sdet4itatsus*b0fustac*dreal(propizqs)*(2*qel*mta**2-2*qel*vmata*
     & mta**2)
     & +javqstseltaz*dreal(propizqs)*stw**2*(-2*qel*qta/qs*mta**2)
     & +javqstseltaz*dreal(propizqs)*(qel/qs*mta**2-qel*vmata/qs*mta**2)
     & +javqsuseltaz*dreal(propizqs)*stw**2*(-2*qel*qta/qs*mta**2)
     & +javqsuseltaz*dreal(propizqs)*(qel/qs*mta**2-qel*vmata/qs*mta**2)
     & +c0irtataqs*stw**2*(-4*qta**2*mta**2-2*qta**2*qs)
     & +c0irelelqs*stw**2*(-2*qel**2*qs)
     & +a0fel*stw**2*(-3*qel**2)
     & +a0fel*dreal(propizqs)*cfscheme*(-3*ctw**2*qel**2/qs)
     & +a0fta*stw**2*(-3*qta**2)
     & +a0fta*dreal(propizqs)*cfscheme*(-3*ctw**2*qta**2/qs)
     & +a0fta*(1d0/2*det3itataqs*qta*qs*mta**2)
     & +b0fqstata*stw**2*(-3*qta**2)
     & +b0fqstata*dreal(propizqs)*cfscheme*(-3*ctw**2*qta**2/qs)
     & +b0fqstata*(1d0/2*det3itataqs*qta*qs*mta**2)
     & +b0fqscc*stw**2*(-3*qel**2)
     & +b0fqscc*dreal(propizqs)*cfscheme*(-3*ctw**2*qel**2/qs)
     & +lnlatam*stw**2*(2*qta**2)
     & +lnlaelm*stw**2*(2*qel**2)
     & +dreal(propizqs)*cfscheme*(-ctw**2*qta**2/qs-ctw**2*qel**2/qs)-1d
     & 0/2*det3itataqs*qta*qs*mta**2

      ff_qed_ld =
     & +stw**2*(-1d0/2*det3itataqs*qta**2*qs+det3itataqs*qta**2*vmata*qs
     & )
     & +sdet3ctats**2*sdet4itatsus**2*c0elelqszelc*dreal(propizqs)*stw**
     & 2*(4*qel*qta*mz**2+4*qel*qta*qs-4*qel*qta*vmata*mz**2-4*qel*qta*v
     & mata*qs-4*qel*vmael*qta*mz**2-4*qel*vmael*qta*qs)
     & +sdet3ctats**2*sdet4itatsus*javqstseltaz*dreal(propizqs)*stw**2*(
     & 2*qel*qta/qs-4*qel*vmael*qta/qs)
     & +sdet3ctats*sdet4itatsus**2*javqstseltaz*dreal(propizqs)*stw**2*(
     & -4*qel*qta*ts*mz**2-4*qel*qta*qs*ts+4*qel*qta*vmata*ts*mz**2+4*qe
     & l*qta*vmata*qs*ts+4*qel*vmael*qta*ts*mz**2+4*qel*vmael*qta*qs*ts)
     &
     & +sdet3ctats*sdet4itatsus**2*c0tataqsztac*dreal(propizqs)*stw**2*(
     & -4*qel*qta*mz**2*mta**2+4*qel*qta*ts*mz**2-4*qel*qta*qs*mta**2+4*
     & qel*qta*qs*ts+4*qel*qta*vmata*mz**2*mta**2-4*qel*qta*vmata*ts*mz*
     & *2+4*qel*qta*vmata*qs*mta**2-4*qel*qta*vmata*qs*ts+4*qel*vmael*qt
     & a*mz**2*mta**2-4*qel*vmael*qta*ts*mz**2+4*qel*vmael*qta*qs*mta**2
     & -4*qel*vmael*qta*qs*ts)
     & +sdet3ctats*sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*stw**2*(-
     & 8*qel*qta*ts*mz**2-8*qel*qta*qs*ts+8*qel*qta*vmata*ts*mz**2+8*qel
     & *qta*vmata*qs*ts+8*qel*vmael*qta*ts*mz**2+8*qel*vmael*qta*qs*ts)
     & +sdet3ctats*sdet4itatsus*javqstseltaz*dreal(propizqs)*stw**2*(-2*
     & qel*qta/qs*mz**2-4*qel*qta+2*qel*qta*vmata/qs*mz**2+4*qel*qta*vma
     & ta+2*qel*vmael*qta/qs*mz**2+4*qel*vmael*qta)
     & +sdet3ctats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*stw**2*(-8*q
     & el*qta+8*qel*qta*vmata+8*qel*vmael*qta)
     & +sdet3ctaus**2*sdet4itatsus**2*c0elelqszelc*dreal(propizqs)*stw**
     & 2*(4*qel*qta*vmata*mz**2+4*qel*qta*vmata*qs-4*qel*vmael*qta*mz**2
     & -4*qel*vmael*qta*qs)
     & +sdet3ctaus**2*sdet4itatsus*javqsuseltaz*dreal(propizqs)*stw**2*(
     & 2*qel*qta/qs-4*qel*vmael*qta/qs)
     & +sdet3ctaus*sdet4itatsus**2*javqsuseltaz*dreal(propizqs)*stw**2*(
     & -4*qel*qta*vmata*us*mz**2-4*qel*qta*vmata*qs*us+4*qel*vmael*qta*u
     & s*mz**2+4*qel*vmael*qta*qs*us)
     & +sdet3ctaus*sdet4itatsus**2*c0tataqsztac*dreal(propizqs)*stw**2*(
     & -4*qel*qta*vmata*mz**2*mta**2+4*qel*qta*vmata*us*mz**2-4*qel*qta*
     & vmata*qs*mta**2+4*qel*qta*vmata*qs*us+4*qel*vmael*qta*mz**2*mta**
     & 2-4*qel*vmael*qta*us*mz**2+4*qel*vmael*qta*qs*mta**2-4*qel*vmael*
     & qta*qs*us)
     & +sdet3ctaus*sdet4itatsus**2*c0ctausczta*dreal(propizqs)*stw**2*(-
     & 8*qel*qta*vmata*us*mz**2-8*qel*qta*vmata*qs*us+8*qel*vmael*qta*us
     & *mz**2+8*qel*vmael*qta*qs*us)
     & +sdet3ctaus*sdet4itatsus*javqsuseltaz*dreal(propizqs)*stw**2*(-2*
     & qel*qta*vmata/qs*mz**2-4*qel*qta*vmata+2*qel*vmael*qta/qs*mz**2+4
     & *qel*vmael*qta)
     & +sdet3ctaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*stw**2*(-8*q
     & el*qta*vmata+8*qel*vmael*qta)
     & +sdet3ictats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*stw**2*(4*q
     & el*qta*ts*mz**2-4*qel*qta*vmata*ts*mz**2-4*qel*vmael*qta*ts*mz**2
     & )
     & +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*stw**2*(4*qel*
     & qta*ts-4*qel*qta*vmata*ts-4*qel*vmael*qta*ts)
     & +sdet3ictats*sdet4itatsus*b0ftatac*dreal(propizqs)*stw**2*(4*qel*
     & qta*ts-4*qel*qta*vmata*ts-4*qel*vmael*qta*ts)
     & +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*stw**2*(-8*qel
     & *qta*ts+8*qel*qta*vmata*ts+8*qel*vmael*qta*ts)
     & +sdet3ictaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*stw**2*(4*q
     & el*qta*vmata*us*mz**2-4*qel*vmael*qta*us*mz**2)
     & +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*stw**2*(4*qel*
     & qta*vmata*us-4*qel*vmael*qta*us)
     & +sdet3ictaus*sdet4itatsus*b0ftatac*dreal(propizqs)*stw**2*(4*qel*
     & qta*vmata*us-4*qel*vmael*qta*us)
     & +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*stw**2*(-8*qel
     & *qta*vmata*us+8*qel*vmael*qta*us)
     & +sdet4itatsus*c0tataqsztac*dreal(propizqs)*stw**2*(-2*qel*qta*mz*
     & *2-2*qel*qta*qs+4*qel*vmael*qta*mz**2+4*qel*vmael*qta*qs+4*det3it
     & ataqs*qel*qta*qs*mta**4-det3itataqs*qel*qta*qs*mz**2*mta**2-4*det
     & 3itataqs*qel*qta*qs*ts*mta**2+det3itataqs*qel*qta*qs*ts*mz**2-4*d
     & et3itataqs*qel*qta*vmata*qs*us*mta**2+det3itataqs*qel*qta*vmata*q
     & s*us*mz**2+4*det3itataqs*qel*qta*vmata*qs*ts*mta**2-det3itataqs*q
     & el*qta*vmata*qs*ts*mz**2-8*det3itataqs*qel*vmael*qta*qs*mta**4+2*
     & det3itataqs*qel*vmael*qta*qs*mz**2*mta**2+4*det3itataqs*qel*vmael
     & *qta*qs*us*mta**2-det3itataqs*qel*vmael*qta*qs*us*mz**2+4*det3ita
     & taqs*qel*vmael*qta*qs*ts*mta**2-det3itataqs*qel*vmael*qta*qs*ts*m
     & z**2)
     & +sdet4itatsus*c0elelqszelc*dreal(propizqs)*stw**2*(2*qel*qta*mz**
     & 2-2*qel*qta*qs-4*qel*vmael*qta*mz**2+4*qel*vmael*qta*qs)
     & +sdet4itatsus*c0ctatsczta*dreal(propizqs)*stw**2*(-4*qel*qta*ts+8
     & *qel*vmael*qta*ts)
     & +sdet4itatsus*c0ctausczta*dreal(propizqs)*stw**2*(-4*qel*qta*us+8
     & *qel*vmael*qta*us)
     & +sdet4itatsus*b0ftazta*dreal(propizqs)*stw**2*(det3itataqs*qel*qt
     & a*qs*mta**2-det3itataqs*qel*qta*qs*ts-det3itataqs*qel*qta*vmata*q
     & s*us+det3itataqs*qel*qta*vmata*qs*ts-2*det3itataqs*qel*vmael*qta*
     & qs*mta**2+det3itataqs*qel*vmael*qta*qs*us+det3itataqs*qel*vmael*q
     & ta*qs*ts)
     & +sdet4itatsus*b0ftatac*dreal(propizqs)*stw**2*(det3itataqs*qel*qt
     & a*qs*mta**2-det3itataqs*qel*qta*qs*ts-det3itataqs*qel*qta*vmata*q
     & s*us+det3itataqs*qel*qta*vmata*qs*ts-2*det3itataqs*qel*vmael*qta*
     & qs*mta**2+det3itataqs*qel*vmael*qta*qs*us+det3itataqs*qel*vmael*q
     & ta*qs*ts)
     & +sdet4itatsus*b0fqszc*dreal(propizqs)*stw**2*(-2*det3itataqs*qel*
     & qta*qs*mta**2+2*det3itataqs*qel*qta*qs*ts+2*det3itataqs*qel*qta*v
     & mata*qs*us-2*det3itataqs*qel*qta*vmata*qs*ts+4*det3itataqs*qel*vm
     & ael*qta*qs*mta**2-2*det3itataqs*qel*vmael*qta*qs*us-2*det3itataqs
     & *qel*vmael*qta*qs*ts)
     & +a0fta*stw**2*(1d0/2*det3itataqs*qta**2*qs-det3itataqs*qta**2*vma
     & ta*qs)
     & +b0fqstata*stw**2*(1d0/2*det3itataqs*qta**2*qs-det3itataqs*qta**2
     & *vmata*qs)

      ff_qed_qd =
     & +stw**2*(-1d0/2*det3itataqs*qta**2*qs+det3itataqs*qta**2*vmata*qs
     & )
     & +sdet3ctats**3*sdet4itatsus**2*jaaqstselta*dreal(propizqs)*stw**2
     & *cfscheme*(4*ctw**2*qel*qta**2)
     & +sdet3ctats**2*sdet4itatsus**2*c0elelqszelc*dreal(propizqs)*stw**
     & 2*(-4*qel*qta*vmata*mz**2-4*qel*qta*vmata*qs)
     & +sdet3ctats**2*sdet4itatsus*javqstseltaz*dreal(propizqs)*stw**2*(
     & -2*qel*qta/qs)
     & +sdet3ctats*sdet4itatsus**2*javqstseltaz*dreal(propizqs)*stw**2*(
     & 4*qel*qta*vmata*ts*mz**2+4*qel*qta*vmata*qs*ts)
     & +sdet3ctats*sdet4itatsus**2*c0tataqsztac*dreal(propizqs)*stw**2*(
     & 4*qel*qta*vmata*mz**2*mta**2-4*qel*qta*vmata*ts*mz**2+4*qel*qta*v
     & mata*qs*mta**2-4*qel*qta*vmata*qs*ts)
     & +sdet3ctats*sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*stw**2*(8
     & *qel*qta*vmata*ts*mz**2+8*qel*qta*vmata*qs*ts)
     & +sdet3ctats*sdet4itatsus*javqstseltaz*dreal(propizqs)*stw**2*(2*q
     & el*qta*vmata/qs*mz**2+4*qel*qta*vmata)
     & +sdet3ctats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*stw**2*(8*qe
     & l*qta*vmata)
     & +sdet3ctaus**3*sdet4itatsus**2*jaaqsuselta*dreal(propizqs)*stw**2
     & *cfscheme*(-4*ctw**2*qel*qta**2)
     & +sdet3ctaus**2*sdet4itatsus**2*c0elelqszelc*dreal(propizqs)*stw**
     & 2*(-4*qel*qta*mz**2-4*qel*qta*qs+4*qel*qta*vmata*mz**2+4*qel*qta*
     & vmata*qs)
     & +sdet3ctaus**2*sdet4itatsus*javqsuseltaz*dreal(propizqs)*stw**2*(
     & -2*qel*qta/qs)
     & +sdet3ctaus*sdet4itatsus**2*javqsuseltaz*dreal(propizqs)*stw**2*(
     & 4*qel*qta*us*mz**2+4*qel*qta*qs*us-4*qel*qta*vmata*us*mz**2-4*qel
     & *qta*vmata*qs*us)
     & +sdet3ctaus*sdet4itatsus**2*c0tataqsztac*dreal(propizqs)*stw**2*(
     & 4*qel*qta*mz**2*mta**2-4*qel*qta*us*mz**2+4*qel*qta*qs*mta**2-4*q
     & el*qta*qs*us-4*qel*qta*vmata*mz**2*mta**2+4*qel*qta*vmata*us*mz**
     & 2-4*qel*qta*vmata*qs*mta**2+4*qel*qta*vmata*qs*us)
     & +sdet3ctaus*sdet4itatsus**2*c0ctausczta*dreal(propizqs)*stw**2*(8
     & *qel*qta*us*mz**2+8*qel*qta*qs*us-8*qel*qta*vmata*us*mz**2-8*qel*
     & qta*vmata*qs*us)
     & +sdet3ctaus*sdet4itatsus*javqsuseltaz*dreal(propizqs)*stw**2*(2*q
     & el*qta/qs*mz**2+4*qel*qta-2*qel*qta*vmata/qs*mz**2-4*qel*qta*vmat
     & a)
     & +sdet3ctaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*stw**2*(8*qe
     & l*qta-8*qel*qta*vmata)
     & +sdet3ictats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*stw**2*(-4*
     & qel*qta*vmata*ts*mz**2)
     & +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*stw**2*(-4*qel
     & *qta*vmata*ts)
     & +sdet3ictats*sdet4itatsus*b0ftatac*dreal(propizqs)*stw**2*(-4*qel
     & *qta*vmata*ts)
     & +sdet3ictats*sdet4itatsus*b0ftatac*dreal(propizqs)*stw**2*cfschem
     & e*(8*ctw**2*qel*qta**2*ts)
     & +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*stw**2*(8*qel*
     & qta*vmata*ts)
     & +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*stw**2*cfschem
     & e*(-8*ctw**2*qel*qta**2*ts)
     & +sdet3ictaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*stw**2*(-4*
     & qel*qta*us*mz**2+4*qel*qta*vmata*us*mz**2)
     & +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*stw**2*(-4*qel
     & *qta*us+4*qel*qta*vmata*us)
     & +sdet3ictaus*sdet4itatsus*b0ftatac*dreal(propizqs)*stw**2*(-4*qel
     & *qta*us+4*qel*qta*vmata*us)
     & +sdet3ictaus*sdet4itatsus*b0ftatac*dreal(propizqs)*stw**2*cfschem
     & e*(-8*ctw**2*qel*qta**2*us)
     & +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*stw**2*(8*qel*
     & qta*us-8*qel*qta*vmata*us)
     & +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*stw**2*cfschem
     & e*(8*ctw**2*qel*qta**2*us)
     & +sdet4itatsus**2*c0tataqsctac*dreal(propizqs)*stw**2*cfscheme*(8*
     & ctw**2*qel*qta**2*qs*us*mta**2-8*ctw**2*qel*qta**2*qs*ts*mta**2+4
     & *ctw**2*qel*qta**2*qs**2*us-4*ctw**2*qel*qta**2*qs**2*ts)
     & +sdet4itatsus**2*c0elelqscelc*dreal(propizqs)*stw**2*cfscheme*(4*
     & ctw**2*qel*qta**2*qs**2*us-4*ctw**2*qel*qta**2*qs**2*ts)
     & +sdet4itatsus*c0tataqsztac*dreal(propizqs)*stw**2*(2*qel*qta*mz**
     & 2+2*qel*qta*qs-4*det3itataqs*qel*qta*qs*mta**4+det3itataqs*qel*qt
     & a*qs*mz**2*mta**2+4*det3itataqs*qel*qta*qs*us*mta**2-det3itataqs*
     & qel*qta*qs*us*mz**2-4*det3itataqs*qel*qta*vmata*qs*us*mta**2+det3
     & itataqs*qel*qta*vmata*qs*us*mz**2+4*det3itataqs*qel*qta*vmata*qs*
     & ts*mta**2-det3itataqs*qel*qta*vmata*qs*ts*mz**2)
     & +sdet4itatsus*c0tataqsctac*dreal(propizqs)*stw**2*cfscheme*(4*det
     & 3itataqs*ctw**2*qel*qta**2*qs*us*mta**2-4*det3itataqs*ctw**2*qel*
     & qta**2*qs*ts*mta**2)
     & +sdet4itatsus*c0elelqszelc*dreal(propizqs)*stw**2*(-2*qel*qta*mz*
     & *2+2*qel*qta*qs)
     & +sdet4itatsus*c0ctatsczta*dreal(propizqs)*stw**2*(4*qel*qta*ts)
     & +sdet4itatsus*c0ctausczta*dreal(propizqs)*stw**2*(4*qel*qta*us)
     & +sdet4itatsus*b0ftazta*dreal(propizqs)*stw**2*(-det3itataqs*qel*q
     & ta*qs*mta**2+det3itataqs*qel*qta*qs*us-det3itataqs*qel*qta*vmata*
     & qs*us+det3itataqs*qel*qta*vmata*qs*ts)
     & +sdet4itatsus*b0ftatac*dreal(propizqs)*stw**2*(-det3itataqs*qel*q
     & ta*qs*mta**2+det3itataqs*qel*qta*qs*us-det3itataqs*qel*qta*vmata*
     & qs*us+det3itataqs*qel*qta*vmata*qs*ts)
     & +sdet4itatsus*b0ftatac*dreal(propizqs)*stw**2*cfscheme*(2*det3ita
     & taqs*ctw**2*qel*qta**2*qs*us-2*det3itataqs*ctw**2*qel*qta**2*qs*t
     & s)
     & +sdet4itatsus*b0fqszc*dreal(propizqs)*stw**2*(2*det3itataqs*qel*q
     & ta*qs*mta**2-2*det3itataqs*qel*qta*qs*us+2*det3itataqs*qel*qta*vm
     & ata*qs*us-2*det3itataqs*qel*qta*vmata*qs*ts)
     & +sdet4itatsus*b0fqscc*dreal(propizqs)*stw**2*cfscheme*(-2*det3ita
     & taqs*ctw**2*qel*qta**2*qs*us+2*det3itataqs*ctw**2*qel*qta**2*qs*t
     & s)
     & +a0fta*stw**2*(1d0/2*det3itataqs*qta**2*qs-det3itataqs*qta**2*vma
     & ta*qs)
     & +a0fta*dreal(propizqs)*stw**2*cfscheme*(2*det3itataqs*ctw**2*qta*
     & *3)
     & +b0fqstata*stw**2*(1d0/2*det3itataqs*qta**2*qs-det3itataqs*qta**2
     & *vmata*qs)
     & +b0fqstata*dreal(propizqs)*stw**2*cfscheme*(2*det3itataqs*ctw**2*
     & qta**3)
     & +dreal(propizqs)*stw**2*cfscheme*(-2*det3itataqs*ctw**2*qta**3)

      ff_ew_ll =
     & +1d0/stw**2*(deltarhofer+deltarhobos)
     & +sdet3ctats**2*sdet4itatsus**2*d0cctataqstszczta*dreal(propizqs)*
     & (pxx2zqsc**2/ctw**2*mta**2+1d0/4*pxx2zqsc**2/ctw**2*qs-2*pxx2zqsc
     & **2/ctw**2*vmata*mta**2-1d0/2*pxx2zqsc**2/ctw**2*vmata*qs+pxx2zqs
     & c**2/ctw**2*vmata**2*mta**2+1d0/4*pxx2zqsc**2/ctw**2*vmata**2*qs-
     & 2*pxx2zqsc**2/ctw**2*vmael*mta**2-1d0/2*pxx2zqsc**2/ctw**2*vmael*
     & qs+4*pxx2zqsc**2/ctw**2*vmael*vmata*mta**2+pxx2zqsc**2/ctw**2*vma
     & el*vmata*qs-2*pxx2zqsc**2/ctw**2*vmael*vmata**2*mta**2-1d0/2*pxx2
     & zqsc**2/ctw**2*vmael*vmata**2*qs+pxx2zqsc**2/ctw**2*vmael**2*mta*
     & *2+1d0/4*pxx2zqsc**2/ctw**2*vmael**2*qs-2*pxx2zqsc**2/ctw**2*vmae
     & l**2*vmata*mta**2-1d0/2*pxx2zqsc**2/ctw**2*vmael**2*vmata*qs+2*px
     & x2zqsc**2/ctw**2*vmael**2*vmata**2*mta**2+1d0/2*pxx2zqsc**2/ctw**
     & 2*vmael**2*vmata**2*qs)
     & +sdet3ctats**2*sdet4itatsus**2*c0ccqszcz*dreal(propizqs)*(1d0/4*p
     & xx2zqsc/ctw**2*mta**2-1d0/4*pxx2zqsc/ctw**2*ts-1d0/2*pxx2zqsc/ctw
     & **2*vmata*mta**2+1d0/2*pxx2zqsc/ctw**2*vmata*ts+1d0/4*pxx2zqsc/ct
     & w**2*vmata**2*mta**2-1d0/4*pxx2zqsc/ctw**2*vmata**2*ts-1d0/2*pxx2
     & zqsc/ctw**2*vmael*mta**2+1d0/2*pxx2zqsc/ctw**2*vmael*ts+pxx2zqsc/
     & ctw**2*vmael*vmata*mta**2-pxx2zqsc/ctw**2*vmael*vmata*ts-1d0/2*px
     & x2zqsc/ctw**2*vmael*vmata**2*mta**2+1d0/2*pxx2zqsc/ctw**2*vmael*v
     & mata**2*ts+1d0/4*pxx2zqsc/ctw**2*vmael**2*mta**2-1d0/4*pxx2zqsc/c
     & tw**2*vmael**2*ts-1d0/2*pxx2zqsc/ctw**2*vmael**2*vmata*mta**2+1d0
     & /2*pxx2zqsc/ctw**2*vmael**2*vmata*ts+1d0/2*pxx2zqsc/ctw**2*vmael*
     & *2*vmata**2*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael**2*vmata**2*ts)
     & +sdet3ctats*sdet4itatsus**2*d0cctataqstszczta*dreal(propizqs)*(1d
     & 0/4*pxx2zqsc**2/ctw**2*mta**4-1d0/4*pxx2zqsc**2/ctw**2*ts*mta**2-
     & 1d0/2*pxx2zqsc**2/ctw**2*vmata*mta**4+1d0/2*pxx2zqsc**2/ctw**2*vm
     & ata*ts*mta**2+1d0/4*pxx2zqsc**2/ctw**2*vmata**2*mta**4-1d0/4*pxx2
     & zqsc**2/ctw**2*vmata**2*ts*mta**2-1d0/2*pxx2zqsc**2/ctw**2*vmael*
     & mta**4+1d0/2*pxx2zqsc**2/ctw**2*vmael*ts*mta**2+pxx2zqsc**2/ctw**
     & 2*vmael*vmata*mta**4-pxx2zqsc**2/ctw**2*vmael*vmata*ts*mta**2-1d0
     & /2*pxx2zqsc**2/ctw**2*vmael*vmata**2*mta**4+1d0/2*pxx2zqsc**2/ctw
     & **2*vmael*vmata**2*ts*mta**2+1d0/4*pxx2zqsc**2/ctw**2*vmael**2*mt
     & a**4-1d0/4*pxx2zqsc**2/ctw**2*vmael**2*ts*mta**2-1d0/2*pxx2zqsc**
     & 2/ctw**2*vmael**2*vmata*mta**4+1d0/2*pxx2zqsc**2/ctw**2*vmael**2*
     & vmata*ts*mta**2+1d0/2*pxx2zqsc**2/ctw**2*vmael**2*vmata**2*mta**4
     & -1d0/2*pxx2zqsc**2/ctw**2*vmael**2*vmata**2*ts*mta**2)
     & +sdet3ctats*sdet4itatsus**2*c0tataqsztaz*dreal(propizqs)*(pxx2zqs
     & c/ctw**2*mta**4+pxx2zqsc/ctw**2*ts*mta**2+1d0/4*pxx2zqsc/ctw**2*q
     & s*mta**2+1d0/4*pxx2zqsc/ctw**2*qs*ts-2*pxx2zqsc/ctw**2*vmata*mta*
     & *4-2*pxx2zqsc/ctw**2*vmata*ts*mta**2-1d0/2*pxx2zqsc/ctw**2*vmata*
     & qs*mta**2-1d0/2*pxx2zqsc/ctw**2*vmata*qs*ts+pxx2zqsc/ctw**2*vmata
     & **2*mta**4+pxx2zqsc/ctw**2*vmata**2*ts*mta**2+1d0/4*pxx2zqsc/ctw*
     & *2*vmata**2*qs*mta**2+1d0/4*pxx2zqsc/ctw**2*vmata**2*qs*ts-2*pxx2
     & zqsc/ctw**2*vmael*mta**4-2*pxx2zqsc/ctw**2*vmael*ts*mta**2-1d0/2*
     & pxx2zqsc/ctw**2*vmael*qs*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael*qs*ts
     & +4*pxx2zqsc/ctw**2*vmael*vmata*mta**4+4*pxx2zqsc/ctw**2*vmael*vma
     & ta*ts*mta**2+pxx2zqsc/ctw**2*vmael*vmata*qs*mta**2+pxx2zqsc/ctw**
     & 2*vmael*vmata*qs*ts-2*pxx2zqsc/ctw**2*vmael*vmata**2*mta**4-2*pxx
     & 2zqsc/ctw**2*vmael*vmata**2*ts*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael
     & *vmata**2*qs*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael*vmata**2*qs*ts+px
     & x2zqsc/ctw**2*vmael**2*mta**4+pxx2zqsc/ctw**2*vmael**2*ts*mta**2+
     & 1d0/4*pxx2zqsc/ctw**2*vmael**2*qs*mta**2+1d0/4*pxx2zqsc/ctw**2*vm
     & ael**2*qs*ts-2*pxx2zqsc/ctw**2*vmael**2*vmata*mta**4-2*pxx2zqsc/c
     & tw**2*vmael**2*vmata*ts*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael**2*vma
     & ta*qs*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael**2*vmata*qs*ts+2*pxx2zqs
     & c/ctw**2*vmael**2*vmata**2*mta**4+2*pxx2zqsc/ctw**2*vmael**2*vmat
     & a**2*ts*mta**2+1d0/2*pxx2zqsc/ctw**2*vmael**2*vmata**2*qs*mta**2+
     & 1d0/2*pxx2zqsc/ctw**2*vmael**2*vmata**2*qs*ts)
     & +sdet3ctats*sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*(-1d0/2*p
     & xx2zqsc/ctw**2*mta**4+1d0/2*pxx2zqsc/ctw**2*ts**2+pxx2zqsc/ctw**2
     & *vmata*mta**4-pxx2zqsc/ctw**2*vmata*ts**2-1d0/2*pxx2zqsc/ctw**2*v
     & mata**2*mta**4+1d0/2*pxx2zqsc/ctw**2*vmata**2*ts**2+pxx2zqsc/ctw*
     & *2*vmael*mta**4-pxx2zqsc/ctw**2*vmael*ts**2-2*pxx2zqsc/ctw**2*vma
     & el*vmata*mta**4+2*pxx2zqsc/ctw**2*vmael*vmata*ts**2+pxx2zqsc/ctw*
     & *2*vmael*vmata**2*mta**4-pxx2zqsc/ctw**2*vmael*vmata**2*ts**2-1d0
     & /2*pxx2zqsc/ctw**2*vmael**2*mta**4+1d0/2*pxx2zqsc/ctw**2*vmael**2
     & *ts**2+pxx2zqsc/ctw**2*vmael**2*vmata*mta**4-pxx2zqsc/ctw**2*vmae
     & l**2*vmata*ts**2-pxx2zqsc/ctw**2*vmael**2*vmata**2*mta**4+pxx2zqs
     & c/ctw**2*vmael**2*vmata**2*ts**2)
     & +sdet3ctats*sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*(-1d0/
     & 8/ctw**2*qs*mta**2+1d0/8/ctw**2*qs*ts+1d0/4/ctw**2*vmata*qs*mta**
     & 2-1d0/4/ctw**2*vmata*qs*ts-1d0/8/ctw**2*vmata**2*qs*mta**2+1d0/8/
     & ctw**2*vmata**2*qs*ts+1d0/4/ctw**2*vmael*qs*mta**2-1d0/4/ctw**2*v
     & mael*qs*ts-1d0/2/ctw**2*vmael*vmata*qs*mta**2+1d0/2/ctw**2*vmael*
     & vmata*qs*ts+1d0/4/ctw**2*vmael*vmata**2*qs*mta**2-1d0/4/ctw**2*vm
     & ael*vmata**2*qs*ts-1d0/8/ctw**2*vmael**2*qs*mta**2+1d0/8/ctw**2*v
     & mael**2*qs*ts+1d0/4/ctw**2*vmael**2*vmata*qs*mta**2-1d0/4/ctw**2*
     & vmael**2*vmata*qs*ts-1d0/4/ctw**2*vmael**2*vmata**2*qs*mta**2+1d0
     & /4/ctw**2*vmael**2*vmata**2*qs*ts-pxx2zqsc/ctw**2*mta**2+2*pxx2zq
     & sc/ctw**2*vmata*mta**2-pxx2zqsc/ctw**2*vmata**2*mta**2+2*pxx2zqsc
     & /ctw**2*vmael*mta**2-4*pxx2zqsc/ctw**2*vmael*vmata*mta**2+2*pxx2z
     & qsc/ctw**2*vmael*vmata**2*mta**2-pxx2zqsc/ctw**2*vmael**2*mta**2+
     & 2*pxx2zqsc/ctw**2*vmael**2*vmata*mta**2-2*pxx2zqsc/ctw**2*vmael**
     & 2*vmata**2*mta**2+1d0/8*pxx2zqsc**2/ctw**2-1d0/4*pxx2zqsc**2/ctw*
     & *2*vmata+1d0/8*pxx2zqsc**2/ctw**2*vmata**2-1d0/4*pxx2zqsc**2/ctw*
     & *2*vmael+1d0/2*pxx2zqsc**2/ctw**2*vmael*vmata-1d0/4*pxx2zqsc**2/c
     & tw**2*vmael*vmata**2+1d0/8*pxx2zqsc**2/ctw**2*vmael**2-1d0/4*pxx2
     & zqsc**2/ctw**2*vmael**2*vmata+1d0/4*pxx2zqsc**2/ctw**2*vmael**2*v
     & mata**2)
     & +sdet3ctats*sdet4itatsus*c0ccqszcz*dreal(propizqs)*(-1d0/2/ctw**2
     & *mta**2-1d0/2/ctw**2*ts+2/ctw**2*vmata*mta**2+1d0/ctw**2*vmata*ts
     & -3d0/2/ctw**2*vmata**2*mta**2-1d0/2/ctw**2*vmata**2*ts+1d0/ctw**2
     & *vmael*mta**2+1d0/ctw**2*vmael*ts-4/ctw**2*vmael*vmata*mta**2-2/c
     & tw**2*vmael*vmata*ts+3/ctw**2*vmael*vmata**2*mta**2+1d0/ctw**2*vm
     & ael*vmata**2*ts-1d0/2/ctw**2*vmael**2*mta**2-1d0/2/ctw**2*vmael**
     & 2*ts+3/ctw**2*vmael**2*vmata*mta**2+1d0/ctw**2*vmael**2*vmata*ts-
     & 3/ctw**2*vmael**2*vmata**2*mta**2-1d0/ctw**2*vmael**2*vmata**2*ts
     & )
     & +sdet3ctats*d0cctataqstszczta*dreal(propizqs)*(1d0/2/ctw**2*vmata
     & **2-1d0/ctw**2*vmael*vmata**2+1d0/2/ctw**2*vmael**2-1d0/ctw**2*vm
     & ael**2*vmata+1d0/ctw**2*vmael**2*vmata**2)
     & +sdet3ctaus**2*sdet4itatsus**2*d0cctataqsuszczta*dreal(propizqs)*
     & (pxx2zqsc**2/ctw**2*vmata**2*mta**2+1d0/4*pxx2zqsc**2/ctw**2*vmat
     & a**2*qs-2*pxx2zqsc**2/ctw**2*vmael*vmata**2*mta**2-1d0/2*pxx2zqsc
     & **2/ctw**2*vmael*vmata**2*qs+pxx2zqsc**2/ctw**2*vmael**2*mta**2+1
     & d0/4*pxx2zqsc**2/ctw**2*vmael**2*qs-2*pxx2zqsc**2/ctw**2*vmael**2
     & *vmata*mta**2-1d0/2*pxx2zqsc**2/ctw**2*vmael**2*vmata*qs+2*pxx2zq
     & sc**2/ctw**2*vmael**2*vmata**2*mta**2+1d0/2*pxx2zqsc**2/ctw**2*vm
     & ael**2*vmata**2*qs)
     & +sdet3ctaus**2*sdet4itatsus**2*c0ccqszcz*dreal(propizqs)*(1d0/4*p
     & xx2zqsc/ctw**2*vmata**2*mta**2-1d0/4*pxx2zqsc/ctw**2*vmata**2*us-
     & 1d0/2*pxx2zqsc/ctw**2*vmael*vmata**2*mta**2+1d0/2*pxx2zqsc/ctw**2
     & *vmael*vmata**2*us+1d0/4*pxx2zqsc/ctw**2*vmael**2*mta**2-1d0/4*px
     & x2zqsc/ctw**2*vmael**2*us-1d0/2*pxx2zqsc/ctw**2*vmael**2*vmata*mt
     & a**2+1d0/2*pxx2zqsc/ctw**2*vmael**2*vmata*us+1d0/2*pxx2zqsc/ctw**
     & 2*vmael**2*vmata**2*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael**2*vmata**
     & 2*us)
     & +sdet3ctaus*sdet4itatsus**2*d0cctataqsuszczta*dreal(propizqs)*(1d
     & 0/4*pxx2zqsc**2/ctw**2*vmata**2*mta**4-1d0/4*pxx2zqsc**2/ctw**2*v
     & mata**2*us*mta**2-1d0/2*pxx2zqsc**2/ctw**2*vmael*vmata**2*mta**4+
     & 1d0/2*pxx2zqsc**2/ctw**2*vmael*vmata**2*us*mta**2+1d0/4*pxx2zqsc*
     & *2/ctw**2*vmael**2*mta**4-1d0/4*pxx2zqsc**2/ctw**2*vmael**2*us*mt
     & a**2-1d0/2*pxx2zqsc**2/ctw**2*vmael**2*vmata*mta**4+1d0/2*pxx2zqs
     & c**2/ctw**2*vmael**2*vmata*us*mta**2+1d0/2*pxx2zqsc**2/ctw**2*vma
     & el**2*vmata**2*mta**4-1d0/2*pxx2zqsc**2/ctw**2*vmael**2*vmata**2*
     & us*mta**2)
     & +sdet3ctaus*sdet4itatsus**2*c0tataqsztaz*dreal(propizqs)*(pxx2zqs
     & c/ctw**2*vmata**2*mta**4+pxx2zqsc/ctw**2*vmata**2*us*mta**2+1d0/4
     & *pxx2zqsc/ctw**2*vmata**2*qs*mta**2+1d0/4*pxx2zqsc/ctw**2*vmata**
     & 2*qs*us-2*pxx2zqsc/ctw**2*vmael*vmata**2*mta**4-2*pxx2zqsc/ctw**2
     & *vmael*vmata**2*us*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael*vmata**2*qs
     & *mta**2-1d0/2*pxx2zqsc/ctw**2*vmael*vmata**2*qs*us+pxx2zqsc/ctw**
     & 2*vmael**2*mta**4+pxx2zqsc/ctw**2*vmael**2*us*mta**2+1d0/4*pxx2zq
     & sc/ctw**2*vmael**2*qs*mta**2+1d0/4*pxx2zqsc/ctw**2*vmael**2*qs*us
     & -2*pxx2zqsc/ctw**2*vmael**2*vmata*mta**4-2*pxx2zqsc/ctw**2*vmael*
     & *2*vmata*us*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael**2*vmata*qs*mta**2
     & -1d0/2*pxx2zqsc/ctw**2*vmael**2*vmata*qs*us+2*pxx2zqsc/ctw**2*vma
     & el**2*vmata**2*mta**4+2*pxx2zqsc/ctw**2*vmael**2*vmata**2*us*mta*
     & *2+1d0/2*pxx2zqsc/ctw**2*vmael**2*vmata**2*qs*mta**2+1d0/2*pxx2zq
     & sc/ctw**2*vmael**2*vmata**2*qs*us)
     & +sdet3ctaus*sdet4itatsus**2*c0ctausczta*dreal(propizqs)*(-1d0/2*p
     & xx2zqsc/ctw**2*vmata**2*mta**4+1d0/2*pxx2zqsc/ctw**2*vmata**2*us*
     & *2+pxx2zqsc/ctw**2*vmael*vmata**2*mta**4-pxx2zqsc/ctw**2*vmael*vm
     & ata**2*us**2-1d0/2*pxx2zqsc/ctw**2*vmael**2*mta**4+1d0/2*pxx2zqsc
     & /ctw**2*vmael**2*us**2+pxx2zqsc/ctw**2*vmael**2*vmata*mta**4-pxx2
     & zqsc/ctw**2*vmael**2*vmata*us**2-pxx2zqsc/ctw**2*vmael**2*vmata**
     & 2*mta**4+pxx2zqsc/ctw**2*vmael**2*vmata**2*us**2)
     & +sdet3ctaus*sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*(-1d0/
     & 8/ctw**2*vmata**2*qs*mta**2+1d0/8/ctw**2*vmata**2*qs*us+1d0/4/ctw
     & **2*vmael*vmata**2*qs*mta**2-1d0/4/ctw**2*vmael*vmata**2*qs*us-1d
     & 0/8/ctw**2*vmael**2*qs*mta**2+1d0/8/ctw**2*vmael**2*qs*us+1d0/4/c
     & tw**2*vmael**2*vmata*qs*mta**2-1d0/4/ctw**2*vmael**2*vmata*qs*us-
     & 1d0/4/ctw**2*vmael**2*vmata**2*qs*mta**2+1d0/4/ctw**2*vmael**2*vm
     & ata**2*qs*us-pxx2zqsc/ctw**2*vmata**2*mta**2+2*pxx2zqsc/ctw**2*vm
     & ael*vmata**2*mta**2-pxx2zqsc/ctw**2*vmael**2*mta**2+2*pxx2zqsc/ct
     & w**2*vmael**2*vmata*mta**2-2*pxx2zqsc/ctw**2*vmael**2*vmata**2*mt
     & a**2+1d0/8*pxx2zqsc**2/ctw**2*vmata**2-1d0/4*pxx2zqsc**2/ctw**2*v
     & mael*vmata**2+1d0/8*pxx2zqsc**2/ctw**2*vmael**2-1d0/4*pxx2zqsc**2
     & /ctw**2*vmael**2*vmata+1d0/4*pxx2zqsc**2/ctw**2*vmael**2*vmata**2
     & )
     & +sdet3ctaus*sdet4itatsus*c0ccqszcz*dreal(propizqs)*(1d0/ctw**2*vm
     & ata*mta**2-3d0/2/ctw**2*vmata**2*mta**2-1d0/2/ctw**2*vmata**2*us-
     & 2/ctw**2*vmael*vmata*mta**2+3/ctw**2*vmael*vmata**2*mta**2+1d0/ct
     & w**2*vmael*vmata**2*us-1d0/2/ctw**2*vmael**2*mta**2-1d0/2/ctw**2*
     & vmael**2*us+3/ctw**2*vmael**2*vmata*mta**2+1d0/ctw**2*vmael**2*vm
     & ata*us-3/ctw**2*vmael**2*vmata**2*mta**2-1d0/ctw**2*vmael**2*vmat
     & a**2*us)
     & +sdet3ctaus*d0cctataqsuszczta*dreal(propizqs)*(1d0/2/ctw**2-1d0/c
     & tw**2*vmata+1d0/2/ctw**2*vmata**2-1d0/ctw**2*vmael+2/ctw**2*vmael
     & *vmata-1d0/ctw**2*vmael*vmata**2+1d0/2/ctw**2*vmael**2-1d0/ctw**2
     & *vmael**2*vmata+1d0/ctw**2*vmael**2*vmata**2)
     & +sdet3itataqs*c0tataqswcw*dreal(propizqs)*(-7d0/2*mw**2*rtaw*rwz+
     & 3*mw**2*rtaw**2*rwz+1d0/2*mw**2*rtaw**3*rwz)
     & +sdet3itataqs*c0tataqswcw*(2*mw**4*rwz+11*mw**4*rtaw*rwz-26*mw**4
     & *rtaw**2*rwz+11*mw**4*rtaw**3*rwz+2*mw**4*rtaw**4*rwz)
     & +sdet3itataqs*c0tataqsztah*(-3d0/4*mw**4*rtaw/rwz**2-1d0/2*mw**4*
     & rtaw/rwz*rhw+1d0/4*mw**4*rtaw*rhw**2+2*mw**4*rtaw**2/rwz-2*mw**4*
     & rtaw**2*rhw+4*mw**4*rtaw**3)
     & +sdet3itataqs*c0tataqstazta*(-7d0/2*mw**4/rwz**3+9*mw**4/rwz**2-6
     & *mw**4/rwz-55d0/4*mw**4*rtaw/rwz**2+36*mw**4*rtaw/rwz-24*mw**4*rt
     & aw)
     & +sdet3itataqs*c0tataqstahta*(1d0/4*mw**4*rtaw*rhw**2-2*mw**4*rtaw
     & **2*rhw)
     & +sdet3itataqs*c0tataqscwc*(mw**4+11d0/2*mw**4*rtaw+6*mw**4*rtaw**
     & 2+3d0/2*mw**4*rtaw**3)
     & +sdet3itataqs*b0ftawc*dreal(propizqs)*(2*rtaw*rwz)
     & +sdet3itataqs*b0ftawc*(mw**2-2*mw**2*rwz+6*mw**2*rtaw-13*mw**2*rt
     & aw*rwz+2*mw**2*rtaw**2+7*mw**2*rtaw**2*rwz)
     & +sdet3itataqs*b0ftazta*(-7d0/2*mw**2/rwz**2+9*mw**2/rwz-6*mw**2-1
     & 3*mw**2*rtaw/rwz+36*mw**2*rtaw-1d0/4*mw**2*rtaw*rhw-24*mw**2*rtaw
     & *rwz+mw**2*rtaw**2)
     & +sdet3itataqs*b0ftahta*(3d0/4*mw**2*rtaw/rwz-mw**2*rtaw**2)
     & +sdet3itataqs*b0fqsww*dreal(propizqs)*(-7d0/2*rtaw*rwz-1d0/2*rtaw
     & **2*rwz)
     & +sdet3itataqs*b0fqsww*(2*mw**2*rwz+13*mw**2*rtaw*rwz-13*mw**2*rta
     & w**2*rwz-2*mw**2*rtaw**3*rwz)
     & +sdet3itataqs*b0fqszh*(-3d0/2*mw**2*rtaw/rwz+1d0/2*mw**2*rtaw*rhw
     & -2*mw**2*rtaw**2)
     & +sdet3itataqs*b0fqstata*(7d0/2*mw**2/rwz**2-9*mw**2/rwz+6*mw**2+5
     & 5d0/4*mw**2*rtaw/rwz-36*mw**2*rtaw-1d0/4*mw**2*rtaw*rhw+24*mw**2*
     & rtaw*rwz+2*mw**2*rtaw**2)
     & +sdet3itataqs*b0fqscc*(-mw**2-9d0/2*mw**2*rtaw-3d0/2*mw**2*rtaw**
     & 2)
     & +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*(1d0/ctw**2*mt
     & a**4+1d0/ctw**2*ts*mta**2-2/ctw**2*vmata*mta**4-2/ctw**2*vmata*ts
     & *mta**2+1d0/ctw**2*vmata**2*mta**4+1d0/ctw**2*vmata**2*ts*mta**2-
     & 2/ctw**2*vmael*mta**4-2/ctw**2*vmael*ts*mta**2+4/ctw**2*vmael*vma
     & ta*mta**4+4/ctw**2*vmael*vmata*ts*mta**2-2/ctw**2*vmael*vmata**2*
     & mta**4-2/ctw**2*vmael*vmata**2*ts*mta**2+1d0/ctw**2*vmael**2*mta*
     & *4+1d0/ctw**2*vmael**2*ts*mta**2-2/ctw**2*vmael**2*vmata*mta**4-2
     & /ctw**2*vmael**2*vmata*ts*mta**2+2/ctw**2*vmael**2*vmata**2*mta**
     & 4+2/ctw**2*vmael**2*vmata**2*ts*mta**2)
     & +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*(-1d0/ctw**2*m
     & ta**4-1d0/ctw**2*ts*mta**2+2/ctw**2*vmata*mta**4+2/ctw**2*vmata*t
     & s*mta**2-1d0/ctw**2*vmata**2*mta**4-1d0/ctw**2*vmata**2*ts*mta**2
     & +2/ctw**2*vmael*mta**4+2/ctw**2*vmael*ts*mta**2-4/ctw**2*vmael*vm
     & ata*mta**4-4/ctw**2*vmael*vmata*ts*mta**2+2/ctw**2*vmael*vmata**2
     & *mta**4+2/ctw**2*vmael*vmata**2*ts*mta**2-1d0/ctw**2*vmael**2*mta
     & **4-1d0/ctw**2*vmael**2*ts*mta**2+2/ctw**2*vmael**2*vmata*mta**4+
     & 2/ctw**2*vmael**2*vmata*ts*mta**2-2/ctw**2*vmael**2*vmata**2*mta*
     & *4-2/ctw**2*vmael**2*vmata**2*ts*mta**2)
     & +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*(1d0/ctw**2*vm
     & ata**2*mta**4+1d0/ctw**2*vmata**2*us*mta**2-2/ctw**2*vmael*vmata*
     & *2*mta**4-2/ctw**2*vmael*vmata**2*us*mta**2+1d0/ctw**2*vmael**2*m
     & ta**4+1d0/ctw**2*vmael**2*us*mta**2-2/ctw**2*vmael**2*vmata*mta**
     & 4-2/ctw**2*vmael**2*vmata*us*mta**2+2/ctw**2*vmael**2*vmata**2*mt
     & a**4+2/ctw**2*vmael**2*vmata**2*us*mta**2)
     & +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*(-1d0/ctw**2*v
     & mata**2*mta**4-1d0/ctw**2*vmata**2*us*mta**2+2/ctw**2*vmael*vmata
     & **2*mta**4+2/ctw**2*vmael*vmata**2*us*mta**2-1d0/ctw**2*vmael**2*
     & mta**4-1d0/ctw**2*vmael**2*us*mta**2+2/ctw**2*vmael**2*vmata*mta*
     & *4+2/ctw**2*vmael**2*vmata*us*mta**2-2/ctw**2*vmael**2*vmata**2*m
     & ta**4-2/ctw**2*vmael**2*vmata**2*us*mta**2)
     & +sdet4itatsus**2*d0cctataqstswcwc*dreal(propizqs)*(4*mw**10*rtaw*
     & *3*rwz-4*mw**10*rtaw**4*rwz+mw**10*rtaw**5*rwz+4*ts*mw**8*rtaw**2
     & *rwz-8*ts*mw**8*rtaw**3*rwz+3*ts*mw**8*rtaw**4*rwz-4*ts**2*mw**6*
     & rtaw*rwz+2*ts**2*mw**6*rtaw**3*rwz-4*ts**3*mw**4*rwz+8*ts**3*mw**
     & 4*rtaw*rwz-2*ts**3*mw**4*rtaw**2*rwz+4*ts**4*mw**2*rwz-3*ts**4*mw
     & **2*rtaw*rwz-ts**5*rwz)
     & +sdet4itatsus**2*d0cctataqstszczta*dreal(propizqs)*(1d0/4*pxx2zqs
     & c**2/ctw**2*us*mta**4-1d0/4*pxx2zqsc**2/ctw**2*ts*mta**4-1d0/2*px
     & x2zqsc**2/ctw**2*vmata*us*mta**4+1d0/2*pxx2zqsc**2/ctw**2*vmata*t
     & s*mta**4+1d0/4*pxx2zqsc**2/ctw**2*vmata**2*us*mta**4-1d0/4*pxx2zq
     & sc**2/ctw**2*vmata**2*ts*mta**4-1d0/2*pxx2zqsc**2/ctw**2*vmael*us
     & *mta**4+1d0/2*pxx2zqsc**2/ctw**2*vmael*ts*mta**4+pxx2zqsc**2/ctw*
     & *2*vmael*vmata*us*mta**4-pxx2zqsc**2/ctw**2*vmael*vmata*ts*mta**4
     & -1d0/2*pxx2zqsc**2/ctw**2*vmael*vmata**2*us*mta**4+1d0/2*pxx2zqsc
     & **2/ctw**2*vmael*vmata**2*ts*mta**4+1d0/4*pxx2zqsc**2/ctw**2*vmae
     & l**2*us*mta**4-1d0/4*pxx2zqsc**2/ctw**2*vmael**2*ts*mta**4-1d0/2*
     & pxx2zqsc**2/ctw**2*vmael**2*vmata*us*mta**4+1d0/2*pxx2zqsc**2/ctw
     & **2*vmael**2*vmata*ts*mta**4+1d0/2*pxx2zqsc**2/ctw**2*vmael**2*vm
     & ata**2*us*mta**4-1d0/2*pxx2zqsc**2/ctw**2*vmael**2*vmata**2*ts*mt
     & a**4)
     & +sdet4itatsus**2*d0cctataqsuszczta*dreal(propizqs)*(-1d0/4*pxx2zq
     & sc**2/ctw**2*vmata**2*us*mta**4+1d0/4*pxx2zqsc**2/ctw**2*vmata**2
     & *ts*mta**4+1d0/2*pxx2zqsc**2/ctw**2*vmael*vmata**2*us*mta**4-1d0/
     & 2*pxx2zqsc**2/ctw**2*vmael*vmata**2*ts*mta**4-1d0/4*pxx2zqsc**2/c
     & tw**2*vmael**2*us*mta**4+1d0/4*pxx2zqsc**2/ctw**2*vmael**2*ts*mta
     & **4+1d0/2*pxx2zqsc**2/ctw**2*vmael**2*vmata*us*mta**4-1d0/2*pxx2z
     & qsc**2/ctw**2*vmael**2*vmata*ts*mta**4-1d0/2*pxx2zqsc**2/ctw**2*v
     & mael**2*vmata**2*us*mta**4+1d0/2*pxx2zqsc**2/ctw**2*vmael**2*vmat
     & a**2*ts*mta**4)
     & +sdet4itatsus**2*c0tataqswcw*dreal(propizqs)*(-2/ts*mw**10*rtaw**
     & 4*rwz+1d0/ts*mw**10*rtaw**5*rwz+mw**8*rtaw**4*rwz+4*ts*mw**6*rtaw
     & **2*rwz-2*ts*mw**6*rtaw**3*rwz-2*ts**2*mw**4*rtaw**2*rwz-2*ts**3*
     & mw**2*rwz+ts**3*mw**2*rtaw*rwz+ts**4*rwz)
     & +sdet4itatsus**2*c0ctatscwc*dreal(propizqs)*(-4*mw**8*rtaw**3*rwz
     & +2*mw**8*rtaw**4*rwz-4*ts*mw**6*rtaw**2*rwz+4*ts*mw**6*rtaw**3*rw
     & z+4*ts**2*mw**4*rtaw*rwz+4*ts**3*mw**2*rwz-4*ts**3*mw**2*rtaw*rwz
     & -2*ts**4*rwz)
     & +sdet4itatsus**2*c0ccqswcw*dreal(propizqs)*(2/ts*mw**10*rtaw**4*r
     & wz-1d0/ts*mw**10*rtaw**5*rwz+4*mw**8*rtaw**3*rwz-3*mw**8*rtaw**4*
     & rwz-2*ts*mw**6*rtaw**3*rwz-4*ts**2*mw**4*rtaw*rwz+2*ts**2*mw**4*r
     & taw**2*rwz-2*ts**3*mw**2*rwz+3*ts**3*mw**2*rtaw*rwz+ts**4*rwz)
     & +sdet4itatsus**2*c0ccqszcz*dreal(propizqs)*(-1d0/4*pxx2zqsc/ctw**
     & 2*qs*mta**4+1d0/4*pxx2zqsc/ctw**2*qs*ts*mta**2+1d0/2*pxx2zqsc/ctw
     & **2*vmata*qs*mta**4-1d0/2*pxx2zqsc/ctw**2*vmata*qs*ts*mta**2-1d0/
     & 2*pxx2zqsc/ctw**2*vmata**2*qs*mta**4+1d0/4*pxx2zqsc/ctw**2*vmata*
     & *2*qs*us*mta**2+1d0/4*pxx2zqsc/ctw**2*vmata**2*qs*ts*mta**2+1d0/2
     & *pxx2zqsc/ctw**2*vmael*qs*mta**4-1d0/2*pxx2zqsc/ctw**2*vmael*qs*t
     & s*mta**2-pxx2zqsc/ctw**2*vmael*vmata*qs*mta**4+pxx2zqsc/ctw**2*vm
     & ael*vmata*qs*ts*mta**2+pxx2zqsc/ctw**2*vmael*vmata**2*qs*mta**4-1
     & d0/2*pxx2zqsc/ctw**2*vmael*vmata**2*qs*us*mta**2-1d0/2*pxx2zqsc/c
     & tw**2*vmael*vmata**2*qs*ts*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael**2*
     & qs*mta**4+1d0/4*pxx2zqsc/ctw**2*vmael**2*qs*us*mta**2+1d0/4*pxx2z
     & qsc/ctw**2*vmael**2*qs*ts*mta**2+pxx2zqsc/ctw**2*vmael**2*vmata*q
     & s*mta**4-1d0/2*pxx2zqsc/ctw**2*vmael**2*vmata*qs*us*mta**2-1d0/2*
     & pxx2zqsc/ctw**2*vmael**2*vmata*qs*ts*mta**2-pxx2zqsc/ctw**2*vmael
     & **2*vmata**2*qs*mta**4+1d0/2*pxx2zqsc/ctw**2*vmael**2*vmata**2*qs
     & *us*mta**2+1d0/2*pxx2zqsc/ctw**2*vmael**2*vmata**2*qs*ts*mta**2)
     & +sdet4itatsus*d0cctataqstswcwc*dreal(propizqs)*(2*mw**6*rtaw*rwz-
     & 2*mw**6*rtaw**2*rwz+mw**6*rtaw**3*rwz-2*ts*mw**4*rwz-2*ts*mw**4*r
     & taw*rwz+2*ts*mw**4*rtaw**2*rwz+ts**2*mw**2*rtaw*rwz)
     & +sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*(-1d0/8/ctw**2*qs
     & *us*mta**2+1d0/8/ctw**2*qs*ts*mta**2+1d0/4/ctw**2*vmata*qs*us*mta
     & **2-1d0/4/ctw**2*vmata*qs*ts*mta**2-1d0/8/ctw**2*vmata**2*qs*us*m
     & ta**2+1d0/8/ctw**2*vmata**2*qs*ts*mta**2+1d0/4/ctw**2*vmael*qs*us
     & *mta**2-1d0/4/ctw**2*vmael*qs*ts*mta**2-1d0/2/ctw**2*vmael*vmata*
     & qs*us*mta**2+1d0/2/ctw**2*vmael*vmata*qs*ts*mta**2+1d0/4/ctw**2*v
     & mael*vmata**2*qs*us*mta**2-1d0/4/ctw**2*vmael*vmata**2*qs*ts*mta*
     & *2-1d0/8/ctw**2*vmael**2*qs*us*mta**2+1d0/8/ctw**2*vmael**2*qs*ts
     & *mta**2+1d0/4/ctw**2*vmael**2*vmata*qs*us*mta**2-1d0/4/ctw**2*vma
     & el**2*vmata*qs*ts*mta**2-1d0/4/ctw**2*vmael**2*vmata**2*qs*us*mta
     & **2+1d0/4/ctw**2*vmael**2*vmata**2*qs*ts*mta**2+3d0/4*pxx2zqsc/ct
     & w**2*mta**4-3d0/4*pxx2zqsc/ctw**2*ts**2-1d0/4*pxx2zqsc/ctw**2*qs*
     & mta**2-pxx2zqsc/ctw**2*vmata*mta**4+1d0/2*pxx2zqsc/ctw**2*vmata*t
     & s*mta**2+3d0/2*pxx2zqsc/ctw**2*vmata*ts**2+1d0/2*pxx2zqsc/ctw**2*
     & vmata*qs*mta**2+1d0/4*pxx2zqsc/ctw**2*vmata**2*mta**4-1d0/2*pxx2z
     & qsc/ctw**2*vmata**2*ts*mta**2-3d0/4*pxx2zqsc/ctw**2*vmata**2*ts**
     & 2-1d0/4*pxx2zqsc/ctw**2*vmata**2*qs*mta**2-3d0/2*pxx2zqsc/ctw**2*
     & vmael*mta**4+3d0/2*pxx2zqsc/ctw**2*vmael*ts**2+1d0/2*pxx2zqsc/ctw
     & **2*vmael*qs*mta**2+2*pxx2zqsc/ctw**2*vmael*vmata*mta**4-pxx2zqsc
     & /ctw**2*vmael*vmata*ts*mta**2-3*pxx2zqsc/ctw**2*vmael*vmata*ts**2
     & -pxx2zqsc/ctw**2*vmael*vmata*qs*mta**2-1d0/2*pxx2zqsc/ctw**2*vmae
     & l*vmata**2*mta**4+pxx2zqsc/ctw**2*vmael*vmata**2*ts*mta**2+3d0/2*
     & pxx2zqsc/ctw**2*vmael*vmata**2*ts**2+1d0/2*pxx2zqsc/ctw**2*vmael*
     & vmata**2*qs*mta**2+3d0/4*pxx2zqsc/ctw**2*vmael**2*mta**4-3d0/4*px
     & x2zqsc/ctw**2*vmael**2*ts**2-1d0/4*pxx2zqsc/ctw**2*vmael**2*qs*mt
     & a**2-1d0/2*pxx2zqsc/ctw**2*vmael**2*vmata*mta**4+pxx2zqsc/ctw**2*
     & vmael**2*vmata*ts*mta**2+3d0/2*pxx2zqsc/ctw**2*vmael**2*vmata*ts*
     & *2+1d0/2*pxx2zqsc/ctw**2*vmael**2*vmata*qs*mta**2+1d0/2*pxx2zqsc/
     & ctw**2*vmael**2*vmata**2*mta**4-pxx2zqsc/ctw**2*vmael**2*vmata**2
     & *ts*mta**2-3d0/2*pxx2zqsc/ctw**2*vmael**2*vmata**2*ts**2-1d0/2*px
     & x2zqsc/ctw**2*vmael**2*vmata**2*qs*mta**2+1d0/2*pxx2zqsc**2/ctw**
     & 2*mta**2-pxx2zqsc**2/ctw**2*vmata*mta**2+1d0/2*pxx2zqsc**2/ctw**2
     & *vmata**2*mta**2-pxx2zqsc**2/ctw**2*vmael*mta**2+2*pxx2zqsc**2/ct
     & w**2*vmael*vmata*mta**2-pxx2zqsc**2/ctw**2*vmael*vmata**2*mta**2+
     & 1d0/2*pxx2zqsc**2/ctw**2*vmael**2*mta**2-pxx2zqsc**2/ctw**2*vmael
     & **2*vmata*mta**2+pxx2zqsc**2/ctw**2*vmael**2*vmata**2*mta**2)
     & +sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*(1d0/8/ctw**2*vma
     & ta**2*qs*us*mta**2-1d0/8/ctw**2*vmata**2*qs*ts*mta**2-1d0/4/ctw**
     & 2*vmael*vmata**2*qs*us*mta**2+1d0/4/ctw**2*vmael*vmata**2*qs*ts*m
     & ta**2+1d0/8/ctw**2*vmael**2*qs*us*mta**2-1d0/8/ctw**2*vmael**2*qs
     & *ts*mta**2-1d0/4/ctw**2*vmael**2*vmata*qs*us*mta**2+1d0/4/ctw**2*
     & vmael**2*vmata*qs*ts*mta**2+1d0/4/ctw**2*vmael**2*vmata**2*qs*us*
     & mta**2-1d0/4/ctw**2*vmael**2*vmata**2*qs*ts*mta**2+1d0/2*pxx2zqsc
     & /ctw**2*vmata*mta**4+1d0/2*pxx2zqsc/ctw**2*vmata*us*mta**2+1d0/4*
     & pxx2zqsc/ctw**2*vmata**2*mta**4-1d0/2*pxx2zqsc/ctw**2*vmata**2*us
     & *mta**2-3d0/4*pxx2zqsc/ctw**2*vmata**2*us**2-1d0/4*pxx2zqsc/ctw**
     & 2*vmata**2*qs*mta**2-pxx2zqsc/ctw**2*vmael*vmata*mta**4-pxx2zqsc/
     & ctw**2*vmael*vmata*us*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael*vmata**2
     & *mta**4+pxx2zqsc/ctw**2*vmael*vmata**2*us*mta**2+3d0/2*pxx2zqsc/c
     & tw**2*vmael*vmata**2*us**2+1d0/2*pxx2zqsc/ctw**2*vmael*vmata**2*q
     & s*mta**2+3d0/4*pxx2zqsc/ctw**2*vmael**2*mta**4-3d0/4*pxx2zqsc/ctw
     & **2*vmael**2*us**2-1d0/4*pxx2zqsc/ctw**2*vmael**2*qs*mta**2-1d0/2
     & *pxx2zqsc/ctw**2*vmael**2*vmata*mta**4+pxx2zqsc/ctw**2*vmael**2*v
     & mata*us*mta**2+3d0/2*pxx2zqsc/ctw**2*vmael**2*vmata*us**2+1d0/2*p
     & xx2zqsc/ctw**2*vmael**2*vmata*qs*mta**2+1d0/2*pxx2zqsc/ctw**2*vma
     & el**2*vmata**2*mta**4-pxx2zqsc/ctw**2*vmael**2*vmata**2*us*mta**2
     & -3d0/2*pxx2zqsc/ctw**2*vmael**2*vmata**2*us**2-1d0/2*pxx2zqsc/ctw
     & **2*vmael**2*vmata**2*qs*mta**2+1d0/2*pxx2zqsc**2/ctw**2*vmata**2
     & *mta**2-pxx2zqsc**2/ctw**2*vmael*vmata**2*mta**2+1d0/2*pxx2zqsc**
     & 2/ctw**2*vmael**2*mta**2-pxx2zqsc**2/ctw**2*vmael**2*vmata*mta**2
     & +pxx2zqsc**2/ctw**2*vmael**2*vmata**2*mta**2)
     & +sdet4itatsus*c0tataqswcw*dreal(propizqs)*(-2/ts*mw**6*rtaw**2*rw
     & z+1d0/ts*mw**6*rtaw**3*rwz+2*mw**4*rtaw**2*rwz-2*ts*mw**2*rwz+ts*
     & mw**2*rtaw*rwz)
     & +sdet4itatsus*c0tataqsztaz*dreal(propizqs)*(1d0/2/ctw**2*mta**4-1
     & d0/2/ctw**2*ts**2-1d0/ctw**2*vmata*mta**4+1d0/ctw**2*vmata*ts**2+
     & 1d0/ctw**2*vmata**2*mta**4-1d0/2/ctw**2*vmata**2*us**2-1d0/2/ctw*
     & *2*vmata**2*ts**2-1d0/ctw**2*vmael*mta**4+1d0/ctw**2*vmael*ts**2+
     & 2/ctw**2*vmael*vmata*mta**4-2/ctw**2*vmael*vmata*ts**2-2/ctw**2*v
     & mael*vmata**2*mta**4+1d0/ctw**2*vmael*vmata**2*us**2+1d0/ctw**2*v
     & mael*vmata**2*ts**2+1d0/ctw**2*vmael**2*mta**4-1d0/2/ctw**2*vmael
     & **2*us**2-1d0/2/ctw**2*vmael**2*ts**2-2/ctw**2*vmael**2*vmata*mta
     & **4+1d0/ctw**2*vmael**2*vmata*us**2+1d0/ctw**2*vmael**2*vmata*ts*
     & *2+2/ctw**2*vmael**2*vmata**2*mta**4-1d0/ctw**2*vmael**2*vmata**2
     & *us**2-1d0/ctw**2*vmael**2*vmata**2*ts**2+1d0/2*pxx2zqsc/ctw**2*m
     & ta**2-pxx2zqsc/ctw**2*vmata*mta**2+pxx2zqsc/ctw**2*vmata**2*mta**
     & 2-pxx2zqsc/ctw**2*vmael*mta**2+2*pxx2zqsc/ctw**2*vmael*vmata*mta*
     & *2-2*pxx2zqsc/ctw**2*vmael*vmata**2*mta**2+pxx2zqsc/ctw**2*vmael*
     & *2*mta**2-2*pxx2zqsc/ctw**2*vmael**2*vmata*mta**2+2*pxx2zqsc/ctw*
     & *2*vmael**2*vmata**2*mta**2)
     & +sdet4itatsus*c0ctatscwc*dreal(propizqs)*(2*ts*mw**2*rtaw*rwz+2*t
     & s**2*rwz)
     & +sdet4itatsus*c0ctatsczta*dreal(propizqs)*(1d0/ctw**2*ts*mta**2+1
     & d0/ctw**2*ts**2-1d0/ctw**2*vmata*mta**4-3/ctw**2*vmata*ts*mta**2-
     & 2/ctw**2*vmata*ts**2+1d0/ctw**2*vmata**2*mta**4+2/ctw**2*vmata**2
     & *ts*mta**2+1d0/ctw**2*vmata**2*ts**2-2/ctw**2*vmael*ts*mta**2-2/c
     & tw**2*vmael*ts**2+2/ctw**2*vmael*vmata*mta**4+6/ctw**2*vmael*vmat
     & a*ts*mta**2+4/ctw**2*vmael*vmata*ts**2-2/ctw**2*vmael*vmata**2*mt
     & a**4-4/ctw**2*vmael*vmata**2*ts*mta**2-2/ctw**2*vmael*vmata**2*ts
     & **2+1d0/ctw**2*vmael**2*ts*mta**2+1d0/ctw**2*vmael**2*ts**2-2/ctw
     & **2*vmael**2*vmata*mta**4-4/ctw**2*vmael**2*vmata*ts*mta**2-2/ctw
     & **2*vmael**2*vmata*ts**2+2/ctw**2*vmael**2*vmata**2*mta**4+4/ctw*
     & *2*vmael**2*vmata**2*ts*mta**2+2/ctw**2*vmael**2*vmata**2*ts**2)
     & +sdet4itatsus*c0ctausczta*dreal(propizqs)*(-1d0/ctw**2*vmata*mta*
     & *4-1d0/ctw**2*vmata*us*mta**2+1d0/ctw**2*vmata**2*mta**4+2/ctw**2
     & *vmata**2*us*mta**2+1d0/ctw**2*vmata**2*us**2+2/ctw**2*vmael*vmat
     & a*mta**4+2/ctw**2*vmael*vmata*us*mta**2-2/ctw**2*vmael*vmata**2*m
     & ta**4-4/ctw**2*vmael*vmata**2*us*mta**2-2/ctw**2*vmael*vmata**2*u
     & s**2+1d0/ctw**2*vmael**2*us*mta**2+1d0/ctw**2*vmael**2*us**2-2/ct
     & w**2*vmael**2*vmata*mta**4-4/ctw**2*vmael**2*vmata*us*mta**2-2/ct
     & w**2*vmael**2*vmata*us**2+2/ctw**2*vmael**2*vmata**2*mta**4+4/ctw
     & **2*vmael**2*vmata**2*us*mta**2+2/ctw**2*vmael**2*vmata**2*us**2)
     &
     & +sdet4itatsus*c0ccqswcw*dreal(propizqs)*(2/ts*mw**6*rtaw**2*rwz-1
     & d0/ts*mw**6*rtaw**3*rwz-2*mw**4*rtaw**2*rwz-2*ts*mw**2*rwz-ts*mw*
     & *2*rtaw*rwz)
     & +sdet4itatsus*c0ccqszcz*dreal(propizqs)*(1d0/4*pxx2zqsc/ctw**2*mt
     & a**2-1d0/4*pxx2zqsc/ctw**2*ts-1d0/2*pxx2zqsc/ctw**2*vmata*mta**2+
     & 1d0/2*pxx2zqsc/ctw**2*vmata*ts+1d0/2*pxx2zqsc/ctw**2*vmata**2*mta
     & **2-1d0/4*pxx2zqsc/ctw**2*vmata**2*us-1d0/4*pxx2zqsc/ctw**2*vmata
     & **2*ts-1d0/2*pxx2zqsc/ctw**2*vmael*mta**2+1d0/2*pxx2zqsc/ctw**2*v
     & mael*ts+pxx2zqsc/ctw**2*vmael*vmata*mta**2-pxx2zqsc/ctw**2*vmael*
     & vmata*ts-pxx2zqsc/ctw**2*vmael*vmata**2*mta**2+1d0/2*pxx2zqsc/ctw
     & **2*vmael*vmata**2*us+1d0/2*pxx2zqsc/ctw**2*vmael*vmata**2*ts+1d0
     & /2*pxx2zqsc/ctw**2*vmael**2*mta**2-1d0/4*pxx2zqsc/ctw**2*vmael**2
     & *us-1d0/4*pxx2zqsc/ctw**2*vmael**2*ts-pxx2zqsc/ctw**2*vmael**2*vm
     & ata*mta**2+1d0/2*pxx2zqsc/ctw**2*vmael**2*vmata*us+1d0/2*pxx2zqsc
     & /ctw**2*vmael**2*vmata*ts+pxx2zqsc/ctw**2*vmael**2*vmata**2*mta**
     & 2-1d0/2*pxx2zqsc/ctw**2*vmael**2*vmata**2*us-1d0/2*pxx2zqsc/ctw**
     & 2*vmael**2*vmata**2*ts)
     & +sdet4itatsus*b0ftawc*dreal(propizqs)*(4*mw**2*rtaw*rwz)
     & +sdet4itatsus*b0fqsww*dreal(propizqs)*(-2*mw**2*rtaw*rwz-2*ts*rwz
     & )
     & +sdet4itatsus*b0fqszz*dreal(propizqs)*(-1d0/2/ctw**2*mta**2-1d0/2
     & /ctw**2*ts+1d0/ctw**2*vmata*mta**2+1d0/ctw**2*vmata*ts-1d0/ctw**2
     & *vmata**2*mta**2-1d0/2/ctw**2*vmata**2*us-1d0/2/ctw**2*vmata**2*t
     & s+1d0/ctw**2*vmael*mta**2+1d0/ctw**2*vmael*ts-2/ctw**2*vmael*vmat
     & a*mta**2-2/ctw**2*vmael*vmata*ts+2/ctw**2*vmael*vmata**2*mta**2+1
     & d0/ctw**2*vmael*vmata**2*us+1d0/ctw**2*vmael*vmata**2*ts-1d0/ctw*
     & *2*vmael**2*mta**2-1d0/2/ctw**2*vmael**2*us-1d0/2/ctw**2*vmael**2
     & *ts+2/ctw**2*vmael**2*vmata*mta**2+1d0/ctw**2*vmael**2*vmata*us+1
     & d0/ctw**2*vmael**2*vmata*ts-2/ctw**2*vmael**2*vmata**2*mta**2-1d0
     & /ctw**2*vmael**2*vmata**2*us-1d0/ctw**2*vmael**2*vmata**2*ts)
     & +sdet4itatsus*b0ftstac*dreal(propizqs)*(1d0/2/ctw**2*mta**2+1d0/2
     & /ctw**2*ts-1d0/ctw**2*vmata*mta**2-1d0/ctw**2*vmata*ts+1d0/2/ctw*
     & *2*vmata**2*mta**2+1d0/2/ctw**2*vmata**2*ts-1d0/ctw**2*vmael*mta*
     & *2-1d0/ctw**2*vmael*ts+2/ctw**2*vmael*vmata*mta**2+2/ctw**2*vmael
     & *vmata*ts-1d0/ctw**2*vmael*vmata**2*mta**2-1d0/ctw**2*vmael*vmata
     & **2*ts+1d0/2/ctw**2*vmael**2*mta**2+1d0/2/ctw**2*vmael**2*ts-1d0/
     & ctw**2*vmael**2*vmata*mta**2-1d0/ctw**2*vmael**2*vmata*ts+1d0/ctw
     & **2*vmael**2*vmata**2*mta**2+1d0/ctw**2*vmael**2*vmata**2*ts)
     & +sdet4itatsus*b0ftscc*dreal(propizqs)*(-2*mw**2*rtaw*rwz+2*ts*rwz
     & )
     & +sdet4itatsus*b0fustac*dreal(propizqs)*(1d0/2/ctw**2*vmata**2*mta
     & **2+1d0/2/ctw**2*vmata**2*us-1d0/ctw**2*vmael*vmata**2*mta**2-1d0
     & /ctw**2*vmael*vmata**2*us+1d0/2/ctw**2*vmael**2*mta**2+1d0/2/ctw*
     & *2*vmael**2*us-1d0/ctw**2*vmael**2*vmata*mta**2-1d0/ctw**2*vmael*
     & *2*vmata*us+1d0/ctw**2*vmael**2*vmata**2*mta**2+1d0/ctw**2*vmael*
     & *2*vmata**2*us)
     & +d0cctataqstswcwc*dreal(propizqs)*(-ts*rwz)
     & +d0cctataqstszczta*dreal(propizqs)*(-1d0/2/ctw**2*mta**2-1d0/2/ct
     & w**2*mz**2-1d0/2/ctw**2*ts-1d0/8/ctw**2*qs+1d0/ctw**2*vmata*mta**
     & 2+1d0/ctw**2*vmata*mz**2+1d0/ctw**2*vmata*ts+1d0/4/ctw**2*vmata*q
     & s-1d0/2/ctw**2*vmata**2*mta**2-1d0/2/ctw**2*vmata**2*mz**2-1d0/2/
     & ctw**2*vmata**2*ts-1d0/8/ctw**2*vmata**2*qs+1d0/ctw**2*vmael*mta*
     & *2+1d0/ctw**2*vmael*mz**2+1d0/ctw**2*vmael*ts+1d0/4/ctw**2*vmael*
     & qs-2/ctw**2*vmael*vmata*mta**2-2/ctw**2*vmael*vmata*mz**2-2/ctw**
     & 2*vmael*vmata*ts-1d0/2/ctw**2*vmael*vmata*qs+1d0/ctw**2*vmael*vma
     & ta**2*mta**2+1d0/ctw**2*vmael*vmata**2*mz**2+1d0/ctw**2*vmael*vma
     & ta**2*ts+1d0/4/ctw**2*vmael*vmata**2*qs-1d0/2/ctw**2*vmael**2*mta
     & **2-1d0/2/ctw**2*vmael**2*mz**2-1d0/2/ctw**2*vmael**2*ts-1d0/8/ct
     & w**2*vmael**2*qs+1d0/ctw**2*vmael**2*vmata*mta**2+1d0/ctw**2*vmae
     & l**2*vmata*mz**2+1d0/ctw**2*vmael**2*vmata*ts+1d0/4/ctw**2*vmael*
     & *2*vmata*qs-1d0/ctw**2*vmael**2*vmata**2*mta**2-1d0/ctw**2*vmael*
     & *2*vmata**2*mz**2-1d0/ctw**2*vmael**2*vmata**2*ts-1d0/4/ctw**2*vm
     & ael**2*vmata**2*qs)
     & +d0cctataqsuszczta*dreal(propizqs)*(-1d0/2/ctw**2*vmata**2*mta**2
     & -1d0/2/ctw**2*vmata**2*us+1d0/8/ctw**2*vmata**2*qs+1d0/ctw**2*vma
     & el*vmata**2*mta**2+1d0/ctw**2*vmael*vmata**2*us-1d0/4/ctw**2*vmae
     & l*vmata**2*qs-1d0/2/ctw**2*vmael**2*mta**2-1d0/2/ctw**2*vmael**2*
     & us+1d0/8/ctw**2*vmael**2*qs+1d0/ctw**2*vmael**2*vmata*mta**2+1d0/
     & ctw**2*vmael**2*vmata*us-1d0/4/ctw**2*vmael**2*vmata*qs-1d0/ctw**
     & 2*vmael**2*vmata**2*mta**2-1d0/ctw**2*vmael**2*vmata**2*us+1d0/4/
     & ctw**2*vmael**2*vmata**2*qs-1d0/4*pxx2zqsc/ctw**2*vmata**2+1d0/2*
     & pxx2zqsc/ctw**2*vmael*vmata**2-1d0/4*pxx2zqsc/ctw**2*vmael**2+1d0
     & /2*pxx2zqsc/ctw**2*vmael**2*vmata-1d0/2*pxx2zqsc/ctw**2*vmael**2*
     & vmata**2)
     & +c0tataqswcw*dreal(propizqs)*(rwz)
     & +c0tataqswcw*(-4*mw**2*rwz+15d0/2*mw**2*rtaw*rwz-3*mw**2*rtaw**2*
     & rwz-1d0/2*mw**2*rtaw**3*rwz)
     & +c0tataqsztaz*dreal(propizqs)*(-1d0/2/ctw**2+1d0/ctw**2*vmata-1d0
     & /ctw**2*vmata**2+1d0/ctw**2*vmael-2/ctw**2*vmael*vmata+2/ctw**2*v
     & mael*vmata**2-1d0/ctw**2*vmael**2+2/ctw**2*vmael**2*vmata-2/ctw**
     & 2*vmael**2*vmata**2)
     & +c0tataqsztah*(-1d0/4/qs*mw**4*rtaw/rwz**2+1d0/2/qs*mw**4*rtaw/rw
     & z*rhw-1d0/4/qs*mw**4*rtaw*rhw**2+mw**2*rtaw/rwz-mw**2*rtaw**2)
     & +c0tataqstazta*(7*mw**2/rwz**2-18*mw**2/rwz+12*mw**2-5d0/2*mw**2*
     & rtaw/rwz+6*mw**2*rtaw-4*mw**2*rtaw*rwz-7d0/2*qs/rwz+9*qs-6*qs*rwz
     & )
     & +c0tataqstahta*(mw**2*rtaw**2)
     & +c0tataqscwc*(-2*mw**2-mw**2*rtaw-1d0/2*mw**2*rtaw**2+qs)
     & +c0ccqswcw*dreal(propizqs)*(rwz)
     & +c0ccqswcw*(2/qs*mw**4*rwz-4*mw**2*rwz)
     & +c0ccqszcz*dreal(propizqs)*(-1d0/2/ctw**2+1d0/ctw**2*vmata-1d0/ct
     & w**2*vmata**2+1d0/ctw**2*vmael-2/ctw**2*vmael*vmata+2/ctw**2*vmae
     & l*vmata**2-1d0/ctw**2*vmael**2+2/ctw**2*vmael**2*vmata-2/ctw**2*v
     & mael**2*vmata**2)
     & +c0ccqscwc*(1d0/qs*mw**4-2*mw**2+qs)
     & +c0ccqsczc*(-7d0/2/qs*mw**4/rwz**3+9/qs*mw**4/rwz**2-6/qs*mw**4/r
     & wz+7*mw**2/rwz**2-18*mw**2/rwz+12*mw**2-7d0/2*qs/rwz+9*qs-6*qs*rw
     & z)
     & +a0fw*dreal(propzqs)*(3*mw**2/rwz/rhw+1d0/6*mw**2/rwz-8d0/3*mw**2
     & -4*mw**2*rwz)
     & +a0fw*(7d0/4-1d0/qs*mw**2+2/qs*mw**2*rwz+1d0/2*rwz)
     & +a0fz*dreal(propzqs)*(3d0/2*mw**2/rwz**3/rhw+1d0/6*mw**2/rwz**2-1
     & d0/12*mw**2/rwz*rhw)
     & +a0fz*(27d0/2+41d0/12/qs*mw**2/rwz**2-9/qs*mw**2/rwz+1d0/12/qs*mw
     & **2/rwz*rhw+6/qs*mw**2-43d0/8/rwz-9*rwz)
     & +a0fh*dreal(propzqs)*(1d0/2*mw**2/rwz*rhw+1d0/12*mw**2*rhw**2)
     & +a0fh*(1d0/12/qs*mw**2/rwz*rhw-1d0/12/qs*mw**2*rhw**2-1d0/8*rhw)
     & +a0fta*(3d0/2-1d0/2/rwz-rwz+1d0/4*rtaw)
     & +b0ftawc*(-5d0/4+5d0/2*rwz-1d0/2*rtaw-3d0/2*rtaw*rwz)
     & +b0ftazta*(-12-1d0/4/qs*mw**2*rtaw/rwz+1d0/4/qs*mw**2*rtaw*rhw+37
     & d0/8/rwz+8*rwz)
     & +b0ftahta*(1d0/4/qs*mw**2*rtaw/rwz-1d0/4/qs*mw**2*rtaw*rhw-1d0/8*
     & rhw)
     & +b0fqsww*dreal(propzqs)*(1d0/12*mw**2/rwz**2+4d0/3*mw**2/rwz-17d0
     & /3*mw**2-4*mw**2*rwz)
     & +b0fqsww*dreal(propizqs)*(5d0/3/mw**2*rwz+1d0/4/mw**2*rtaw*rwz-1d
     & 0/12*qs/mw**4*rwz)
     & +b0fqsww*(-4d0/3+2/qs*mw**2*rwz-1d0/12/rwz+rwz+3*rtaw*rwz+1d0/2*r
     & taw**2*rwz+1d0/12*qs/mw**2-5d0/3*qs/mw**2*rwz-1d0/4*qs/mw**2*rtaw
     & *rwz+1d0/12*qs**2/mw**4*rwz)
     & +b0fqszh*dreal(propzqs)*(mw**2/rwz**2-1d0/3*mw**2/rwz*rhw+1d0/12*
     & mw**2*rhw**2)
     & +b0fqszh*(-1d0/12/qs*mw**2/rwz**2+1d0/6/qs*mw**2/rwz*rhw-1d0/12/q
     & s*mw**2*rhw**2-1d0/12/rwz+1d0/2*rtaw)
     & +b0fqstata*(27d0/2-21d0/4/rwz-9*rwz-1d0/4*rtaw)
     & +b0fqscc*(33d0/2+7d0/2/qs*mw**2/rwz**2-9/qs*mw**2/rwz+5/qs*mw**2-
     & 21d0/4/rwz-9*rwz+1d0/4*rtaw)
     & +dreal(propzqs)*(mw**2/rwz**3/rhw-1d0/18*mw**2/rwz**2+2*mw**2/rwz
     & /rhw-5d0/9*mw**2/rwz-mw**2/rwz*zmzzzbos-1d0/6*mw**2/rwz*rhw-8d0/3
     & *mw**2-4*mw**2*rwz)
     & +dreal(b0ptazta)*(-5d0/4*mw**2/rwz**2+3*mw**2/rwz-2*mw**2-7d0/4*m
     & w**2*rtaw/rwz+6*mw**2*rtaw-4*mw**2*rtaw*rwz)
     & +dreal(b0ptahta)*(-1d0/4*mw**2*rtaw*rhw+mw**2*rtaw**2)
     & +dreal(b0ptacw)*(-1d0/2*mw**2+1d0/4*mw**2*rtaw+1d0/4*mw**2*rtaw**
     & 2)
     & +b0d1tataz*(-3d0/2+1d0/2/rwz+rwz)
     & +b0dwtacw*(-1+rwz)
     & +139d0/18-197d0/72/rwz+caldzfer-2*deltarhofer-za1fer-2*deltarhobo
     & s-za1bos+2*rwz+3d0/4*rtaw-1d0/2*rtaw*rwz

      ff_ew_ql =
     & +sdet3ctats**2*sdet4itatsus**2*d0cctataqstszczta*dreal(propizqs)*
     & (pxx2zqsc**2/ctw**2*vmael*vmata**2*mta**2+1d0/4*pxx2zqsc**2/ctw**
     & 2*vmael*vmata**2*qs)
     & +sdet3ctats**2*sdet4itatsus**2*c0ccqszcz*dreal(propizqs)*(1d0/4*p
     & xx2zqsc/ctw**2*vmael*vmata**2*mta**2-1d0/4*pxx2zqsc/ctw**2*vmael*
     & vmata**2*ts)
     & +sdet3ctats*sdet4itatsus**2*d0cctataqstszczta*dreal(propizqs)*(1d
     & 0/4*pxx2zqsc**2/ctw**2*vmael*vmata**2*mta**4-1d0/4*pxx2zqsc**2/ct
     & w**2*vmael*vmata**2*ts*mta**2)
     & +sdet3ctats*sdet4itatsus**2*c0tataqsztaz*dreal(propizqs)*(pxx2zqs
     & c/ctw**2*vmael*vmata**2*mta**4+pxx2zqsc/ctw**2*vmael*vmata**2*ts*
     & mta**2+1d0/4*pxx2zqsc/ctw**2*vmael*vmata**2*qs*mta**2+1d0/4*pxx2z
     & qsc/ctw**2*vmael*vmata**2*qs*ts)
     & +sdet3ctats*sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*(-1d0/2*p
     & xx2zqsc/ctw**2*vmael*vmata**2*mta**4+1d0/2*pxx2zqsc/ctw**2*vmael*
     & vmata**2*ts**2)
     & +sdet3ctats*sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*(-1d0/
     & 8/ctw**2*vmael*vmata**2*qs*mta**2+1d0/8/ctw**2*vmael*vmata**2*qs*
     & ts-pxx2zqsc/ctw**2*vmael*vmata**2*mta**2+1d0/8*pxx2zqsc**2/ctw**2
     & *vmael*vmata**2)
     & +sdet3ctats*sdet4itatsus*c0ccqszcz*dreal(propizqs)*(1d0/ctw**2*vm
     & ael*vmata*mta**2-3d0/2/ctw**2*vmael*vmata**2*mta**2-1d0/2/ctw**2*
     & vmael*vmata**2*ts)
     & +sdet3ctats*d0cctataqstszczta*dreal(propizqs)*(1d0/2/ctw**2*vmael
     & -1d0/ctw**2*vmael*vmata+1d0/2/ctw**2*vmael*vmata**2)
     & +sdet3ctaus**2*sdet4itatsus**2*d0cctataqsuszczta*dreal(propizqs)*
     & (pxx2zqsc**2/ctw**2*vmael*mta**2+1d0/4*pxx2zqsc**2/ctw**2*vmael*q
     & s-2*pxx2zqsc**2/ctw**2*vmael*vmata*mta**2-1d0/2*pxx2zqsc**2/ctw**
     & 2*vmael*vmata*qs+pxx2zqsc**2/ctw**2*vmael*vmata**2*mta**2+1d0/4*p
     & xx2zqsc**2/ctw**2*vmael*vmata**2*qs)
     & +sdet3ctaus**2*sdet4itatsus**2*c0ccqszcz*dreal(propizqs)*(1d0/4*p
     & xx2zqsc/ctw**2*vmael*mta**2-1d0/4*pxx2zqsc/ctw**2*vmael*us-1d0/2*
     & pxx2zqsc/ctw**2*vmael*vmata*mta**2+1d0/2*pxx2zqsc/ctw**2*vmael*vm
     & ata*us+1d0/4*pxx2zqsc/ctw**2*vmael*vmata**2*mta**2-1d0/4*pxx2zqsc
     & /ctw**2*vmael*vmata**2*us)
     & +sdet3ctaus*sdet4itatsus**2*d0cctataqsuszczta*dreal(propizqs)*(1d
     & 0/4*pxx2zqsc**2/ctw**2*vmael*mta**4-1d0/4*pxx2zqsc**2/ctw**2*vmae
     & l*us*mta**2-1d0/2*pxx2zqsc**2/ctw**2*vmael*vmata*mta**4+1d0/2*pxx
     & 2zqsc**2/ctw**2*vmael*vmata*us*mta**2+1d0/4*pxx2zqsc**2/ctw**2*vm
     & ael*vmata**2*mta**4-1d0/4*pxx2zqsc**2/ctw**2*vmael*vmata**2*us*mt
     & a**2)
     & +sdet3ctaus*sdet4itatsus**2*c0tataqsztaz*dreal(propizqs)*(pxx2zqs
     & c/ctw**2*vmael*mta**4+pxx2zqsc/ctw**2*vmael*us*mta**2+1d0/4*pxx2z
     & qsc/ctw**2*vmael*qs*mta**2+1d0/4*pxx2zqsc/ctw**2*vmael*qs*us-2*px
     & x2zqsc/ctw**2*vmael*vmata*mta**4-2*pxx2zqsc/ctw**2*vmael*vmata*us
     & *mta**2-1d0/2*pxx2zqsc/ctw**2*vmael*vmata*qs*mta**2-1d0/2*pxx2zqs
     & c/ctw**2*vmael*vmata*qs*us+pxx2zqsc/ctw**2*vmael*vmata**2*mta**4+
     & pxx2zqsc/ctw**2*vmael*vmata**2*us*mta**2+1d0/4*pxx2zqsc/ctw**2*vm
     & ael*vmata**2*qs*mta**2+1d0/4*pxx2zqsc/ctw**2*vmael*vmata**2*qs*us
     & )
     & +sdet3ctaus*sdet4itatsus**2*c0ctausczta*dreal(propizqs)*(-1d0/2*p
     & xx2zqsc/ctw**2*vmael*mta**4+1d0/2*pxx2zqsc/ctw**2*vmael*us**2+pxx
     & 2zqsc/ctw**2*vmael*vmata*mta**4-pxx2zqsc/ctw**2*vmael*vmata*us**2
     & -1d0/2*pxx2zqsc/ctw**2*vmael*vmata**2*mta**4+1d0/2*pxx2zqsc/ctw**
     & 2*vmael*vmata**2*us**2)
     & +sdet3ctaus*sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*(-1d0/
     & 8/ctw**2*vmael*qs*mta**2+1d0/8/ctw**2*vmael*qs*us+1d0/4/ctw**2*vm
     & ael*vmata*qs*mta**2-1d0/4/ctw**2*vmael*vmata*qs*us-1d0/8/ctw**2*v
     & mael*vmata**2*qs*mta**2+1d0/8/ctw**2*vmael*vmata**2*qs*us-pxx2zqs
     & c/ctw**2*vmael*mta**2+2*pxx2zqsc/ctw**2*vmael*vmata*mta**2-pxx2zq
     & sc/ctw**2*vmael*vmata**2*mta**2+1d0/8*pxx2zqsc**2/ctw**2*vmael-1d
     & 0/4*pxx2zqsc**2/ctw**2*vmael*vmata+1d0/8*pxx2zqsc**2/ctw**2*vmael
     & *vmata**2)
     & +sdet3ctaus*sdet4itatsus*c0ccqszcz*dreal(propizqs)*(-1d0/2/ctw**2
     & *vmael*mta**2-1d0/2/ctw**2*vmael*us+2/ctw**2*vmael*vmata*mta**2+1
     & d0/ctw**2*vmael*vmata*us-3d0/2/ctw**2*vmael*vmata**2*mta**2-1d0/2
     & /ctw**2*vmael*vmata**2*us)
     & +sdet3ctaus*d0cctataqsuszczta*dreal(propizqs)*(1d0/2/ctw**2*vmael
     & *vmata**2)
     & +sdet3itataqs*c0tataqswcw*(-2/qs*mw**6+11d0/4*mw**4-13d0/2*mw**4*
     & rtaw+11d0/4*mw**4*rtaw**2+1d0/2*mw**4*rtaw**3)
     & +sdet3itataqs*c0tataqsztah*(-3d0/4*mw**4*rtaw/rwz**2-1d0/2*mw**4*
     & rtaw/rwz*rhw+1d0/4*mw**4*rtaw*rhw**2+2*mw**4*rtaw**2/rwz-2*mw**4*
     & rtaw**2*rhw+4*mw**4*rtaw**3)
     & +sdet3itataqs*c0tataqstazta*(-3/qs*mw**6/rwz**3+4/qs*mw**6/rwz**2
     & -7d0/2*mw**4/rwz**3+9*mw**4/rwz**2-6*mw**4/rwz-55d0/4*mw**4*rtaw/
     & rwz**2+24*mw**4*rtaw/rwz-8*mw**4*rtaw)
     & +sdet3itataqs*c0tataqstahta*(1d0/4*mw**4*rtaw*rhw**2-2*mw**4*rtaw
     & **2*rhw)
     & +sdet3itataqs*c0tataqscwc*(mw**4+11d0/2*mw**4*rtaw+6*mw**4*rtaw**
     & 2+3d0/2*mw**4*rtaw**3)
     & +sdet3itataqs*b0ftawc*(2/qs*mw**4-9d0/4*mw**2+31d0/4*mw**2*rtaw+2
     & *mw**2*rtaw**2)
     & +sdet3itataqs*b0ftazta*(-3/qs*mw**4/rwz**2+4/qs*mw**4/rwz-7d0/2*m
     & w**2/rwz**2+9*mw**2/rwz-6*mw**2-13*mw**2*rtaw/rwz+24*mw**2*rtaw-1
     & d0/4*mw**2*rtaw*rhw-8*mw**2*rtaw*rwz+mw**2*rtaw**2)
     & +sdet3itataqs*b0ftahta*(3d0/4*mw**2*rtaw/rwz-mw**2*rtaw**2)
     & +sdet3itataqs*b0fqsww*(-2/qs*mw**4+13d0/4*mw**2-13d0/4*mw**2*rtaw
     & -1d0/2*mw**2*rtaw**2)
     & +sdet3itataqs*b0fqszh*(-3d0/2*mw**2*rtaw/rwz+1d0/2*mw**2*rtaw*rhw
     & -2*mw**2*rtaw**2)
     & +sdet3itataqs*b0fqstata*(3/qs*mw**4/rwz**2-4/qs*mw**4/rwz+7d0/2*m
     & w**2/rwz**2-9*mw**2/rwz+6*mw**2+55d0/4*mw**2*rtaw/rwz-24*mw**2*rt
     & aw-1d0/4*mw**2*rtaw*rhw+8*mw**2*rtaw*rwz+2*mw**2*rtaw**2)
     & +sdet3itataqs*b0fqscc*(-mw**2-9d0/2*mw**2*rtaw-3d0/2*mw**2*rtaw**
     & 2)
     & +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*(1d0/ctw**2*vm
     & ael*vmata**2*mta**4+1d0/ctw**2*vmael*vmata**2*ts*mta**2)
     & +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*(-1d0/ctw**2*v
     & mael*vmata**2*mta**4-1d0/ctw**2*vmael*vmata**2*ts*mta**2)
     & +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*(1d0/ctw**2*vm
     & ael*mta**4+1d0/ctw**2*vmael*us*mta**2-2/ctw**2*vmael*vmata*mta**4
     & -2/ctw**2*vmael*vmata*us*mta**2+1d0/ctw**2*vmael*vmata**2*mta**4+
     & 1d0/ctw**2*vmael*vmata**2*us*mta**2)
     & +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*(-1d0/ctw**2*v
     & mael*mta**4-1d0/ctw**2*vmael*us*mta**2+2/ctw**2*vmael*vmata*mta**
     & 4+2/ctw**2*vmael*vmata*us*mta**2-1d0/ctw**2*vmael*vmata**2*mta**4
     & -1d0/ctw**2*vmael*vmata**2*us*mta**2)
     & +sdet4itatsus**2*d0cctataqstszczta*dreal(propizqs)*(1d0/4*pxx2zqs
     & c**2/ctw**2*vmael*vmata**2*us*mta**4-1d0/4*pxx2zqsc**2/ctw**2*vma
     & el*vmata**2*ts*mta**4)
     & +sdet4itatsus**2*d0cctataqsuszczta*dreal(propizqs)*(-1d0/4*pxx2zq
     & sc**2/ctw**2*vmael*us*mta**4+1d0/4*pxx2zqsc**2/ctw**2*vmael*ts*mt
     & a**4+1d0/2*pxx2zqsc**2/ctw**2*vmael*vmata*us*mta**4-1d0/2*pxx2zqs
     & c**2/ctw**2*vmael*vmata*ts*mta**4-1d0/4*pxx2zqsc**2/ctw**2*vmael*
     & vmata**2*us*mta**4+1d0/4*pxx2zqsc**2/ctw**2*vmael*vmata**2*ts*mta
     & **4)
     & +sdet4itatsus**2*c0ccqszcz*dreal(propizqs)*(-1d0/4*pxx2zqsc/ctw**
     & 2*vmael*qs*mta**4+1d0/4*pxx2zqsc/ctw**2*vmael*qs*us*mta**2+1d0/2*
     & pxx2zqsc/ctw**2*vmael*vmata*qs*mta**4-1d0/2*pxx2zqsc/ctw**2*vmael
     & *vmata*qs*us*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael*vmata**2*qs*mta**
     & 4+1d0/4*pxx2zqsc/ctw**2*vmael*vmata**2*qs*us*mta**2+1d0/4*pxx2zqs
     & c/ctw**2*vmael*vmata**2*qs*ts*mta**2)
     & +sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*(-1d0/8/ctw**2*vm
     & ael*vmata**2*qs*us*mta**2+1d0/8/ctw**2*vmael*vmata**2*qs*ts*mta**
     & 2+1d0/2*pxx2zqsc/ctw**2*vmael*vmata*mta**4+1d0/2*pxx2zqsc/ctw**2*
     & vmael*vmata*ts*mta**2+1d0/4*pxx2zqsc/ctw**2*vmael*vmata**2*mta**4
     & -1d0/2*pxx2zqsc/ctw**2*vmael*vmata**2*ts*mta**2-3d0/4*pxx2zqsc/ct
     & w**2*vmael*vmata**2*ts**2-1d0/4*pxx2zqsc/ctw**2*vmael*vmata**2*qs
     & *mta**2+1d0/2*pxx2zqsc**2/ctw**2*vmael*vmata**2*mta**2)
     & +sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*(1d0/8/ctw**2*vma
     & el*qs*us*mta**2-1d0/8/ctw**2*vmael*qs*ts*mta**2-1d0/4/ctw**2*vmae
     & l*vmata*qs*us*mta**2+1d0/4/ctw**2*vmael*vmata*qs*ts*mta**2+1d0/8/
     & ctw**2*vmael*vmata**2*qs*us*mta**2-1d0/8/ctw**2*vmael*vmata**2*qs
     & *ts*mta**2+3d0/4*pxx2zqsc/ctw**2*vmael*mta**4-3d0/4*pxx2zqsc/ctw*
     & *2*vmael*us**2-1d0/4*pxx2zqsc/ctw**2*vmael*qs*mta**2-pxx2zqsc/ctw
     & **2*vmael*vmata*mta**4+1d0/2*pxx2zqsc/ctw**2*vmael*vmata*us*mta**
     & 2+3d0/2*pxx2zqsc/ctw**2*vmael*vmata*us**2+1d0/2*pxx2zqsc/ctw**2*v
     & mael*vmata*qs*mta**2+1d0/4*pxx2zqsc/ctw**2*vmael*vmata**2*mta**4-
     & 1d0/2*pxx2zqsc/ctw**2*vmael*vmata**2*us*mta**2-3d0/4*pxx2zqsc/ctw
     & **2*vmael*vmata**2*us**2-1d0/4*pxx2zqsc/ctw**2*vmael*vmata**2*qs*
     & mta**2+1d0/2*pxx2zqsc**2/ctw**2*vmael*mta**2-pxx2zqsc**2/ctw**2*v
     & mael*vmata*mta**2+1d0/2*pxx2zqsc**2/ctw**2*vmael*vmata**2*mta**2)
     &
     & +sdet4itatsus*c0tataqsztaz*dreal(propizqs)*(1d0/2/ctw**2*vmael*mt
     & a**4-1d0/2/ctw**2*vmael*us**2-1d0/ctw**2*vmael*vmata*mta**4+1d0/c
     & tw**2*vmael*vmata*us**2+1d0/ctw**2*vmael*vmata**2*mta**4-1d0/2/ct
     & w**2*vmael*vmata**2*us**2-1d0/2/ctw**2*vmael*vmata**2*ts**2+1d0/2
     & *pxx2zqsc/ctw**2*vmael*mta**2-pxx2zqsc/ctw**2*vmael*vmata*mta**2+
     & pxx2zqsc/ctw**2*vmael*vmata**2*mta**2)
     & +sdet4itatsus*c0ctatsczta*dreal(propizqs)*(-1d0/ctw**2*vmael*vmat
     & a*mta**4-1d0/ctw**2*vmael*vmata*ts*mta**2+1d0/ctw**2*vmael*vmata*
     & *2*mta**4+2/ctw**2*vmael*vmata**2*ts*mta**2+1d0/ctw**2*vmael*vmat
     & a**2*ts**2)
     & +sdet4itatsus*c0ctausczta*dreal(propizqs)*(1d0/ctw**2*vmael*us*mt
     & a**2+1d0/ctw**2*vmael*us**2-1d0/ctw**2*vmael*vmata*mta**4-3/ctw**
     & 2*vmael*vmata*us*mta**2-2/ctw**2*vmael*vmata*us**2+1d0/ctw**2*vma
     & el*vmata**2*mta**4+2/ctw**2*vmael*vmata**2*us*mta**2+1d0/ctw**2*v
     & mael*vmata**2*us**2)
     & +sdet4itatsus*c0ccqszcz*dreal(propizqs)*(1d0/4*pxx2zqsc/ctw**2*vm
     & ael*mta**2-1d0/4*pxx2zqsc/ctw**2*vmael*us-1d0/2*pxx2zqsc/ctw**2*v
     & mael*vmata*mta**2+1d0/2*pxx2zqsc/ctw**2*vmael*vmata*us+1d0/2*pxx2
     & zqsc/ctw**2*vmael*vmata**2*mta**2-1d0/4*pxx2zqsc/ctw**2*vmael*vma
     & ta**2*us-1d0/4*pxx2zqsc/ctw**2*vmael*vmata**2*ts)
     & +sdet4itatsus*b0fqszz*dreal(propizqs)*(-1d0/2/ctw**2*vmael*mta**2
     & -1d0/2/ctw**2*vmael*us+1d0/ctw**2*vmael*vmata*mta**2+1d0/ctw**2*v
     & mael*vmata*us-1d0/ctw**2*vmael*vmata**2*mta**2-1d0/2/ctw**2*vmael
     & *vmata**2*us-1d0/2/ctw**2*vmael*vmata**2*ts)
     & +sdet4itatsus*b0ftstac*dreal(propizqs)*(1d0/2/ctw**2*vmael*vmata*
     & *2*mta**2+1d0/2/ctw**2*vmael*vmata**2*ts)
     & +sdet4itatsus*b0fustac*dreal(propizqs)*(1d0/2/ctw**2*vmael*mta**2
     & +1d0/2/ctw**2*vmael*us-1d0/ctw**2*vmael*vmata*mta**2-1d0/ctw**2*v
     & mael*vmata*us+1d0/2/ctw**2*vmael*vmata**2*mta**2+1d0/2/ctw**2*vma
     & el*vmata**2*us)
     & +d0cctataqstszczta*dreal(propizqs)*(-1d0/2/ctw**2*vmael*vmata**2*
     & mta**2-1d0/2/ctw**2*vmael*vmata**2*mz**2-1d0/2/ctw**2*vmael*vmata
     & **2*ts-1d0/8/ctw**2*vmael*vmata**2*qs)
     & +d0cctataqsuszczta*dreal(propizqs)*(-1d0/2/ctw**2*vmael*mta**2-1d
     & 0/2/ctw**2*vmael*us+1d0/8/ctw**2*vmael*qs+1d0/ctw**2*vmael*vmata*
     & mta**2+1d0/ctw**2*vmael*vmata*us-1d0/4/ctw**2*vmael*vmata*qs-1d0/
     & 2/ctw**2*vmael*vmata**2*mta**2-1d0/2/ctw**2*vmael*vmata**2*us+1d0
     & /8/ctw**2*vmael*vmata**2*qs-1d0/4*pxx2zqsc/ctw**2*vmael+1d0/2*pxx
     & 2zqsc/ctw**2*vmael*vmata-1d0/4*pxx2zqsc/ctw**2*vmael*vmata**2)
     & +c0tataqswcw*(5d0/4/qs*mw**4-1d0/qs*mw**4*rtaw+1d0/4/qs*mw**4*rta
     & w**2)
     & +c0tataqsztaz*dreal(propizqs)*(-1d0/2/ctw**2*vmael+1d0/ctw**2*vma
     & el*vmata-1d0/ctw**2*vmael*vmata**2)
     & +c0tataqsztah*(-1d0/4/qs*mw**4*rtaw/rwz**2+1d0/2/qs*mw**4*rtaw/rw
     & z*rhw-1d0/4/qs*mw**4*rtaw*rhw**2+mw**2*rtaw/rwz-mw**2*rtaw**2)
     & +c0tataqstazta*(3/qs*mw**4/rwz**2-4/qs*mw**4/rwz+7*mw**2/rwz**2-1
     & 5*mw**2/rwz+8*mw**2-5d0/2*mw**2*rtaw/rwz+6*mw**2*rtaw-4*mw**2*rta
     & w*rwz-7d0/2*qs/rwz+6*qs-2*qs*rwz)
     & +c0tataqstahta*(mw**2*rtaw**2)
     & +c0tataqscwc*(-2*mw**2-mw**2*rtaw-1d0/2*mw**2*rtaw**2+qs)
     & +c0ccqszcz*dreal(propizqs)*(-1d0/2/ctw**2*vmael+1d0/ctw**2*vmael*
     & vmata-1d0/ctw**2*vmael*vmata**2)
     & +c0ccqsczc*(-2/qs*mw**4/rwz**3+4/qs*mw**4/rwz**2-2/qs*mw**4/rwz+4
     & *mw**2/rwz**2-8*mw**2/rwz+4*mw**2-2*qs/rwz+4*qs-2*qs*rwz)
     & +a0fw*dreal(propzqs)*(3*mw**2/rwz/rhw+1d0/6*mw**2/rwz-8d0/3*mw**2
     & -4*mw**2*rwz)
     & +a0fw*(1d0/4-1d0/6/qs*mw**2+4/qs*mw**2*rwz)
     & +a0fz*dreal(propzqs)*(3d0/2*mw**2/rwz**3/rhw+1d0/6*mw**2/rwz**2-1
     & d0/12*mw**2/rwz*rhw)
     & +a0fz*(6+23d0/12/qs*mw**2/rwz**2-4/qs*mw**2/rwz+1d0/12/qs*mw**2/r
     & wz*rhw+2/qs*mw**2-25d0/8/rwz-3*rwz)
     & +a0fh*dreal(propzqs)*(1d0/2*mw**2/rwz*rhw+1d0/12*mw**2*rhw**2)
     & +a0fh*(1d0/12/qs*mw**2/rwz*rhw-1d0/12/qs*mw**2*rhw**2-1d0/8*rhw)
     & +a0fta*(-3d0/2/qs*mw**2/rwz+2/qs*mw**2-1d0/2/rwz+rwz+1d0/4*rtaw)
     & +b0ftawc*(-5d0/4+3d0/4/qs*mw**2-1d0/4/qs*mw**2*rtaw-1d0/2*rtaw)
     & +b0ftazta*(-9-1d0/4/qs*mw**2*rtaw/rwz+1d0/4/qs*mw**2*rtaw*rhw+37d
     & 0/8/rwz+4*rwz)
     & +b0ftahta*(1d0/4/qs*mw**2*rtaw/rwz-1d0/4/qs*mw**2*rtaw*rhw-1d0/8*
     & rhw)
     & +b0fqsww*dreal(propzqs)*(1d0/12*mw**2/rwz**2+4d0/3*mw**2/rwz-17d0
     & /3*mw**2-4*mw**2*rwz)
     & +b0fqsww*(1d0/6-11d0/12/qs*mw**2+4/qs*mw**2*rwz+1d0/4/qs*mw**2*rt
     & aw-1d0/12/rwz+1d0/4*rtaw)
     & +b0fqszh*dreal(propzqs)*(mw**2/rwz**2-1d0/3*mw**2/rwz*rhw+1d0/12*
     & mw**2*rhw**2)
     & +b0fqszh*(-1d0/12/qs*mw**2/rwz**2+1d0/6/qs*mw**2/rwz*rhw-1d0/12/q
     & s*mw**2*rhw**2-1d0/12/rwz+1d0/2*rtaw)
     & +b0fqstata*(9-3d0/2/qs*mw**2/rwz+2/qs*mw**2-21d0/4/rwz-3*rwz-1d0/
     & 4*rtaw)
     & +b0fqscc*(15d0/2+2/qs*mw**2/rwz**2-4/qs*mw**2/rwz+2/qs*mw**2-3/rw
     & z-3*rwz+1d0/4*rtaw)
     & +dreal(propzqs)*(mw**2/rwz**3/rhw-1d0/18*mw**2/rwz**2+2*mw**2/rwz
     & /rhw-5d0/9*mw**2/rwz-mw**2/rwz*zmzzzbos-1d0/6*mw**2/rwz*rhw-8d0/3
     & *mw**2-4*mw**2*rwz)
     & +dreal(b0ptazta)*(-5d0/4*mw**2/rwz**2+3*mw**2/rwz-2*mw**2-7d0/4*m
     & w**2*rtaw/rwz+6*mw**2*rtaw-4*mw**2*rtaw*rwz)
     & +dreal(b0ptahta)*(-1d0/4*mw**2*rtaw*rhw+mw**2*rtaw**2)
     & +dreal(b0ptacw)*(-1d0/2*mw**2+1d0/4*mw**2*rtaw+1d0/4*mw**2*rtaw**
     & 2)
     & +b0d1tataz*(3d0/2/qs*mw**2/rwz-2/qs*mw**2+1d0/2/rwz-rwz)
     & +b0dwtacw*(-1-1d0/qs*mw**2)
     & +83d0/18-3d0/2/qs*mw**2/rwz+1d0/3/qs*mw**2+4/qs*mw**2*rwz+1d0/2/q
     & s*mw**2*rtaw-85d0/36/rwz-pizgfer+caldzfer-deltarhofer-za1fer-delt
     & arhobos-za1bos-3d0/2*rwz+3d0/4*rtaw

      ff_ew_lq =
     & +sdet3ctats**2*sdet4itatsus**2*d0cctataqstszczta*dreal(propizqs)*
     & (pxx2zqsc**2/ctw**2*vmael**2*vmata*mta**2+1d0/4*pxx2zqsc**2/ctw**
     & 2*vmael**2*vmata*qs)
     & +sdet3ctats**2*sdet4itatsus**2*c0ccqszcz*dreal(propizqs)*(1d0/4*p
     & xx2zqsc/ctw**2*vmael**2*vmata*mta**2-1d0/4*pxx2zqsc/ctw**2*vmael*
     & *2*vmata*ts)
     & +sdet3ctats*sdet4itatsus**2*d0cctataqstszczta*dreal(propizqs)*(1d
     & 0/4*pxx2zqsc**2/ctw**2/vmata*mta**4-1d0/4*pxx2zqsc**2/ctw**2/vmat
     & a*ts*mta**2-1d0/2*pxx2zqsc**2/ctw**2*mta**4+1d0/2*pxx2zqsc**2/ctw
     & **2*ts*mta**2+1d0/4*pxx2zqsc**2/ctw**2*vmata*mta**4-1d0/4*pxx2zqs
     & c**2/ctw**2*vmata*ts*mta**2-1d0/2*pxx2zqsc**2/ctw**2*vmael/vmata*
     & mta**4+1d0/2*pxx2zqsc**2/ctw**2*vmael/vmata*ts*mta**2+pxx2zqsc**2
     & /ctw**2*vmael*mta**4-pxx2zqsc**2/ctw**2*vmael*ts*mta**2-1d0/2*pxx
     & 2zqsc**2/ctw**2*vmael*vmata*mta**4+1d0/2*pxx2zqsc**2/ctw**2*vmael
     & *vmata*ts*mta**2+1d0/4*pxx2zqsc**2/ctw**2*vmael**2/vmata*mta**4-1
     & d0/4*pxx2zqsc**2/ctw**2*vmael**2/vmata*ts*mta**2-1d0/2*pxx2zqsc**
     & 2/ctw**2*vmael**2*mta**4+1d0/2*pxx2zqsc**2/ctw**2*vmael**2*ts*mta
     & **2+1d0/4*pxx2zqsc**2/ctw**2*vmael**2*vmata*mta**4-1d0/4*pxx2zqsc
     & **2/ctw**2*vmael**2*vmata*ts*mta**2)
     & +sdet3ctats*sdet4itatsus**2*c0tataqsztaz*dreal(propizqs)*(pxx2zqs
     & c/ctw**2/vmata*mta**4+1d0/4*pxx2zqsc/ctw**2/vmata*qs*mta**2-2*pxx
     & 2zqsc/ctw**2*mta**4-1d0/2*pxx2zqsc/ctw**2*qs*mta**2+pxx2zqsc/ctw*
     & *2*vmata*mta**4+1d0/4*pxx2zqsc/ctw**2*vmata*qs*mta**2-2*pxx2zqsc/
     & ctw**2*vmael/vmata*mta**4-1d0/2*pxx2zqsc/ctw**2*vmael/vmata*qs*mt
     & a**2+4*pxx2zqsc/ctw**2*vmael*mta**4+pxx2zqsc/ctw**2*vmael*qs*mta*
     & *2-2*pxx2zqsc/ctw**2*vmael*vmata*mta**4-1d0/2*pxx2zqsc/ctw**2*vma
     & el*vmata*qs*mta**2+pxx2zqsc/ctw**2*vmael**2/vmata*mta**4+1d0/4*px
     & x2zqsc/ctw**2*vmael**2/vmata*qs*mta**2-2*pxx2zqsc/ctw**2*vmael**2
     & *mta**4-1d0/2*pxx2zqsc/ctw**2*vmael**2*qs*mta**2+pxx2zqsc/ctw**2*
     & vmael**2*vmata*mta**4+pxx2zqsc/ctw**2*vmael**2*vmata*ts*mta**2+1d
     & 0/4*pxx2zqsc/ctw**2*vmael**2*vmata*qs*mta**2+1d0/4*pxx2zqsc/ctw**
     & 2*vmael**2*vmata*qs*ts)
     & +sdet3ctats*sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*(-1d0/2*p
     & xx2zqsc/ctw**2/vmata*mta**4+1d0/2*pxx2zqsc/ctw**2/vmata*ts*mta**2
     & +pxx2zqsc/ctw**2*mta**4-pxx2zqsc/ctw**2*ts*mta**2-1d0/2*pxx2zqsc/
     & ctw**2*vmata*mta**4+1d0/2*pxx2zqsc/ctw**2*vmata*ts*mta**2+pxx2zqs
     & c/ctw**2*vmael/vmata*mta**4-pxx2zqsc/ctw**2*vmael/vmata*ts*mta**2
     & -2*pxx2zqsc/ctw**2*vmael*mta**4+2*pxx2zqsc/ctw**2*vmael*ts*mta**2
     & +pxx2zqsc/ctw**2*vmael*vmata*mta**4-pxx2zqsc/ctw**2*vmael*vmata*t
     & s*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael**2/vmata*mta**4+1d0/2*pxx2zq
     & sc/ctw**2*vmael**2/vmata*ts*mta**2+pxx2zqsc/ctw**2*vmael**2*mta**
     & 4-pxx2zqsc/ctw**2*vmael**2*ts*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael*
     & *2*vmata*mta**4+1d0/2*pxx2zqsc/ctw**2*vmael**2*vmata*ts**2)
     & +sdet3ctats*sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*(-1d0/
     & 8/ctw**2*vmael**2*vmata*qs*mta**2+1d0/8/ctw**2*vmael**2*vmata*qs*
     & ts-pxx2zqsc/ctw**2/vmata*mta**2+2*pxx2zqsc/ctw**2*mta**2-pxx2zqsc
     & /ctw**2*vmata*mta**2+2*pxx2zqsc/ctw**2*vmael/vmata*mta**2-4*pxx2z
     & qsc/ctw**2*vmael*mta**2+2*pxx2zqsc/ctw**2*vmael*vmata*mta**2-pxx2
     & zqsc/ctw**2*vmael**2/vmata*mta**2+2*pxx2zqsc/ctw**2*vmael**2*mta*
     & *2-pxx2zqsc/ctw**2*vmael**2*vmata*mta**2+1d0/8*pxx2zqsc**2/ctw**2
     & *vmael**2*vmata)
     & +sdet3ctats*sdet4itatsus*c0ccqszcz*dreal(propizqs)*(-1d0/2/ctw**2
     & /vmata*mta**2+1d0/ctw**2*mta**2-1d0/2/ctw**2*vmata*mta**2+1d0/ctw
     & **2*vmael/vmata*mta**2-2/ctw**2*vmael*mta**2+1d0/ctw**2*vmael*vma
     & ta*mta**2-1d0/2/ctw**2*vmael**2/vmata*mta**2+2/ctw**2*vmael**2*mt
     & a**2-3d0/2/ctw**2*vmael**2*vmata*mta**2-1d0/2/ctw**2*vmael**2*vma
     & ta*ts)
     & +sdet3ctats*d0cctataqstszczta*dreal(propizqs)*(1d0/2/ctw**2*vmata
     & -1d0/ctw**2*vmael*vmata+1d0/2/ctw**2*vmael**2*vmata)
     & +sdet3ctaus**2*sdet4itatsus**2*d0cctataqsuszczta*dreal(propizqs)*
     & (pxx2zqsc**2/ctw**2*vmata*mta**2+1d0/4*pxx2zqsc**2/ctw**2*vmata*q
     & s-2*pxx2zqsc**2/ctw**2*vmael*vmata*mta**2-1d0/2*pxx2zqsc**2/ctw**
     & 2*vmael*vmata*qs+pxx2zqsc**2/ctw**2*vmael**2*vmata*mta**2+1d0/4*p
     & xx2zqsc**2/ctw**2*vmael**2*vmata*qs)
     & +sdet3ctaus**2*sdet4itatsus**2*c0ccqszcz*dreal(propizqs)*(1d0/4*p
     & xx2zqsc/ctw**2*vmata*mta**2-1d0/4*pxx2zqsc/ctw**2*vmata*us-1d0/2*
     & pxx2zqsc/ctw**2*vmael*vmata*mta**2+1d0/2*pxx2zqsc/ctw**2*vmael*vm
     & ata*us+1d0/4*pxx2zqsc/ctw**2*vmael**2*vmata*mta**2-1d0/4*pxx2zqsc
     & /ctw**2*vmael**2*vmata*us)
     & +sdet3ctaus*sdet4itatsus**2*d0cctataqsuszczta*dreal(propizqs)*(1d
     & 0/4*pxx2zqsc**2/ctw**2*vmael**2/vmata*mta**4-1d0/4*pxx2zqsc**2/ct
     & w**2*vmael**2/vmata*us*mta**2-1d0/2*pxx2zqsc**2/ctw**2*vmael**2*m
     & ta**4+1d0/2*pxx2zqsc**2/ctw**2*vmael**2*us*mta**2+1d0/4*pxx2zqsc*
     & *2/ctw**2*vmael**2*vmata*mta**4-1d0/4*pxx2zqsc**2/ctw**2*vmael**2
     & *vmata*us*mta**2)
     & +sdet3ctaus*sdet4itatsus**2*c0tataqsztaz*dreal(propizqs)*(pxx2zqs
     & c/ctw**2*vmata*us*mta**2+1d0/4*pxx2zqsc/ctw**2*vmata*qs*us-2*pxx2
     & zqsc/ctw**2*vmael*vmata*us*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael*vma
     & ta*qs*us+pxx2zqsc/ctw**2*vmael**2/vmata*mta**4+1d0/4*pxx2zqsc/ctw
     & **2*vmael**2/vmata*qs*mta**2-2*pxx2zqsc/ctw**2*vmael**2*mta**4-1d
     & 0/2*pxx2zqsc/ctw**2*vmael**2*qs*mta**2+pxx2zqsc/ctw**2*vmael**2*v
     & mata*mta**4+pxx2zqsc/ctw**2*vmael**2*vmata*us*mta**2+1d0/4*pxx2zq
     & sc/ctw**2*vmael**2*vmata*qs*mta**2+1d0/4*pxx2zqsc/ctw**2*vmael**2
     & *vmata*qs*us)
     & +sdet3ctaus*sdet4itatsus**2*c0ctausczta*dreal(propizqs)*(-1d0/2*p
     & xx2zqsc/ctw**2*vmata*us*mta**2+1d0/2*pxx2zqsc/ctw**2*vmata*us**2+
     & pxx2zqsc/ctw**2*vmael*vmata*us*mta**2-pxx2zqsc/ctw**2*vmael*vmata
     & *us**2-1d0/2*pxx2zqsc/ctw**2*vmael**2/vmata*mta**4+1d0/2*pxx2zqsc
     & /ctw**2*vmael**2/vmata*us*mta**2+pxx2zqsc/ctw**2*vmael**2*mta**4-
     & pxx2zqsc/ctw**2*vmael**2*us*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael**2
     & *vmata*mta**4+1d0/2*pxx2zqsc/ctw**2*vmael**2*vmata*us**2)
     & +sdet3ctaus*sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*(-1d0/
     & 8/ctw**2*vmata*qs*mta**2+1d0/8/ctw**2*vmata*qs*us+1d0/4/ctw**2*vm
     & ael*vmata*qs*mta**2-1d0/4/ctw**2*vmael*vmata*qs*us-1d0/8/ctw**2*v
     & mael**2*vmata*qs*mta**2+1d0/8/ctw**2*vmael**2*vmata*qs*us-pxx2zqs
     & c/ctw**2*vmael**2/vmata*mta**2+2*pxx2zqsc/ctw**2*vmael**2*mta**2-
     & pxx2zqsc/ctw**2*vmael**2*vmata*mta**2+1d0/8*pxx2zqsc**2/ctw**2*vm
     & ata-1d0/4*pxx2zqsc**2/ctw**2*vmael*vmata+1d0/8*pxx2zqsc**2/ctw**2
     & *vmael**2*vmata)
     & +sdet3ctaus*sdet4itatsus*c0ccqszcz*dreal(propizqs)*(1d0/ctw**2*mt
     & a**2-1d0/ctw**2*vmata*mta**2-1d0/2/ctw**2*vmata*us-2/ctw**2*vmael
     & *mta**2+2/ctw**2*vmael*vmata*mta**2+1d0/ctw**2*vmael*vmata*us-1d0
     & /2/ctw**2*vmael**2/vmata*mta**2+2/ctw**2*vmael**2*mta**2-3d0/2/ct
     & w**2*vmael**2*vmata*mta**2-1d0/2/ctw**2*vmael**2*vmata*us)
     & +sdet3ctaus*d0cctataqsuszczta*dreal(propizqs)*(1d0/2/ctw**2*vmael
     & **2*vmata)
     & +sdet3itataqs*c0tataqswcw*dreal(propizqs)*(-3d0/2/vmata*mw**2*rta
     & w*rwz+1d0/vmata*mw**2*rtaw**2*rwz+1d0/2/vmata*mw**2*rtaw**3*rwz)
     & +sdet3itataqs*c0tataqswcw*(7/vmata*mw**4*rtaw*rwz-12/vmata*mw**4*
     & rtaw**2*rwz+3/vmata*mw**4*rtaw**3*rwz+2/vmata*mw**4*rtaw**4*rwz)
     & +sdet3itataqs*c0tataqsztah*(-3d0/8/vmata*mw**4*rtaw/rwz**2-1d0/4/
     & vmata*mw**4*rtaw/rwz*rhw+1d0/8/vmata*mw**4*rtaw*rhw**2+1d0/vmata*
     & mw**4*rtaw**2/rwz-1d0/vmata*mw**4*rtaw**2*rhw+2/vmata*mw**4*rtaw*
     & *3)
     & +sdet3itataqs*c0tataqstazta*(-3d0/4/vmata*mw**4*rtaw/rwz**2-2*mw*
     & *4/rwz**3+4*mw**4/rwz**2-2*mw**4/rwz-13d0/4*mw**4*rtaw/rwz**2+6*m
     & w**4*rtaw/rwz)
     & +sdet3itataqs*c0tataqstahta*(1d0/4/vmata*mw**4*rtaw*rhw**2-1d0/vm
     & ata*mw**4*rtaw**2*rhw-1d0/4*mw**4*rtaw*rhw**2)
     & +sdet3itataqs*c0tataqscwc*(3d0/2/vmata*mw**4*rtaw+2/vmata*mw**4*r
     & taw**2+1d0/2/vmata*mw**4*rtaw**3)
     & +sdet3itataqs*b0ftawc*dreal(propizqs)*(1d0/vmata*rtaw*rwz)
     & +sdet3itataqs*b0ftawc*(2/vmata*mw**2*rtaw-7/vmata*mw**2*rtaw*rwz+
     & 1d0/vmata*mw**2*rtaw**2+3/vmata*mw**2*rtaw**2*rwz)
     & +sdet3itataqs*b0ftazta*(-3d0/8/vmata*mw**2*rtaw/rwz-1d0/8/vmata*m
     & w**2*rtaw*rhw+1d0/2/vmata*mw**2*rtaw**2-2*mw**2/rwz**2+4*mw**2/rw
     & z-2*mw**2-13d0/4*mw**2*rtaw/rwz+6*mw**2*rtaw)
     & +sdet3itataqs*b0ftahta*(3d0/8/vmata*mw**2*rtaw/rwz+1d0/8/vmata*mw
     & **2*rtaw*rhw-1d0/2/vmata*mw**2*rtaw**2-1d0/4*mw**2*rtaw*rhw)
     & +sdet3itataqs*b0fqsww*dreal(propizqs)*(-3d0/2/vmata*rtaw*rwz-1d0/
     & 2/vmata*rtaw**2*rwz)
     & +sdet3itataqs*b0fqsww*(7/vmata*mw**2*rtaw*rwz-5/vmata*mw**2*rtaw*
     & *2*rwz-2/vmata*mw**2*rtaw**3*rwz)
     & +sdet3itataqs*b0fqszh*(-3d0/4/vmata*mw**2*rtaw/rwz+1d0/4/vmata*mw
     & **2*rtaw*rhw-1d0/vmata*mw**2*rtaw**2)
     & +sdet3itataqs*b0fqstata*(3d0/4/vmata*mw**2*rtaw/rwz-1d0/4/vmata*m
     & w**2*rtaw*rhw+1d0/vmata*mw**2*rtaw**2+2*mw**2/rwz**2-4*mw**2/rwz+
     & 2*mw**2+13d0/4*mw**2*rtaw/rwz-6*mw**2*rtaw+1d0/4*mw**2*rtaw*rhw)
     & +sdet3itataqs*b0fqscc*(-3d0/2/vmata*mw**2*rtaw-1d0/2/vmata*mw**2*
     & rtaw**2)
     & +sdet3ictats*sdet4itatsus*c0ctatscwc*dreal(propizqs)*(4/vmata*ts*
     & *2*mw**2*rwz)
     & +sdet3ictats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*(-1d0/2*pxx
     & 2zqsc/ctw**2/vmata*ts*mta**2+pxx2zqsc/ctw**2*ts*mta**2-1d0/2*pxx2
     & zqsc/ctw**2*vmata*ts*mta**2+pxx2zqsc/ctw**2*vmael/vmata*ts*mta**2
     & -2*pxx2zqsc/ctw**2*vmael*ts*mta**2+pxx2zqsc/ctw**2*vmael*vmata*ts
     & *mta**2-1d0/2*pxx2zqsc/ctw**2*vmael**2/vmata*ts*mta**2+pxx2zqsc/c
     & tw**2*vmael**2*ts*mta**2)
     & +sdet3ictats*sdet4itatsus*b0ftawc*dreal(propizqs)*(4/vmata*ts**2*
     & rwz)
     & +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*(1d0/ctw**2/vm
     & ata*mta**4-2/ctw**2*mta**4+1d0/ctw**2*vmata*mta**4-2/ctw**2*vmael
     & /vmata*mta**4+4/ctw**2*vmael*mta**4-2/ctw**2*vmael*vmata*mta**4+1
     & d0/ctw**2*vmael**2/vmata*mta**4-2/ctw**2*vmael**2*mta**4+1d0/ctw*
     & *2*vmael**2*vmata*mta**4+1d0/ctw**2*vmael**2*vmata*ts*mta**2)
     & +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*(-1d0/ctw**2/v
     & mata*mta**4+2/ctw**2*mta**4-1d0/ctw**2*vmata*mta**4+2/ctw**2*vmae
     & l/vmata*mta**4-4/ctw**2*vmael*mta**4+2/ctw**2*vmael*vmata*mta**4-
     & 1d0/ctw**2*vmael**2/vmata*mta**4+2/ctw**2*vmael**2*mta**4-1d0/ctw
     & **2*vmael**2*vmata*mta**4-1d0/ctw**2*vmael**2*vmata*ts*mta**2)
     & +sdet3ictats*sdet4itatsus*b0ftscc*dreal(propizqs)*(-4/vmata*ts**2
     & *rwz)
     & +sdet3ictats*c0ctatsczta*dreal(propizqs)*(-1d0/2/ctw**2/vmata*mta
     & **2+1d0/ctw**2*mta**2-1d0/2/ctw**2*vmata*mta**2+1d0/ctw**2*vmael/
     & vmata*mta**2-2/ctw**2*vmael*mta**2+1d0/ctw**2*vmael*vmata*mta**2-
     & 1d0/2/ctw**2*vmael**2/vmata*mta**2+1d0/ctw**2*vmael**2*mta**2)
     & +sdet3ictaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*(1d0/2*pxx2
     & zqsc/ctw**2*vmata*us*mta**2-pxx2zqsc/ctw**2*vmael*vmata*us*mta**2
     & -1d0/2*pxx2zqsc/ctw**2*vmael**2/vmata*us*mta**2+pxx2zqsc/ctw**2*v
     & mael**2*us*mta**2)
     & +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*(1d0/ctw**2*vm
     & ata*us*mta**2-2/ctw**2*vmael*vmata*us*mta**2+1d0/ctw**2*vmael**2/
     & vmata*mta**4-2/ctw**2*vmael**2*mta**4+1d0/ctw**2*vmael**2*vmata*m
     & ta**4+1d0/ctw**2*vmael**2*vmata*us*mta**2)
     & +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*(-1d0/ctw**2*v
     & mata*us*mta**2+2/ctw**2*vmael*vmata*us*mta**2-1d0/ctw**2*vmael**2
     & /vmata*mta**4+2/ctw**2*vmael**2*mta**4-1d0/ctw**2*vmael**2*vmata*
     & mta**4-1d0/ctw**2*vmael**2*vmata*us*mta**2)
     & +sdet3ictaus*c0ctausczta*dreal(propizqs)*(1d0/2/ctw**2*vmata*mta*
     & *2-1d0/ctw**2*vmael*vmata*mta**2-1d0/2/ctw**2*vmael**2/vmata*mta*
     & *2+1d0/ctw**2*vmael**2*mta**2)
     & +sdet4itatsus**2*d0cctataqstswcwc*dreal(propizqs)*(4/vmata*mw**10
     & *rtaw**3*rwz-4/vmata*mw**10*rtaw**4*rwz+1d0/vmata*mw**10*rtaw**5*
     & rwz-4/vmata*ts*mw**8*rtaw**3*rwz+2/vmata*ts*mw**8*rtaw**4*rwz-4/v
     & mata*ts**2*mw**6*rtaw*rwz+4/vmata*ts**2*mw**6*rtaw**2*rwz+4/vmata
     & *ts**3*mw**4*rtaw*rwz-2/vmata*ts**3*mw**4*rtaw**2*rwz-1d0/vmata*t
     & s**4*mw**2*rtaw*rwz)
     & +sdet4itatsus**2*d0cctataqstszczta*dreal(propizqs)*(1d0/4*pxx2zqs
     & c**2/ctw**2*vmael**2*vmata*us*mta**4-1d0/4*pxx2zqsc**2/ctw**2*vma
     & el**2*vmata*ts*mta**4)
     & +sdet4itatsus**2*d0cctataqsuszczta*dreal(propizqs)*(-1d0/4*pxx2zq
     & sc**2/ctw**2*vmata*us*mta**4+1d0/4*pxx2zqsc**2/ctw**2*vmata*ts*mt
     & a**4+1d0/2*pxx2zqsc**2/ctw**2*vmael*vmata*us*mta**4-1d0/2*pxx2zqs
     & c**2/ctw**2*vmael*vmata*ts*mta**4-1d0/4*pxx2zqsc**2/ctw**2*vmael*
     & *2*vmata*us*mta**4+1d0/4*pxx2zqsc**2/ctw**2*vmael**2*vmata*ts*mta
     & **4)
     & +sdet4itatsus**2*c0tataqswcw*dreal(propizqs)*(-2/vmata/ts*mw**10*
     & rtaw**4*rwz+1d0/vmata/ts*mw**10*rtaw**5*rwz+2/vmata*mw**8*rtaw**3
     & *rwz+2/vmata*ts*mw**6*rtaw**2*rwz-2/vmata*ts*mw**6*rtaw**3*rwz-2/
     & vmata*ts**2*mw**4*rtaw*rwz+1d0/vmata*ts**3*mw**2*rtaw*rwz)
     & +sdet4itatsus**2*c0ctatscwc*dreal(propizqs)*(-4/vmata*mw**8*rtaw*
     & *3*rwz+2/vmata*mw**8*rtaw**4*rwz+2/vmata*ts*mw**6*rtaw**3*rwz+4/v
     & mata*ts**2*mw**4*rtaw*rwz-2/vmata*ts**2*mw**4*rtaw**2*rwz-2/vmata
     & *ts**3*mw**2*rtaw*rwz)
     & +sdet4itatsus**2*c0ccqswcw*dreal(propizqs)*(2/vmata/ts*mw**10*rta
     & w**4*rwz-1d0/vmata/ts*mw**10*rtaw**5*rwz+2/vmata*mw**8*rtaw**3*rw
     & z-2/vmata*mw**8*rtaw**4*rwz-2/vmata*ts*mw**6*rtaw**2*rwz-2/vmata*
     & ts**2*mw**4*rtaw*rwz+2/vmata*ts**2*mw**4*rtaw**2*rwz+1d0/vmata*ts
     & **3*mw**2*rtaw*rwz)
     & +sdet4itatsus**2*c0ccqszcz*dreal(propizqs)*(-1d0/4*pxx2zqsc/ctw**
     & 2/vmata*qs*mta**4+1d0/4*pxx2zqsc/ctw**2/vmata*qs*ts*mta**2+1d0/2*
     & pxx2zqsc/ctw**2*qs*mta**4-1d0/2*pxx2zqsc/ctw**2*qs*ts*mta**2-1d0/
     & 4*pxx2zqsc/ctw**2*vmata*qs*mta**4+1d0/4*pxx2zqsc/ctw**2*vmata*qs*
     & ts*mta**2+1d0/2*pxx2zqsc/ctw**2*vmael/vmata*qs*mta**4-1d0/2*pxx2z
     & qsc/ctw**2*vmael/vmata*qs*ts*mta**2-pxx2zqsc/ctw**2*vmael*qs*mta*
     & *4+pxx2zqsc/ctw**2*vmael*qs*ts*mta**2+1d0/2*pxx2zqsc/ctw**2*vmael
     & *vmata*qs*mta**4-1d0/2*pxx2zqsc/ctw**2*vmael*vmata*qs*ts*mta**2-1
     & d0/2*pxx2zqsc/ctw**2*vmael**2/vmata*qs*mta**4+1d0/4*pxx2zqsc/ctw*
     & *2*vmael**2/vmata*qs*us*mta**2+1d0/4*pxx2zqsc/ctw**2*vmael**2/vma
     & ta*qs*ts*mta**2+pxx2zqsc/ctw**2*vmael**2*qs*mta**4-1d0/2*pxx2zqsc
     & /ctw**2*vmael**2*qs*us*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael**2*qs*t
     & s*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael**2*vmata*qs*mta**4+1d0/4*pxx
     & 2zqsc/ctw**2*vmael**2*vmata*qs*us*mta**2+1d0/4*pxx2zqsc/ctw**2*vm
     & ael**2*vmata*qs*ts*mta**2)
     & +sdet4itatsus*d0cctataqstswcwc*dreal(propizqs)*(2/vmata*mw**6*rta
     & w*rwz-2/vmata*mw**6*rtaw**2*rwz+1d0/vmata*mw**6*rtaw**3*rwz-4/vma
     & ta*ts*mw**4*rtaw*rwz+2/vmata*ts*mw**4*rtaw**2*rwz+1d0/vmata*ts**2
     & *mw**2*rtaw*rwz)
     & +sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*(-1d0/8/ctw**2/vm
     & ata*qs*us*mta**2+1d0/8/ctw**2/vmata*qs*ts*mta**2+1d0/4/ctw**2*qs*
     & us*mta**2-1d0/4/ctw**2*qs*ts*mta**2-1d0/8/ctw**2*vmata*qs*us*mta*
     & *2+1d0/8/ctw**2*vmata*qs*ts*mta**2+1d0/4/ctw**2*vmael/vmata*qs*us
     & *mta**2-1d0/4/ctw**2*vmael/vmata*qs*ts*mta**2-1d0/2/ctw**2*vmael*
     & qs*us*mta**2+1d0/2/ctw**2*vmael*qs*ts*mta**2+1d0/4/ctw**2*vmael*v
     & mata*qs*us*mta**2-1d0/4/ctw**2*vmael*vmata*qs*ts*mta**2-1d0/8/ctw
     & **2*vmael**2/vmata*qs*us*mta**2+1d0/8/ctw**2*vmael**2/vmata*qs*ts
     & *mta**2+1d0/4/ctw**2*vmael**2*qs*us*mta**2-1d0/4/ctw**2*vmael**2*
     & qs*ts*mta**2-1d0/8/ctw**2*vmael**2*vmata*qs*us*mta**2+1d0/8/ctw**
     & 2*vmael**2*vmata*qs*ts*mta**2+1d0/2*pxx2zqsc/ctw**2/vmata*mta**4-
     & 1d0/4*pxx2zqsc/ctw**2/vmata*qs*mta**2-1d0/2*pxx2zqsc/ctw**2*mta**
     & 4+1d0/2*pxx2zqsc/ctw**2*qs*mta**2-1d0/4*pxx2zqsc/ctw**2*vmata*qs*
     & mta**2-pxx2zqsc/ctw**2*vmael/vmata*mta**4+1d0/2*pxx2zqsc/ctw**2*v
     & mael/vmata*qs*mta**2+pxx2zqsc/ctw**2*vmael*mta**4-pxx2zqsc/ctw**2
     & *vmael*qs*mta**2+1d0/2*pxx2zqsc/ctw**2*vmael*vmata*qs*mta**2+1d0/
     & 2*pxx2zqsc/ctw**2*vmael**2/vmata*mta**4-1d0/4*pxx2zqsc/ctw**2*vma
     & el**2/vmata*qs*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael**2*mta**4+1d0/2
     & *pxx2zqsc/ctw**2*vmael**2*ts*mta**2+1d0/2*pxx2zqsc/ctw**2*vmael**
     & 2*qs*mta**2+1d0/4*pxx2zqsc/ctw**2*vmael**2*vmata*mta**4-1d0/2*pxx
     & 2zqsc/ctw**2*vmael**2*vmata*ts*mta**2-3d0/4*pxx2zqsc/ctw**2*vmael
     & **2*vmata*ts**2-1d0/4*pxx2zqsc/ctw**2*vmael**2*vmata*qs*mta**2+1d
     & 0/8*pxx2zqsc**2/ctw**2/vmata*mta**2-1d0/4*pxx2zqsc**2/ctw**2*mta*
     & *2+1d0/8*pxx2zqsc**2/ctw**2*vmata*mta**2-1d0/4*pxx2zqsc**2/ctw**2
     & *vmael/vmata*mta**2+1d0/2*pxx2zqsc**2/ctw**2*vmael*mta**2-1d0/4*p
     & xx2zqsc**2/ctw**2*vmael*vmata*mta**2+1d0/8*pxx2zqsc**2/ctw**2*vma
     & el**2/vmata*mta**2-1d0/4*pxx2zqsc**2/ctw**2*vmael**2*mta**2+1d0/2
     & *pxx2zqsc**2/ctw**2*vmael**2*vmata*mta**2)
     & +sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*(1d0/8/ctw**2*vma
     & el**2/vmata*qs*us*mta**2-1d0/8/ctw**2*vmael**2/vmata*qs*ts*mta**2
     & -1d0/4/ctw**2*vmael**2*qs*us*mta**2+1d0/4/ctw**2*vmael**2*qs*ts*m
     & ta**2+1d0/8/ctw**2*vmael**2*vmata*qs*us*mta**2-1d0/8/ctw**2*vmael
     & **2*vmata*qs*ts*mta**2+1d0/2*pxx2zqsc/ctw**2*us*mta**2+1d0/4*pxx2
     & zqsc/ctw**2*vmata*mta**4-1d0/2*pxx2zqsc/ctw**2*vmata*us*mta**2-3d
     & 0/4*pxx2zqsc/ctw**2*vmata*us**2-pxx2zqsc/ctw**2*vmael*us*mta**2-1
     & d0/2*pxx2zqsc/ctw**2*vmael*vmata*mta**4+pxx2zqsc/ctw**2*vmael*vma
     & ta*us*mta**2+3d0/2*pxx2zqsc/ctw**2*vmael*vmata*us**2+1d0/2*pxx2zq
     & sc/ctw**2*vmael**2/vmata*mta**4-1d0/4*pxx2zqsc/ctw**2*vmael**2/vm
     & ata*qs*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael**2*mta**4+1d0/2*pxx2zqs
     & c/ctw**2*vmael**2*us*mta**2+1d0/2*pxx2zqsc/ctw**2*vmael**2*qs*mta
     & **2+1d0/4*pxx2zqsc/ctw**2*vmael**2*vmata*mta**4-1d0/2*pxx2zqsc/ct
     & w**2*vmael**2*vmata*us*mta**2-3d0/4*pxx2zqsc/ctw**2*vmael**2*vmat
     & a*us**2-1d0/4*pxx2zqsc/ctw**2*vmael**2*vmata*qs*mta**2+3d0/8*pxx2
     & zqsc**2/ctw**2*vmata*mta**2-3d0/4*pxx2zqsc**2/ctw**2*vmael*vmata*
     & mta**2+1d0/8*pxx2zqsc**2/ctw**2*vmael**2/vmata*mta**2-1d0/4*pxx2z
     & qsc**2/ctw**2*vmael**2*mta**2+1d0/2*pxx2zqsc**2/ctw**2*vmael**2*v
     & mata*mta**2)
     & +sdet4itatsus*c0tataqswcw*dreal(propizqs)*(-2/vmata/ts*mw**6*rtaw
     & **2*rwz+1d0/vmata/ts*mw**6*rtaw**3*rwz+2/vmata*mw**4*rtaw**2*rwz-
     & 1d0/vmata*ts*mw**2*rtaw*rwz)
     & +sdet4itatsus*c0tataqsztaz*dreal(propizqs)*(1d0/2/ctw**2/vmata*mt
     & a**4-1d0/2/ctw**2/vmata*ts*mta**2-1d0/ctw**2*mta**4+1d0/ctw**2*ts
     & *mta**2+1d0/2/ctw**2*vmata*mta**4+1d0/2/ctw**2*vmata*us*mta**2-1d
     & 0/2/ctw**2*vmata*us**2-1d0/2/ctw**2*vmata*ts*mta**2-1d0/ctw**2*vm
     & ael/vmata*mta**4+1d0/ctw**2*vmael/vmata*ts*mta**2+2/ctw**2*vmael*
     & mta**4-2/ctw**2*vmael*ts*mta**2-1d0/ctw**2*vmael*vmata*mta**4-1d0
     & /ctw**2*vmael*vmata*us*mta**2+1d0/ctw**2*vmael*vmata*us**2+1d0/ct
     & w**2*vmael*vmata*ts*mta**2+1d0/ctw**2*vmael**2/vmata*mta**4-1d0/2
     & /ctw**2*vmael**2/vmata*us*mta**2-1d0/2/ctw**2*vmael**2/vmata*ts*m
     & ta**2-2/ctw**2*vmael**2*mta**4+1d0/ctw**2*vmael**2*us*mta**2+1d0/
     & ctw**2*vmael**2*ts*mta**2+1d0/ctw**2*vmael**2*vmata*mta**4-1d0/2/
     & ctw**2*vmael**2*vmata*us**2-1d0/2/ctw**2*vmael**2*vmata*ts**2+1d0
     & /4*pxx2zqsc/ctw**2/vmata*mta**2-1d0/2*pxx2zqsc/ctw**2*mta**2+1d0/
     & 2*pxx2zqsc/ctw**2*vmata*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael/vmata*
     & mta**2+pxx2zqsc/ctw**2*vmael*mta**2-pxx2zqsc/ctw**2*vmael*vmata*m
     & ta**2+1d0/2*pxx2zqsc/ctw**2*vmael**2/vmata*mta**2-pxx2zqsc/ctw**2
     & *vmael**2*mta**2+pxx2zqsc/ctw**2*vmael**2*vmata*mta**2)
     & +sdet4itatsus*c0ctatscwc*dreal(propizqs)*(-4/vmata*ts*mw**2*rwz+4
     & /vmata*ts*mw**2*rtaw*rwz)
     & +sdet4itatsus*c0ctatsczta*dreal(propizqs)*(1d0/ctw**2/vmata*ts*mt
     & a**2-1d0/ctw**2*mta**4-2/ctw**2*ts*mta**2+1d0/ctw**2*vmata*mta**4
     & +1d0/ctw**2*vmata*ts*mta**2-2/ctw**2*vmael/vmata*ts*mta**2+2/ctw*
     & *2*vmael*mta**4+4/ctw**2*vmael*ts*mta**2-2/ctw**2*vmael*vmata*mta
     & **4-2/ctw**2*vmael*vmata*ts*mta**2+1d0/ctw**2*vmael**2/vmata*ts*m
     & ta**2-1d0/ctw**2*vmael**2*mta**4-3/ctw**2*vmael**2*ts*mta**2+1d0/
     & ctw**2*vmael**2*vmata*mta**4+2/ctw**2*vmael**2*vmata*ts*mta**2+1d
     & 0/ctw**2*vmael**2*vmata*ts**2)
     & +sdet4itatsus*c0ctausczta*dreal(propizqs)*(-1d0/ctw**2*us*mta**2+
     & 1d0/ctw**2*vmata*us*mta**2+1d0/ctw**2*vmata*us**2+2/ctw**2*vmael*
     & us*mta**2-2/ctw**2*vmael*vmata*us*mta**2-2/ctw**2*vmael*vmata*us*
     & *2+1d0/ctw**2*vmael**2/vmata*us*mta**2-1d0/ctw**2*vmael**2*mta**4
     & -3/ctw**2*vmael**2*us*mta**2+1d0/ctw**2*vmael**2*vmata*mta**4+2/c
     & tw**2*vmael**2*vmata*us*mta**2+1d0/ctw**2*vmael**2*vmata*us**2)
     & +sdet4itatsus*c0ccqswcw*dreal(propizqs)*(2/vmata/ts*mw**6*rtaw**2
     & *rwz-1d0/vmata/ts*mw**6*rtaw**3*rwz-2/vmata*mw**4*rtaw**2*rwz-1d0
     & /vmata*ts*mw**2*rtaw*rwz)
     & +sdet4itatsus*c0ccqszcz*dreal(propizqs)*(1d0/4*pxx2zqsc/ctw**2/vm
     & ata*mta**2-1d0/2*pxx2zqsc/ctw**2*mta**2+1d0/4*pxx2zqsc/ctw**2*vma
     & ta*mta**2-1d0/4*pxx2zqsc/ctw**2*vmata*us-1d0/2*pxx2zqsc/ctw**2*vm
     & ael/vmata*mta**2+pxx2zqsc/ctw**2*vmael*mta**2-1d0/2*pxx2zqsc/ctw*
     & *2*vmael*vmata*mta**2+1d0/2*pxx2zqsc/ctw**2*vmael*vmata*us+1d0/2*
     & pxx2zqsc/ctw**2*vmael**2/vmata*mta**2-pxx2zqsc/ctw**2*vmael**2*mt
     & a**2+1d0/2*pxx2zqsc/ctw**2*vmael**2*vmata*mta**2-1d0/4*pxx2zqsc/c
     & tw**2*vmael**2*vmata*us-1d0/4*pxx2zqsc/ctw**2*vmael**2*vmata*ts)
     & +sdet4itatsus*b0ftawc*dreal(propizqs)*(4/vmata*mw**2*rtaw*rwz-4/v
     & mata*ts*rwz)
     & +sdet4itatsus*b0fqsww*dreal(propizqs)*(-2/vmata*mw**2*rtaw*rwz)
     & +sdet4itatsus*b0fqszz*dreal(propizqs)*(-1d0/2/ctw**2/vmata*mta**2
     & +1d0/ctw**2*mta**2-1d0/2/ctw**2*vmata*mta**2-1d0/2/ctw**2*vmata*u
     & s+1d0/ctw**2*vmael/vmata*mta**2-2/ctw**2*vmael*mta**2+1d0/ctw**2*
     & vmael*vmata*mta**2+1d0/ctw**2*vmael*vmata*us-1d0/ctw**2*vmael**2/
     & vmata*mta**2+2/ctw**2*vmael**2*mta**2-1d0/ctw**2*vmael**2*vmata*m
     & ta**2-1d0/2/ctw**2*vmael**2*vmata*us-1d0/2/ctw**2*vmael**2*vmata*
     & ts)
     & +sdet4itatsus*b0ftstac*dreal(propizqs)*(1d0/2/ctw**2/vmata*mta**2
     & -1d0/ctw**2*mta**2+1d0/2/ctw**2*vmata*mta**2-1d0/ctw**2*vmael/vma
     & ta*mta**2+2/ctw**2*vmael*mta**2-1d0/ctw**2*vmael*vmata*mta**2+1d0
     & /2/ctw**2*vmael**2/vmata*mta**2-1d0/ctw**2*vmael**2*mta**2+1d0/2/
     & ctw**2*vmael**2*vmata*mta**2+1d0/2/ctw**2*vmael**2*vmata*ts)
     & +sdet4itatsus*b0ftscc*dreal(propizqs)*(-2/vmata*mw**2*rtaw*rwz+4/
     & vmata*ts*rwz)
     & +sdet4itatsus*b0fustac*dreal(propizqs)*(1d0/2/ctw**2*vmata*us-1d0
     & /ctw**2*vmael*vmata*us+1d0/2/ctw**2*vmael**2/vmata*mta**2-1d0/ctw
     & **2*vmael**2*mta**2+1d0/2/ctw**2*vmael**2*vmata*mta**2+1d0/2/ctw*
     & *2*vmael**2*vmata*us)
     & +d0cctataqstszczta*dreal(propizqs)*(-1d0/2/ctw**2/vmata*mta**2+1d
     & 0/2/ctw**2*mta**2+1d0/ctw**2*vmael/vmata*mta**2-1d0/ctw**2*vmael*
     & mta**2-1d0/2/ctw**2*vmael**2/vmata*mta**2+1d0/ctw**2*vmael**2*mta
     & **2-1d0/2/ctw**2*vmael**2*vmata*mta**2-1d0/2/ctw**2*vmael**2*vmat
     & a*mz**2-1d0/2/ctw**2*vmael**2*vmata*ts-1d0/8/ctw**2*vmael**2*vmat
     & a*qs)
     & +d0cctataqsuszczta*dreal(propizqs)*(1d0/2/ctw**2*mta**2-1d0/2/ctw
     & **2*vmata*mta**2-1d0/2/ctw**2*vmata*us+1d0/8/ctw**2*vmata*qs-1d0/
     & ctw**2*vmael*mta**2+1d0/ctw**2*vmael*vmata*mta**2+1d0/ctw**2*vmae
     & l*vmata*us-1d0/4/ctw**2*vmael*vmata*qs-1d0/2/ctw**2*vmael**2/vmat
     & a*mta**2+1d0/ctw**2*vmael**2*mta**2-1d0/2/ctw**2*vmael**2*vmata*m
     & ta**2-1d0/2/ctw**2*vmael**2*vmata*us+1d0/8/ctw**2*vmael**2*vmata*
     & qs-1d0/4*pxx2zqsc/ctw**2*vmata+1d0/2*pxx2zqsc/ctw**2*vmael*vmata-
     & 1d0/4*pxx2zqsc/ctw**2*vmael**2*vmata)
     & +c0tataqswcw*(3d0/2/vmata*mw**2*rtaw*rwz-1d0/vmata*mw**2*rtaw**2*
     & rwz-1d0/2/vmata*mw**2*rtaw**3*rwz)
     & +c0tataqsztaz*dreal(propizqs)*(-1d0/2/ctw**2*vmata+1d0/ctw**2*vma
     & el*vmata-1d0/ctw**2*vmael**2*vmata)
     & +c0tataqsztah*(3d0/8/vmata/qs*mw**4*rtaw/rwz**2-1d0/4/vmata/qs*mw
     & **4*rtaw/rwz*rhw-1d0/8/vmata/qs*mw**4*rtaw*rhw**2-1d0/2/vmata*mw*
     & *2*rtaw**2-1d0/qs*mw**4*rtaw/rwz**2+1d0/qs*mw**4*rtaw/rwz*rhw+mw*
     & *2*rtaw/rwz)
     & +c0tataqstazta*(1d0/2/vmata*mw**2*rtaw/rwz+4*mw**2/rwz**2-8*mw**2
     & /rwz+4*mw**2-7d0/2*mw**2*rtaw/rwz+6*mw**2*rtaw-4*mw**2*rtaw*rwz-2
     & *qs/rwz+4*qs-2*qs*rwz)
     & +c0tataqstahta*(mw**2*rtaw**2)
     & +c0tataqscwc*(-1d0/vmata*mw**2*rtaw)
     & +c0ccqswcw*(-2/qs**2*mw**6+4/qs*mw**4)
     & +c0ccqszcz*dreal(propizqs)*(-1d0/2/ctw**2*vmata+1d0/ctw**2*vmael*
     & vmata-1d0/ctw**2*vmael**2*vmata)
     & +c0ccqscwc*(1d0/qs*mw**4-2*mw**2+qs)
     & +c0ccqsczc*(-3/qs**2*mw**6/rwz**3+4/qs**2*mw**6/rwz**2-7d0/2/qs*m
     & w**4/rwz**3+12/qs*mw**4/rwz**2-10/qs*mw**4/rwz+7*mw**2/rwz**2-15*
     & mw**2/rwz+8*mw**2-7d0/2*qs/rwz+6*qs-2*qs*rwz)
     & +a0fw*dreal(propzqs)*(3*mw**2/rwz/rhw+1d0/6*mw**2/rwz-8d0/3*mw**2
     & -4*mw**2*rwz)
     & +a0fw*(3d0/2-2/qs**2*mw**4+4d0/3/qs*mw**2+4/qs*mw**2*rwz)
     & +a0fz*dreal(propzqs)*(3d0/2*mw**2/rwz**3/rhw+1d0/6*mw**2/rwz**2-1
     & d0/12*mw**2/rwz*rhw)
     & +a0fz*(9+3/qs**2*mw**4/rwz**2-4/qs**2*mw**4/rwz+41d0/12/qs*mw**2/
     & rwz**2-21d0/2/qs*mw**2/rwz+1d0/12/qs*mw**2/rwz*rhw+8/qs*mw**2-43d
     & 0/8/rwz-3*rwz)
     & +a0fh*dreal(propzqs)*(1d0/2*mw**2/rwz*rhw+1d0/12*mw**2*rhw**2)
     & +a0fh*(1d0/12/qs*mw**2/rwz*rhw-1d0/12/qs*mw**2*rhw**2-1d0/8*rhw)
     & +a0fta*(-1+1d0/4/rwz+rwz+1d0/4*rtaw)
     & +b0ftawc*(-1d0/vmata*rtaw*rwz-1d0/4*rtaw)
     & +b0ftazta*(-7+3d0/8/vmata/qs*mw**2*rtaw/rwz+1d0/8/vmata/qs*mw**2*
     & rtaw*rhw-1d0/qs*mw**2*rtaw/rwz+25d0/8/rwz+4*rwz)
     & +b0ftahta*(-3d0/8/vmata/qs*mw**2*rtaw/rwz-1d0/8/vmata/qs*mw**2*rt
     & aw*rhw+1d0/qs*mw**2*rtaw/rwz-1d0/8*rhw)
     & +b0fqsww*dreal(propzqs)*(1d0/12*mw**2/rwz**2+4d0/3*mw**2/rwz-17d0
     & /3*mw**2-4*mw**2*rwz)
     & +b0fqsww*dreal(propizqs)*(1d0/4/vmata/mw**2*rtaw*rwz)
     & +b0fqsww*(1d0/6+1d0/vmata*rtaw*rwz+1d0/2/vmata*rtaw**2*rwz-1d0/4/
     & vmata*qs/mw**2*rtaw*rwz-2/qs**2*mw**4+7d0/3/qs*mw**2+4/qs*mw**2*r
     & wz-1d0/12/rwz)
     & +b0fqszh*dreal(propzqs)*(mw**2/rwz**2-1d0/3*mw**2/rwz*rhw+1d0/12*
     & mw**2*rhw**2)
     & +b0fqszh*(1d0/4/vmata*rtaw-1d0/12/qs*mw**2/rwz**2+1d0/6/qs*mw**2/
     & rwz*rhw-1d0/12/qs*mw**2*rhw**2-1d0/12/rwz)
     & +b0fqstata*(6-1d0/4/vmata*rtaw-3/rwz-3*rwz+1d0/4*rtaw)
     & +b0fqscc*(21d0/2+1d0/4/vmata*rtaw+3/qs**2*mw**4/rwz**2-4/qs**2*mw
     & **4/rwz+7d0/2/qs*mw**2/rwz**2-21d0/2/qs*mw**2/rwz+7/qs*mw**2-21d0
     & /4/rwz-3*rwz)
     & +dreal(propzqs)*(mw**2/rwz**3/rhw-1d0/18*mw**2/rwz**2+2*mw**2/rwz
     & /rhw-5d0/9*mw**2/rwz-mw**2/rwz*zmzzzbos-1d0/6*mw**2/rwz*rhw-8d0/3
     & *mw**2-4*mw**2*rwz)
     & +dreal(b0ptazta)*(-5d0/4*mw**2/rwz**2+3*mw**2/rwz-2*mw**2-7d0/4*m
     & w**2*rtaw/rwz+6*mw**2*rtaw-4*mw**2*rtaw*rwz)
     & +dreal(b0ptahta)*(-1d0/4*mw**2*rtaw*rhw+mw**2*rtaw**2)
     & +dreal(b0ptacw)*(-1d0/2*mw**2+1d0/4*mw**2*rtaw+1d0/4*mw**2*rtaw**
     & 2)
     & +b0d1tataz*(1-1d0/4/rwz-rwz)
     & +b0dwtacw*(-1d0/2)
     & +139d0/36+1d0/2/vmata*rtaw-1d0/2/vmata*rtaw*rwz-3d0/4/qs*mw**2/rw
     & z-7d0/6/qs*mw**2+4/qs*mw**2*rwz-143d0/72/rwz-pizgfer+caldzfer-del
     & tarhofer-za1fer-deltarhobos-za1bos-3d0/2*rwz-1d0/4*rtaw

      ff_ew_qq =
     & +1d0/stw**2*(-1d0/qs*mw**2*za1bos-1d0/4/qs*mw**2*rtaw-deltarhofer
     & -deltarhobos-za1bos-1d0/4*rtaw)
     & +sdet3ctats**2*sdet4itatsus**2*d0cctataqstszczta*dreal(propizqs)*
     & (pxx2zqsc**2/ctw**2*vmael*vmata*mta**2+1d0/4*pxx2zqsc**2/ctw**2*v
     & mael*vmata*qs)
     & +sdet3ctats**2*sdet4itatsus**2*c0ccqszcz*dreal(propizqs)*(1d0/4*p
     & xx2zqsc/ctw**2*vmael*vmata*mta**2-1d0/4*pxx2zqsc/ctw**2*vmael*vma
     & ta*ts)
     & +sdet3ctats*sdet4itatsus**2*c0tataqsztaz*dreal(propizqs)*(pxx2zqs
     & c/ctw**2*vmael*vmata*ts*mta**2+1d0/4*pxx2zqsc/ctw**2*vmael*vmata*
     & qs*ts)
     & +sdet3ctats*sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*(-1d0/2*p
     & xx2zqsc/ctw**2*vmael*vmata*ts*mta**2+1d0/2*pxx2zqsc/ctw**2*vmael*
     & vmata*ts**2)
     & +sdet3ctats*sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*(-1d0/
     & 8/ctw**2*vmael*vmata*qs*mta**2+1d0/8/ctw**2*vmael*vmata*qs*ts+1d0
     & /8*pxx2zqsc**2/ctw**2*vmael*vmata)
     & +sdet3ctats*sdet4itatsus*c0ccqszcz*dreal(propizqs)*(1d0/ctw**2*vm
     & ael*mta**2-1d0/ctw**2*vmael*vmata*mta**2-1d0/2/ctw**2*vmael*vmata
     & *ts)
     & +sdet3ctaus*sdet4itatsus**2*d0cctataqsuszczta*dreal(propizqs)*(1d
     & 0/4*pxx2zqsc**2/ctw**2*vmael/vmata*mta**4-1d0/4*pxx2zqsc**2/ctw**
     & 2*vmael/vmata*us*mta**2-1d0/2*pxx2zqsc**2/ctw**2*vmael*mta**4+1d0
     & /2*pxx2zqsc**2/ctw**2*vmael*us*mta**2+1d0/4*pxx2zqsc**2/ctw**2*vm
     & ael*vmata*mta**4-1d0/4*pxx2zqsc**2/ctw**2*vmael*vmata*us*mta**2)
     & +sdet3ctaus*sdet4itatsus**2*c0tataqsztaz*dreal(propizqs)*(pxx2zqs
     & c/ctw**2*vmael/vmata*mta**4+1d0/4*pxx2zqsc/ctw**2*vmael/vmata*qs*
     & mta**2-2*pxx2zqsc/ctw**2*vmael*mta**4-1d0/2*pxx2zqsc/ctw**2*vmael
     & *qs*mta**2+pxx2zqsc/ctw**2*vmael*vmata*mta**4+1d0/4*pxx2zqsc/ctw*
     & *2*vmael*vmata*qs*mta**2)
     & +sdet3ctaus*sdet4itatsus**2*c0ctausczta*dreal(propizqs)*(-1d0/2*p
     & xx2zqsc/ctw**2*vmael/vmata*mta**4+1d0/2*pxx2zqsc/ctw**2*vmael/vma
     & ta*us*mta**2+pxx2zqsc/ctw**2*vmael*mta**4-pxx2zqsc/ctw**2*vmael*u
     & s*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael*vmata*mta**4+1d0/2*pxx2zqsc/
     & ctw**2*vmael*vmata*us*mta**2)
     & +sdet3ctaus*sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*(-pxx2
     & zqsc/ctw**2*vmael/vmata*mta**2+2*pxx2zqsc/ctw**2*vmael*mta**2-pxx
     & 2zqsc/ctw**2*vmael*vmata*mta**2)
     & +sdet3ctaus*sdet4itatsus*c0ccqszcz*dreal(propizqs)*(-1d0/2/ctw**2
     & *vmael/vmata*mta**2+1d0/ctw**2*vmael*mta**2-1d0/2/ctw**2*vmael*vm
     & ata*mta**2)
     & +sdet3ctaus*d0cctataqsuszczta*dreal(propizqs)*(1d0/2/ctw**2*vmael
     & *vmata)
     & +sdet3itataqs*c0tataqswcw*(7d0/4/vmata*mw**4-3/vmata*mw**4*rtaw+3
     & d0/4/vmata*mw**4*rtaw**2+1d0/2/vmata*mw**4*rtaw**3)
     & +sdet3itataqs*c0tataqsztah*(-3d0/8/vmata*mw**4*rtaw/rwz**2-1d0/4/
     & vmata*mw**4*rtaw/rwz*rhw+1d0/8/vmata*mw**4*rtaw*rhw**2+1d0/vmata*
     & mw**4*rtaw**2/rwz-1d0/vmata*mw**4*rtaw**2*rhw+2/vmata*mw**4*rtaw*
     & *3)
     & +sdet3itataqs*c0tataqstazta/stw**2*(-3d0/16*mw**4+3d0/4*mw**4*rta
     & w)
     & +sdet3itataqs*c0tataqstazta*(-3d0/4/vmata*mw**4*rtaw/rwz**2-2/qs*
     & mw**6/rwz**3+2/qs*mw**6/rwz**2-2*mw**4/rwz**3+45d0/16*mw**4/rwz**
     & 2-3d0/16*mw**4/rwz-13d0/4*mw**4*rtaw/rwz**2+11d0/4*mw**4*rtaw/rwz
     & )
     & +sdet3itataqs*c0tataqstahta/stw**2*(1d0/16*mw**4*rhw**2-1d0/4*mw*
     & *4*rtaw*rhw**2)
     & +sdet3itataqs*c0tataqstahta*(1d0/4/vmata*mw**4*rtaw*rhw**2-1d0/vm
     & ata*mw**4*rtaw**2*rhw)
     & +sdet3itataqs*c0tataqscwc*(3d0/2/vmata*mw**4*rtaw+2/vmata*mw**4*r
     & taw**2+1d0/2/vmata*mw**4*rtaw**3)
     & +sdet3itataqs*b0ftawc*(-7d0/4/vmata*mw**2+11d0/4/vmata*mw**2*rtaw
     & +1d0/vmata*mw**2*rtaw**2)
     & +sdet3itataqs*b0ftazta/stw**2*(-3d0/16*mw**2+3d0/4*mw**2*rtaw)
     & +sdet3itataqs*b0ftazta*(-3d0/8/vmata*mw**2*rtaw/rwz-1d0/8/vmata*m
     & w**2*rtaw*rhw+1d0/2/vmata*mw**2*rtaw**2-2/qs*mw**4/rwz**2+2/qs*mw
     & **4/rwz-2*mw**2/rwz**2+45d0/16*mw**2/rwz-13d0/4*mw**2*rtaw/rwz+2*
     & mw**2*rtaw)
     & +sdet3itataqs*b0ftahta/stw**2*(1d0/16*mw**2*rhw-1d0/4*mw**2*rtaw*
     & rhw)
     & +sdet3itataqs*b0ftahta*(3d0/8/vmata*mw**2*rtaw/rwz+1d0/8/vmata*mw
     & **2*rtaw*rhw-1d0/2/vmata*mw**2*rtaw**2)
     & +sdet3itataqs*b0fqsww*(7d0/4/vmata*mw**2-5d0/4/vmata*mw**2*rtaw-1
     & d0/2/vmata*mw**2*rtaw**2)
     & +sdet3itataqs*b0fqszh*(-3d0/4/vmata*mw**2*rtaw/rwz+1d0/4/vmata*mw
     & **2*rtaw*rhw-1d0/vmata*mw**2*rtaw**2)
     & +sdet3itataqs*b0fqstata/stw**2*(3d0/16*mw**2-1d0/16*mw**2*rhw-3d0
     & /4*mw**2*rtaw+1d0/4*mw**2*rtaw*rhw)
     & +sdet3itataqs*b0fqstata*(3d0/4/vmata*mw**2*rtaw/rwz-1d0/4/vmata*m
     & w**2*rtaw*rhw+1d0/vmata*mw**2*rtaw**2+2/qs*mw**4/rwz**2-2/qs*mw**
     & 4/rwz+2*mw**2/rwz**2-45d0/16*mw**2/rwz+13d0/4*mw**2*rtaw/rwz-2*mw
     & **2*rtaw)
     & +sdet3itataqs*b0fqscc*(-3d0/2/vmata*mw**2*rtaw-1d0/2/vmata*mw**2*
     & rtaw**2)
     & +sdet3ictats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*(1d0/2*pxx2
     & zqsc/ctw**2*vmael*vmata*ts*mta**2)
     & +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*(1d0/ctw**2*vm
     & ael*vmata*ts*mta**2)
     & +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*(-1d0/ctw**2*v
     & mael*vmata*ts*mta**2)
     & +sdet3ictats*c0ctatsczta*dreal(propizqs)*(1d0/2/ctw**2*vmael*vmat
     & a*mta**2)
     & +sdet3ictaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*(-1d0/2*pxx
     & 2zqsc/ctw**2*vmael/vmata*us*mta**2+pxx2zqsc/ctw**2*vmael*us*mta**
     & 2-1d0/2*pxx2zqsc/ctw**2*vmael*vmata*us*mta**2)
     & +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*(1d0/ctw**2*vm
     & ael/vmata*mta**4-2/ctw**2*vmael*mta**4+1d0/ctw**2*vmael*vmata*mta
     & **4)
     & +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*(-1d0/ctw**2*v
     & mael/vmata*mta**4+2/ctw**2*vmael*mta**4-1d0/ctw**2*vmael*vmata*mt
     & a**4)
     & +sdet3ictaus*c0ctausczta*dreal(propizqs)*(-1d0/2/ctw**2*vmael/vma
     & ta*mta**2+1d0/ctw**2*vmael*mta**2-1d0/2/ctw**2*vmael*vmata*mta**2
     & )
     & +sdet4itatsus**2*d0cctataqstszczta*dreal(propizqs)*(1d0/4*pxx2zqs
     & c**2/ctw**2*vmael*vmata*us*mta**4-1d0/4*pxx2zqsc**2/ctw**2*vmael*
     & vmata*ts*mta**4)
     & +sdet4itatsus**2*c0ccqszcz*dreal(propizqs)*(-1d0/4*pxx2zqsc/ctw**
     & 2*vmael/vmata*qs*mta**4+1d0/4*pxx2zqsc/ctw**2*vmael/vmata*qs*us*m
     & ta**2+1d0/2*pxx2zqsc/ctw**2*vmael*qs*mta**4-1d0/2*pxx2zqsc/ctw**2
     & *vmael*qs*us*mta**2-1d0/4*pxx2zqsc/ctw**2*vmael*vmata*qs*mta**4+1
     & d0/4*pxx2zqsc/ctw**2*vmael*vmata*qs*us*mta**2)
     & +sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*(1d0/2*pxx2zqsc/c
     & tw**2*vmael*ts*mta**2+1d0/4*pxx2zqsc/ctw**2*vmael*vmata*mta**4-1d
     & 0/2*pxx2zqsc/ctw**2*vmael*vmata*ts*mta**2-3d0/4*pxx2zqsc/ctw**2*v
     & mael*vmata*ts**2+3d0/8*pxx2zqsc**2/ctw**2*vmael*vmata*mta**2)
     & +sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*(1d0/8/ctw**2*vma
     & el/vmata*qs*us*mta**2-1d0/8/ctw**2*vmael/vmata*qs*ts*mta**2-1d0/4
     & /ctw**2*vmael*qs*us*mta**2+1d0/4/ctw**2*vmael*qs*ts*mta**2+1d0/8/
     & ctw**2*vmael*vmata*qs*us*mta**2-1d0/8/ctw**2*vmael*vmata*qs*ts*mt
     & a**2+1d0/2*pxx2zqsc/ctw**2*vmael/vmata*mta**4-1d0/4*pxx2zqsc/ctw*
     & *2*vmael/vmata*qs*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael*mta**4+1d0/2
     & *pxx2zqsc/ctw**2*vmael*qs*mta**2-1d0/4*pxx2zqsc/ctw**2*vmael*vmat
     & a*qs*mta**2+1d0/8*pxx2zqsc**2/ctw**2*vmael/vmata*mta**2-1d0/4*pxx
     & 2zqsc**2/ctw**2*vmael*mta**2+1d0/8*pxx2zqsc**2/ctw**2*vmael*vmata
     & *mta**2)
     & +sdet4itatsus*c0tataqsztaz*dreal(propizqs)*(1d0/2/ctw**2*vmael/vm
     & ata*mta**4-1d0/2/ctw**2*vmael/vmata*us*mta**2-1d0/ctw**2*vmael*mt
     & a**4+1d0/ctw**2*vmael*us*mta**2+1d0/2/ctw**2*vmael*vmata*mta**4-1
     & d0/2/ctw**2*vmael*vmata*us*mta**2+1d0/2/ctw**2*vmael*vmata*ts*mta
     & **2-1d0/2/ctw**2*vmael*vmata*ts**2+1d0/4*pxx2zqsc/ctw**2*vmael/vm
     & ata*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael*mta**2+1d0/2*pxx2zqsc/ctw*
     & *2*vmael*vmata*mta**2)
     & +sdet4itatsus*c0ctatsczta*dreal(propizqs)*(-1d0/ctw**2*vmael*ts*m
     & ta**2+1d0/ctw**2*vmael*vmata*ts*mta**2+1d0/ctw**2*vmael*vmata*ts*
     & *2)
     & +sdet4itatsus*c0ctausczta*dreal(propizqs)*(1d0/ctw**2*vmael/vmata
     & *us*mta**2-1d0/ctw**2*vmael*mta**4-2/ctw**2*vmael*us*mta**2+1d0/c
     & tw**2*vmael*vmata*mta**4+1d0/ctw**2*vmael*vmata*us*mta**2)
     & +sdet4itatsus*c0ccqszcz*dreal(propizqs)*(1d0/4*pxx2zqsc/ctw**2*vm
     & ael/vmata*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael*mta**2+1d0/4*pxx2zqs
     & c/ctw**2*vmael*vmata*mta**2-1d0/4*pxx2zqsc/ctw**2*vmael*vmata*ts)
     &
     & +sdet4itatsus*b0fqszz*dreal(propizqs)*(-1d0/2/ctw**2*vmael/vmata*
     & mta**2+1d0/ctw**2*vmael*mta**2-1d0/2/ctw**2*vmael*vmata*mta**2-1d
     & 0/2/ctw**2*vmael*vmata*ts)
     & +sdet4itatsus*b0ftstac*dreal(propizqs)*(1d0/2/ctw**2*vmael*vmata*
     & ts)
     & +sdet4itatsus*b0fustac*dreal(propizqs)*(1d0/2/ctw**2*vmael/vmata*
     & mta**2-1d0/ctw**2*vmael*mta**2+1d0/2/ctw**2*vmael*vmata*mta**2)
     & +d0cctataqstszczta*dreal(propizqs)*(1d0/2/ctw**2*vmael*mta**2-1d0
     & /2/ctw**2*vmael*vmata*mta**2-1d0/2/ctw**2*vmael*vmata*mz**2-1d0/2
     & /ctw**2*vmael*vmata*ts-1d0/8/ctw**2*vmael*vmata*qs)
     & +d0cctataqsuszczta*dreal(propizqs)*(-1d0/2/ctw**2*vmael/vmata*mta
     & **2+1d0/2/ctw**2*vmael*mta**2)
     & +c0tataqswcw*(-7d0/4/vmata/qs*mw**4+3d0/2/vmata/qs*mw**4*rtaw+1d0
     & /4/vmata/qs*mw**4*rtaw**2)
     & +c0tataqsztaz*dreal(propizqs)*(-1d0/2/ctw**2*vmael*vmata)
     & +c0tataqsztah*(3d0/8/vmata/qs*mw**4*rtaw/rwz**2-1d0/4/vmata/qs*mw
     & **4*rtaw/rwz*rhw-1d0/8/vmata/qs*mw**4*rtaw*rhw**2-1d0/2/vmata*mw*
     & *2*rtaw**2-1d0/qs*mw**4*rtaw/rwz**2+1d0/qs*mw**4*rtaw/rwz*rhw+mw*
     & *2*rtaw/rwz)
     & +c0tataqstazta/stw**2*(3d0/16/qs*mw**4-1d0/2/qs*mw**4*rtaw-1d0/2*
     & mw**2*rtaw)
     & +c0tataqstazta*(1d0/2/vmata*mw**2*rtaw/rwz+51d0/16/qs*mw**4/rwz**
     & 2-61d0/16/qs*mw**4/rwz-5d0/2/qs*mw**4*rtaw/rwz+4/qs*mw**4*rtaw+4*
     & mw**2/rwz**2-6*mw**2/rwz+2*mw**2-7d0/2*mw**2*rtaw/rwz+4*mw**2*rta
     & w-2*qs/rwz+2*qs)
     & +c0tataqstahta/stw**2*(-1d0/16/qs*mw**4*rhw**2+1d0/qs*mw**4*rtaw*
     & *2+mw**2*rtaw**2)
     & +c0tataqscwc*(-1d0/vmata*mw**2*rtaw)
     & +c0ccqszcz*dreal(propizqs)*(-1d0/2/ctw**2*vmael*vmata)
     & +c0ccqsczc*(-2/qs**2*mw**6/rwz**3+2/qs**2*mw**6/rwz**2-2/qs*mw**4
     & /rwz**3+6/qs*mw**4/rwz**2-4/qs*mw**4/rwz+4*mw**2/rwz**2-6*mw**2/r
     & wz+2*mw**2-2*qs/rwz+2*qs)
     & +a0fw*dreal(propzqs)*(3*mw**2/rwz/rhw+1d0/6*mw**2/rwz-8d0/3*mw**2
     & -4*mw**2*rwz)
     & +a0fw*(-4/qs**2*mw**4+8d0/3/qs*mw**2+4/qs*mw**2*rwz)
     & +a0fz/stw**2*(-1d0/8-1d0/8/qs*mw**2)
     & +a0fz*dreal(propzqs)*(3d0/2*mw**2/rwz**3/rhw+1d0/6*mw**2/rwz**2-1
     & d0/12*mw**2/rwz*rhw)
     & +a0fz*(3+2/qs**2*mw**4/rwz**2-2/qs**2*mw**4/rwz+23d0/12/qs*mw**2/
     & rwz**2-41d0/8/qs*mw**2/rwz+1d0/12/qs*mw**2/rwz*rhw+3/qs*mw**2-25d
     & 0/8/rwz)
     & +a0fh/stw**2*(-1d0/8/qs*mw**2*rhw-1d0/8*rhw)
     & +a0fh*dreal(propzqs)*(1d0/2*mw**2/rwz*rhw+1d0/12*mw**2*rhw**2)
     & +a0fh*(1d0/12/qs*mw**2/rwz*rhw-1d0/12/qs*mw**2*rhw**2)
     & +a0fta/stw**2*(1d0/4+1d0/4/qs*mw**2+1d0/4/qs*mw**2*rtaw+1d0/4*rta
     & w)
     & +a0fta*(-1+1d0/4/qs*mw**2/rwz-1d0/qs*mw**2+1d0/4/rwz)
     & +b0ftawc/stw**2*(-1d0/4/qs*mw**2*rtaw-1d0/4*rtaw)
     & +b0ftawc*(7d0/4/vmata/qs*mw**2+1d0/4/vmata/qs*mw**2*rtaw)
     & +b0ftazta/stw**2*(1d0/8+5d0/16/qs*mw**2)
     & +b0ftazta*(-4+3d0/8/vmata/qs*mw**2*rtaw/rwz+1d0/8/vmata/qs*mw**2*
     & rtaw*rhw+37d0/16/qs*mw**2/rwz-4/qs*mw**2-1d0/qs*mw**2*rtaw/rwz+25
     & d0/8/rwz)
     & +b0ftahta/stw**2*(-3d0/16/qs*mw**2*rhw-1d0/8*rhw)
     & +b0ftahta*(-3d0/8/vmata/qs*mw**2*rtaw/rwz-1d0/8/vmata/qs*mw**2*rt
     & aw*rhw+1d0/qs*mw**2*rtaw/rwz)
     & +b0fqsww*dreal(propzqs)*(1d0/12*mw**2/rwz**2+4d0/3*mw**2/rwz-17d0
     & /3*mw**2-4*mw**2*rwz)
     & +b0fqsww*(-7d0/4/vmata/qs*mw**2+1d0/4/vmata/qs*mw**2*rtaw+1d0/4/v
     & mata*rtaw-4/qs**2*mw**4+17d0/3/qs*mw**2+4/qs*mw**2*rwz-1d0/12/rwz
     & )
     & +b0fqszh*dreal(propzqs)*(mw**2/rwz**2-1d0/3*mw**2/rwz*rhw+1d0/12*
     & mw**2*rhw**2)
     & +b0fqszh*(1d0/4/vmata*rtaw-1d0/12/qs*mw**2/rwz**2+1d0/6/qs*mw**2/
     & rwz*rhw-1d0/12/qs*mw**2*rhw**2-1d0/12/rwz)
     & +b0fqstata/stw**2*(-3d0/16/qs*mw**2+1d0/16/qs*mw**2*rhw+1d0/4/qs*
     & mw**2*rtaw+1d0/4*rtaw)
     & +b0fqstata*(3-1d0/4/vmata*rtaw-35d0/16/qs*mw**2/rwz+3/qs*mw**2-3/
     & rwz)
     & +b0fqscc*(3+1d0/4/vmata*rtaw+2/qs**2*mw**4/rwz**2-2/qs**2*mw**4/r
     & wz+2/qs*mw**2/rwz**2-5/qs*mw**2/rwz+3/qs*mw**2-3/rwz)
     & +dreal(propzqs)*(mw**2/rwz**3/rhw-1d0/18*mw**2/rwz**2+2*mw**2/rwz
     & /rhw-5d0/9*mw**2/rwz-mw**2/rwz*zmzzzbos-1d0/6*mw**2/rwz*rhw-8d0/3
     & *mw**2-4*mw**2*rwz)
     & +dreal(b0ptazta)/stw**2*(-1d0/4/qs*mw**4+1d0/4/qs*mw**4*rtaw-1d0/
     & 4*mw**2+1d0/4*mw**2*rtaw)
     & +dreal(b0ptazta)*(-5d0/4/qs*mw**4/rwz**2+7d0/4/qs*mw**4/rwz-7d0/4
     & /qs*mw**4*rtaw/rwz+4/qs*mw**4*rtaw-5d0/4*mw**2/rwz**2+7d0/4*mw**2
     & /rwz-7d0/4*mw**2*rtaw/rwz+4*mw**2*rtaw)
     & +dreal(b0ptahta)/stw**2*(-1d0/4/qs*mw**4*rtaw*rhw+1d0/qs*mw**4*rt
     & aw**2-1d0/4*mw**2*rtaw*rhw+mw**2*rtaw**2)
     & +dreal(b0ptacw)/stw**2*(-1d0/2/qs*mw**4+1d0/4/qs*mw**4*rtaw+1d0/4
     & /qs*mw**4*rtaw**2-1d0/2*mw**2+1d0/4*mw**2*rtaw+1d0/4*mw**2*rtaw**
     & 2)
     & +b0d1tataz/stw**2*(-1d0/4-1d0/4/qs*mw**2)
     & +b0d1tataz*(1-1d0/4/qs*mw**2/rwz+1d0/qs*mw**2-1d0/4/rwz)
     & +b0dwtacw/stw**2*(-1d0/2-1d0/2/qs*mw**2)
     & +3d0/2+1d0/2/vmata/qs*mw**2*rtaw+1d0/2/vmata*rtaw-4/qs**2*mw**4-3
     & d0/2/qs*mw**2/rwz+25d0/6/qs*mw**2+4/qs*mw**2*rwz-29d0/18/rwz-2*pi
     & zgfer+caldzfer-za1fer

      ff_ew_ld =
     & +sdet3ctats*sdet4itatsus**2*d0cctataqstszczta*dreal(propizqs)*(1d
     & 0/2*pxx2zqsc**2/ctw**2*ts-pxx2zqsc**2/ctw**2*vmata*ts+1d0/2*pxx2z
     & qsc**2/ctw**2*vmata**2*ts-pxx2zqsc**2/ctw**2*vmael*ts+2*pxx2zqsc*
     & *2/ctw**2*vmael*vmata*ts-pxx2zqsc**2/ctw**2*vmael*vmata**2*ts+1d0
     & /2*pxx2zqsc**2/ctw**2*vmael**2*ts-pxx2zqsc**2/ctw**2*vmael**2*vma
     & ta*ts)
     & +sdet3ctats*sdet4itatsus**2*c0tataqsztaz*dreal(propizqs)*(-1d0/2*
     & pxx2zqsc/ctw**2*mta**2+1d0/2*pxx2zqsc/ctw**2*ts+pxx2zqsc/ctw**2*v
     & mata*mta**2-pxx2zqsc/ctw**2*vmata*ts-1d0/2*pxx2zqsc/ctw**2*vmata*
     & *2*mta**2+1d0/2*pxx2zqsc/ctw**2*vmata**2*ts+pxx2zqsc/ctw**2*vmael
     & *mta**2-pxx2zqsc/ctw**2*vmael*ts-2*pxx2zqsc/ctw**2*vmael*vmata*mt
     & a**2+2*pxx2zqsc/ctw**2*vmael*vmata*ts+pxx2zqsc/ctw**2*vmael*vmata
     & **2*mta**2-pxx2zqsc/ctw**2*vmael*vmata**2*ts-1d0/2*pxx2zqsc/ctw**
     & 2*vmael**2*mta**2+1d0/2*pxx2zqsc/ctw**2*vmael**2*ts+pxx2zqsc/ctw*
     & *2*vmael**2*vmata*mta**2-pxx2zqsc/ctw**2*vmael**2*vmata*ts)
     & +sdet3ctats*sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*(-pxx2zqs
     & c/ctw**2*ts+2*pxx2zqsc/ctw**2*vmata*ts-pxx2zqsc/ctw**2*vmata**2*t
     & s+2*pxx2zqsc/ctw**2*vmael*ts-4*pxx2zqsc/ctw**2*vmael*vmata*ts+2*p
     & xx2zqsc/ctw**2*vmael*vmata**2*ts-pxx2zqsc/ctw**2*vmael**2*ts+2*px
     & x2zqsc/ctw**2*vmael**2*vmata*ts)
     & +sdet3ctats*sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*(-1d0/
     & 4/ctw**2*qs+1d0/2/ctw**2*vmata*qs-1d0/4/ctw**2*vmata**2*qs+1d0/2/
     & ctw**2*vmael*qs-1d0/ctw**2*vmael*vmata*qs+1d0/2/ctw**2*vmael*vmat
     & a**2*qs-1d0/4/ctw**2*vmael**2*qs+1d0/2/ctw**2*vmael**2*vmata*qs+5
     & d0/4*pxx2zqsc/ctw**2-5d0/2*pxx2zqsc/ctw**2*vmata+5d0/4*pxx2zqsc/c
     & tw**2*vmata**2-5d0/2*pxx2zqsc/ctw**2*vmael+5*pxx2zqsc/ctw**2*vmae
     & l*vmata-5d0/2*pxx2zqsc/ctw**2*vmael*vmata**2+5d0/4*pxx2zqsc/ctw**
     & 2*vmael**2-5d0/2*pxx2zqsc/ctw**2*vmael**2*vmata)
     & +sdet3ctats*sdet4itatsus*c0ccqszcz*dreal(propizqs)*(1d0/2/ctw**2-
     & 1d0/ctw**2*vmata+1d0/2/ctw**2*vmata**2-1d0/ctw**2*vmael+2/ctw**2*
     & vmael*vmata-1d0/ctw**2*vmael*vmata**2+1d0/2/ctw**2*vmael**2-1d0/c
     & tw**2*vmael**2*vmata)
     & +sdet3ctaus*sdet4itatsus**2*d0cctataqsuszczta*dreal(propizqs)*(-1
     & d0/2*pxx2zqsc**2/ctw**2*vmata**2*us+pxx2zqsc**2/ctw**2*vmael*vmat
     & a**2*us+1d0/2*pxx2zqsc**2/ctw**2*vmael**2*us-pxx2zqsc**2/ctw**2*v
     & mael**2*vmata*us)
     & +sdet3ctaus*sdet4itatsus**2*c0tataqsztaz*dreal(propizqs)*(1d0/2*p
     & xx2zqsc/ctw**2*vmata**2*mta**2-1d0/2*pxx2zqsc/ctw**2*vmata**2*us-
     & pxx2zqsc/ctw**2*vmael*vmata**2*mta**2+pxx2zqsc/ctw**2*vmael*vmata
     & **2*us-1d0/2*pxx2zqsc/ctw**2*vmael**2*mta**2+1d0/2*pxx2zqsc/ctw**
     & 2*vmael**2*us+pxx2zqsc/ctw**2*vmael**2*vmata*mta**2-pxx2zqsc/ctw*
     & *2*vmael**2*vmata*us)
     & +sdet3ctaus*sdet4itatsus**2*c0ctausczta*dreal(propizqs)*(pxx2zqsc
     & /ctw**2*vmata**2*us-2*pxx2zqsc/ctw**2*vmael*vmata**2*us-pxx2zqsc/
     & ctw**2*vmael**2*us+2*pxx2zqsc/ctw**2*vmael**2*vmata*us)
     & +sdet3ctaus*sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*(1d0/4
     & /ctw**2*vmata**2*qs-1d0/2/ctw**2*vmael*vmata**2*qs-1d0/4/ctw**2*v
     & mael**2*qs+1d0/2/ctw**2*vmael**2*vmata*qs-5d0/4*pxx2zqsc/ctw**2*v
     & mata**2+5d0/2*pxx2zqsc/ctw**2*vmael*vmata**2+5d0/4*pxx2zqsc/ctw**
     & 2*vmael**2-5d0/2*pxx2zqsc/ctw**2*vmael**2*vmata)
     & +sdet3ctaus*sdet4itatsus*c0ccqszcz*dreal(propizqs)*(-1d0/2/ctw**2
     & *vmata**2+1d0/ctw**2*vmael*vmata**2+1d0/2/ctw**2*vmael**2-1d0/ctw
     & **2*vmael**2*vmata)
     & +sdet3itataqs**2*c0tataqswcw*dreal(propizqs)*(-3*mw**2*rtaw*rwz+6
     & *mw**2*rtaw**2*rwz-3*mw**2*rtaw**3*rwz)
     & +sdet3itataqs**2*c0tataqswcw*(12*mw**4*rwz-18*mw**4*rtaw*rwz-12*m
     & w**4*rtaw**2*rwz+30*mw**4*rtaw**3*rwz-12*mw**4*rtaw**4*rwz)
     & +sdet3itataqs**2*c0tataqstazta*(27*mw**4/rwz**3-90*mw**4/rwz**2+1
     & 08*mw**4/rwz-48*mw**4+9d0/2*mw**4*rtaw/rwz**2-6*mw**4*rtaw/rwz)
     & +sdet3itataqs**2*c0tataqstahta*(9d0/2*mw**4*rtaw*rhw**2-6*mw**4*r
     & taw*rwz*rhw**2)
     & +sdet3itataqs**2*c0tataqscwc*(6*mw**4+15*mw**4*rtaw+12*mw**4*rtaw
     & **2+3*mw**4*rtaw**3)
     & +sdet3itataqs**2*b0ftawc*(6*mw**2-12*mw**2*rwz+12*mw**2*rtaw+6*mw
     & **2*rtaw*rwz+6*mw**2*rtaw**2*rwz)
     & +sdet3itataqs**2*b0ftazta*(27*mw**2/rwz**2-90*mw**2/rwz+108*mw**2
     & -48*mw**2*rwz+9d0/2*mw**2*rtaw/rwz-6*mw**2*rtaw)
     & +sdet3itataqs**2*b0ftahta*(9d0/2*mw**2*rtaw*rhw-6*mw**2*rtaw*rwz*
     & rhw)
     & +sdet3itataqs**2*b0fqsww*dreal(propizqs)*(-3*rtaw*rwz+3*rtaw**2*r
     & wz)
     & +sdet3itataqs**2*b0fqsww*(12*mw**2*rwz-6*mw**2*rtaw*rwz-18*mw**2*
     & rtaw**2*rwz+12*mw**2*rtaw**3*rwz)
     & +sdet3itataqs**2*b0fqstata*(-27*mw**2/rwz**2+90*mw**2/rwz-108*mw*
     & *2+48*mw**2*rwz-9d0/2*mw**2*rtaw/rwz+6*mw**2*rtaw-9d0/2*mw**2*rta
     & w*rhw+6*mw**2*rtaw*rwz*rhw)
     & +sdet3itataqs**2*b0fqscc*(-6*mw**2-9*mw**2*rtaw-3*mw**2*rtaw**2)
     & +sdet3itataqs*sdet4itatsus*c0tataqswcw*dreal(propizqs)*(4/ts**4*m
     & w**12*rtaw**5*rwz-4/ts**4*mw**12*rtaw**6*rwz-4/ts**3*mw**10*rtaw*
     & *4*rwz+4/ts**3*mw**10*rtaw**5*rwz)
     & +sdet3itataqs*sdet4itatsus*b0ftawc*dreal(propizqs)*(-4/ts**4*mw**
     & 10*rtaw**5*rwz+4/ts**3*mw**8*rtaw**4*rwz)
     & +sdet3itataqs*sdet4itatsus*b0fqsww*dreal(propizqs)*(4/ts**4*mw**1
     & 0*rtaw**5*rwz-4/ts**3*mw**8*rtaw**4*rwz)
     & +sdet3itataqs*c0tataqswcw*dreal(propizqs)*(4/ts**4*mw**8*rtaw**3*
     & rwz-4/ts**4*mw**8*rtaw**4*rwz+4/ts**3*mw**6*rtaw**2*rwz-4/ts**3*m
     & w**6*rtaw**3*rwz+4/ts**2*mw**4*rtaw*rwz-4/ts**2*mw**4*rtaw**2*rwz
     & +4/ts*mw**2*rwz-4/ts*mw**2*rtaw*rwz+2*rwz-3*rtaw*rwz+rtaw**2*rwz)
     &
     & +sdet3itataqs*c0tataqswcw*(-4*mw**2*rwz+17*mw**2*rtaw*rwz-20*mw**
     & 2*rtaw**2*rwz+7*mw**2*rtaw**3*rwz)
     & +sdet3itataqs*c0tataqsztah*(-3d0/2*mw**2/rwz**2+2*mw**2/rwz-3d0/2
     & *mw**2/rwz*rhw+2*mw**2*rhw+6*mw**2*rtaw/rwz-8*mw**2*rtaw)
     & +sdet3itataqs*c0tataqstazta*(-24*mw**2/rwz**2+68*mw**2/rwz-72*mw*
     & *2+32*mw**2*rwz-3d0/2*mw**2*rtaw/rwz+2*mw**2*rtaw)
     & +sdet3itataqs*c0tataqstahta*(-9d0/2*mw**2*rtaw*rhw+6*mw**2*rtaw*r
     & wz*rhw)
     & +sdet3itataqs*c0tataqscwc*(-8*mw**2-8*mw**2*rtaw-mw**2*rtaw**2)
     & +sdet3itataqs*a0fw*(1-4/qs*mw**2+8/qs*mw**2*rwz-rwz)
     & +sdet3itataqs*a0fz*(-1-18/qs*mw**2/rwz**2+60/qs*mw**2/rwz-72/qs*m
     & w**2+32/qs*mw**2*rwz+3d0/4/rwz)
     & +sdet3itataqs*a0fh*(3d0/4*rhw-rwz*rhw)
     & +sdet3itataqs*a0fta*(15-9d0/2/rwz-18*rwz+8*rwz**2-3d0/2*rtaw+2*rt
     & aw*rwz)
     & +sdet3itataqs*b0ftawc*dreal(propizqs)*(-4/ts**4*mw**6*rtaw**3*rwz
     & -4/ts**3*mw**4*rtaw**2*rwz-4/ts**2*mw**2*rtaw*rwz-4/ts*rwz-1d0/mw
     & **2*rwz)
     & +sdet3itataqs*b0ftawc*(-5-4/qs*mw**2+8/qs*mw**2*rwz+5*rwz-5*rtaw*
     & rwz)
     & +sdet3itataqs*b0ftazta*(35-18/qs*mw**2/rwz**2+60/qs*mw**2/rwz-72/
     & qs*mw**2+32/qs*mw**2*rwz-51d0/4/rwz-36*rwz+16*rwz**2)
     & +sdet3itataqs*b0ftahta*(-2+3d0/2/rwz+3d0/4*rhw-rwz*rhw-3*rtaw+4*r
     & taw*rwz)
     & +sdet3itataqs*b0fqsww*dreal(propizqs)*(4/ts**4*mw**6*rtaw**3*rwz+
     & 4/ts**3*mw**4*rtaw**2*rwz+4/ts**2*mw**2*rtaw*rwz+4/ts*rwz+2/mw**2
     & *rwz-1d0/2/mw**2*rtaw*rwz)
     & +sdet3itataqs*b0fqsww*(-6*rwz+12*rtaw*rwz-5*rtaw**2*rwz)
     & +sdet3itataqs*b0fqszh*(4-3/rwz)
     & +sdet3itataqs*b0fqstata*(-23+21d0/2/rwz+18*rwz-8*rwz**2+3d0/2*rta
     & w-2*rtaw*rwz)
     & +sdet3itataqs*b0fqscc*(5+1d0/2*rtaw)
     & +sdet3itataqs*(-14+9d0/2/rwz+20*rwz-8*rwz**2+3d0/2*rtaw-rtaw*rwz)
     & +sdet3ictats*sdet4itatsus*c0ctatscwc*dreal(propizqs)*(4*ts*mw**2*
     & rwz)
     & +sdet3ictats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*(1d0/2*pxx2
     & zqsc/ctw**2*ts-pxx2zqsc/ctw**2*vmata*ts+1d0/2*pxx2zqsc/ctw**2*vma
     & ta**2*ts-pxx2zqsc/ctw**2*vmael*ts+2*pxx2zqsc/ctw**2*vmael*vmata*t
     & s-pxx2zqsc/ctw**2*vmael*vmata**2*ts+1d0/2*pxx2zqsc/ctw**2*vmael**
     & 2*ts-pxx2zqsc/ctw**2*vmael**2*vmata*ts)
     & +sdet3ictats*sdet4itatsus*b0ftawc*dreal(propizqs)*(4*ts*rwz)
     & +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*(1d0/ctw**2*ts
     & -2/ctw**2*vmata*ts+1d0/ctw**2*vmata**2*ts-2/ctw**2*vmael*ts+4/ctw
     & **2*vmael*vmata*ts-2/ctw**2*vmael*vmata**2*ts+1d0/ctw**2*vmael**2
     & *ts-2/ctw**2*vmael**2*vmata*ts)
     & +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*(-1d0/ctw**2*t
     & s+2/ctw**2*vmata*ts-1d0/ctw**2*vmata**2*ts+2/ctw**2*vmael*ts-4/ct
     & w**2*vmael*vmata*ts+2/ctw**2*vmael*vmata**2*ts-1d0/ctw**2*vmael**
     & 2*ts+2/ctw**2*vmael**2*vmata*ts)
     & +sdet3ictats*sdet4itatsus*b0ftscc*dreal(propizqs)*(-4*ts*rwz)
     & +sdet3ictats*c0ctatsczta*dreal(propizqs)*(1d0/2/ctw**2-1d0/ctw**2
     & *vmata+1d0/2/ctw**2*vmata**2-1d0/ctw**2*vmael+2/ctw**2*vmael*vmat
     & a-1d0/ctw**2*vmael*vmata**2+1d0/2/ctw**2*vmael**2-1d0/ctw**2*vmae
     & l**2*vmata)
     & +sdet3ictaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*(-1d0/2*pxx
     & 2zqsc/ctw**2*vmata**2*us+pxx2zqsc/ctw**2*vmael*vmata**2*us+1d0/2*
     & pxx2zqsc/ctw**2*vmael**2*us-pxx2zqsc/ctw**2*vmael**2*vmata*us)
     & +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*(-1d0/ctw**2*v
     & mata**2*us+2/ctw**2*vmael*vmata**2*us+1d0/ctw**2*vmael**2*us-2/ct
     & w**2*vmael**2*vmata*us)
     & +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*(1d0/ctw**2*vm
     & ata**2*us-2/ctw**2*vmael*vmata**2*us-1d0/ctw**2*vmael**2*us+2/ctw
     & **2*vmael**2*vmata*us)
     & +sdet3ictaus*c0ctausczta*dreal(propizqs)*(-1d0/2/ctw**2*vmata**2+
     & 1d0/ctw**2*vmael*vmata**2+1d0/2/ctw**2*vmael**2-1d0/ctw**2*vmael*
     & *2*vmata)
     & +sdet4itatsus**2*d0cctataqstswcwc*dreal(propizqs)*(8*ts*mw**6*rta
     & w*rwz-8*ts*mw**6*rtaw**2*rwz+2*ts*mw**6*rtaw**3*rwz+8*ts**2*mw**4
     & *rwz-16*ts**2*mw**4*rtaw*rwz+6*ts**2*mw**4*rtaw**2*rwz-8*ts**3*mw
     & **2*rwz+6*ts**3*mw**2*rtaw*rwz+2*ts**4*rwz)
     & +sdet4itatsus**2*c0tataqswcw*dreal(propizqs)*(-4*mw**6*rtaw**2*rw
     & z+2*mw**6*rtaw**3*rwz+2*ts*mw**4*rtaw**2*rwz+4*ts**2*mw**2*rwz-2*
     & ts**2*mw**2*rtaw*rwz-2*ts**3*rwz)
     & +sdet4itatsus**2*c0ctatscwc*dreal(propizqs)*(-8*ts*mw**4*rtaw*rwz
     & +4*ts*mw**4*rtaw**2*rwz-8*ts**2*mw**2*rwz+8*ts**2*mw**2*rtaw*rwz+
     & 4*ts**3*rwz)
     & +sdet4itatsus**2*c0ccqswcw*dreal(propizqs)*(4*mw**6*rtaw**2*rwz-2
     & *mw**6*rtaw**3*rwz+8*ts*mw**4*rtaw*rwz-6*ts*mw**4*rtaw**2*rwz+4*t
     & s**2*mw**2*rwz-6*ts**2*mw**2*rtaw*rwz-2*ts**3*rwz)
     & +sdet4itatsus**2*c0ccqszcz*dreal(propizqs)*(-1d0/2*pxx2zqsc/ctw**
     & 2*qs*ts+pxx2zqsc/ctw**2*vmata*qs*ts+1d0/2*pxx2zqsc/ctw**2*vmata**
     & 2*qs*us-1d0/2*pxx2zqsc/ctw**2*vmata**2*qs*ts+pxx2zqsc/ctw**2*vmae
     & l*qs*ts-2*pxx2zqsc/ctw**2*vmael*vmata*qs*ts-pxx2zqsc/ctw**2*vmael
     & *vmata**2*qs*us+pxx2zqsc/ctw**2*vmael*vmata**2*qs*ts-1d0/2*pxx2zq
     & sc/ctw**2*vmael**2*qs*us-1d0/2*pxx2zqsc/ctw**2*vmael**2*qs*ts+pxx
     & 2zqsc/ctw**2*vmael**2*vmata*qs*us+pxx2zqsc/ctw**2*vmael**2*vmata*
     & qs*ts)
     & +sdet4itatsus*d0cctataqstswcwc*dreal(propizqs)*(2*ts*mw**2*rwz)
     & +sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*(-1d0/2*pxx2zqsc/
     & ctw**2*mta**2+pxx2zqsc/ctw**2*vmata*mta**2+1d0/2*pxx2zqsc/ctw**2*
     & vmata*ts-1d0/2*pxx2zqsc/ctw**2*vmata**2*mta**2-1d0/2*pxx2zqsc/ctw
     & **2*vmata**2*ts+pxx2zqsc/ctw**2*vmael*mta**2-2*pxx2zqsc/ctw**2*vm
     & ael*vmata*mta**2-pxx2zqsc/ctw**2*vmael*vmata*ts+pxx2zqsc/ctw**2*v
     & mael*vmata**2*mta**2+pxx2zqsc/ctw**2*vmael*vmata**2*ts-1d0/2*pxx2
     & zqsc/ctw**2*vmael**2*mta**2+pxx2zqsc/ctw**2*vmael**2*vmata*mta**2
     & )
     & +sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*(-1d0/2*pxx2zqsc/
     & ctw**2*vmata*us+1d0/2*pxx2zqsc/ctw**2*vmata**2*mta**2+1d0/2*pxx2z
     & qsc/ctw**2*vmata**2*us+pxx2zqsc/ctw**2*vmael*vmata*us-pxx2zqsc/ct
     & w**2*vmael*vmata**2*mta**2-pxx2zqsc/ctw**2*vmael*vmata**2*us-1d0/
     & 2*pxx2zqsc/ctw**2*vmael**2*mta**2+pxx2zqsc/ctw**2*vmael**2*vmata*
     & mta**2)
     & +sdet4itatsus*c0tataqswcw*dreal(propizqs)*(4/ts**3*mw**8*rtaw**3*
     & rwz-4/ts**3*mw**8*rtaw**4*rwz+4/ts**2*mw**6*rtaw**2*rwz-4/ts**2*m
     & w**6*rtaw**3*rwz+4/ts*mw**4*rtaw*rwz-4/ts*mw**4*rtaw**2*rwz+2*mw*
     & *2*rwz-4*mw**2*rtaw*rwz)
     & +sdet4itatsus*c0tataqsztaz*dreal(propizqs)*(1d0/ctw**2*ts+1d0/4/c
     & tw**2*qs-1d0/2/ctw**2*vmata*us-3d0/2/ctw**2*vmata*ts-1d0/2/ctw**2
     & *vmata*qs-1d0/2/ctw**2*vmata**2*us+1d0/2/ctw**2*vmata**2*ts-2/ctw
     & **2*vmael*ts-1d0/2/ctw**2*vmael*qs+1d0/ctw**2*vmael*vmata*us+3/ct
     & w**2*vmael*vmata*ts+1d0/ctw**2*vmael*vmata*qs+1d0/ctw**2*vmael*vm
     & ata**2*us-1d0/ctw**2*vmael*vmata**2*ts+1d0/ctw**2*vmael**2*us+1d0
     & /ctw**2*vmael**2*ts+1d0/2/ctw**2*vmael**2*qs-2/ctw**2*vmael**2*vm
     & ata*us-2/ctw**2*vmael**2*vmata*ts-1d0/ctw**2*vmael**2*vmata*qs-1d
     & 0/8*det3itataqs*pxx2zqsc/ctw**2*qs*mta**2+1d0/8*det3itataqs*pxx2z
     & qsc/ctw**2*qs*ts+1d0/4*det3itataqs*pxx2zqsc/ctw**2*vmata*qs*mta**
     & 2-1d0/4*det3itataqs*pxx2zqsc/ctw**2*vmata*qs*ts-1d0/8*det3itataqs
     & *pxx2zqsc/ctw**2*vmata**2*qs*us+1d0/8*det3itataqs*pxx2zqsc/ctw**2
     & *vmata**2*qs*ts+1d0/4*det3itataqs*pxx2zqsc/ctw**2*vmael*qs*mta**2
     & -1d0/4*det3itataqs*pxx2zqsc/ctw**2*vmael*qs*ts-1d0/2*det3itataqs*
     & pxx2zqsc/ctw**2*vmael*vmata*qs*mta**2+1d0/2*det3itataqs*pxx2zqsc/
     & ctw**2*vmael*vmata*qs*ts+1d0/4*det3itataqs*pxx2zqsc/ctw**2*vmael*
     & vmata**2*qs*us-1d0/4*det3itataqs*pxx2zqsc/ctw**2*vmael*vmata**2*q
     & s*ts-1d0/4*det3itataqs*pxx2zqsc/ctw**2*vmael**2*qs*mta**2+1d0/8*d
     & et3itataqs*pxx2zqsc/ctw**2*vmael**2*qs*us+1d0/8*det3itataqs*pxx2z
     & qsc/ctw**2*vmael**2*qs*ts+1d0/2*det3itataqs*pxx2zqsc/ctw**2*vmael
     & **2*vmata*qs*mta**2-1d0/4*det3itataqs*pxx2zqsc/ctw**2*vmael**2*vm
     & ata*qs*us-1d0/4*det3itataqs*pxx2zqsc/ctw**2*vmael**2*vmata*qs*ts-
     & 1d0/4*pxx2zqsc/ctw**2+1d0/2*pxx2zqsc/ctw**2*vmata+1d0/2*pxx2zqsc/
     & ctw**2*vmael-pxx2zqsc/ctw**2*vmael*vmata-1d0/2*pxx2zqsc/ctw**2*vm
     & ael**2+pxx2zqsc/ctw**2*vmael**2*vmata)
     & +sdet4itatsus*c0ctatscwc*dreal(propizqs)*(-4*ts*rwz)
     & +sdet4itatsus*c0ctatsczta*dreal(propizqs)*(-1d0/2/ctw**2*mta**2-3
     & d0/2/ctw**2*ts+1d0/ctw**2*vmata*mta**2+2/ctw**2*vmata*ts-1d0/2/ct
     & w**2*vmata**2*mta**2-1d0/2/ctw**2*vmata**2*ts+1d0/ctw**2*vmael*mt
     & a**2+3/ctw**2*vmael*ts-2/ctw**2*vmael*vmata*mta**2-4/ctw**2*vmael
     & *vmata*ts+1d0/ctw**2*vmael*vmata**2*mta**2+1d0/ctw**2*vmael*vmata
     & **2*ts-1d0/2/ctw**2*vmael**2*mta**2-3d0/2/ctw**2*vmael**2*ts+1d0/
     & ctw**2*vmael**2*vmata*mta**2+3/ctw**2*vmael**2*vmata*ts)
     & +sdet4itatsus*c0ctausczta*dreal(propizqs)*(1d0/ctw**2*vmata*us+1d
     & 0/2/ctw**2*vmata**2*mta**2+1d0/2/ctw**2*vmata**2*us-2/ctw**2*vmae
     & l*vmata*us-1d0/ctw**2*vmael*vmata**2*mta**2-1d0/ctw**2*vmael*vmat
     & a**2*us-1d0/2/ctw**2*vmael**2*mta**2-3d0/2/ctw**2*vmael**2*us+1d0
     & /ctw**2*vmael**2*vmata*mta**2+3/ctw**2*vmael**2*vmata*us)
     & +sdet4itatsus*c0ccqswcw*dreal(propizqs)*(2*mw**2*rwz)
     & +sdet4itatsus*c0ccqszcz*dreal(propizqs)*(-1d0/4/ctw**2*qs-1d0/2/c
     & tw**2*vmata*us+1d0/2/ctw**2*vmata*ts+1d0/2/ctw**2*vmata*qs+1d0/2/
     & ctw**2*vmata**2*us-1d0/2/ctw**2*vmata**2*ts+1d0/2/ctw**2*vmael*qs
     & +1d0/ctw**2*vmael*vmata*us-1d0/ctw**2*vmael*vmata*ts-1d0/ctw**2*v
     & mael*vmata*qs-1d0/ctw**2*vmael*vmata**2*us+1d0/ctw**2*vmael*vmata
     & **2*ts-1d0/2/ctw**2*vmael**2*qs+1d0/ctw**2*vmael**2*vmata*qs-1d0/
     & 4*pxx2zqsc/ctw**2+1d0/2*pxx2zqsc/ctw**2*vmata+1d0/2*pxx2zqsc/ctw*
     & *2*vmael-pxx2zqsc/ctw**2*vmael*vmata-1d0/2*pxx2zqsc/ctw**2*vmael*
     & *2+pxx2zqsc/ctw**2*vmael**2*vmata)
     & +sdet4itatsus*b0ftawc*dreal(propizqs)*(-4/ts**3*mw**6*rtaw**3*rwz
     & -4/ts**2*mw**4*rtaw**2*rwz-4/ts*mw**2*rtaw*rwz-4*rwz)
     & +sdet4itatsus*b0ftazta*dreal(propizqs)*(1d0/4*det3itataqs/ctw**2*
     & qs*mta**2-1d0/4*det3itataqs/ctw**2*qs*ts-1d0/2*det3itataqs/ctw**2
     & *vmata*qs*mta**2+1d0/2*det3itataqs/ctw**2*vmata*qs*ts+1d0/4*det3i
     & tataqs/ctw**2*vmata**2*qs*us-1d0/4*det3itataqs/ctw**2*vmata**2*qs
     & *ts-1d0/2*det3itataqs/ctw**2*vmael*qs*mta**2+1d0/2*det3itataqs/ct
     & w**2*vmael*qs*ts+det3itataqs/ctw**2*vmael*vmata*qs*mta**2-det3ita
     & taqs/ctw**2*vmael*vmata*qs*ts-1d0/2*det3itataqs/ctw**2*vmael*vmat
     & a**2*qs*us+1d0/2*det3itataqs/ctw**2*vmael*vmata**2*qs*ts+1d0/2*de
     & t3itataqs/ctw**2*vmael**2*qs*mta**2-1d0/4*det3itataqs/ctw**2*vmae
     & l**2*qs*us-1d0/4*det3itataqs/ctw**2*vmael**2*qs*ts-det3itataqs/ct
     & w**2*vmael**2*vmata*qs*mta**2+1d0/2*det3itataqs/ctw**2*vmael**2*v
     & mata*qs*us+1d0/2*det3itataqs/ctw**2*vmael**2*vmata*qs*ts)
     & +sdet4itatsus*b0fqsww*dreal(propizqs)*(4/ts**3*mw**6*rtaw**3*rwz+
     & 4/ts**2*mw**4*rtaw**2*rwz+4/ts*mw**2*rtaw*rwz+4*rwz)
     & +sdet4itatsus*b0fqszz*dreal(propizqs)*(-1d0/4*det3itataqs/ctw**2*
     & qs*mta**2+1d0/4*det3itataqs/ctw**2*qs*ts+1d0/2*det3itataqs/ctw**2
     & *vmata*qs*mta**2-1d0/2*det3itataqs/ctw**2*vmata*qs*ts-1d0/4*det3i
     & tataqs/ctw**2*vmata**2*qs*us+1d0/4*det3itataqs/ctw**2*vmata**2*qs
     & *ts+1d0/2*det3itataqs/ctw**2*vmael*qs*mta**2-1d0/2*det3itataqs/ct
     & w**2*vmael*qs*ts-det3itataqs/ctw**2*vmael*vmata*qs*mta**2+det3ita
     & taqs/ctw**2*vmael*vmata*qs*ts+1d0/2*det3itataqs/ctw**2*vmael*vmat
     & a**2*qs*us-1d0/2*det3itataqs/ctw**2*vmael*vmata**2*qs*ts-1d0/2*de
     & t3itataqs/ctw**2*vmael**2*qs*mta**2+1d0/4*det3itataqs/ctw**2*vmae
     & l**2*qs*us+1d0/4*det3itataqs/ctw**2*vmael**2*qs*ts+det3itataqs/ct
     & w**2*vmael**2*vmata*qs*mta**2-1d0/2*det3itataqs/ctw**2*vmael**2*v
     & mata*qs*us-1d0/2*det3itataqs/ctw**2*vmael**2*vmata*qs*ts)
     & +d0cctataqstszczta*dreal(propizqs)*(1d0/2/ctw**2-1d0/2/ctw**2*vma
     & ta-1d0/ctw**2*vmael+1d0/ctw**2*vmael*vmata+1d0/2/ctw**2*vmael**2-
     & 1d0/ctw**2*vmael**2*vmata)
     & +d0cctataqsuszczta*dreal(propizqs)*(-1d0/2/ctw**2*vmata+1d0/ctw**
     & 2*vmael*vmata+1d0/2/ctw**2*vmael**2-1d0/ctw**2*vmael**2*vmata)
     & +c0tataqswcw*(-2*rwz+3*rtaw*rwz-rtaw**2*rwz)
     & +c0tataqsztah*(3d0/2/qs*mw**2/rwz**2-2/qs*mw**2/rwz-3d0/2/qs*mw**
     & 2/rwz*rhw+2/qs*mw**2*rhw)
     & +c0tataqstazta*(-4+3/rwz)
     & +c0tataqscwc*(2)
     & +b0ftawc*(1d0/mw**2*rwz)
     & +b0ftazta*(3d0/2/qs/rwz-2/qs)
     & +b0ftahta*(-3d0/2/qs/rwz+2/qs)
     & +b0fqsww*(-2/mw**2*rwz+1d0/2/mw**2*rtaw*rwz)
     & +b0d1tataz*(9d0/2/qs/rwz-15/qs+18/qs*rwz-8/qs*rwz**2)
     & +b0dwtacw*(1d0/qs-2/qs*rwz)

      ff_ew_qd =
     & +sdet3ctats*sdet4itatsus**2*d0cctataqstszczta*dreal(propizqs)*(-1
     & d0/2*pxx2zqsc**2/ctw**2*vmael*vmata**2*ts)
     & +sdet3ctats*sdet4itatsus**2*c0tataqsztaz*dreal(propizqs)*(1d0/2*p
     & xx2zqsc/ctw**2*vmael*vmata**2*mta**2-1d0/2*pxx2zqsc/ctw**2*vmael*
     & vmata**2*ts)
     & +sdet3ctats*sdet4itatsus**2*c0ctatsczta*dreal(propizqs)*(pxx2zqsc
     & /ctw**2*vmael*vmata**2*ts)
     & +sdet3ctats*sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*(1d0/4
     & /ctw**2*vmael*vmata**2*qs-5d0/4*pxx2zqsc/ctw**2*vmael*vmata**2)
     & +sdet3ctats*sdet4itatsus*c0ccqszcz*dreal(propizqs)*(-1d0/2/ctw**2
     & *vmael*vmata**2)
     & +sdet3ctaus*sdet4itatsus**2*d0cctataqsuszczta*dreal(propizqs)*(1d
     & 0/2*pxx2zqsc**2/ctw**2*vmael*us-pxx2zqsc**2/ctw**2*vmael*vmata*us
     & +1d0/2*pxx2zqsc**2/ctw**2*vmael*vmata**2*us)
     & +sdet3ctaus*sdet4itatsus**2*c0tataqsztaz*dreal(propizqs)*(-1d0/2*
     & pxx2zqsc/ctw**2*vmael*mta**2+1d0/2*pxx2zqsc/ctw**2*vmael*us+pxx2z
     & qsc/ctw**2*vmael*vmata*mta**2-pxx2zqsc/ctw**2*vmael*vmata*us-1d0/
     & 2*pxx2zqsc/ctw**2*vmael*vmata**2*mta**2+1d0/2*pxx2zqsc/ctw**2*vma
     & el*vmata**2*us)
     & +sdet3ctaus*sdet4itatsus**2*c0ctausczta*dreal(propizqs)*(-pxx2zqs
     & c/ctw**2*vmael*us+2*pxx2zqsc/ctw**2*vmael*vmata*us-pxx2zqsc/ctw**
     & 2*vmael*vmata**2*us)
     & +sdet3ctaus*sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*(-1d0/
     & 4/ctw**2*vmael*qs+1d0/2/ctw**2*vmael*vmata*qs-1d0/4/ctw**2*vmael*
     & vmata**2*qs+5d0/4*pxx2zqsc/ctw**2*vmael-5d0/2*pxx2zqsc/ctw**2*vma
     & el*vmata+5d0/4*pxx2zqsc/ctw**2*vmael*vmata**2)
     & +sdet3ctaus*sdet4itatsus*c0ccqszcz*dreal(propizqs)*(1d0/2/ctw**2*
     & vmael-1d0/ctw**2*vmael*vmata+1d0/2/ctw**2*vmael*vmata**2)
     & +sdet3itataqs**2*c0tataqswcw*(-12/qs*mw**6-9d0/2*mw**4-3*mw**4*rt
     & aw+15d0/2*mw**4*rtaw**2-3*mw**4*rtaw**3)
     & +sdet3itataqs**2*c0tataqstazta*(30/qs*mw**6/rwz**3-72/qs*mw**6/rw
     & z**2+48/qs*mw**6/rwz+27*mw**4/rwz**3-123d0/2*mw**4/rwz**2+36*mw**
     & 4/rwz+9d0/2*mw**4*rtaw/rwz**2)
     & +sdet3itataqs**2*c0tataqstahta*(-3d0/2*mw**4*rhw**2+9d0/2*mw**4*r
     & taw*rhw**2)
     & +sdet3itataqs**2*c0tataqscwc*(6*mw**4+15*mw**4*rtaw+12*mw**4*rtaw
     & **2+3*mw**4*rtaw**3)
     & +sdet3itataqs**2*b0ftawc*(12/qs*mw**4+15d0/2*mw**2+27d0/2*mw**2*r
     & taw)
     & +sdet3itataqs**2*b0ftazta*(30/qs*mw**4/rwz**2-72/qs*mw**4/rwz+48/
     & qs*mw**4+27*mw**2/rwz**2-123d0/2*mw**2/rwz+36*mw**2+9d0/2*mw**2*r
     & taw/rwz)
     & +sdet3itataqs**2*b0ftahta*(-3d0/2*mw**2*rhw+9d0/2*mw**2*rtaw*rhw)
     & +sdet3itataqs**2*b0fqsww*(-12/qs*mw**4-3d0/2*mw**2-9d0/2*mw**2*rt
     & aw+3*mw**2*rtaw**2)
     & +sdet3itataqs**2*b0fqstata*(-30/qs*mw**4/rwz**2+72/qs*mw**4/rwz-4
     & 8/qs*mw**4-27*mw**2/rwz**2+123d0/2*mw**2/rwz-36*mw**2+3d0/2*mw**2
     & *rhw-9d0/2*mw**2*rtaw/rwz-9d0/2*mw**2*rtaw*rhw)
     & +sdet3itataqs**2*b0fqscc*(-6*mw**2-9*mw**2*rtaw-3*mw**2*rtaw**2)
     & +sdet3itataqs*c0tataqswcw*(17d0/2/qs*mw**4+7d0/2*mw**2-25d0/8*mw*
     & *2*rtaw+mw**2*rtaw**2)
     & +sdet3itataqs*c0tataqsztah*(-3d0/2*mw**2/rwz**2+2*mw**2/rwz-3d0/2
     & *mw**2/rwz*rhw+2*mw**2*rhw+6*mw**2*rtaw/rwz-8*mw**2*rtaw)
     & +sdet3itataqs*c0tataqstazta*(-45d0/2/qs*mw**4/rwz**2+48/qs*mw**4/
     & rwz-32/qs*mw**4-24*mw**2/rwz**2+89d0/2*mw**2/rwz-24*mw**2-3d0/2*m
     & w**2*rtaw/rwz)
     & +sdet3itataqs*c0tataqstahta*(3d0/2/qs*mw**4*rhw**2+3d0/2*mw**2*rh
     & w-9d0/2*mw**2*rtaw*rhw)
     & +sdet3itataqs*c0tataqscwc*(-8*mw**2-8*mw**2*rtaw-mw**2*rtaw**2)
     & +sdet3itataqs*a0fw*(1-8/qs**2*mw**4-3/qs*mw**2)
     & +sdet3itataqs*a0fz*(-20/qs**2*mw**4/rwz**2+48/qs**2*mw**4/rwz-32/
     & qs**2*mw**4-18/qs*mw**2/rwz**2+41/qs*mw**2/rwz-24/qs*mw**2+3d0/4/
     & rwz)
     & +sdet3itataqs*a0fh*(1d0/qs*mw**2*rhw+3d0/4*rhw)
     & +sdet3itataqs*a0fta*(21d0/2-5/qs*mw**2/rwz+12/qs*mw**2-8/qs*mw**2
     & *rwz-9d0/2/rwz-6*rwz-3d0/2*rtaw)
     & +sdet3itataqs*b0ftawc*(-47d0/8-8/qs**2*mw**4-21d0/2/qs*mw**2)
     & +sdet3itataqs*b0ftazta*(22-20/qs**2*mw**4/rwz**2+48/qs**2*mw**4/r
     & wz-32/qs**2*mw**4-18/qs*mw**2/rwz**2+57d0/2/qs*mw**2/rwz-16/qs*mw
     & **2*rwz-51d0/4/rwz-12*rwz)
     & +sdet3itataqs*b0ftahta*(-1+5d0/2/qs*mw**2*rhw+3d0/2/rwz+3d0/4*rhw
     & -3*rtaw)
     & +sdet3itataqs*b0fqsww*(15d0/8+15d0/2/qs*mw**2-1d0/2*rtaw)
     & +sdet3itataqs*b0fqszh*(4-3/rwz)
     & +sdet3itataqs*b0fqstata*(-29d0/2+15d0/2/qs*mw**2/rwz-12/qs*mw**2-
     & 3d0/2/qs*mw**2*rhw+8/qs*mw**2*rwz+21d0/2/rwz+6*rwz+3d0/2*rtaw)
     & +sdet3itataqs*b0fqscc*(5+1d0/2*rtaw)
     & +sdet3itataqs*(-37d0/4+5/qs*mw**2/rwz-14/qs*mw**2+8/qs*mw**2*rwz+
     & 9d0/2/rwz+6*rwz+3d0/2*rtaw)
     & +sdet3ictats*sdet4itatsus*c0ctatsczta*dreal(propizqs)*(-1d0/2*pxx
     & 2zqsc/ctw**2*vmael*vmata**2*ts)
     & +sdet3ictats*sdet4itatsus*b0ftazta*dreal(propizqs)*(-1d0/ctw**2*v
     & mael*vmata**2*ts)
     & +sdet3ictats*sdet4itatsus*b0ftstac*dreal(propizqs)*(1d0/ctw**2*vm
     & ael*vmata**2*ts)
     & +sdet3ictats*c0ctatsczta*dreal(propizqs)*(-1d0/2/ctw**2*vmael*vma
     & ta**2)
     & +sdet3ictaus*sdet4itatsus*c0ctausczta*dreal(propizqs)*(1d0/2*pxx2
     & zqsc/ctw**2*vmael*us-pxx2zqsc/ctw**2*vmael*vmata*us+1d0/2*pxx2zqs
     & c/ctw**2*vmael*vmata**2*us)
     & +sdet3ictaus*sdet4itatsus*b0ftazta*dreal(propizqs)*(1d0/ctw**2*vm
     & ael*us-2/ctw**2*vmael*vmata*us+1d0/ctw**2*vmael*vmata**2*us)
     & +sdet3ictaus*sdet4itatsus*b0fustac*dreal(propizqs)*(-1d0/ctw**2*v
     & mael*us+2/ctw**2*vmael*vmata*us-1d0/ctw**2*vmael*vmata**2*us)
     & +sdet3ictaus*c0ctausczta*dreal(propizqs)*(1d0/2/ctw**2*vmael-1d0/
     & ctw**2*vmael*vmata+1d0/2/ctw**2*vmael*vmata**2)
     & +sdet4itatsus**2*c0ccqszcz*dreal(propizqs)*(-1d0/2*pxx2zqsc/ctw**
     & 2*vmael*qs*us+pxx2zqsc/ctw**2*vmael*vmata*qs*us-1d0/2*pxx2zqsc/ct
     & w**2*vmael*vmata**2*qs*us+1d0/2*pxx2zqsc/ctw**2*vmael*vmata**2*qs
     & *ts)
     & +sdet4itatsus*d0cctataqstszczta*dreal(propizqs)*(-1d0/2*pxx2zqsc/
     & ctw**2*vmael*vmata*ts+1d0/2*pxx2zqsc/ctw**2*vmael*vmata**2*mta**2
     & +1d0/2*pxx2zqsc/ctw**2*vmael*vmata**2*ts)
     & +sdet4itatsus*d0cctataqsuszczta*dreal(propizqs)*(-1d0/2*pxx2zqsc/
     & ctw**2*vmael*mta**2+pxx2zqsc/ctw**2*vmael*vmata*mta**2+1d0/2*pxx2
     & zqsc/ctw**2*vmael*vmata*us-1d0/2*pxx2zqsc/ctw**2*vmael*vmata**2*m
     & ta**2-1d0/2*pxx2zqsc/ctw**2*vmael*vmata**2*us)
     & +sdet4itatsus*c0tataqsztaz*dreal(propizqs)*(1d0/ctw**2*vmael*us+1
     & d0/4/ctw**2*vmael*qs-3d0/2/ctw**2*vmael*vmata*us-1d0/2/ctw**2*vma
     & el*vmata*ts-1d0/2/ctw**2*vmael*vmata*qs+1d0/2/ctw**2*vmael*vmata*
     & *2*us-1d0/2/ctw**2*vmael*vmata**2*ts-1d0/8*det3itataqs*pxx2zqsc/c
     & tw**2*vmael*qs*mta**2+1d0/8*det3itataqs*pxx2zqsc/ctw**2*vmael*qs*
     & us+1d0/4*det3itataqs*pxx2zqsc/ctw**2*vmael*vmata*qs*mta**2-1d0/4*
     & det3itataqs*pxx2zqsc/ctw**2*vmael*vmata*qs*us+1d0/8*det3itataqs*p
     & xx2zqsc/ctw**2*vmael*vmata**2*qs*us-1d0/8*det3itataqs*pxx2zqsc/ct
     & w**2*vmael*vmata**2*qs*ts-1d0/4*pxx2zqsc/ctw**2*vmael+1d0/2*pxx2z
     & qsc/ctw**2*vmael*vmata)
     & +sdet4itatsus*c0ctatsczta*dreal(propizqs)*(1d0/ctw**2*vmael*vmata
     & *ts+1d0/2/ctw**2*vmael*vmata**2*mta**2+1d0/2/ctw**2*vmael*vmata**
     & 2*ts)
     & +sdet4itatsus*c0ctausczta*dreal(propizqs)*(-1d0/2/ctw**2*vmael*mt
     & a**2-3d0/2/ctw**2*vmael*us+1d0/ctw**2*vmael*vmata*mta**2+2/ctw**2
     & *vmael*vmata*us-1d0/2/ctw**2*vmael*vmata**2*mta**2-1d0/2/ctw**2*v
     & mael*vmata**2*us)
     & +sdet4itatsus*c0ccqszcz*dreal(propizqs)*(-1d0/4/ctw**2*vmael*qs+1
     & d0/2/ctw**2*vmael*vmata*us-1d0/2/ctw**2*vmael*vmata*ts+1d0/2/ctw*
     & *2*vmael*vmata*qs-1d0/2/ctw**2*vmael*vmata**2*us+1d0/2/ctw**2*vma
     & el*vmata**2*ts-1d0/4*pxx2zqsc/ctw**2*vmael+1d0/2*pxx2zqsc/ctw**2*
     & vmael*vmata)
     & +sdet4itatsus*b0ftazta*dreal(propizqs)*(1d0/4*det3itataqs/ctw**2*
     & vmael*qs*mta**2-1d0/4*det3itataqs/ctw**2*vmael*qs*us-1d0/2*det3it
     & ataqs/ctw**2*vmael*vmata*qs*mta**2+1d0/2*det3itataqs/ctw**2*vmael
     & *vmata*qs*us-1d0/4*det3itataqs/ctw**2*vmael*vmata**2*qs*us+1d0/4*
     & det3itataqs/ctw**2*vmael*vmata**2*qs*ts)
     & +sdet4itatsus*b0fqszz*dreal(propizqs)*(-1d0/4*det3itataqs/ctw**2*
     & vmael*qs*mta**2+1d0/4*det3itataqs/ctw**2*vmael*qs*us+1d0/2*det3it
     & ataqs/ctw**2*vmael*vmata*qs*mta**2-1d0/2*det3itataqs/ctw**2*vmael
     & *vmata*qs*us+1d0/4*det3itataqs/ctw**2*vmael*vmata**2*qs*us-1d0/4*
     & det3itataqs/ctw**2*vmael*vmata**2*qs*ts)
     & +d0cctataqstszczta*dreal(propizqs)*(-1d0/2/ctw**2*vmael*vmata)
     & +d0cctataqsuszczta*dreal(propizqs)*(1d0/2/ctw**2*vmael-1d0/2/ctw*
     & *2*vmael*vmata)
     & +c0tataqswcw*(-3d0/2/qs*mw**2+1d0/8/qs*mw**2*rtaw)
     & +c0tataqsztah*(3d0/2/qs*mw**2/rwz**2-2/qs*mw**2/rwz-3d0/2/qs*mw**
     & 2/rwz*rhw+2/qs*mw**2*rhw)
     & +c0tataqstazta*(-2+3d0/2/qs*mw**2/rwz+3/rwz)
     & +c0tataqstahta*(-3d0/2/qs*mw**2*rhw)
     & +c0tataqscwc*(2)
     & +a0fta*(-1d0/2/qs)
     & +b0ftawc*(-1d0/8/qs)
     & +b0ftazta*(3d0/2/qs/rwz-2/qs)
     & +b0ftahta*(-3d0/2/qs/rwz+1d0/qs)
     & +b0fqsww*(1d0/8/qs)
     & +b0fqstata*(1d0/2/qs)
     & +b0d1tataz*(5/qs**2*mw**2/rwz-12/qs**2*mw**2+8/qs**2*mw**2*rwz+9d
     & 0/2/qs/rwz-10/qs+6/qs*rwz)
     & +b0dwtacw*(2/qs**2*mw**2+1d0/qs)
     & +1d0/4/qs

      ffarray(1,1) = ff_qed_ll
      ffarray(1,2) = ff_ew_ll
      ffarray(1,3) = ff_qed_lq
      ffarray(1,4) = ff_ew_lq
      ffarray(1,5) = ff_qed_ql
      ffarray(1,6) = ff_ew_ql
      ffarray(1,7) = ff_qed_qq
      ffarray(1,8) = ff_ew_qq
      ffarray(1,9) = ff_qed_ld
      ffarray(1,10) = ff_ew_ld
      ffarray(1,11) = ff_qed_qd
      ffarray(1,12) = ff_ew_qd
      ffarray(1,13) = ff_qed_gg

      return
      end
